!******************************************************************************!
!                                                                              !
!    class_couplings.f90                                                       !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   class_couplings.f90                            |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module class_couplings
  use constants_mdl
  use class_particles
  implicit none
  save
  integer, parameter :: n = 22

  logical :: couplings_init = .false.
  logical :: ctcouplings_init = .false.
  complex(dp) :: coupl(289)
  integer, parameter :: nGC_1534 = 1
  integer, parameter :: nGC_1531 = 2
  integer, parameter :: nGC_1530 = 3
  integer, parameter :: nGC_1533 = 4
  integer, parameter :: nGC_1532 = 5
  integer, parameter :: nGC_MI = 6
  integer, parameter :: nGC_2417 = 7
  integer, parameter :: nGC_14 = 8
  integer, parameter :: nGC_2257 = 9
  integer, parameter :: nGC_1348 = 10
  integer, parameter :: nGC_1349 = 11
  integer, parameter :: nGC_11 = 12
  integer, parameter :: nGC_10 = 13
  integer, parameter :: nGC_3090 = 14
  integer, parameter :: nGC_3091 = 15
  integer, parameter :: nGC_1520 = 16
  integer, parameter :: nGC_2651 = 17
  integer, parameter :: nGC_MD = 18
  integer, parameter :: nGC_2260 = 19
  integer, parameter :: nGC_2390 = 20
  integer, parameter :: nGC_2392 = 21
  integer, parameter :: nGC_284 = 22
  integer, parameter :: nGC_2648 = 23
  integer, parameter :: nGC_2649 = 24
  integer, parameter :: nGC_144 = 25
  integer, parameter :: nGC_2198 = 26
  integer, parameter :: nGC_142 = 27
  integer, parameter :: nGC_148 = 28
  integer, parameter :: nGC_MU = 29
  integer, parameter :: nGC_2196 = 30
  integer, parameter :: nGC_22 = 31
  integer, parameter :: nGC_26 = 32
  integer, parameter :: nGC_1355 = 33
  integer, parameter :: nGC_1356 = 34
  integer, parameter :: nGC_MC = 35
  integer, parameter :: nGC_MB = 36
  integer, parameter :: nGC_13 = 37
  integer, parameter :: nGC_MS = 38
  integer, parameter :: nGC_2197 = 39
  integer, parameter :: nGC_2 = 40
  integer, parameter :: nGC_12 = 41
  integer, parameter :: nGC_2420 = 42
  integer, parameter :: nGC_1379 = 43
  integer, parameter :: nGC_2173 = 44
  integer, parameter :: nGC_1441 = 45
  integer, parameter :: nGC_1442 = 46
  integer, parameter :: nGC_194 = 47
  integer, parameter :: nGC_1378 = 48
  integer, parameter :: nGC_1372 = 49
  integer, parameter :: nGC_1377 = 50
  integer, parameter :: nGC_1376 = 51
  integer, parameter :: nGC_1375 = 52
  integer, parameter :: nGC_2273 = 53
  integer, parameter :: nGC_2270 = 54
  integer, parameter :: nGC_1517 = 55
  integer, parameter :: nGC_2652 = 56
  integer, parameter :: nGC_1368 = 57
  integer, parameter :: nGC_1369 = 58
  integer, parameter :: nGC_4 = 59
  integer, parameter :: nGC_1360 = 60
  integer, parameter :: nGC_1361 = 61
  integer, parameter :: nGC_182 = 62
  integer, parameter :: nGC_1363 = 63
  integer, parameter :: nGC_1364 = 64
  integer, parameter :: nGC_1365 = 65
  integer, parameter :: nGC_1366 = 66
  integer, parameter :: nGC_1367 = 67
  integer, parameter :: nGC_1528 = 68
  integer, parameter :: nGC_1354 = 69
  integer, parameter :: nGC_1357 = 70
  integer, parameter :: nGC_1351 = 71
  integer, parameter :: nGC_1350 = 72
  integer, parameter :: nGC_1353 = 73
  integer, parameter :: nGC_1352 = 74
  integer, parameter :: nGC_1359 = 75
  integer, parameter :: nGC_1358 = 76
  integer, parameter :: nGC_3 = 77
  integer, parameter :: nGC_1 = 78
  integer, parameter :: nGC_7 = 79
  integer, parameter :: nGC_6 = 80
  integer, parameter :: nGC_5 = 81
  integer, parameter :: nGC_1400 = 82
  integer, parameter :: nGC_9 = 83
  integer, parameter :: nGC_8 = 84
  integer, parameter :: nGC_2172 = 85
  integer, parameter :: nGC_1395 = 86
  integer, parameter :: nGC_344 = 87
  integer, parameter :: nGC_1362 = 88
  integer, parameter :: nGC_1519 = 89
  integer, parameter :: nGC_2493 = 90
  integer, parameter :: nGC_2258 = 91
  integer, parameter :: nGC_2418 = 92
  integer, parameter :: nGC_290 = 93
  integer, parameter :: nGC_1522 = 94
  integer, parameter :: nGC_1523 = 95
  integer, parameter :: nGC_1521 = 96
  integer, parameter :: nGC_1526 = 97
  integer, parameter :: nGC_1527 = 98
  integer, parameter :: nGC_1524 = 99
  integer, parameter :: nGC_3624 = 100
  integer, parameter :: nGC_2406 = 101
  integer, parameter :: nGC_2407 = 102
  integer, parameter :: nGC_1405 = 103
  integer, parameter :: nGC_1404 = 104
  integer, parameter :: nGC_1407 = 105
  integer, parameter :: nGC_2087 = 106
  integer, parameter :: nGC_2078 = 107
  integer, parameter :: nGC_2391 = 108
  integer, parameter :: nGC_2393 = 109
  integer, parameter :: nGC_2152 = 110
  integer, parameter :: nGC_2153 = 111
  integer, parameter :: nGC_2092 = 112
  integer, parameter :: nGC_1412 = 113
  integer, parameter :: nGC_1410 = 114
  integer, parameter :: nGC_1411 = 115
  integer, parameter :: nGC_2109 = 116
  integer, parameter :: nGC_2108 = 117
  integer, parameter :: nGC_2107 = 118
  integer, parameter :: nGC_1399 = 119
  integer, parameter :: nGC_1398 = 120
  integer, parameter :: nGC_1462 = 121
  integer, parameter :: nGC_1393 = 122
  integer, parameter :: nGC_1392 = 123
  integer, parameter :: nGC_1466 = 124
  integer, parameter :: nGC_1396 = 125
  integer, parameter :: nGC_1496 = 126
  integer, parameter :: nGC_1495 = 127
  integer, parameter :: nGC_1492 = 128
  integer, parameter :: nGC_1490 = 129
  integer, parameter :: nGC_1491 = 130
  integer, parameter :: nGC_176 = 131
  integer, parameter :: nGC_1525 = 132
  integer, parameter :: nGC_1387 = 133
  integer, parameter :: nGC_1384 = 134
  integer, parameter :: nGC_1385 = 135
  integer, parameter :: nGC_1382 = 136
  integer, parameter :: nGC_1383 = 137
  integer, parameter :: nGC_1380 = 138
  integer, parameter :: nGC_1381 = 139
  integer, parameter :: nGC_2055 = 140
  integer, parameter :: nGC_1388 = 141
  integer, parameter :: nGC_1389 = 142
  integer, parameter :: nGC_2199 = 143
  integer, parameter :: nGC_1471 = 144
  integer, parameter :: nGC_1460 = 145
  integer, parameter :: nGC_1394 = 146
  integer, parameter :: nGC_122 = 147
  integer, parameter :: nGC_1397 = 148
  integer, parameter :: nGC_120 = 149
  integer, parameter :: nGC_1464 = 150
  integer, parameter :: nGC_128 = 151
  integer, parameter :: nGC_1444 = 152
  integer, parameter :: nGC_1447 = 153
  integer, parameter :: nGC_1446 = 154
  integer, parameter :: nGC_1440 = 155
  integer, parameter :: nGC_1443 = 156
  integer, parameter :: nGC_2511 = 157
  integer, parameter :: nGC_2444 = 158
  integer, parameter :: nGC_2445 = 159
  integer, parameter :: nGC_2446 = 160
  integer, parameter :: nGC_1373 = 161
  integer, parameter :: nGC_1371 = 162
  integer, parameter :: nGC_1370 = 163
  integer, parameter :: nGC_1374 = 164
  integer, parameter :: nGC_2274 = 165
  integer, parameter :: nGC_2110 = 166
  integer, parameter :: nGC_2111 = 167
  integer, parameter :: nGC_1391 = 168
  integer, parameter :: nGC_2118 = 169
  integer, parameter :: nGC_2119 = 170
  integer, parameter :: nGC_1452 = 171
  integer, parameter :: nGC_1453 = 172
  integer, parameter :: nGC_1450 = 173
  integer, parameter :: nGC_1451 = 174
  integer, parameter :: nGC_1457 = 175
  integer, parameter :: nGC_1455 = 176
  integer, parameter :: nGC_2073 = 177
  integer, parameter :: nGC_1459 = 178
  integer, parameter :: nGC_2275 = 179
  integer, parameter :: nGC_1518 = 180
  integer, parameter :: nGC_1390 = 181
  integer, parameter :: nGC_3626 = 182
  integer, parameter :: nGC_2685 = 183
  integer, parameter :: nGC_184 = 184
  integer, parameter :: nGC_1461 = 185
  integer, parameter :: nGC_1514 = 186
  integer, parameter :: nGC_1483 = 187
  integer, parameter :: nGC_2676 = 188
  integer, parameter :: nGC_1419 = 189
  integer, parameter :: nGC_1508 = 190
  integer, parameter :: nGC_1426 = 191
  integer, parameter :: nGC_1425 = 192
  integer, parameter :: nGC_1424 = 193
  integer, parameter :: nGC_1423 = 194
  integer, parameter :: nGC_2261 = 195
  integer, parameter :: nGC_1421 = 196
  integer, parameter :: nGC_1420 = 197
  integer, parameter :: nGC_1500 = 198
  integer, parameter :: nGC_1501 = 199
  integer, parameter :: nGC_1502 = 200
  integer, parameter :: nGC_1503 = 201
  integer, parameter :: nGC_1504 = 202
  integer, parameter :: nGC_1505 = 203
  integer, parameter :: nGC_1506 = 204
  integer, parameter :: nGC_1507 = 205
  integer, parameter :: nGC_1401 = 206
  integer, parameter :: nGC_1429 = 207
  integer, parameter :: nGC_1403 = 208
  integer, parameter :: nGC_1402 = 209
  integer, parameter :: nGC_2176 = 210
  integer, parameter :: nGC_2177 = 211
  integer, parameter :: nGC_1499 = 212
  integer, parameter :: nGC_1386 = 213
  integer, parameter :: nGC_1445 = 214
  integer, parameter :: nGC_1456 = 215
  integer, parameter :: nGC_2411 = 216
  integer, parameter :: nGC_1454 = 217
  integer, parameter :: nGC_2451 = 218
  integer, parameter :: nGC_2494 = 219
  integer, parameter :: nGC_1510 = 220
  integer, parameter :: nGC_2421 = 221
  integer, parameter :: nGC_1434 = 222
  integer, parameter :: nGC_1435 = 223
  integer, parameter :: nGC_1436 = 224
  integer, parameter :: nGC_1437 = 225
  integer, parameter :: nGC_1430 = 226
  integer, parameter :: nGC_1431 = 227
  integer, parameter :: nGC_1432 = 228
  integer, parameter :: nGC_2410 = 229
  integer, parameter :: nGC_1416 = 230
  integer, parameter :: nGC_1417 = 231
  integer, parameter :: nGC_1414 = 232
  integer, parameter :: nGC_1415 = 233
  integer, parameter :: nGC_1438 = 234
  integer, parameter :: nGC_1439 = 235
  integer, parameter :: nGC_1478 = 236
  integer, parameter :: nGC_1477 = 237
  integer, parameter :: nGC_1473 = 238
  integer, parameter :: nGC_1475 = 239
  integer, parameter :: nGC_1433 = 240
  integer, parameter :: nGC_1474 = 241
  integer, parameter :: nGC_1512 = 242
  integer, parameter :: nGC_1418 = 243
  integer, parameter :: nGC_1413 = 244
  integer, parameter :: nGC_2512 = 245
  integer, parameter :: nGC_1513 = 246
  integer, parameter :: nGC_1476 = 247
  integer, parameter :: nGC_1470 = 248
  integer, parameter :: nGC_2146 = 249
  integer, parameter :: nGC_1479 = 250
  integer, parameter :: nGC_1458 = 251
  integer, parameter :: nGC_2068 = 252
  integer, parameter :: nGC_1489 = 253
  integer, parameter :: nGC_1488 = 254
  integer, parameter :: nGC_1481 = 255
  integer, parameter :: nGC_1480 = 256
  integer, parameter :: nGC_2125 = 257
  integer, parameter :: nGC_1482 = 258
  integer, parameter :: nGC_1485 = 259
  integer, parameter :: nGC_1484 = 260
  integer, parameter :: nGC_1487 = 261
  integer, parameter :: nGC_1486 = 262
  integer, parameter :: nGC_2088 = 263
  integer, parameter :: nGC_2089 = 264
  integer, parameter :: nGC_1469 = 265
  integer, parameter :: nGC_1468 = 266
  integer, parameter :: nGC_1472 = 267
  integer, parameter :: nGC_1422 = 268
  integer, parameter :: nGC_1448 = 269
  integer, parameter :: nGC_1406 = 270
  integer, parameter :: nGC_1409 = 271
  integer, parameter :: nGC_1408 = 272
  integer, parameter :: nGC_1449 = 273
  integer, parameter :: nGC_2120 = 274
  integer, parameter :: nGC_1467 = 275
  integer, parameter :: nGC_1465 = 276
  integer, parameter :: nGC_1428 = 277
  integer, parameter :: nGC_1427 = 278
  integer, parameter :: nGC_1509 = 279
  integer, parameter :: nGC_1511 = 280
  integer, parameter :: nGC_1497 = 281
  integer, parameter :: nGC_1494 = 282
  integer, parameter :: nGC_2686 = 283
  integer, parameter :: nGC_1493 = 284
  integer, parameter :: nGC_1498 = 285
  integer, parameter :: nGC_1463 = 286
  integer, parameter :: nGC_2154 = 287
  integer, parameter :: nGC_2155 = 288
  integer, parameter :: nGC_2147 = 289
  contains
  function get_coupling_value_mdl(c_id) result(ret_c)
    integer, intent(in) :: c_id
    complex(dp) :: ret_c
    if (c_id .eq. 0) then
      ret_c = cnul
    else
      ret_c = coupl(c_id)
    end if
  end function get_coupling_value_mdl
end module class_couplings
