!******************************************************************************!
!                                                                              !
!    lcSSVVVS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSSVVVS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSSVVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopSSVVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SSVVVS0)
!       c0*(Metric(3,4)*P(5,3) - Metric(3,4)*P(5,4) - Metric(3,5)*P(4,3) + Metric
!       (3,5)*P(4,5) + Metric(4,5)*P(3,4) - Metric(4,5)*P(3,5))
        x0 = w3(1)*w4(1)
        x1 = P3(0)*w5(0)
        x2 = w3(2)*w4(2)
        x3 = w3(3)*w4(3)
        x4 = w3(0)*w4(0)*w5(1)
        x5 = w3(2)*w4(1)*w5(2)
        x6 = P3(1)*w3(3)
        x7 = w4(1)*w5(3)
        x8 = P3(2)*w5(2)
        x9 = w3(0)*w4(0)
        x10 = w3(1)*w4(2)*w5(1)
        x11 = P3(2)*w4(2)
        x12 = w3(3)*w5(3)
        x13 = w3(0)*w4(0)*w5(3)
        x14 = w3(1)*w4(3)*w5(1)
        x15 = w3(2)*w5(2)
        x16 = P3(3)*w4(3)
        x17 = P4(0)*w3(0)
        x18 = w4(1)*w5(1)
        x19 = w4(2)*w5(2)
        x20 = w4(3)*w5(3)
        x21 = P4(1)*w3(1)
        x22 = w4(0)*w5(0)
        x23 = w3(2)*w4(2)*w5(1)
        x24 = w4(3)*w5(1)
        x25 = P4(2)*w5(2)
        x26 = w3(2)*w4(0)*w5(0)
        x27 = P4(3)*w5(3)
        x28 = P4(3)*w3(3)
        x29 = w3(1)*w4(0)*w5(1)
        x30 = w3(2)*w4(0)*w5(2)
        x31 = w3(3)*w4(0)*w5(3)
        x32 = w3(0)*w4(1)*w5(0)
        x33 = P5(1)*w3(1)
        x34 = w3(0)*w5(0)
        x35 = P5(2)*w4(2)
        x36 = P5(2)*w3(2)
        x37 = P5(3)*w4(3)
        x38 = w3(3)*w4(1)*w5(1)
        x39 = P5(3)*w3(3)
        x40 = P3(3)*w5(3)
        x41 = P4(0)*w5(0)
        x42 = P4(2)*w3(2)
        x43 = P5(0)*w3(0)
        wp(0,:) = -P3(0)*cima*co(0)*w2(0)*wl(0,:)*x29 - P3(0)*cima*co(0)*w2(0)*&
                  wl(0,:)*x30 - P3(0)*cima*co(0)*w2(0)*wl(0,:)*x31 - P3(1)*cima&
                  *co(0)*w2(0)*wl(0,:)*x23 - P3(1)*cima*co(0)*w2(0)*wl(0,:)*x32&
                   + P3(1)*cima*co(0)*w2(0)*wl(0,:)*x4 + P3(1)*cima*co(0)*w2(0 &
                  )*wl(0,:)*x5 + P3(2)*cima*co(0)*w2(0)*wl(0,:)*x10 + P3(3)*   &
                  cima*co(0)*w2(0)*wl(0,:)*x13 + P3(3)*cima*co(0)*w2(0)*wl(0   &
                  ,:)*x14 + P4(1)*cima*co(0)*w2(0)*w3(3)*wl(0,:)*x24 + P4(1)*  &
                  cima*co(0)*w2(0)*wl(0,:)*x23 - P4(1)*cima*co(0)*w2(0)*wl(0   &
                  ,:)*x4 + P4(2)*cima*co(0)*w2(0)*wl(0,:)*x26 - P4(3)*cima*co(0&
                  )*w2(0)*wl(0,:)*x13 - P4(3)*cima*co(0)*w2(0)*wl(0,:)*x38 + P5&
                  (0)*cima*co(0)*w2(0)*wl(0,:)*x29 + P5(0)*cima*co(0)*w2(0)*wl(&
                  0,:)*x30 + P5(0)*cima*co(0)*w2(0)*wl(0,:)*x31 - P5(1)*cima*co&
                  (0)*w2(0)*w3(3)*wl(0,:)*x7 + P5(1)*cima*co(0)*w2(0)*wl(0,:)* &
                  x32 - P5(1)*cima*co(0)*w2(0)*wl(0,:)*x5 - P5(2)*cima*co(0)*w2&
                  (0)*wl(0,:)*x10 - P5(2)*cima*co(0)*w2(0)*wl(0,:)*x26 - P5(3)*&
                  cima*co(0)*w2(0)*wl(0,:)*x14 + P5(3)*cima*co(0)*w2(0)*wl(0   &
                  ,:)*x38 + cima*co(0)*w2(0)*wl(0,:)*x0*x1 + cima*co(0)*w2(0)* &
                  wl(0,:)*x0*x25 + cima*co(0)*w2(0)*wl(0,:)*x0*x27 - cima*co(0 &
                  )*w2(0)*wl(0,:)*x0*x40 - cima*co(0)*w2(0)*wl(0,:)*x0*x41 -   &
                  cima*co(0)*w2(0)*wl(0,:)*x0*x8 + cima*co(0)*w2(0)*wl(0,:)*x1*&
                  x2 + cima*co(0)*w2(0)*wl(0,:)*x1*x3 + cima*co(0)*w2(0)*wl(0  &
                  ,:)*x11*x12 - cima*co(0)*w2(0)*wl(0,:)*x11*x34 - cima*co(0)* &
                  w2(0)*wl(0,:)*x12*x35 + cima*co(0)*w2(0)*wl(0,:)*x15*x16 -   &
                  cima*co(0)*w2(0)*wl(0,:)*x15*x37 - cima*co(0)*w2(0)*wl(0,:)* &
                  x16*x34 + cima*co(0)*w2(0)*wl(0,:)*x17*x18 + cima*co(0)*w2(0 &
                  )*wl(0,:)*x17*x19 + cima*co(0)*w2(0)*wl(0,:)*x17*x20 + cima* &
                  co(0)*w2(0)*wl(0,:)*x18*x36 - cima*co(0)*w2(0)*wl(0,:)*x18*  &
                  x42 - cima*co(0)*w2(0)*wl(0,:)*x18*x43 - cima*co(0)*w2(0)*wl(&
                  0,:)*x19*x21 - cima*co(0)*w2(0)*wl(0,:)*x19*x28 + cima*co(0)*&
                  w2(0)*wl(0,:)*x19*x33 + cima*co(0)*w2(0)*wl(0,:)*x19*x39 -   &
                  cima*co(0)*w2(0)*wl(0,:)*x19*x43 + cima*co(0)*w2(0)*wl(0,:)* &
                  x2*x27 - cima*co(0)*w2(0)*wl(0,:)*x2*x40 - cima*co(0)*w2(0)* &
                  wl(0,:)*x2*x41 - cima*co(0)*w2(0)*wl(0,:)*x20*x21 + cima*co(0&
                  )*w2(0)*wl(0,:)*x20*x33 + cima*co(0)*w2(0)*wl(0,:)*x20*x36 - &
                  cima*co(0)*w2(0)*wl(0,:)*x20*x42 - cima*co(0)*w2(0)*wl(0,:)* &
                  x20*x43 + cima*co(0)*w2(0)*wl(0,:)*x21*x22 + cima*co(0)*w2(0 &
                  )*wl(0,:)*x22*x28 - cima*co(0)*w2(0)*wl(0,:)*x22*x33 - cima* &
                  co(0)*w2(0)*wl(0,:)*x22*x39 - cima*co(0)*w2(0)*wl(0,:)*x24*x6&
                   + cima*co(0)*w2(0)*wl(0,:)*x25*x3 - cima*co(0)*w2(0)*wl(0   &
                  ,:)*x25*x9 - cima*co(0)*w2(0)*wl(0,:)*x3*x41 - cima*co(0)*w2(&
                  0)*wl(0,:)*x3*x8 + cima*co(0)*w2(0)*wl(0,:)*x34*x35 + cima*co&
                  (0)*w2(0)*wl(0,:)*x34*x37 + cima*co(0)*w2(0)*wl(0,:)*x6*x7 + &
                  cima*co(0)*w2(0)*wl(0,:)*x8*x9
        wp(1:3,:) = cnul
      end select 
    end subroutine loopSSVVVS
end module lcSSVVVS
