!******************************************************************************!
!                                                                              !
!    lcSVSVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSVSVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSVSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopSVSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SVSVS0)
!       P(2,4)*P(4,2)*c0
!       Metric(2,4)*P(-1,2)*P(-1,4)*c1
        x0 = P4(0)*w2(0)
        x1 = P2(0)*co(0)*w4(0)
        x2 = w2(0)*w4(0)
        x3 = P2(0)*P4(0)*co(1)
        x4 = P2(1)*P4(1)*w2(1)
        x5 = co(1)*w2(2)*w4(2)
        x6 = P2(1)*P4(1)*co(1)
        x7 = w2(3)*w4(3)
        x8 = P4(2)*w2(2)
        x9 = P2(1)*co(0)*w4(1)
        x10 = P4(3)*w2(3)
        x11 = P2(2)*co(0)*w4(2)
        x12 = P4(1)*w2(1)
        x13 = P2(2)*P4(2)*co(1)
        x14 = w2(1)*w4(1)
        x15 = P2(3)*co(0)*w4(3)
        x16 = P2(3)*P4(3)*co(1)
        wp(0,:) = -P2(0)*P4(0)*cima*co(1)*w2(1)*w3(0)*w4(1)*wl(0,:) - P2(0)*P4(&
                  0)*cima*w3(0)*wl(0,:)*x5 - P2(0)*P4(1)*cima*co(0)*w2(1)*w3(0 &
                  )*w4(0)*wl(0,:) + P2(1)*P4(1)*cima*w3(0)*wl(0,:)*x5 + P2(2)* &
                  P4(2)*cima*w3(0)*wl(0,:)*x5 + P2(3)*P4(2)*cima*co(0)*w2(2)*w3&
                  (0)*w4(3)*wl(0,:) + P2(3)*P4(3)*cima*co(1)*w2(2)*w3(0)*w4(2)*&
                  wl(0,:) + P2(3)*cima*co(1)*w3(0)*w4(3)*wl(0,:)*x10 + cima*co(&
                  0)*w3(0)*w4(1)*wl(0,:)*x4 + cima*co(1)*w3(0)*w4(1)*wl(0,:)*x4&
                   + cima*w3(0)*wl(0,:)*x0*x1 - cima*w3(0)*wl(0,:)*x0*x11 -    &
                  cima*w3(0)*wl(0,:)*x0*x15 - cima*w3(0)*wl(0,:)*x0*x9 - cima* &
                  w3(0)*wl(0,:)*x1*x10 - cima*w3(0)*wl(0,:)*x1*x8 + cima*w3(0)*&
                  wl(0,:)*x10*x11 + cima*w3(0)*wl(0,:)*x10*x15 + cima*w3(0)*wl(&
                  0,:)*x10*x9 + cima*w3(0)*wl(0,:)*x11*x12 + cima*w3(0)*wl(0   &
                  ,:)*x11*x8 + cima*w3(0)*wl(0,:)*x12*x15 + cima*w3(0)*wl(0,:)*&
                  x13*x14 - cima*w3(0)*wl(0,:)*x13*x2 + cima*w3(0)*wl(0,:)*x13*&
                  x7 + cima*w3(0)*wl(0,:)*x14*x16 - cima*w3(0)*wl(0,:)*x16*x2  &
                   + cima*w3(0)*wl(0,:)*x2*x3 - cima*w3(0)*wl(0,:)*x2*x6 - cima&
                  *w3(0)*wl(0,:)*x3*x7 + cima*w3(0)*wl(0,:)*x6*x7 + cima*w3(0)*&
                  wl(0,:)*x8*x9
        wp(1:3,:) = cnul
      end select 
    end subroutine loopSVSVS
end module lcSVSVS
