!******************************************************************************!
!                                                                              !
!    lcSVSVVS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSVSVVS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSVSVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopSVSVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SVSVVS0)
!       c0*(Metric(2,4)*P(5,2) - Metric(2,4)*P(5,4) - Metric(2,5)*P(4,2) + Metric
!       (2,5)*P(4,5) + Metric(4,5)*P(2,4) - Metric(4,5)*P(2,5))
        x0 = w2(1)*w4(1)
        x1 = P2(0)*w5(0)
        x2 = w2(2)*w4(2)
        x3 = w2(3)*w4(3)
        x4 = w2(0)*w4(0)*w5(1)
        x5 = w2(2)*w5(2)
        x6 = P2(1)*w4(1)
        x7 = w2(3)*w4(1)*w5(3)
        x8 = P2(2)*w5(2)
        x9 = w2(0)*w4(0)
        x10 = w2(1)*w4(2)*w5(1)
        x11 = w2(3)*w4(2)*w5(3)
        x12 = P2(3)*w5(3)
        x13 = P2(3)*w4(3)
        x14 = w2(1)*w5(1)
        x15 = w4(1)*w5(1)
        x16 = P4(0)*w2(0)
        x17 = w4(2)*w5(2)
        x18 = w4(3)*w5(3)
        x19 = w2(1)*w4(0)*w5(0)
        x20 = P4(1)*w5(1)
        x21 = P4(2)*w5(2)
        x22 = w4(0)*w5(0)
        x23 = P4(2)*w2(2)
        x24 = P4(3)*w5(3)
        x25 = w2(2)*w4(2)*w5(3)
        x26 = P4(3)*w2(3)
        x27 = w2(1)*w4(0)*w5(1)
        x28 = P5(0)*w5(3)
        x29 = w2(0)*w5(0)
        x30 = P5(1)*w4(1)
        x31 = P5(1)*w2(1)
        x32 = w2(0)*w4(2)*w5(0)
        x33 = w2(2)*w4(1)*w5(1)
        x34 = P5(2)*w2(2)
        x35 = P5(3)*w4(3)
        x36 = P5(3)*w2(3)
        x37 = P2(0)*w4(0)
        x38 = P2(1)*w5(1)
        x39 = P4(0)*w5(0)
        x40 = P4(1)*w2(1)
        x41 = P5(0)*w2(0)
        wp(0,:) = -P2(0)*cima*co(0)*w3(0)*wl(0,:)*x27 + P2(1)*cima*co(0)*w3(0)*&
                  wl(0,:)*x4 + P2(1)*cima*co(0)*w3(0)*wl(0,:)*x7 + P2(2)*cima* &
                  co(0)*w3(0)*wl(0,:)*x10 + P2(2)*cima*co(0)*w3(0)*wl(0,:)*x11 &
                   - P2(2)*cima*co(0)*w3(0)*wl(0,:)*x32 - P2(3)*cima*co(0)*w3(0&
                  )*wl(0,:)*x25 + P4(1)*cima*co(0)*w3(0)*wl(0,:)*x19 - P4(1)*  &
                  cima*co(0)*w3(0)*wl(0,:)*x4 - P4(2)*cima*co(0)*w3(0)*wl(0,:)*&
                  x33 - P4(3)*cima*co(0)*w2(3)*w3(0)*w4(1)*w5(1)*wl(0,:) + P4(3&
                  )*cima*co(0)*w3(0)*wl(0,:)*x25 + P5(0)*cima*co(0)*w3(0)*w4(0 &
                  )*wl(0,:)*x5 + P5(0)*cima*co(0)*w3(0)*wl(0,:)*x27 - P5(1)*   &
                  cima*co(0)*w3(0)*wl(0,:)*x19 - P5(1)*cima*co(0)*w3(0)*wl(0   &
                  ,:)*x7 - P5(2)*cima*co(0)*w3(0)*wl(0,:)*x10 - P5(2)*cima*co(0&
                  )*w3(0)*wl(0,:)*x11 + P5(2)*cima*co(0)*w3(0)*wl(0,:)*x32 + P5&
                  (2)*cima*co(0)*w3(0)*wl(0,:)*x33 - cima*co(0)*w2(0)*w3(0)*w4(&
                  3)*wl(0,:)*x28 + cima*co(0)*w2(3)*w3(0)*w4(0)*wl(0,:)*x28 -  &
                  cima*co(0)*w2(3)*w3(0)*w5(3)*wl(0,:)*x37 + cima*co(0)*w3(0)* &
                  wl(0,:)*x0*x1 - cima*co(0)*w3(0)*wl(0,:)*x0*x12 + cima*co(0)*&
                  w3(0)*wl(0,:)*x0*x21 + cima*co(0)*w3(0)*wl(0,:)*x0*x24 - cima&
                  *co(0)*w3(0)*wl(0,:)*x0*x39 - cima*co(0)*w3(0)*wl(0,:)*x0*x8 &
                   + cima*co(0)*w3(0)*wl(0,:)*x1*x2 + cima*co(0)*w3(0)*wl(0,:)*&
                  x1*x3 + cima*co(0)*w3(0)*wl(0,:)*x12*x9 + cima*co(0)*w3(0)*wl&
                  (0,:)*x13*x14 - cima*co(0)*w3(0)*wl(0,:)*x13*x29 + cima*co(0 &
                  )*w3(0)*wl(0,:)*x13*x5 - cima*co(0)*w3(0)*wl(0,:)*x14*x35 +  &
                  cima*co(0)*w3(0)*wl(0,:)*x15*x16 + cima*co(0)*w3(0)*wl(0,:)* &
                  x15*x36 - cima*co(0)*w3(0)*wl(0,:)*x15*x41 + cima*co(0)*w3(0 &
                  )*wl(0,:)*x16*x17 + cima*co(0)*w3(0)*wl(0,:)*x16*x18 - cima* &
                  co(0)*w3(0)*wl(0,:)*x17*x26 + cima*co(0)*w3(0)*wl(0,:)*x17*  &
                  x31 + cima*co(0)*w3(0)*wl(0,:)*x17*x36 - cima*co(0)*w3(0)*wl(&
                  0,:)*x17*x40 - cima*co(0)*w3(0)*wl(0,:)*x17*x41 - cima*co(0)*&
                  w3(0)*wl(0,:)*x18*x23 + cima*co(0)*w3(0)*wl(0,:)*x18*x31 +   &
                  cima*co(0)*w3(0)*wl(0,:)*x18*x34 - cima*co(0)*w3(0)*wl(0,:)* &
                  x18*x40 + cima*co(0)*w3(0)*wl(0,:)*x2*x20 - cima*co(0)*w3(0)*&
                  wl(0,:)*x2*x38 - cima*co(0)*w3(0)*wl(0,:)*x2*x39 + cima*co(0 &
                  )*w3(0)*wl(0,:)*x20*x3 + cima*co(0)*w3(0)*wl(0,:)*x21*x3 -   &
                  cima*co(0)*w3(0)*wl(0,:)*x21*x9 + cima*co(0)*w3(0)*wl(0,:)*  &
                  x22*x23 + cima*co(0)*w3(0)*wl(0,:)*x22*x26 - cima*co(0)*w3(0 &
                  )*wl(0,:)*x22*x34 - cima*co(0)*w3(0)*wl(0,:)*x22*x36 - cima* &
                  co(0)*w3(0)*wl(0,:)*x24*x9 + cima*co(0)*w3(0)*wl(0,:)*x29*x30&
                   + cima*co(0)*w3(0)*wl(0,:)*x29*x35 - cima*co(0)*w3(0)*wl(0  &
                  ,:)*x29*x6 - cima*co(0)*w3(0)*wl(0,:)*x3*x38 - cima*co(0)*w3(&
                  0)*wl(0,:)*x3*x39 - cima*co(0)*w3(0)*wl(0,:)*x3*x8 - cima*co(&
                  0)*w3(0)*wl(0,:)*x30*x5 - cima*co(0)*w3(0)*wl(0,:)*x35*x5 -  &
                  cima*co(0)*w3(0)*wl(0,:)*x37*x5 + cima*co(0)*w3(0)*wl(0,:)*x5&
                  *x6 + cima*co(0)*w3(0)*wl(0,:)*x8*x9
        wp(1:3,:) = cnul
      end select 
    end subroutine loopSVSVVS
end module lcSVSVVS
