!******************************************************************************!
!                                                                              !
!    lcSVVSVS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSVVSVS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSVVSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopSVVSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SVVSVS0)
!       c0*(Metric(2,3)*P(5,2) - Metric(2,3)*P(5,3) - Metric(2,5)*P(3,2) + Metric
!       (2,5)*P(3,5) + Metric(3,5)*P(2,3) - Metric(3,5)*P(2,5))
        x0 = w2(1)*w3(1)
        x1 = P2(0)*w5(0)
        x2 = w2(2)*w3(2)
        x3 = w2(3)*w3(3)
        x4 = w2(0)*w3(0)
        x5 = P2(1)*w5(1)
        x6 = P2(1)*w2(2)
        x7 = w3(1)*w5(2)
        x8 = w2(3)*w5(3)
        x9 = P2(1)*w3(1)
        x10 = w2(0)*w3(0)*w5(2)
        x11 = w2(1)*w3(2)*w5(1)
        x12 = w2(3)*w3(2)*w5(3)
        x13 = P2(3)*w5(3)
        x14 = P2(3)*w3(3)
        x15 = w2(1)*w5(1)
        x16 = w2(2)*w5(2)
        x17 = w2(0)*w3(1)*w5(1)
        x18 = w2(0)*w3(2)*w5(2)
        x19 = w2(0)*w3(3)*w5(3)
        x20 = w2(1)*w3(0)*w5(0)
        x21 = P3(1)*w5(1)
        x22 = w2(1)*w3(1)*w5(2)
        x23 = P3(2)*w2(2)
        x24 = w3(0)*w5(0)
        x25 = w2(3)*w3(3)*w5(2)
        x26 = P3(3)*w5(3)
        x27 = w2(2)*w3(2)*w5(3)
        x28 = P3(3)*w2(3)
        x29 = w2(1)*w3(0)*w5(1)
        x30 = P5(0)*w3(0)
        x31 = w2(0)*w5(0)
        x32 = P5(1)*w3(1)
        x33 = w2(1)*w3(2)*w5(2)
        x34 = w2(1)*w3(3)*w5(3)
        x35 = w2(0)*w3(2)*w5(0)
        x36 = w3(1)*w5(1)
        x37 = P5(2)*w2(2)
        x38 = w3(3)*w5(3)
        x39 = P5(3)*w3(3)
        x40 = P5(3)*w2(3)
        x41 = w3(2)*w5(2)
        x42 = P2(0)*w3(0)
        x43 = P3(0)*w5(0)
        wp(0,:) = -P2(0)*cima*co(0)*w4(0)*wl(0,:)*x29 + P2(2)*cima*co(0)*w4(0)*&
                  wl(0,:)*x10 + P2(2)*cima*co(0)*w4(0)*wl(0,:)*x11 + P2(2)*cima&
                  *co(0)*w4(0)*wl(0,:)*x12 - P2(2)*cima*co(0)*w4(0)*wl(0,:)*x22&
                   - P2(2)*cima*co(0)*w4(0)*wl(0,:)*x25 - P2(2)*cima*co(0)*w4(0&
                  )*wl(0,:)*x35 - P2(3)*cima*co(0)*w4(0)*wl(0,:)*x27 + P3(0)*  &
                  cima*co(0)*w4(0)*wl(0,:)*x17 + P3(0)*cima*co(0)*w4(0)*wl(0   &
                  ,:)*x18 + P3(0)*cima*co(0)*w4(0)*wl(0,:)*x19 + P3(1)*cima*co(&
                  0)*w4(0)*wl(0,:)*x20 - P3(1)*cima*co(0)*w4(0)*wl(0,:)*x33 -  &
                  P3(1)*cima*co(0)*w4(0)*wl(0,:)*x34 - P3(2)*cima*co(0)*w4(0)* &
                  wl(0,:)*x10 + P3(2)*cima*co(0)*w4(0)*wl(0,:)*x22 + P3(2)*cima&
                  *co(0)*w4(0)*wl(0,:)*x25 + P3(3)*cima*co(0)*w4(0)*wl(0,:)*x27&
                   - P5(0)*cima*co(0)*w4(0)*wl(0,:)*x17 - P5(0)*cima*co(0)*w4(0&
                  )*wl(0,:)*x18 - P5(0)*cima*co(0)*w4(0)*wl(0,:)*x19 + P5(0)*  &
                  cima*co(0)*w4(0)*wl(0,:)*x29 - P5(1)*cima*co(0)*w2(2)*w4(0)* &
                  wl(0,:)*x7 - P5(1)*cima*co(0)*w4(0)*wl(0,:)*x20 + P5(1)*cima*&
                  co(0)*w4(0)*wl(0,:)*x33 + P5(1)*cima*co(0)*w4(0)*wl(0,:)*x34 &
                   - P5(2)*cima*co(0)*w4(0)*wl(0,:)*x11 - P5(2)*cima*co(0)*w4(0&
                  )*wl(0,:)*x12 + P5(2)*cima*co(0)*w4(0)*wl(0,:)*x35 - cima*co(&
                  0)*w3(2)*w4(0)*w5(1)*wl(0,:)*x6 + cima*co(0)*w4(0)*wl(0,:)*x0&
                  *x1 - cima*co(0)*w4(0)*wl(0,:)*x0*x13 + cima*co(0)*w4(0)*wl(0&
                  ,:)*x0*x26 - cima*co(0)*w4(0)*wl(0,:)*x0*x43 + cima*co(0)*w4(&
                  0)*wl(0,:)*x1*x2 + cima*co(0)*w4(0)*wl(0,:)*x1*x3 + cima*co(0&
                  )*w4(0)*wl(0,:)*x13*x4 + cima*co(0)*w4(0)*wl(0,:)*x14*x15 +  &
                  cima*co(0)*w4(0)*wl(0,:)*x14*x16 - cima*co(0)*w4(0)*wl(0,:)* &
                  x14*x31 - cima*co(0)*w4(0)*wl(0,:)*x15*x39 + cima*co(0)*w4(0 &
                  )*wl(0,:)*x16*x30 - cima*co(0)*w4(0)*wl(0,:)*x16*x39 - cima* &
                  co(0)*w4(0)*wl(0,:)*x16*x42 + cima*co(0)*w4(0)*wl(0,:)*x2*x21&
                   - cima*co(0)*w4(0)*wl(0,:)*x2*x43 + cima*co(0)*w4(0)*wl(0   &
                  ,:)*x21*x3 - cima*co(0)*w4(0)*wl(0,:)*x21*x4 + cima*co(0)*w4(&
                  0)*wl(0,:)*x23*x24 - cima*co(0)*w4(0)*wl(0,:)*x23*x36 - cima*&
                  co(0)*w4(0)*wl(0,:)*x23*x38 + cima*co(0)*w4(0)*wl(0,:)*x24*  &
                  x28 - cima*co(0)*w4(0)*wl(0,:)*x24*x37 - cima*co(0)*w4(0)*wl(&
                  0,:)*x24*x40 - cima*co(0)*w4(0)*wl(0,:)*x26*x4 - cima*co(0)* &
                  w4(0)*wl(0,:)*x28*x36 - cima*co(0)*w4(0)*wl(0,:)*x28*x41 -   &
                  cima*co(0)*w4(0)*wl(0,:)*x3*x43 - cima*co(0)*w4(0)*wl(0,:)*x3&
                  *x5 + cima*co(0)*w4(0)*wl(0,:)*x30*x8 + cima*co(0)*w4(0)*wl(0&
                  ,:)*x31*x32 + cima*co(0)*w4(0)*wl(0,:)*x31*x39 - cima*co(0)* &
                  w4(0)*wl(0,:)*x31*x9 - cima*co(0)*w4(0)*wl(0,:)*x32*x8 + cima&
                  *co(0)*w4(0)*wl(0,:)*x36*x37 + cima*co(0)*w4(0)*wl(0,:)*x36* &
                  x40 + cima*co(0)*w4(0)*wl(0,:)*x37*x38 + cima*co(0)*w4(0)*wl(&
                  0,:)*x4*x5 + cima*co(0)*w4(0)*wl(0,:)*x40*x41 - cima*co(0)*w4&
                  (0)*wl(0,:)*x42*x8 + cima*co(0)*w4(0)*wl(0,:)*x6*x7 + cima*co&
                  (0)*w4(0)*wl(0,:)*x8*x9
        wp(1:3,:) = cnul
      end select 
    end subroutine loopSVVSVS
end module lcSVVSVS
