!******************************************************************************!
!                                                                              !
!    lcSVVSVVS.f90                                                             !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcSVVSVVS.f90                                  |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcSVVSVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopSVVSVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4,  &
    P4, PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (kind = dp), intent(in), dimension(0:3) :: P6, PL6
      complex (kind = dp), intent(in), dimension(0:3) :: w6
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(SVVSVVS0)
!       c0*(-2*Metric(2,3)*Metric(5,6) + Metric(2,5)*Metric(3,6) + Metric(2,6)*  
!       Metric(3,5))
        x0 = w5(1)*w6(2)
        x1 = w2(1)*w3(2)
        x2 = w5(2)*w6(1)
        x3 = w3(3)*w6(3)
        x4 = w3(3)*w5(3)
        x5 = w2(2)*w3(1)
        x6 = w2(2)*w5(2)
        x7 = w2(2)*w6(2)
        x8 = w2(3)*w6(3)
        x9 = w2(3)*w5(3)
        x10 = w3(2)*w5(2)
        x11 = w3(2)*w6(2)
        x12 = w5(0)*w6(1)
        x13 = w2(0)*w3(1)
        x14 = w5(1)*w6(0)
        x15 = w2(0)*w5(0)
        x16 = w2(0)*w6(0)
        x17 = w2(1)*w3(0)
        x18 = w3(0)*w5(0)
        x19 = w3(0)*w6(0)
        x20 = 2*w5(2)*w6(2)
        x21 = w2(1)*w3(1)
        x22 = 2*w5(3)*w6(3)
        x23 = 2*w5(1)*w6(1)
        x24 = w2(2)*w3(2)
        x25 = w2(3)*w3(3)
        x26 = w2(0)*w3(0)
        x27 = 2*w5(0)*w6(0)
        wp(0,:) = cima*co(0)*w2(1)*w4(0)*w5(1)*wl(0,:)*x3 + cima*co(0)*w2(1)*w4&
                  (0)*w6(1)*wl(0,:)*x4 + cima*co(0)*w3(1)*w4(0)*w5(1)*wl(0,:)* &
                  x8 + cima*co(0)*w3(1)*w4(0)*w6(1)*wl(0,:)*x9 + cima*co(0)*w4(&
                  0)*wl(0,:)*x0*x1 + cima*co(0)*w4(0)*wl(0,:)*x0*x5 + cima*co(0&
                  )*w4(0)*wl(0,:)*x1*x2 - cima*co(0)*w4(0)*wl(0,:)*x10*x16 +   &
                  cima*co(0)*w4(0)*wl(0,:)*x10*x8 - cima*co(0)*w4(0)*wl(0,:)*  &
                  x11*x15 + cima*co(0)*w4(0)*wl(0,:)*x11*x9 - cima*co(0)*w4(0)*&
                  wl(0,:)*x12*x13 - cima*co(0)*w4(0)*wl(0,:)*x12*x17 - cima*co(&
                  0)*w4(0)*wl(0,:)*x13*x14 - cima*co(0)*w4(0)*wl(0,:)*x14*x17  &
                   - cima*co(0)*w4(0)*wl(0,:)*x15*x3 - cima*co(0)*w4(0)*wl(0   &
                  ,:)*x16*x4 - cima*co(0)*w4(0)*wl(0,:)*x18*x7 - cima*co(0)*w4(&
                  0)*wl(0,:)*x18*x8 - cima*co(0)*w4(0)*wl(0,:)*x19*x6 - cima*co&
                  (0)*w4(0)*wl(0,:)*x19*x9 + cima*co(0)*w4(0)*wl(0,:)*x2*x5 -  &
                  cima*co(0)*w4(0)*wl(0,:)*x20*x21 - cima*co(0)*w4(0)*wl(0,:)* &
                  x20*x25 + cima*co(0)*w4(0)*wl(0,:)*x20*x26 - cima*co(0)*w4(0 &
                  )*wl(0,:)*x21*x22 + cima*co(0)*w4(0)*wl(0,:)*x21*x27 - cima* &
                  co(0)*w4(0)*wl(0,:)*x22*x24 + cima*co(0)*w4(0)*wl(0,:)*x22*  &
                  x26 - cima*co(0)*w4(0)*wl(0,:)*x23*x24 - cima*co(0)*w4(0)*wl(&
                  0,:)*x23*x25 + cima*co(0)*w4(0)*wl(0,:)*x23*x26 + cima*co(0)*&
                  w4(0)*wl(0,:)*x24*x27 + cima*co(0)*w4(0)*wl(0,:)*x25*x27 +   &
                  cima*co(0)*w4(0)*wl(0,:)*x3*x6 + cima*co(0)*w4(0)*wl(0,:)*x4*&
                  x7
        wp(1:3,:) = cnul
      case(SVVSVVS1)
!       c0*(-Metric(2,3)*Metric(5,6) - Metric(2,5)*Metric(3,6) + 2*Metric(2,6)*  
!       Metric(3,5))
        x0 = w2(0)*w3(0)
        x1 = w5(1)*w6(1)
        x2 = w5(2)*w6(2)
        x3 = w5(3)*w6(3)
        x4 = w2(0)*w5(0)
        x5 = w3(1)*w6(1)
        x6 = w3(2)*w6(2)
        x7 = w3(3)*w6(3)
        x8 = w3(0)*w6(0)
        x9 = w2(1)*w5(1)
        x10 = w2(1)*w3(1)
        x11 = w5(0)*w6(0)
        x12 = w2(2)*w5(2)
        x13 = w2(2)*w3(2)
        x14 = w2(3)*w5(3)
        x15 = w2(3)*w3(3)
        x16 = 2*w3(1)*w5(1)
        x17 = w2(0)*w6(0)
        x18 = 2*w3(2)*w5(2)
        x19 = 2*w3(3)*w5(3)
        x20 = 2*w3(0)*w5(0)
        x21 = w2(1)*w6(1)
        x22 = w2(2)*w6(2)
        x23 = w2(3)*w6(3)
        wp(0,:) = cima*co(0)*w4(0)*wl(0,:)*x0*x1 + cima*co(0)*w4(0)*wl(0,:)*x0*&
                  x2 + cima*co(0)*w4(0)*wl(0,:)*x0*x3 - cima*co(0)*w4(0)*wl(0  &
                  ,:)*x1*x13 - cima*co(0)*w4(0)*wl(0,:)*x1*x15 + cima*co(0)*w4(&
                  0)*wl(0,:)*x10*x11 - cima*co(0)*w4(0)*wl(0,:)*x10*x2 - cima* &
                  co(0)*w4(0)*wl(0,:)*x10*x3 + cima*co(0)*w4(0)*wl(0,:)*x11*x13&
                   + cima*co(0)*w4(0)*wl(0,:)*x11*x15 - cima*co(0)*w4(0)*wl(0  &
                  ,:)*x12*x5 - cima*co(0)*w4(0)*wl(0,:)*x12*x7 + cima*co(0)*w4(&
                  0)*wl(0,:)*x12*x8 - cima*co(0)*w4(0)*wl(0,:)*x13*x3 - cima*co&
                  (0)*w4(0)*wl(0,:)*x14*x5 - cima*co(0)*w4(0)*wl(0,:)*x14*x6 + &
                  cima*co(0)*w4(0)*wl(0,:)*x14*x8 - cima*co(0)*w4(0)*wl(0,:)*  &
                  x15*x2 - cima*co(0)*w4(0)*wl(0,:)*x16*x17 + cima*co(0)*w4(0)*&
                  wl(0,:)*x16*x22 + cima*co(0)*w4(0)*wl(0,:)*x16*x23 - cima*co(&
                  0)*w4(0)*wl(0,:)*x17*x18 - cima*co(0)*w4(0)*wl(0,:)*x17*x19  &
                   + cima*co(0)*w4(0)*wl(0,:)*x18*x21 + cima*co(0)*w4(0)*wl(0  &
                  ,:)*x18*x23 + cima*co(0)*w4(0)*wl(0,:)*x19*x21 + cima*co(0)* &
                  w4(0)*wl(0,:)*x19*x22 - cima*co(0)*w4(0)*wl(0,:)*x20*x21 -   &
                  cima*co(0)*w4(0)*wl(0,:)*x20*x22 - cima*co(0)*w4(0)*wl(0,:)* &
                  x20*x23 + cima*co(0)*w4(0)*wl(0,:)*x4*x5 + cima*co(0)*w4(0)* &
                  wl(0,:)*x4*x6 + cima*co(0)*w4(0)*wl(0,:)*x4*x7 - cima*co(0)* &
                  w4(0)*wl(0,:)*x6*x9 - cima*co(0)*w4(0)*wl(0,:)*x7*x9 + cima* &
                  co(0)*w4(0)*wl(0,:)*x8*x9
        wp(1:3,:) = cnul
      case(SVVSVVS2)
!       c0*(-Metric(2,3)*Metric(5,6) + 2*Metric(2,5)*Metric(3,6) - Metric(2,6)*  
!       Metric(3,5))
        x0 = w2(0)*w3(0)
        x1 = w5(3)*w6(3)
        x2 = w2(0)*w6(0)
        x3 = w3(3)*w5(3)
        x4 = w3(0)*w5(0)
        x5 = w2(1)*w6(1)
        x6 = w2(1)*w3(1)
        x7 = w5(0)*w6(0)
        x8 = w2(2)*w6(2)
        x9 = w2(2)*w3(2)
        x10 = w3(1)*w6(2)
        x11 = w2(1)*w5(2)
        x12 = w3(2)*w6(1)
        x13 = w2(2)*w5(1)
        x14 = w2(3)*w5(1)
        x15 = w2(3)*w5(2)
        x16 = w2(0)*w5(0)
        x17 = 2*w3(1)*w6(1)
        x18 = 2*w3(2)*w6(2)
        x19 = 2*w3(3)*w6(3)
        x20 = 2*w3(0)*w6(0)
        x21 = w2(1)*w5(1)
        x22 = w2(2)*w5(2)
        x23 = w2(3)*w5(3)
        wp(0,:) = cima*co(0)*w2(3)*w3(3)*w4(0)*wl(0,:)*x7 + cima*co(0)*w2(3)*w4&
                  (0)*w6(3)*wl(0,:)*x4 + cima*co(0)*w3(1)*w4(0)*w5(1)*wl(0,:)* &
                  x2 - cima*co(0)*w3(1)*w4(0)*w6(3)*wl(0,:)*x14 + cima*co(0)*w3&
                  (2)*w4(0)*w5(2)*wl(0,:)*x2 - cima*co(0)*w3(2)*w4(0)*w6(3)*wl(&
                  0,:)*x15 - cima*co(0)*w3(3)*w4(0)*w6(1)*wl(0,:)*x14 - cima*co&
                  (0)*w3(3)*w4(0)*w6(2)*wl(0,:)*x15 + cima*co(0)*w4(0)*w5(1)*w6&
                  (1)*wl(0,:)*x0 + cima*co(0)*w4(0)*w5(2)*w6(2)*wl(0,:)*x0 +   &
                  cima*co(0)*w4(0)*wl(0,:)*x0*x1 - cima*co(0)*w4(0)*wl(0,:)*x1*&
                  x6 - cima*co(0)*w4(0)*wl(0,:)*x1*x9 - cima*co(0)*w4(0)*wl(0  &
                  ,:)*x10*x11 - cima*co(0)*w4(0)*wl(0,:)*x10*x13 - cima*co(0)* &
                  w4(0)*wl(0,:)*x11*x12 - cima*co(0)*w4(0)*wl(0,:)*x12*x13 -   &
                  cima*co(0)*w4(0)*wl(0,:)*x16*x17 - cima*co(0)*w4(0)*wl(0,:)* &
                  x16*x18 - cima*co(0)*w4(0)*wl(0,:)*x16*x19 + cima*co(0)*w4(0 &
                  )*wl(0,:)*x17*x22 + cima*co(0)*w4(0)*wl(0,:)*x17*x23 + cima* &
                  co(0)*w4(0)*wl(0,:)*x18*x21 + cima*co(0)*w4(0)*wl(0,:)*x18*  &
                  x23 + cima*co(0)*w4(0)*wl(0,:)*x19*x21 + cima*co(0)*w4(0)*wl(&
                  0,:)*x19*x22 + cima*co(0)*w4(0)*wl(0,:)*x2*x3 - cima*co(0)*w4&
                  (0)*wl(0,:)*x20*x21 - cima*co(0)*w4(0)*wl(0,:)*x20*x22 - cima&
                  *co(0)*w4(0)*wl(0,:)*x20*x23 - cima*co(0)*w4(0)*wl(0,:)*x3*x5&
                   - cima*co(0)*w4(0)*wl(0,:)*x3*x8 + cima*co(0)*w4(0)*wl(0,:)*&
                  x4*x5 + cima*co(0)*w4(0)*wl(0,:)*x4*x8 + cima*co(0)*w4(0)*wl(&
                  0,:)*x6*x7 + cima*co(0)*w4(0)*wl(0,:)*x7*x9
        wp(1:3,:) = cnul
      end select 
    end subroutine loopSVVSVVS
end module lcSVVSVVS
