!******************************************************************************!
!                                                                              !
!    lcVSSVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSSVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopVSSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, m, wp, riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSSVS0)
!       P(1,4)*P(4,1)*c0
!       Metric(1,4)*P(-1,1)*P(-1,4)*c1
        x1 = P1(0)*co(0)*w4(0)
        x2 = P1(1)*P4(1)
        x7 = P1(1)*co(0)*w4(1)
        x10 = P1(2)*co(0)*w4(2)
        x11 = P1(2)*P4(2)
        x12 = P1(3)*co(0)*w4(3)
        x13 = P1(3)*P4(3)
        x14 = P1(0)*P4(0)
        x16 = cima*w2(0)*w3(0)
        do j = riMaxIn, 0, -1
          x0 = P4(0)*wl(0,j)
          x3 = co(1)*w4(1)*wl(1,j)
          x4 = co(1)*w4(2)*wl(2,j)
          x5 = co(1)*w4(3)*wl(3,j)
          x6 = P4(2)*wl(2,j)
          x8 = P4(3)*wl(3,j)
          x9 = P4(1)*wl(1,j)
          x15 = co(1)*w4(0)*wl(0,j)
          wp(0,j) = P1(0)*co(1)*w4(0)*x0*x16 + P1(3)*co(1)*w4(3)*x16*x8 + co(0 &
                    )*w4(1)*wl(1,j)*x16*x2 + co(0)*w4(2)*wl(2,j)*x11*x16 + x0* &
                    x1*x16 - x0*x10*x16 - x0*x12*x16 - x0*x16*x7 - x1*x16*x6 - &
                    x1*x16*x8 - x1*x16*x9 + x10*x16*x8 + x10*x16*x9 - x11*x15* &
                    x16 + x11*x16*x3 + x11*x16*x4 + x11*x16*x5 + x12*x16*x6 +  &
                    x12*x16*x8 + x12*x16*x9 - x13*x15*x16 + x13*x16*x3 + x13*  &
                    x16*x4 - x14*x16*x3 - x14*x16*x4 - x14*x16*x5 - x15*x16*x2 &
                     + x16*x2*x3 + x16*x2*x4 + x16*x2*x5 + x16*x6*x7 + x16*x7* &
                    x8
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x17 = co(0)*w4(mu)
            x18 = P4(mu)*co(1)
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) + w4(0)*wl(0,j)*x16*x18 - w4(1)*wl(1,j)* &
                          x16*x18 - w4(2)*wl(2,j)*x16*x18 - w4(3)*wl(3,j)*x16* &
                          x18 + x0*x16*x17 - x16*x17*x6 - x16*x17*x8 - x16*x17*&
                          x9
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVSSVS
end module lcVSSVS
