!******************************************************************************!
!                                                                              !
!    lcVSSVVS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSSVVS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSSVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopVSSVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSSVVS0)
!       c0*(Metric(1,4)*P(5,1) - Metric(1,4)*P(5,4) - Metric(1,5)*P(4,1) + Metric
!       (1,5)*P(4,5) + Metric(4,5)*P(1,4) - Metric(4,5)*P(1,5))
        x1 = P1(0)*w5(0)
        x5 = P1(1)*w5(1)
        x7 = P1(1)*w4(1)
        x9 = P1(2)*w5(2)
        x11 = P1(2)*w4(2)
        x12 = P1(3)*w5(3)
        x13 = P1(3)*w4(3)
        x15 = w4(1)*w5(1)
        x16 = w4(2)*w5(2)
        x17 = w4(3)*w5(3)
        x18 = w4(0)*w5(0)
        x20 = P4(1)*w5(1)
        x22 = P4(2)*w5(2)
        x24 = P4(3)*w5(3)
        x25 = P5(0)*w4(0)
        x27 = P5(1)*w4(1)
        x30 = P5(2)*w4(2)
        x33 = P5(3)*w4(3)
        x34 = P1(0)*w4(0)
        x35 = P4(0)*w5(0)
        x37 = cima*co(0)*w2(0)*w3(0)
        do j = riMaxIn, 0, -1
          x0 = w4(1)*wl(1,j)
          x2 = w4(2)*wl(2,j)
          x3 = w4(3)*wl(3,j)
          x4 = w4(0)*wl(0,j)
          x6 = w5(2)*wl(2,j)
          x8 = w5(3)*wl(3,j)
          x10 = w5(1)*wl(1,j)
          x14 = P4(0)*wl(0,j)
          x19 = P4(1)*wl(1,j)
          x21 = P4(2)*wl(2,j)
          x23 = P4(3)*wl(3,j)
          x26 = w5(0)*wl(0,j)
          x28 = P5(1)*wl(1,j)
          x29 = P5(2)*wl(2,j)
          x31 = w4(1)*w5(1)*wl(3,j)
          x32 = P5(3)*wl(3,j)
          x36 = P5(0)*wl(0,j)
          wp(0,j) = -P4(3)*x31*x37 + P5(3)*x31*x37 + x0*x1*x37 - x0*x12*x37 +  &
                    x0*x22*x37 + x0*x24*x37 - x0*x35*x37 - x0*x37*x9 + x1*x2*  &
                    x37 + x1*x3*x37 + x10*x11*x37 + x10*x13*x37 + x10*x25*x37  &
                     - x10*x30*x37 - x10*x33*x37 - x10*x34*x37 - x11*x26*x37 + &
                    x11*x37*x8 - x12*x2*x37 + x12*x37*x4 - x13*x26*x37 + x13*  &
                    x37*x6 + x14*x15*x37 + x14*x16*x37 + x14*x17*x37 - x15*x21*&
                    x37 + x15*x29*x37 - x15*x36*x37 - x16*x19*x37 - x16*x23*x37&
                     + x16*x28*x37 + x16*x32*x37 - x16*x36*x37 - x17*x19*x37 - &
                    x17*x21*x37 + x17*x28*x37 + x17*x29*x37 - x17*x36*x37 + x18&
                    *x19*x37 + x18*x21*x37 + x18*x23*x37 - x18*x28*x37 - x18*  &
                    x29*x37 - x18*x32*x37 + x2*x20*x37 + x2*x24*x37 - x2*x35*  &
                    x37 - x2*x37*x5 + x20*x3*x37 - x20*x37*x4 + x22*x3*x37 -   &
                    x22*x37*x4 - x24*x37*x4 + x25*x37*x6 + x25*x37*x8 + x26*x27&
                    *x37 + x26*x30*x37 + x26*x33*x37 - x26*x37*x7 - x27*x37*x6 &
                     - x27*x37*x8 - x3*x35*x37 - x3*x37*x5 - x3*x37*x9 - x30*  &
                    x37*x8 - x33*x37*x6 - x34*x37*x6 - x34*x37*x8 + x37*x4*x5  &
                     + x37*x4*x9 + x37*x6*x7 + x37*x7*x8
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - w4(mu)*x10*x37 + w4(mu)*x26*x37 - w4(mu&
                          )*x37*x6 - w4(mu)*x37*x8 + w5(mu)*x0*x37 + w5(mu)*x2*&
                          x37 + w5(mu)*x3*x37 - w5(mu)*x37*x4
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVSSVVS
end module lcVSSVVS
