!******************************************************************************!
!                                                                              !
!    lcVSSVVVS.f90                                                             !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSSVVVS.f90                                  |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSSVVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopVSSVVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4,  &
    P4, PL4, w5, P5, PL5, w6, P6, PL6, m, wp, riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (kind = dp), intent(in), dimension(0:3) :: P6, PL6
      complex (kind = dp), intent(in), dimension(0:3) :: w6
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSSVVVS0)
!       c0*(-2*Metric(1,4)*Metric(5,6) + Metric(1,5)*Metric(4,6) + Metric(1,6)*  
!       Metric(4,5))
        x2 = w5(1)*w6(3)
        x4 = w5(3)*w6(1)
        x5 = w4(2)*w6(2)
        x6 = w4(2)*w5(2)
        x10 = w4(0)*w5(0)
        x11 = w5(1)*w6(0)
        x12 = w5(3)*w6(0)
        x17 = 2*w5(1)*w6(1)
        x18 = 2*w5(3)*w6(3)
        x20 = 2*w5(2)*w6(2)
        x22 = 2*w5(0)*w6(0)
        do j = riMaxIn, 0, -1
          x0 = w6(2)*wl(2,j)
          x1 = w4(1)*wl(3,j)
          x3 = w5(2)*wl(2,j)
          x7 = w6(1)*wl(1,j)
          x8 = w6(3)*wl(3,j)
          x9 = w4(3)*wl(1,j)
          x13 = w4(1)*wl(0,j)
          x14 = w4(3)*wl(0,j)
          x15 = 2*w4(1)*wl(1,j)
          x16 = w4(2)*wl(2,j)
          x19 = w4(3)*wl(3,j)
          x21 = w4(0)*wl(0,j)
          wp(0,j) = -cima*co(0)*w2(0)*w3(0)*w4(0)*w6(0)*x3 - cima*co(0)*w2(0)* &
                    w3(0)*w4(0)*wl(1,j)*x11 - cima*co(0)*w2(0)*w3(0)*w4(0)*wl(3&
                    ,j)*x12 + cima*co(0)*w2(0)*w3(0)*w4(1)*w5(1)*x0 + cima*co(0&
                    )*w2(0)*w3(0)*w4(1)*w6(1)*x3 + cima*co(0)*w2(0)*w3(0)*w4(3 &
                    )*w5(3)*x0 + cima*co(0)*w2(0)*w3(0)*w4(3)*w6(3)*x3 + cima* &
                    co(0)*w2(0)*w3(0)*w5(0)*w6(0)*x15 - cima*co(0)*w2(0)*w3(0)*&
                    w5(0)*w6(1)*x13 - cima*co(0)*w2(0)*w3(0)*w5(0)*w6(3)*x14 - &
                    cima*co(0)*w2(0)*w3(0)*w5(0)*wl(0,j)*x5 + cima*co(0)*w2(0)*&
                    w3(0)*w5(1)*wl(1,j)*x5 - cima*co(0)*w2(0)*w3(0)*w5(2)*w6(2 &
                    )*x15 - cima*co(0)*w2(0)*w3(0)*w5(3)*w6(3)*x15 + cima*co(0 &
                    )*w2(0)*w3(0)*w5(3)*wl(3,j)*x5 - cima*co(0)*w2(0)*w3(0)*w6(&
                    0)*wl(0,j)*x6 - cima*co(0)*w2(0)*w3(0)*x0*x10 + cima*co(0)*&
                    w2(0)*w3(0)*x1*x2 + cima*co(0)*w2(0)*w3(0)*x1*x4 - cima*co(&
                    0)*w2(0)*w3(0)*x10*x7 - cima*co(0)*w2(0)*w3(0)*x10*x8 -    &
                    cima*co(0)*w2(0)*w3(0)*x11*x13 - cima*co(0)*w2(0)*w3(0)*x12&
                    *x14 - cima*co(0)*w2(0)*w3(0)*x16*x17 - cima*co(0)*w2(0)*w3&
                    (0)*x16*x18 + cima*co(0)*w2(0)*w3(0)*x16*x22 - cima*co(0)* &
                    w2(0)*w3(0)*x17*x19 + cima*co(0)*w2(0)*w3(0)*x17*x21 + cima&
                    *co(0)*w2(0)*w3(0)*x18*x21 - cima*co(0)*w2(0)*w3(0)*x19*x20&
                     + cima*co(0)*w2(0)*w3(0)*x19*x22 + cima*co(0)*w2(0)*w3(0)*&
                    x2*x9 + cima*co(0)*w2(0)*w3(0)*x20*x21 + cima*co(0)*w2(0)* &
                    w3(0)*x4*x9 + cima*co(0)*w2(0)*w3(0)*x6*x7 + cima*co(0)*w2(&
                    0)*w3(0)*x6*x8
        end do 
        wp(1:3,:) = cnul
      case(VSSVVVS1)
!       c0*(-Metric(1,4)*Metric(5,6) - Metric(1,5)*Metric(4,6) + 2*Metric(1,6)*  
!       Metric(4,5))
        x1 = w4(0)*w5(1)
        x3 = w4(0)*w5(2)
        x5 = w4(0)*w5(3)
        x7 = w4(1)*w6(1)
        x9 = w4(2)*w6(2)
        x10 = w4(3)*w5(0)
        x12 = w4(1)*w5(2)
        x16 = w4(2)*w5(1)
        x18 = w4(3)*w5(1)
        x19 = w4(3)*w5(2)
        x20 = 2*w4(0)*w5(0)
        x24 = 2*w4(1)*w5(1)
        x26 = 2*w4(2)*w5(2)
        x27 = 2*w4(3)*w5(3)
        do j = riMaxIn, 0, -1
          x0 = w6(0)*wl(1,j)
          x2 = w6(0)*wl(2,j)
          x4 = w6(0)*wl(3,j)
          x6 = w6(3)*wl(0,j)
          x8 = w5(0)*wl(0,j)
          x11 = w6(1)*wl(2,j)
          x13 = w6(2)*wl(1,j)
          x14 = w5(3)*wl(3,j)
          x15 = w6(3)*wl(1,j)
          x17 = w6(3)*wl(2,j)
          x21 = w6(1)*wl(1,j)
          x22 = w6(2)*wl(2,j)
          x23 = w6(3)*wl(3,j)
          x25 = w6(0)*wl(0,j)
          wp(0,j) = cima*co(0)*w2(0)*w3(0)*w4(1)*w5(0)*x0 - cima*co(0)*w2(0)*w3&
                    (0)*w4(1)*w5(3)*x15 + cima*co(0)*w2(0)*w3(0)*w4(2)*w5(0)*x2&
                     - cima*co(0)*w2(0)*w3(0)*w4(2)*w5(3)*x17 + cima*co(0)*w2(0&
                    )*w3(0)*w6(1)*wl(0,j)*x1 - cima*co(0)*w2(0)*w3(0)*w6(1)*wl(&
                    3,j)*x18 + cima*co(0)*w2(0)*w3(0)*w6(2)*wl(0,j)*x3 - cima* &
                    co(0)*w2(0)*w3(0)*w6(2)*wl(3,j)*x19 + cima*co(0)*w2(0)*w3(0&
                    )*x0*x1 + cima*co(0)*w2(0)*w3(0)*x10*x4 + cima*co(0)*w2(0)*&
                    w3(0)*x10*x6 - cima*co(0)*w2(0)*w3(0)*x11*x12 - cima*co(0)*&
                    w2(0)*w3(0)*x11*x16 - cima*co(0)*w2(0)*w3(0)*x12*x13 - cima&
                    *co(0)*w2(0)*w3(0)*x13*x16 - cima*co(0)*w2(0)*w3(0)*x14*x7 &
                     - cima*co(0)*w2(0)*w3(0)*x14*x9 - cima*co(0)*w2(0)*w3(0)* &
                    x15*x18 - cima*co(0)*w2(0)*w3(0)*x17*x19 + cima*co(0)*w2(0 &
                    )*w3(0)*x2*x3 - cima*co(0)*w2(0)*w3(0)*x20*x21 - cima*co(0 &
                    )*w2(0)*w3(0)*x20*x22 - cima*co(0)*w2(0)*w3(0)*x20*x23 +   &
                    cima*co(0)*w2(0)*w3(0)*x21*x26 + cima*co(0)*w2(0)*w3(0)*x21&
                    *x27 + cima*co(0)*w2(0)*w3(0)*x22*x24 + cima*co(0)*w2(0)*w3&
                    (0)*x22*x27 + cima*co(0)*w2(0)*w3(0)*x23*x24 + cima*co(0)* &
                    w2(0)*w3(0)*x23*x26 - cima*co(0)*w2(0)*w3(0)*x24*x25 - cima&
                    *co(0)*w2(0)*w3(0)*x25*x26 - cima*co(0)*w2(0)*w3(0)*x25*x27&
                     + cima*co(0)*w2(0)*w3(0)*x4*x5 + cima*co(0)*w2(0)*w3(0)*x5&
                    *x6 + cima*co(0)*w2(0)*w3(0)*x7*x8 + cima*co(0)*w2(0)*w3(0 &
                    )*x8*x9
        end do 
        wp(1:3,:) = cnul
      case(VSSVVVS2)
!       c0*(-Metric(1,4)*Metric(5,6) + 2*Metric(1,5)*Metric(4,6) - Metric(1,6)*  
!       Metric(4,5))
        x0 = w4(0)*w6(1)
        x2 = w4(0)*w6(2)
        x5 = w5(3)*w6(3)
        x6 = w4(1)*w6(0)
        x7 = w5(0)*w6(0)
        x9 = w4(2)*w5(2)
        x12 = w4(3)*w5(3)
        x14 = w4(1)*w6(2)
        x15 = w4(1)*w6(3)
        x18 = w4(2)*w6(1)
        x20 = w4(0)*w6(0)
        x23 = 2*w4(1)*w6(1)
        x25 = 2*w4(2)*w6(2)
        x26 = w4(3)*w6(3)
        do j = riMaxIn, 0, -1
          x1 = w5(0)*wl(1,j)
          x3 = w6(3)*wl(3,j)
          x4 = w5(1)*wl(0,j)
          x8 = w4(2)*wl(2,j)
          x10 = w6(0)*wl(0,j)
          x11 = w4(3)*wl(3,j)
          x13 = w5(1)*wl(2,j)
          x16 = w5(2)*wl(1,j)
          x17 = w5(3)*wl(1,j)
          x19 = 2*w5(1)*wl(1,j)
          x21 = 2*w5(2)*wl(2,j)
          x22 = w5(3)*wl(3,j)
          x24 = w5(0)*wl(0,j)
          wp(0,j) = cima*co(0)*w2(0)*w3(0)*w4(0)*w5(0)*x3 - 2*cima*co(0)*w2(0)*&
                    w3(0)*w4(0)*w6(0)*x22 + cima*co(0)*w2(0)*w3(0)*w4(0)*wl(0,j&
                    )*x5 + cima*co(0)*w2(0)*w3(0)*w4(2)*w6(2)*x19 - cima*co(0)*&
                    w2(0)*w3(0)*w4(3)*w6(1)*x17 - 2*cima*co(0)*w2(0)*w3(0)*w4(3&
                    )*w6(3)*x24 + cima*co(0)*w2(0)*w3(0)*w5(0)*wl(2,j)*x2 -    &
                    cima*co(0)*w2(0)*w3(0)*w5(1)*w6(1)*x11 - cima*co(0)*w2(0)* &
                    w3(0)*w5(1)*wl(3,j)*x15 - cima*co(0)*w2(0)*w3(0)*w5(2)*w6(2&
                    )*x11 + cima*co(0)*w2(0)*w3(0)*w5(2)*wl(0,j)*x2 + cima*co(0&
                    )*w2(0)*w3(0)*w5(2)*wl(2,j)*x23 - cima*co(0)*w2(0)*w3(0)*w6&
                    (2)*wl(2,j)*x12 + cima*co(0)*w2(0)*w3(0)*x0*x1 + cima*co(0 &
                    )*w2(0)*w3(0)*x0*x4 + cima*co(0)*w2(0)*w3(0)*x1*x6 + cima* &
                    co(0)*w2(0)*w3(0)*x10*x12 + cima*co(0)*w2(0)*w3(0)*x10*x9  &
                     + cima*co(0)*w2(0)*w3(0)*x11*x7 - cima*co(0)*w2(0)*w3(0)* &
                    x13*x14 - cima*co(0)*w2(0)*w3(0)*x13*x18 - cima*co(0)*w2(0 &
                    )*w3(0)*x14*x16 - cima*co(0)*w2(0)*w3(0)*x15*x17 - cima*co(&
                    0)*w2(0)*w3(0)*x16*x18 - cima*co(0)*w2(0)*w3(0)*x19*x20 +  &
                    cima*co(0)*w2(0)*w3(0)*x19*x26 - cima*co(0)*w2(0)*w3(0)*x20&
                    *x21 + cima*co(0)*w2(0)*w3(0)*x21*x26 + cima*co(0)*w2(0)*w3&
                    (0)*x22*x23 + cima*co(0)*w2(0)*w3(0)*x22*x25 - cima*co(0)* &
                    w2(0)*w3(0)*x23*x24 - cima*co(0)*w2(0)*w3(0)*x24*x25 - cima&
                    *co(0)*w2(0)*w3(0)*x3*x9 + cima*co(0)*w2(0)*w3(0)*x4*x6 -  &
                    cima*co(0)*w2(0)*w3(0)*x5*x8 + cima*co(0)*w2(0)*w3(0)*x7*x8
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVSSVVVS
end module lcVSSVVVS
