!******************************************************************************!
!                                                                              !
!    lcVSVSVS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSVSVS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSVSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopVSVSVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSVSVS0)
!       c0*(Metric(1,3)*P(5,1) - Metric(1,3)*P(5,3) - Metric(1,5)*P(3,1) + Metric
!       (1,5)*P(3,5) + Metric(3,5)*P(1,3) - Metric(3,5)*P(1,5))
        x2 = P1(0)*w5(0)
        x5 = P1(1)*w5(1)
        x7 = P1(1)*w3(1)
        x9 = P1(2)*w5(2)
        x12 = P1(3)*w5(3)
        x14 = P1(3)*w3(3)
        x16 = w3(2)*w5(2)
        x18 = w3(3)*w5(3)
        x20 = P3(1)*w5(1)
        x23 = P3(2)*w5(2)
        x25 = P3(3)*w5(3)
        x30 = P5(1)*w3(1)
        x32 = w3(1)*w5(1)
        x37 = P5(3)*w3(3)
        x38 = P3(0)*w5(0)
        x42 = cima*co(0)*w2(0)*w4(0)
        do j = riMaxIn, 0, -1
          x0 = w3(1)*w5(0)*wl(1,j)
          x1 = w3(2)*wl(2,j)
          x3 = w3(3)*wl(3,j)
          x4 = w3(0)*wl(0,j)
          x6 = w5(2)*wl(2,j)
          x8 = w3(1)*w5(3)*wl(3,j)
          x10 = w3(2)*w5(1)*wl(1,j)
          x11 = w3(2)*w5(3)*wl(3,j)
          x13 = w5(1)*wl(1,j)
          x15 = w3(1)*w5(1)*wl(0,j)
          x17 = P3(0)*wl(0,j)
          x19 = w3(0)*w5(0)*wl(1,j)
          x21 = w3(0)*w5(0)*wl(2,j)
          x22 = w3(1)*wl(1,j)
          x24 = w3(0)*w5(0)*wl(3,j)
          x26 = w3(0)*w5(1)*wl(1,j)
          x27 = w3(0)*w5(2)*wl(2,j)
          x28 = w3(0)*w5(3)*wl(3,j)
          x29 = w5(0)*wl(0,j)
          x31 = P5(1)*wl(1,j)
          x33 = P5(2)*wl(2,j)
          x34 = w3(2)*w5(0)*wl(0,j)
          x35 = w3(1)*w5(1)*wl(3,j)
          x36 = w3(2)*w5(2)*wl(3,j)
          x39 = P3(1)*wl(1,j)
          x40 = P3(2)*wl(2,j)
          x41 = P5(0)*wl(0,j)
          wp(0,j) = P1(0)*x0*x42 - P1(0)*x26*x42 - P1(0)*x27*x42 - P1(0)*x28*  &
                    x42 + P1(1)*x42*x8 + P1(2)*x10*x42 + P1(2)*x11*x42 - P1(2)*&
                    x34*x42 - P3(0)*x0*x42 + P3(0)*x15*x42 + P3(1)*x19*x42 + P3&
                    (2)*x21*x42 + P3(3)*x24*x42 - P3(3)*x35*x42 - P3(3)*x36*x42&
                     - P5(0)*x15*x42 + P5(0)*x26*x42 + P5(0)*x27*x42 + P5(0)*  &
                    x28*x42 - P5(1)*x19*x42 - P5(1)*x42*x8 - P5(2)*x10*x42 - P5&
                    (2)*x11*x42 - P5(2)*x21*x42 + P5(2)*x34*x42 - P5(3)*x24*x42&
                     + P5(3)*x35*x42 + P5(3)*x36*x42 - x1*x12*x42 + x1*x2*x42  &
                     + x1*x20*x42 + x1*x25*x42 - x1*x38*x42 - x1*x42*x5 - x12* &
                    x22*x42 + x12*x4*x42 + x13*x14*x42 - x13*x37*x42 - x14*x29*&
                    x42 + x14*x42*x6 + x16*x17*x42 + x16*x31*x42 - x16*x39*x42 &
                     - x16*x41*x42 + x17*x18*x42 + x18*x31*x42 + x18*x33*x42 - &
                    x18*x39*x42 - x18*x40*x42 - x18*x41*x42 + x2*x3*x42 + x20* &
                    x3*x42 - x20*x4*x42 + x22*x23*x42 + x22*x25*x42 - x22*x42* &
                    x9 + x23*x3*x42 - x23*x4*x42 - x25*x4*x42 + x29*x30*x42 +  &
                    x29*x37*x42 - x29*x42*x7 - x3*x38*x42 - x3*x42*x5 - x3*x42*&
                    x9 - x30*x42*x6 + x32*x33*x42 - x32*x40*x42 - x37*x42*x6 + &
                    x4*x42*x5 + x4*x42*x9 + x42*x6*x7
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - w3(mu)*w5(3)*wl(3,j)*x42 - w3(mu)*x13* &
                          x42 + w3(mu)*x29*x42 - w3(mu)*x42*x6 + w5(mu)*x1*x42 &
                           + w5(mu)*x22*x42 + w5(mu)*x3*x42 - w5(mu)*x4*x42
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVSVSVS
end module lcVSVSVS
