!******************************************************************************!
!                                                                              !
!    lcVSVVSS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVSVVSS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVSVVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopVSVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VSVVSS0)
!       c0*(Metric(1,3)*P(4,1) - Metric(1,3)*P(4,3) - Metric(1,4)*P(3,1) + Metric
!       (1,4)*P(3,4) + Metric(3,4)*P(1,3) - Metric(3,4)*P(1,4))
        x1 = P1(0)*w4(0)
        x6 = P1(1)*w3(1)
        x9 = P1(2)*w4(2)
        x11 = P1(2)*w3(2)
        x12 = P1(3)*w4(3)
        x13 = P1(3)*w3(3)
        x15 = w3(1)*w4(1)
        x17 = w3(2)*w4(2)
        x19 = w3(0)*w4(0)
        x24 = P3(2)*w4(2)
        x26 = P3(3)*w4(3)
        x27 = P4(0)*w3(0)
        x29 = P4(1)*w3(1)
        x31 = w3(3)*w4(3)
        x33 = P4(2)*w3(2)
        x36 = P4(3)*w3(3)
        x37 = P1(0)*w3(0)
        x38 = P3(0)*w4(0)
        x40 = cima*co(0)*w2(0)*w5(0)
        do j = riMaxIn, 0, -1
          x0 = w3(1)*wl(1,j)
          x2 = w3(2)*wl(2,j)
          x3 = w3(3)*wl(3,j)
          x4 = w3(0)*w4(1)*wl(0,j)
          x5 = w4(2)*wl(2,j)
          x7 = w4(3)*wl(3,j)
          x8 = w3(0)*wl(0,j)
          x10 = w4(1)*wl(1,j)
          x14 = w3(3)*w4(2)*wl(2,j)
          x16 = P3(0)*wl(0,j)
          x18 = w3(3)*w4(3)*wl(0,j)
          x20 = P3(1)*wl(1,j)
          x21 = w3(2)*w4(1)*wl(2,j)
          x22 = w3(3)*w4(1)*wl(3,j)
          x23 = w3(0)*w4(0)*wl(2,j)
          x25 = P3(3)*wl(3,j)
          x28 = w4(0)*wl(0,j)
          x30 = P4(1)*wl(1,j)
          x32 = w3(1)*w4(1)*wl(2,j)
          x34 = w3(3)*w4(3)*wl(2,j)
          x35 = P4(3)*wl(3,j)
          x39 = P4(0)*wl(0,j)
          wp(0,j) = -P1(1)*x21*x40 - P1(1)*x22*x40 + P1(1)*x4*x40 + P1(3)*x14* &
                    x40 + P3(0)*x18*x40 + P3(1)*x21*x40 + P3(1)*x22*x40 - P3(1 &
                    )*x4*x40 + P3(2)*x23*x40 - P3(2)*x32*x40 - P3(2)*x34*x40 - &
                    P4(0)*x18*x40 - P4(2)*x23*x40 + P4(2)*x32*x40 + P4(2)*x34* &
                    x40 - P4(3)*x14*x40 + x0*x1*x40 - x0*x12*x40 + x0*x24*x40  &
                     + x0*x26*x40 - x0*x38*x40 - x0*x40*x9 + x1*x2*x40 + x1*x3*&
                    x40 + x10*x11*x40 + x10*x13*x40 + x10*x27*x40 - x10*x33*x40&
                     - x10*x36*x40 - x10*x37*x40 - x11*x28*x40 + x11*x40*x7 -  &
                    x12*x2*x40 + x12*x40*x8 - x13*x28*x40 + x15*x16*x40 - x15* &
                    x25*x40 + x15*x35*x40 - x15*x39*x40 + x16*x17*x40 - x17*x20&
                    *x40 - x17*x25*x40 + x17*x30*x40 + x17*x35*x40 - x17*x39*  &
                    x40 + x19*x20*x40 + x19*x25*x40 - x19*x30*x40 - x19*x35*x40&
                     + x2*x26*x40 - x2*x38*x40 - x20*x31*x40 + x24*x3*x40 - x24&
                    *x40*x8 - x26*x40*x8 + x27*x40*x5 + x27*x40*x7 + x28*x29*  &
                    x40 + x28*x33*x40 + x28*x36*x40 - x28*x40*x6 - x29*x40*x5  &
                     - x29*x40*x7 - x3*x38*x40 - x3*x40*x9 + x30*x31*x40 - x33*&
                    x40*x7 - x37*x40*x5 - x37*x40*x7 + x40*x5*x6 + x40*x6*x7 + &
                    x40*x8*x9
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - w3(mu)*x10*x40 + w3(mu)*x28*x40 - w3(mu&
                          )*x40*x5 - w3(mu)*x40*x7 + w4(mu)*x0*x40 + w4(mu)*x2*&
                          x40 + w4(mu)*x3*x40 - w4(mu)*x40*x8
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVSVVSS
end module lcVSVVSS
