!******************************************************************************!
!                                                                              !
!    lcVVS.f90                                                                 !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVVS.f90                                      |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopVVS(ty, co, wl, P1, PL1, w2, P2, PL2, m, wp, riMaxIn,       &
    riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VVS0)
!       P(1,2)*P(2,1)*c0
!       Metric(1,2)*P(-1,1)*P(-1,2)*c1
        x1 = P1(0)*co(0)*w2(0)
        x2 = P1(1)*P2(1)
        x5 = P1(1)*P2(1)*co(1)
        x9 = P1(1)*co(0)*w2(1)
        x11 = P1(2)*co(0)*w2(2)
        x12 = P1(2)*w2(2)
        x13 = P1(2)*P2(2)
        x14 = P1(3)*co(0)*w2(3)
        x16 = P1(3)*P2(3)
        x18 = P1(0)*P2(0)
        do j = riMaxIn, 0, -1
          x0 = P2(0)*wl(0,j)
          x3 = co(1)*w2(1)*wl(1,j)
          x4 = w2(2)*wl(2,j)
          x6 = co(1)*w2(3)*wl(3,j)
          x7 = P2(2)*co(0)*wl(2,j)
          x8 = P2(3)*wl(3,j)
          x10 = P2(1)*wl(1,j)
          x15 = P2(2)*wl(2,j)
          x17 = co(1)*w2(2)*wl(2,j)
          x19 = w2(0)*wl(0,j)
          x20 = co(1)*w2(0)*wl(0,j)
          wp(0,j) = P1(0)*cima*co(1)*w2(0)*x0 + P1(1)*cima*w2(1)*x7 + P2(2)*   &
                    cima*co(1)*wl(2,j)*x12 + cima*co(0)*w2(1)*wl(1,j)*x2 + cima&
                    *co(0)*w2(3)*wl(3,j)*x16 + cima*x0*x1 - cima*x0*x11 - cima*&
                    x0*x14 - cima*x0*x9 - cima*x1*x10 - cima*x1*x15 - cima*x1* &
                    x8 + cima*x10*x11 + cima*x10*x14 + cima*x11*x8 + cima*x12* &
                    x7 - cima*x13*x20 + cima*x13*x3 + cima*x13*x6 + cima*x14*  &
                    x15 + cima*x16*x17 - cima*x16*x20 + cima*x16*x3 + cima*x16*&
                    x6 - cima*x17*x18 - cima*x18*x3 - cima*x18*x6 - cima*x19*x5&
                     + cima*x2*x3 + cima*x2*x6 + cima*x4*x5 + cima*x8*x9
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x21 = co(0)*w2(mu)
            x22 = P2(mu)*co(1)
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - cima*w2(1)*wl(1,j)*x22 - cima*w2(3)*wl(&
                          3,j)*x22 + cima*x0*x21 - cima*x10*x21 - cima*x15*x21 &
                           + cima*x19*x22 - cima*x21*x8 - cima*x22*x4
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVVS
end module lcVVS
