!******************************************************************************!
!                                                                              !
!    lcVVSS.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVVSS.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,  &
    riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VVSS0)
!       P(1,2)*P(2,1)*c0
!       Metric(1,2)*P(-1,1)*P(-1,2)*c1
        x1 = P1(0)*co(0)*w2(0)
        x4 = P1(1)*P2(1)*co(1)
        x8 = P1(1)*co(0)*w2(1)
        x10 = P1(2)*co(0)*w2(2)
        x11 = P1(2)*w2(2)
        x13 = P1(2)*P2(2)*co(1)
        x14 = P1(3)*co(0)*w2(3)
        x16 = P1(3)*P2(3)
        x17 = P1(3)*P2(3)*co(1)
        x18 = P1(0)*P2(0)*co(1)
        x20 = cima*w3(0)
        do j = riMaxIn, 0, -1
          x0 = P2(0)*wl(0,j)
          x2 = P1(1)*P2(1)*w2(1)*wl(1,j)
          x3 = w2(2)*wl(2,j)
          x5 = co(1)*w2(3)*wl(3,j)
          x6 = P2(2)*co(0)*wl(2,j)
          x7 = P2(3)*wl(3,j)
          x9 = P2(1)*wl(1,j)
          x12 = w2(1)*wl(1,j)
          x15 = P2(2)*wl(2,j)
          x19 = w2(0)*wl(0,j)
          wp(0,j) = P1(0)*P2(0)*co(1)*w2(0)*wl(0,j)*x20 - P1(0)*P2(0)*x20*x5 + &
                    P1(1)*P2(1)*x20*x5 + P1(1)*w2(1)*x20*x6 + P1(2)*P2(2)*x20* &
                    x5 + P2(2)*co(1)*wl(2,j)*x11*x20 + co(0)*w2(3)*wl(3,j)*x16*&
                    x20 + co(0)*x2*x20 + co(1)*x2*x20 + x0*x1*x20 - x0*x10*x20 &
                     - x0*x14*x20 - x0*x20*x8 - x1*x15*x20 - x1*x20*x7 - x1*x20&
                    *x9 + x10*x20*x7 + x10*x20*x9 + x11*x20*x6 + x12*x13*x20 + &
                    x12*x17*x20 - x12*x18*x20 - x13*x19*x20 + x14*x15*x20 + x14&
                    *x20*x9 + x16*x20*x5 - x17*x19*x20 + x17*x20*x3 - x18*x20* &
                    x3 - x19*x20*x4 + x20*x3*x4 + x20*x7*x8
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            x21 = co(0)*w2(mu)
            x22 = P2(mu)*co(1)
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - w2(3)*wl(3,j)*x20*x22 + x0*x20*x21 -   &
                          x12*x20*x22 - x15*x20*x21 + x19*x20*x22 - x20*x21*x7 &
                           - x20*x21*x9 - x20*x22*x3
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVVSS
end module lcVVSS
