!******************************************************************************!
!                                                                              !
!    lcVVSVSS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVVSVSS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVVSVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopVVSVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VVSVSS0)
!       c0*(Metric(1,2)*P(4,1) - Metric(1,2)*P(4,2) - Metric(1,4)*P(2,1) + Metric
!       (1,4)*P(2,4) + Metric(2,4)*P(1,2) - Metric(2,4)*P(1,4))
        x1 = P1(0)*w4(0)
        x5 = P1(1)*w4(1)
        x8 = P1(2)*w4(2)
        x10 = P1(2)*w2(2)
        x12 = P1(3)*w4(3)
        x13 = P1(3)*w2(3)
        x15 = w2(1)*w4(1)
        x17 = w2(2)*w4(2)
        x18 = w2(3)*w4(3)
        x19 = w2(0)*w4(0)
        x21 = P2(1)*w4(1)
        x24 = P2(2)*w4(2)
        x27 = P2(3)*w4(3)
        x28 = P4(0)*w2(0)
        x33 = P4(2)*w2(2)
        x36 = P4(3)*w2(3)
        x37 = P1(0)*w2(0)
        x38 = P2(0)*w4(0)
        x40 = cima*co(0)*w3(0)*w5(0)
        do j = riMaxIn, 0, -1
          x0 = w2(1)*wl(1,j)
          x2 = w2(2)*wl(2,j)
          x3 = w2(3)*w4(0)*wl(3,j)
          x4 = w2(0)*wl(0,j)
          x6 = w2(1)*w4(2)*wl(2,j)
          x7 = w2(1)*w4(3)*wl(3,j)
          x9 = w4(1)*wl(1,j)
          x11 = w4(3)*wl(3,j)
          x14 = w4(2)*wl(2,j)
          x16 = P2(0)*wl(0,j)
          x20 = P2(1)*wl(1,j)
          x22 = w2(3)*wl(3,j)
          x23 = P2(2)*wl(2,j)
          x25 = w2(0)*w4(0)*wl(3,j)
          x26 = w2(1)*w4(3)*wl(1,j)
          x29 = w2(1)*w4(0)*wl(0,j)
          x30 = P4(1)*wl(1,j)
          x31 = P4(2)*wl(2,j)
          x32 = w4(0)*wl(0,j)
          x34 = w2(1)*w4(1)*wl(3,j)
          x35 = w2(2)*w4(2)*wl(3,j)
          x39 = P4(0)*wl(0,j)
          wp(0,j) = P1(0)*x3*x40 - P1(1)*x29*x40 + P1(1)*x40*x6 + P1(1)*x40*x7 &
                     - P1(3)*x26*x40 - P2(0)*x3*x40 + P2(3)*x25*x40 + P2(3)*x26&
                    *x40 - P2(3)*x34*x40 - P2(3)*x35*x40 + P4(1)*x29*x40 - P4(1&
                    )*x40*x6 - P4(1)*x40*x7 - P4(3)*x25*x40 + P4(3)*x34*x40 +  &
                    P4(3)*x35*x40 + x0*x1*x40 + x0*x24*x40 - x0*x38*x40 - x0*  &
                    x40*x8 + x1*x2*x40 + x10*x11*x40 - x10*x32*x40 + x10*x40*x9&
                     + x11*x28*x40 - x11*x33*x40 - x11*x37*x40 - x12*x2*x40 +  &
                    x12*x4*x40 + x13*x14*x40 - x13*x32*x40 + x13*x40*x9 + x14* &
                    x28*x40 - x14*x36*x40 - x14*x37*x40 + x15*x16*x40 - x15*x23&
                    *x40 + x15*x31*x40 - x15*x39*x40 + x16*x17*x40 + x16*x18*  &
                    x40 - x17*x20*x40 + x17*x30*x40 - x17*x39*x40 - x18*x20*x40&
                     - x18*x23*x40 + x18*x30*x40 + x18*x31*x40 - x18*x39*x40 + &
                    x19*x20*x40 + x19*x23*x40 - x19*x30*x40 - x19*x31*x40 + x2*&
                    x21*x40 + x2*x27*x40 - x2*x38*x40 - x2*x40*x5 + x21*x22*x40&
                     - x21*x4*x40 + x22*x24*x40 - x22*x40*x5 - x22*x40*x8 - x24&
                    *x4*x40 - x27*x4*x40 + x28*x40*x9 + x32*x33*x40 + x32*x36* &
                    x40 - x33*x40*x9 - x36*x40*x9 - x37*x40*x9 + x4*x40*x5 + x4&
                    *x40*x8
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - w2(mu)*x11*x40 - w2(mu)*x14*x40 + w2(mu&
                          )*x32*x40 - w2(mu)*x40*x9 + w4(mu)*x0*x40 + w4(mu)*x2&
                          *x40 + w4(mu)*x22*x40 - w4(mu)*x4*x40
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVVSVSS
end module lcVVSVSS
