!******************************************************************************!
!                                                                              !
!    lcVVVS.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVVVS.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopVVVS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, m, wp,  &
    riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VVVS0)
!       c0*(Metric(1,2)*P(3,1) - Metric(1,2)*P(3,2) - Metric(1,3)*P(2,1) + Metric
!       (1,3)*P(2,3) + Metric(2,3)*P(1,2) - Metric(2,3)*P(1,3))
        x1 = P1(0)*w3(0)
        x5 = P1(1)*w3(1)
        x7 = P1(1)*w2(1)
        x9 = P1(2)*w3(2)
        x12 = P1(3)*w3(3)
        x14 = P1(3)*w2(3)
        x15 = w2(1)*w3(1)
        x17 = w2(2)*w3(2)
        x18 = w2(3)*w3(3)
        x19 = w2(0)*w3(0)
        x21 = P2(1)*w3(1)
        x23 = P2(2)*w3(2)
        x25 = P2(3)*w3(3)
        x27 = P3(0)*w2(0)
        x29 = P3(1)*w2(1)
        x34 = P3(3)*w2(3)
        x35 = P1(0)*w2(0)
        x36 = P2(0)*w3(0)
        x38 = cima*co(0)
        do j = riMaxIn, 0, -1
          x0 = w2(1)*wl(1,j)
          x2 = w2(2)*wl(2,j)
          x3 = w2(3)*wl(3,j)
          x4 = w2(0)*wl(0,j)
          x6 = w3(2)*wl(2,j)
          x8 = w3(3)*wl(3,j)
          x10 = w2(2)*w3(1)*wl(1,j)
          x11 = w2(2)*w3(3)*wl(3,j)
          x13 = w3(1)*wl(1,j)
          x16 = P2(0)*wl(0,j)
          x20 = P2(1)*wl(1,j)
          x22 = P2(2)*wl(2,j)
          x24 = P2(3)*wl(3,j)
          x26 = w2(2)*w3(3)*wl(2,j)
          x28 = w3(0)*wl(0,j)
          x30 = P3(1)*wl(1,j)
          x31 = P3(2)*wl(2,j)
          x32 = w2(2)*w3(0)*wl(0,j)
          x33 = P3(3)*wl(3,j)
          x37 = P3(0)*wl(0,j)
          wp(0,j) = P1(2)*x10*x38 + P1(2)*x11*x38 - P1(2)*x32*x38 - P1(3)*x26* &
                    x38 + P2(3)*x26*x38 - P3(2)*x10*x38 - P3(2)*x11*x38 + P3(2 &
                    )*x32*x38 + x0*x1*x38 - x0*x12*x38 + x0*x23*x38 + x0*x25*  &
                    x38 - x0*x36*x38 - x0*x38*x9 + x1*x2*x38 + x1*x3*x38 + x12*&
                    x38*x4 + x13*x14*x38 + x13*x27*x38 - x13*x34*x38 - x13*x35*&
                    x38 - x14*x28*x38 + x14*x38*x6 + x15*x16*x38 - x15*x22*x38 &
                     - x15*x24*x38 + x15*x31*x38 + x15*x33*x38 - x15*x37*x38 + &
                    x16*x17*x38 + x16*x18*x38 - x17*x20*x38 - x17*x24*x38 + x17&
                    *x30*x38 + x17*x33*x38 - x17*x37*x38 - x18*x20*x38 - x18*  &
                    x22*x38 + x18*x30*x38 + x18*x31*x38 - x18*x37*x38 + x19*x20&
                    *x38 + x19*x22*x38 + x19*x24*x38 - x19*x30*x38 - x19*x31*  &
                    x38 - x19*x33*x38 + x2*x21*x38 - x2*x36*x38 - x2*x38*x5 +  &
                    x21*x3*x38 - x21*x38*x4 + x23*x3*x38 - x23*x38*x4 - x25*x38&
                    *x4 + x27*x38*x6 + x27*x38*x8 + x28*x29*x38 + x28*x34*x38  &
                     - x28*x38*x7 - x29*x38*x6 - x29*x38*x8 - x3*x36*x38 - x3* &
                    x38*x5 - x3*x38*x9 - x34*x38*x6 - x35*x38*x6 - x35*x38*x8  &
                     + x38*x4*x5 + x38*x4*x9 + x38*x6*x7 + x38*x7*x8
          if(rankInc .lt. 1) cycle
          do mu = 0, 3
            riOut = incRI(mu, j)
            wp(0,riOut) = wp(0,riOut) - w2(mu)*x13*x38 + w2(mu)*x28*x38 - w2(mu&
                          )*x38*x6 - w2(mu)*x38*x8 + w3(mu)*x0*x38 + w3(mu)*x2*&
                          x38 + w3(mu)*x3*x38 - w3(mu)*x38*x4
          end do 
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVVVS
end module lcVVVS
