!******************************************************************************!
!                                                                              !
!    lcVVVVSS.f90                                                              !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   lcVVVVSS.f90                                   |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module lcVVVVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec
  contains
    subroutine loopVVVVSS(ty, co, wl, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4&
    , PL4, w5, P5, PL5, m, wp, riMaxIn, riMaxOut, rankInc)
      integer, intent(in) :: riMaxIn, riMaxOut, rankInc
      complex (kind = dp), intent(in), dimension(0:3) :: P1, PL1
      complex (kind = dp), intent(in), dimension(0:3, 0:riMaxIn) :: wl
      complex (kind = dp), intent(in), dimension(0:3) :: P2, PL2
      complex (kind = dp), intent(in), dimension(0:3) :: w2
      complex (kind = dp), intent(in), dimension(0:3) :: P3, PL3
      complex (kind = dp), intent(in), dimension(0:3) :: w3
      complex (kind = dp), intent(in), dimension(0:3) :: P4, PL4
      complex (kind = dp), intent(in), dimension(0:3) :: w4
      complex (kind = dp), intent(in), dimension(0:3) :: P5, PL5
      complex (kind = dp), intent(in), dimension(0:3) :: w5
      complex (dp), intent(out), dimension(0:3,0:riMaxOut) :: wp
      complex (kind = dp), intent(in) :: m
      complex (kind = dp), dimension(0:3) :: pl, p
      integer, intent(in) :: ty
      complex (kind = dp), dimension(0:), intent(in) :: co
      complex (kind = dp), dimension(0:3) :: sp1
      complex (kind = dp), dimension(0:3,0:3) :: sp2
      complex (kind = dp), dimension(0:3,0:3,0:3) :: sp3
      complex (kind = dp), dimension(0:3,0:3,0:3,0:3) :: sp4
      character(len=3) :: ty_str
      integer :: riOut, j
      logical :: isFirstRI
      integer :: mu, nu, ro, ta, te, tu
      select case(ty)
      case(VVVVSS0)
!       Metric(1,4)*Metric(2,3)*c0
!       Metric(1,3)*Metric(2,4)*c1
!       Metric(1,2)*Metric(3,4)*c2
        x0 = co(0)*w3(0)
        x3 = co(0)*w2(1)*w3(1)
        x5 = co(0)*w2(2)*w3(2)
        x7 = co(0)*w2(3)*w3(3)
        x10 = w2(1)*w4(1)
        x14 = co(1)*w2(2)*w4(2)
        x16 = co(1)*w2(3)*w4(3)
        x17 = w2(3)*w4(3)
        x19 = co(2)*w3(2)*w4(2)
        x20 = co(2)*w3(3)*w4(3)
        x21 = co(2)*w3(1)*w4(1)
        x25 = w2(0)*w4(0)
        x28 = co(2)*w3(0)*w4(0)
        do j = riMaxIn, 0, -1
          x1 = w2(1)*w3(1)*w4(1)*wl(1,j)
          x2 = co(0)*w4(2)*wl(2,j)
          x4 = w4(3)*wl(3,j)
          x6 = w4(1)*wl(1,j)
          x8 = w2(3)*w3(3)*wl(3,j)
          x9 = w2(0)*w3(0)*w4(0)*wl(0,j)
          x11 = co(1)*w3(2)*wl(2,j)
          x12 = co(1)*w3(3)*wl(3,j)
          x13 = w3(1)*wl(1,j)
          x15 = w2(2)*w4(2)*wl(2,j)
          x18 = w2(1)*wl(1,j)
          x22 = w2(2)*wl(2,j)
          x23 = w2(3)*wl(3,j)
          x24 = w4(0)*wl(0,j)
          x26 = w3(0)*wl(0,j)
          x27 = w2(0)*wl(0,j)
          wp(0,j) = -cima*co(0)*w2(0)*w3(0)*w5(0)*x6 + cima*co(0)*w4(3)*w5(0)* &
                    x8 + cima*co(0)*w5(0)*x1 - cima*co(1)*w2(0)*w3(3)*w4(0)*w5(&
                    0)*wl(3,j) - cima*co(1)*w2(1)*w4(1)*w5(0)*x26 - cima*co(1)*&
                    w3(1)*w5(0)*wl(1,j)*x25 + cima*co(1)*w3(2)*w5(0)*x15 + cima&
                    *co(1)*w5(0)*x1 + cima*co(1)*w5(0)*x9 + cima*co(2)*w3(2)*w5&
                    (0)*x15 + cima*co(2)*w4(3)*w5(0)*x8 + cima*co(2)*w5(0)*x1  &
                     + cima*co(2)*w5(0)*x9 - cima*w2(0)*w3(0)*w5(0)*x2 + cima* &
                    w2(0)*w4(0)*w5(0)*wl(0,j)*x0 - cima*w2(0)*w4(3)*w5(0)*wl(3,&
                    j)*x0 + cima*w2(1)*w3(1)*w5(0)*x2 + cima*w2(2)*w4(2)*w5(0)*&
                    x12 + cima*w2(3)*w3(3)*w5(0)*x2 + cima*w4(2)*w5(0)*wl(2,j)*&
                    x5 + cima*w5(0)*x10*x11 + cima*w5(0)*x10*x12 + cima*w5(0)* &
                    x11*x17 - cima*w5(0)*x11*x25 + cima*w5(0)*x12*x17 + cima*w5&
                    (0)*x13*x14 + cima*w5(0)*x13*x16 - cima*w5(0)*x14*x26 -    &
                    cima*w5(0)*x16*x26 + cima*w5(0)*x18*x19 + cima*w5(0)*x18*  &
                    x20 - cima*w5(0)*x18*x28 + cima*w5(0)*x19*x23 - cima*w5(0)*&
                    x19*x27 + cima*w5(0)*x20*x22 - cima*w5(0)*x20*x27 + cima*w5&
                    (0)*x21*x22 + cima*w5(0)*x21*x23 - cima*w5(0)*x21*x27 -    &
                    cima*w5(0)*x22*x28 - cima*w5(0)*x23*x28 - cima*w5(0)*x24*x3&
                     - cima*w5(0)*x24*x5 - cima*w5(0)*x24*x7 + cima*w5(0)*x3*x4&
                     + cima*w5(0)*x4*x5 + cima*w5(0)*x5*x6 + cima*w5(0)*x6*x7
        end do 
        wp(1:3,:) = cnul
      end select 
    end subroutine loopVVVVSS
end module lcVVVVSS
