!******************************************************************************!
!                                                                              !
!    tcFSFa.f90                                                                !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFSFa.f90                                     |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFSFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeFSFa(ty, co, w1, P1, PL1, w2, P2, PL2, den, m, wout, last,  &
    VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FSFa0)
!       c0*(GammaP(-1,3,1)*P(-1,2) + 2*GammaP(-1,3,1)*P(-1,3))
!       c1*(GammaM(-1,3,1)*P(-1,2) + 2*GammaM(-1,3,1)*P(-1,3))
!       ProjP(3,1)*c2
!       ProjM(3,1)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:)
      x0 = pl(0)*w1(1)
      x1 = pl(3)*w1(0)
      x2 = x0 + x1
      x3 = P2(1)*co(0)
      x4 = pl(0)*w1(0)
      x5 = pl(3)*w1(1)
      x6 = x4 - x5
      x7 = P2(3)*co(0)
      x8 = pl(0)*w1(2)
      x9 = pl(3)*w1(3)
      x10 = x4 + x5
      x11 = P2(0)*co(0)
      x12 = co(2)*m
      x13 = 2*P1(0)*co(0)
      x14 = 2*P1(1)*co(0)
      x15 = 2*P1(3)*co(0)
      x16 = P2(0)*co(1)*m
      x17 = P2(1)*co(1)*m
      x18 = P2(3)*co(1)*m
      x19 = x0 - x1
      x20 = P2(2)*cima*co(0)
      x21 = 2*P1(2)*cima*co(0)
      x22 = 2*P1(0)*co(1)
      x23 = m*w1(2)
      x24 = 2*P1(1)*co(1)
      x25 = m*w1(3)
      x26 = 2*P1(3)*co(1)
      x27 = P2(2)*cima*co(1)
      x28 = 2*P1(2)*cima*co(1)
      x29 = pl(1)*w1(0)
      x30 = pl(2)*w1(1)
      x31 = x29 + x30
      x32 = pl(1)*w1(3)
      x33 = pl(2)*w1(2)
      x34 = pl(1)*w1(1)
      x35 = pl(2)*w1(0)
      x36 = x34 + x35
      x37 = x34 - x35
      x38 = x29 - x30
      x39 = pl(1)*w1(2)
      x40 = x39 - x9
      x41 = P2(0)*co(1)
      x42 = pl(3)*w1(2)
      x43 = x32 - x42
      x44 = P2(1)*co(1)
      x45 = x39 + x9
      x46 = P2(3)*co(1)
      x47 = co(3)*m
      x48 = P2(1)*co(0)*m
      x49 = P2(3)*co(0)*m
      x50 = P2(0)*co(0)*m
      x51 = x32 + x42
      x52 = m*w1(0)
      x53 = m*w1(1)
      x54 = pl(0)*w1(3)
      x55 = -x33 + x54
      x56 = pl(2)*w1(3)
      x57 = -x56 + x8
      x58 = x33 + x54
      x59 = x56 + x8
      wout(0) = -w2(0)*(co(3)*x8 + co(3)*x9 - w1(0)*x12 + w1(2)*x16 + w1(2)*x18&
                 + w1(3)*x17 - x10*x11 - x10*x13 + x14*x2 + x15*x6 - x19*x20 - &
                x19*x21 + x2*x3 + x22*x23 + x23*x26 + x24*x25 - x25*x27 - x25* &
                x28 + x6*x7)
      wout(1) = -w2(0)*(co(3)*x32 + co(3)*x33 - w1(1)*x12 + w1(2)*x17 + w1(3)* &
                x16 - w1(3)*x18 - x11*x36 - x13*x36 + x14*x31 - x15*x37 + x20* &
                x38 + x21*x38 + x22*x25 + x23*x24 + x23*x27 + x23*x28 - x25*x26&
                 + x3*x31 - x37*x7)
      wout(2) = w2(0)*(-co(2)*x29 + co(2)*x5 + w1(0)*x49 - w1(0)*x50 + w1(1)*  &
                x48 + w1(2)*x47 - x13*x52 + x14*x53 + x15*x52 - x20*x53 - x21* &
                x53 + x22*x40 + x24*x43 + x26*x45 - x27*x51 - x28*x51 + x40*x41&
                 + x43*x44 + x45*x46)
      wout(3) = w2(0)*(-co(2)*x0 + co(2)*x35 + w1(0)*x48 - w1(1)*x49 - w1(1)*  &
                x50 + w1(3)*x47 - x13*x53 + x14*x52 - x15*x53 + x20*x52 + x21* &
                x52 + x22*x55 + x24*x57 - x26*x58 + x27*x59 + x28*x59 + x41*x55&
                 + x44*x57 - x46*x58)
    else
      x0 = co(1)*w1(2)
      x1 = co(1)*w1(3)
      x2 = 2*P1(0)
      x3 = 2*P1(1)
      x4 = 2*P1(3)
      x5 = P2(2)*cima
      x6 = 2*P1(2)*cima
      x7 = co(0)*w1(1)
      x8 = co(0)*w1(0)
      wout(0) = -w2(0)*(P2(0)*x0 + P2(1)*x1 + P2(3)*x0 - co(2)*w1(0) + x0*x2 + &
                x0*x4 + x1*x3 - x1*x5 - x1*x6)
      wout(1) = -w2(0)*(P2(0)*x1 + P2(1)*x0 - P2(3)*x1 - co(2)*w1(1) + x0*x3 + &
                x0*x5 + x0*x6 + x1*x2 - x1*x4)
      wout(2) = w2(0)*(-P2(0)*x8 + P2(1)*x7 + P2(3)*x8 + co(3)*w1(2) - x2*x8 + &
                x3*x7 + x4*x8 - x5*x7 - x6*x7)
      wout(3) = w2(0)*(-P2(0)*x7 + P2(1)*x8 - P2(3)*x7 + co(3)*w1(3) - x2*x7 + &
                x3*x8 - x4*x7 + x5*x8 + x6*x8)
    end if 
      end select 
    end subroutine treeFSFa
end module tcFSFa
