!******************************************************************************!
!                                                                              !
!    tcFaSSF.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcFaSSF.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcFaSSF
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeFaSSF(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(FaSSF0)
!       c0*(GammaP(-1,1,4)*P(-1,2) + GammaP(-1,1,4)*P(-1,3) + GammaP(-1,1,4)*P(-1
!       ,4)/2)
!       c1*(GammaM(-1,1,4)*P(-1,2) + GammaM(-1,1,4)*P(-1,3) + GammaM(-1,1,4)*P(-1
!       ,4)/2)
!       ProjP(1,4)*c2
!       ProjM(1,4)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = pl(1)*w1(0)
      x1 = pl(2)*w1(1)
      x2 = x0 - x1
      x3 = P2(0)*co(1)
      x4 = pl(1)*w1(1)
      x5 = pl(2)*w1(0)
      x6 = co(1)*(x4 - x5)
      x7 = co(1)*(x0 + x1)
      x8 = P3(0)*co(1)
      x9 = P1(0)*co(1)
      x10 = pl(2)*w1(3)
      x11 = 2*co(3)
      x12 = 2*co(2)
      x13 = m*w1(0)
      x14 = pl(1)*w1(2)
      x15 = co(0)*m*w1(3)
      x16 = co(0)*m*w1(2)
      x17 = P2(2)*cima
      x18 = x4 + x5
      x19 = co(1)*x18
      x20 = P3(2)*cima*co(1)
      x21 = P1(2)*cima
      x22 = P3(1)*co(0)
      x23 = m*w1(3)
      x24 = P3(2)*cima
      x25 = w2(0)*w3(0)/2
      x26 = pl(0)*w1(1)
      x27 = pl(3)*w1(0)
      x28 = co(1)*(x26 + x27)
      x29 = x26 - x27
      x30 = pl(0)*w1(0)
      x31 = pl(3)*w1(1)
      x32 = co(1)*(x30 - x31)
      x33 = pl(3)*w1(2)
      x34 = m*w1(1)
      x35 = pl(0)*w1(3)
      x36 = x30 + x31
      x37 = co(1)*x36
      x38 = m*w1(2)
      x39 = pl(2)*w1(2)
      x40 = x35 + x39
      x41 = co(0)*x40
      x42 = pl(0)*w1(2)
      x43 = co(0)*(-x10 + x42)
      x44 = co(0)*(x10 + x42)
      x45 = co(0)*(x35 - x39)
      x46 = co(1)*m*w1(1)
      x47 = co(1)*m*w1(0)
      x48 = pl(3)*w1(3)
      x49 = x14 + x48
      x50 = co(0)*x49
      x51 = pl(1)*w1(3)
      x52 = co(0)*(x33 + x51)
      x53 = co(0)*(-x33 + x51)
      x54 = co(0)*(x14 - x48)
      wout(0) = x25*(-P1(0)*x16 + P1(1)*x15 - P1(1)*x6 + P1(3)*x16 - P1(3)*x7  &
                 + P2(0)*x16 - P2(1)*x15 + P2(1)*x6 - P2(3)*x16 + P2(3)*x7 + P3&
                (0)*x16 + P3(1)*x6 - P3(3)*x16 + P3(3)*x7 - x10*x11 + x11*x14  &
                 + x12*x13 - x15*x17 + x15*x21 - x15*x24 + x17*x19 + x18*x20 - &
                x19*x21 + x2*x3 + x2*x8 - x2*x9 - x22*x23)
      wout(1) = x25*(-P1(0)*x15 + P1(1)*x16 - P1(1)*x32 - P1(3)*x15 + P1(3)*x28&
                 + P2(0)*x15 - P2(1)*x16 + P2(1)*x32 + P2(3)*x15 - P2(3)*x28 + &
                P3(0)*x15 + P3(1)*x32 + P3(3)*x15 - P3(3)*x28 - x11*x33 + x11* &
                x35 + x12*x34 + x16*x17 - x16*x21 + x16*x24 - x17*x37 - x20*x36&
                 + x21*x37 - x22*x38 + x29*x3 + x29*x8 - x29*x9)
      wout(2) = x25*(-P1(0)*x44 + P1(1)*x41 - P1(1)*x46 + P1(3)*x43 - P1(3)*x47&
                 + P2(0)*x44 - P2(1)*x41 + P2(1)*x46 - P2(3)*x43 + P2(3)*x47 + &
                P3(0)*x44 + P3(1)*x46 - P3(3)*x43 + P3(3)*x47 + x1*x12 + x11*  &
                x38 + x12*x30 + x13*x3 + x13*x8 - x13*x9 - x17*x45 + x17*x46 + &
                x20*x34 + x21*x45 - x21*x46 - x22*x40 - x24*x45)
      wout(3) = x25*(-P1(0)*x52 - P1(1)*x47 + P1(1)*x50 + P1(3)*x46 - P1(3)*x53&
                 + P2(0)*x52 + P2(1)*x47 - P2(1)*x50 - P2(3)*x46 + P2(3)*x53 + &
                P3(0)*x52 + P3(1)*x47 - P3(3)*x46 + P3(3)*x53 + x11*x23 + x12* &
                x27 + x12*x4 - x13*x20 - x17*x47 + x17*x54 + x21*x47 - x21*x54 &
                 - x22*x49 + x24*x54 + x3*x34 + x34*x8 - x34*x9)
    else
      x0 = 2*co(2)
      x1 = co(0)*w1(2)
      x2 = co(0)*w1(3)
      x3 = cima*co(0)*w1(3)
      x4 = P1(2)*cima
      x5 = w2(0)*w3(0)/2
      x6 = P2(2)*cima
      x7 = P3(2)*cima
      x8 = 2*co(3)
      x9 = co(1)*w1(0)
      x10 = co(1)*w1(1)
      wout(0) = -x5*(P1(0)*x1 - P1(1)*x2 - P1(3)*x1 - P2(0)*x1 + P2(1)*x2 + P2(&
                2)*x3 + P2(3)*x1 - P3(0)*x1 + P3(1)*x2 + P3(2)*x3 + P3(3)*x1 - &
                w1(0)*x0 - x2*x4)
      wout(1) = x5*(-P1(0)*x2 + P1(1)*x1 - P1(3)*x2 + P2(0)*x2 - P2(1)*x1 + P2(&
                3)*x2 + P3(0)*x2 - P3(1)*x1 + P3(3)*x2 + w1(1)*x0 - x1*x4 + x1*&
                x6 + x1*x7)
      wout(2) = x5*(-P1(0)*x9 - P1(1)*x10 - P1(3)*x9 + P2(0)*x9 + P2(1)*x10 +  &
                P2(3)*x9 + P3(0)*x9 + P3(1)*x10 + P3(3)*x9 + w1(2)*x8 - x10*x4 &
                 + x10*x6 + x10*x7)
      wout(3) = x5*(-P1(0)*x10 - P1(1)*x9 + P1(3)*x10 + P2(0)*x10 + P2(1)*x9 - &
                P2(3)*x10 + P3(0)*x10 + P3(1)*x9 - P3(3)*x10 + w1(3)*x8 + x4*x9&
                 - x6*x9 - x7*x9)
    end if 
      end select 
    end subroutine treeFaSSF
end module tcFaSSF
