!******************************************************************************!
!                                                                              !
!    tcSFFaS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSFFaS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSFFaS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeSFFaS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SFFaS0)
!       c0*(GammaP(-1,3,2)*P(-1,1) + GammaP(-1,3,2)*P(-1,2)/2 + GammaP(-1,3,2)*P 
!       (-1,4))
!       c1*(GammaM(-1,3,2)*P(-1,1) + GammaM(-1,3,2)*P(-1,2)/2 + GammaM(-1,3,2)*P 
!       (-1,4))
!       ProjP(3,2)*c2
!       ProjM(3,2)*c3
        x0 = w2(0)*w3(2)
        x1 = w2(1)*w3(3)
        x2 = co(0)*(x0 + x1)
        x3 = w2(2)*w3(0)
        x4 = w2(3)*w3(1)
        x5 = co(1)*(x3 + x4)
        x6 = w2(2)*w3(1)
        x7 = w2(3)*w3(0)
        x8 = co(1)*(x6 + x7)
        x9 = co(1)*(x3 - x4)
        x10 = w2(0)*w3(3)
        x11 = w2(1)*w3(2)
        x12 = co(0)*(x10 + x11)
        x13 = co(0)*(x0 - x1)
        x14 = 2*P3(1)
        x15 = 2*P3(3)
        x16 = 2*co(2)
        x17 = 2*co(3)
        x18 = 2*P3(0)
        x19 = P2(2)*cima
        x20 = co(1)*(x6 - x7)
        x21 = co(0)*(x10 - x11)
        x22 = 2*P3(2)*cima
        wout(0) = -w1(0)*(P2(0)*x2 + P2(0)*x5 - P2(1)*x12 + P2(1)*x8 - P2(3)*  &
                  x13 + P2(3)*x9 - w2(0)*w3(0)*x16 - w2(1)*w3(1)*x16 - w2(2)*w3&
                  (2)*x17 - w2(3)*w3(3)*x17 - x12*x14 - x13*x15 + x14*x8 + x15*&
                  x9 + x18*x2 + x18*x5 + x19*x20 - x19*x21 + x20*x22 - x21*x22 &
                  )/2
        wout(1:3) = cnul
      end select 
    end subroutine treeSFFaS
end module tcSFFaS
