!******************************************************************************!
!                                                                              !
!    tcSSFFa.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSSFFa.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSSFFa
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeSSFFa(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, den, m &
    , wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SSFFa0)
!       c0*(GammaP(-1,4,3)*P(-1,1) + GammaP(-1,4,3)*P(-1,2) + GammaP(-1,4,3)*P(-1
!       ,3)/2)
!       c1*(GammaM(-1,4,3)*P(-1,1) + GammaM(-1,4,3)*P(-1,2) + GammaM(-1,4,3)*P(-1
!       ,3)/2)
!       ProjP(4,3)*c2
!       ProjM(4,3)*c3
    if (last .eqv. .false.) then
      pl(:) = PL1(:) + PL2(:) + PL3(:)
      x0 = pl(0)*w3(1)
      x1 = pl(3)*w3(0)
      x2 = x0 + x1
      x3 = P3(1)*co(0)
      x4 = pl(0)*w3(0)
      x5 = pl(3)*w3(1)
      x6 = x4 - x5
      x7 = P3(3)*co(0)
      x8 = x4 + x5
      x9 = P3(0)*co(0)
      x10 = 2*P1(0)*co(0)
      x11 = 2*P2(0)*co(0)
      x12 = pl(0)*w3(2)
      x13 = 2*co(3)
      x14 = pl(3)*w3(3)
      x15 = 2*co(0)*x2
      x16 = 2*P1(3)*co(0)
      x17 = 2*P2(3)*co(0)
      x18 = 2*co(2)
      x19 = m*w3(0)
      x20 = P3(0)*co(1)
      x21 = m*w3(2)
      x22 = P3(1)*co(1)
      x23 = m*w3(3)
      x24 = P3(3)*co(1)
      x25 = x0 - x1
      x26 = P3(2)*cima*co(0)
      x27 = 2*cima*co(0)*x25
      x28 = 2*co(1)*m*w3(2)
      x29 = 2*P1(1)*co(1)
      x30 = 2*P1(3)*co(1)
      x31 = 2*P2(1)*co(1)
      x32 = 2*P2(3)*co(1)
      x33 = P3(2)*cima*co(1)
      x34 = 2*cima*co(1)*m*w3(3)
      x35 = w1(0)*w2(0)/2
      x36 = pl(1)*w3(0)
      x37 = pl(2)*w3(1)
      x38 = x36 + x37
      x39 = pl(1)*w3(1)
      x40 = pl(2)*w3(0)
      x41 = x39 + x40
      x42 = x39 - x40
      x43 = pl(1)*w3(3)
      x44 = pl(2)*w3(2)
      x45 = 2*co(0)*x38
      x46 = m*w3(1)
      x47 = x36 - x37
      x48 = 2*co(1)*m*w3(3)
      x49 = 2*cima*co(0)*x47
      x50 = 2*cima*co(1)*m*w3(2)
      x51 = pl(1)*w3(2)
      x52 = -x14 + x51
      x53 = pl(3)*w3(2)
      x54 = x43 - x53
      x55 = x14 + x51
      x56 = 2*co(1)*x52
      x57 = P3(1)*co(0)*m
      x58 = x43 + x53
      x59 = 2*cima*co(1)*x58
      x60 = 2*P1(1)*co(0)
      x61 = 2*P2(1)*co(0)
      x62 = 2*P1(2)*cima*co(0)
      x63 = 2*P2(2)*cima*co(0)
      x64 = pl(0)*w3(3)
      x65 = -x44 + x64
      x66 = pl(2)*w3(3)
      x67 = x12 - x66
      x68 = x44 + x64
      x69 = 2*co(1)*x65
      x70 = x12 + x66
      x71 = 2*cima*co(1)*x70
      wout(0) = x35*(P1(0)*x28 + P1(1)*x15 - P1(2)*x27 - P1(2)*x34 + P2(0)*x28 &
                 + P2(1)*x15 - P2(2)*x27 - P2(2)*x34 - x10*x8 - x11*x8 - x12*  &
                x13 - x13*x14 + x16*x6 + x17*x6 + x18*x19 + x2*x3 + x20*x21 +  &
                x21*x24 + x21*x30 + x21*x32 + x22*x23 + x23*x29 + x23*x31 - x23&
                *x33 - x25*x26 + x6*x7 - x8*x9)
      wout(1) = x35*(P1(0)*x48 + P1(1)*x45 + P1(2)*x49 + P1(2)*x50 + P2(0)*x48 &
                 + P2(1)*x45 + P2(2)*x49 + P2(2)*x50 - x10*x41 - x11*x41 - x13*&
                x43 - x13*x44 - x16*x42 - x17*x42 + x18*x46 + x20*x23 + x21*x22&
                 + x21*x29 + x21*x31 + x21*x33 - x23*x24 - x23*x30 - x23*x32 + &
                x26*x47 + x3*x38 - x41*x9 - x42*x7)
      wout(2) = -x35*(P1(0)*x56 - P1(2)*x59 + P2(0)*x56 - P2(2)*x59 + w3(1)*x57&
                 - x10*x19 - x11*x19 - x13*x21 + x16*x19 + x17*x19 + x18*x36 - &
                x18*x5 + x19*x7 - x19*x9 + x20*x52 + x22*x54 + x24*x55 - x26*  &
                x46 + x29*x54 + x30*x55 + x31*x54 + x32*x55 - x33*x58 + x46*x60&
                 + x46*x61 - x46*x62 - x46*x63)
      wout(3) = -x35*(P1(0)*x69 + P1(2)*x71 + P2(0)*x69 + P2(2)*x71 + w3(0)*x57&
                 + x0*x18 - x10*x46 - x11*x46 - x13*x23 - x16*x46 - x17*x46 -  &
                x18*x40 + x19*x26 + x19*x60 + x19*x61 + x19*x62 + x19*x63 + x20&
                *x65 + x22*x67 - x24*x68 + x29*x67 - x30*x68 + x31*x67 - x32*  &
                x68 + x33*x70 - x46*x7 - x46*x9)
    else
      x0 = 2*co(2)
      x1 = P3(0)*co(1)
      x2 = co(1)*w3(3)
      x3 = co(1)*w3(2)
      x4 = 2*co(1)*w3(2)
      x5 = 2*P1(1)
      x6 = 2*co(1)*w3(3)
      x7 = P3(2)*cima
      x8 = P1(2)*cima
      x9 = P2(2)*cima
      x10 = w1(0)*w2(0)/2
      x11 = 2*co(3)
      x12 = co(0)*w3(0)
      x13 = co(0)*w3(1)
      x14 = 2*co(0)*w3(1)
      x15 = 2*co(0)*w3(0)
      wout(0) = x10*(P1(0)*x4 + P1(3)*x4 + P2(0)*x4 + P2(1)*x6 + P2(3)*x4 + P3(&
                1)*x2 + P3(3)*x3 + w3(0)*x0 + w3(2)*x1 + x2*x5 - x2*x7 - x6*x8 &
                 - x6*x9)
      wout(1) = x10*(P1(0)*x6 + P1(1)*x4 - P1(3)*x6 + P2(0)*x6 + P2(1)*x4 - P2(&
                3)*x6 + P3(1)*x3 - P3(3)*x2 + w3(1)*x0 + w3(3)*x1 + x3*x7 + x4*&
                x8 + x4*x9)
      wout(2) = x10*(P1(0)*x15 - P1(1)*x14 - P1(3)*x15 + P2(0)*x15 - P2(1)*x14 &
                 - P2(3)*x15 + P3(0)*x12 - P3(1)*x13 - P3(3)*x12 + w3(2)*x11 + &
                x13*x7 + x14*x8 + x14*x9)
      wout(3) = x10*(P1(0)*x14 + P1(3)*x14 + P2(0)*x14 - P2(1)*x15 + P2(3)*x14 &
                 + P3(0)*x13 - P3(1)*x12 + P3(3)*x13 + w3(3)*x11 - x12*x5 - x12&
                *x7 - x15*x8 - x15*x9)
    end if 
      end select 
    end subroutine treeSSFFa
end module tcSSFFa
