!******************************************************************************!
!                                                                              !
!    tcSSSVV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSSSVV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSSSVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeSSSVV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SSSVV0)
!       P(4,5)*P(5,4)*c0
!       Metric(4,5)*P(-1,4)*P(-1,5)*c1
        if (last) VB_last = .true.
        x0vec = co(1)*w4(:)
        x1vec = P4(1)*co(1)*w4(:)
        x2vec = P4(:)*co(0)*w4(1)
        x3vec = P4(2)*co(1)*w4(:)
        x4vec = P4(:)*co(0)*w4(2)
        x5vec = P4(3)*co(1)*w4(:)
        x6vec = P4(:)*co(0)*w4(3)
        x7vec = P4(0)*co(1)*w4(:)
        x8vec = P4(:)*co(0)*w4(0)
        wout = -w1(0)*w2(0)*w3(0)*(-P1(0)*x7vec - P1(0)*x8vec + P1(1)*x1vec +  &
               P1(1)*x2vec + P1(2)*x3vec + P1(2)*x4vec + P1(3)*x5vec + P1(3)*  &
               x6vec - P2(0)*x7vec - P2(0)*x8vec + P2(1)*x1vec + P2(1)*x2vec + &
               P2(2)*x3vec + P2(2)*x4vec + P2(3)*x5vec + P2(3)*x6vec - P3(0)*  &
               x7vec - P3(0)*x8vec + P3(1)*x1vec + P3(1)*x2vec + P3(2)*x3vec + &
               P3(2)*x4vec + P3(3)*x5vec + P3(3)*x6vec - P4(0)**2*x0vec - P4(0 &
               )*x8vec + P4(1)**2*x0vec + P4(1)*x2vec + P4(2)**2*x0vec + P4(2)*&
               x4vec + P4(3)**2*x0vec + P4(3)*x6vec)
      case(SSSVV1)
!       P(4,5)*P(5,4)*c0
!       P(4,4)*P(5,5)*c1
!       c2*(2*P(4,2)*P(5,2) + P(4,2)*P(5,3) + P(4,2)*P(5,4) + P(4,2)*P(5,5) + P(4
!       ,3)*P(5,2) + 2*P(4,3)*P(5,3) + P(4,3)*P(5,4) + P(4,3)*P(5,5) + P(4,4)*P(5
!       ,2) + P(4,4)*P(5,3) + P(4,5)*P(5,2) + P(4,5)*P(5,3))
!       c3*(P(4,4)*P(5,4) + P(4,5)*P(5,5))
!       Metric(4,5)*P(-1,4)*P(-1,5)*c4
!       c5*(Metric(4,5)*P(-1,4)**2 + Metric(4,5)*P(-1,5)**2)
!       c6*(Metric(4,5)*P(-1,2)**2 + Metric(4,5)*P(-1,2)*P(-1,3) + Metric(4,5)*P 
!       (-1,2)*P(-1,4) + Metric(4,5)*P(-1,2)*P(-1,5) + Metric(4,5)*P(-1,3)**2 +  
!       Metric(4,5)*P(-1,3)*P(-1,4) + Metric(4,5)*P(-1,3)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P4(0)**2
        x0vec = co(4)*w4(:)
        x1vec = co(5)*w4(:)
        x1 = P4(1)**2
        x2 = P4(2)**2
        x3 = P4(3)**2
        x2vec = 2*co(5)*w4(:)
        x3vec = co(6)*w4(:)
        x4 = P1(0)*P2(0)
        x4vec = P2(:)*co(2)
        x5 = P1(0)*w4(0)
        x5vec = P3(0)*co(6)*w4(:)
        x6vec = P3(:)*co(2)
        x7vec = P4(0)*co(4)*w4(:)
        x8vec = P4(:)*co(0)
        x6 = P1(1)*w4(1)
        x9vec = P1(:)*co(3)
        x7 = P1(1)*co(3)*w4(1)
        x10vec = P4(:)*co(3)*w4(1)
        x8 = P1(2)*w4(2)
        x11vec = P2(:)*co(3)
        x12vec = P3(:)*co(3)
        x13vec = P4(:)*co(3)
        x9 = P1(3)*w4(3)
        x14vec = P2(:)*co(3)*w4(3)
        x15vec = P4(:)*co(3)*w4(3)
        x16vec = P1(:)*co(2)*w4(0)
        x10 = P2(1)*w4(1)
        x11 = P2(2)*co(3)*w4(2)
        x12 = P2(3)*w4(3)
        x13 = P3(1)*w4(1)
        x14 = P3(2)*w4(2)
        x15 = P3(3)*w4(3)
        x16 = P4(0)*co(1)*w4(0)
        x17 = P4(1)*w4(1)
        x18 = P4(2)*w4(2)
        x19 = P4(3)*co(3)*w4(3)
        x20 = P2(0)*w4(0)
        x21 = P2(2)*w4(2)
        x22 = P3(0)*w4(0)
        x17vec = P3(:)*co(1)
        x23 = P4(0)*w4(0)
        x18vec = P4(:)*co(3)*w4(0)
        x19vec = P1(1)*co(6)*w4(:)
        x20vec = P4(1)*co(4)*w4(:)
        x21vec = P4(:)*co(0)*w4(1)
        x24 = P1(2)*P2(2)
        x22vec = P3(2)*co(6)*w4(:)
        x23vec = P4(2)*co(4)*w4(:)
        x24vec = P4(:)*co(0)*w4(2)
        x25vec = P1(3)*co(6)*w4(:)
        x26vec = P4(3)*co(4)*w4(:)
        x27vec = P1(:)*co(2)
        x25 = P4(1)*co(1)*w4(1)
        x26 = P4(2)*co(1)*w4(2)
        x27 = P4(3)*co(1)*w4(3)
        x28 = P2(1)*P3(1)
        x29 = P2(3)*P3(3)
        x30 = P4(3)*w4(3)
        x28vec = 2*P3(0)*co(5)*w4(:)
        x29vec = 2*P4(0)*co(5)*w4(:)
        x30vec = 2*P1(1)*co(5)*w4(:)
        x31vec = 2*P4(2)*co(5)*w4(:)
        x32vec = 2*P2(3)*co(5)*w4(:)
        x33vec = 2*P3(3)*co(5)*w4(:)
        x34vec = 2*P4(1)*co(5)*w4(:)
        x35vec = 2*P2(2)*co(5)*w4(:)
        wout = w1(0)*w2(0)*w3(0)*(-P1(0)**2*x1vec - P1(0)*x18vec - P1(0)*x28vec&
                - P1(0)*x29vec + P1(0)*x5vec + P1(0)*x7vec + P1(1)**2*x1vec +  &
               P1(1)*x10vec - P1(1)*x20vec - P1(1)*x21vec + P1(2)**2*x1vec + P1&
               (2)*P3(2)*x2vec - P1(2)*x22vec - P1(2)*x23vec - P1(2)*x24vec +  &
               P1(2)*x31vec + P1(3)**2*x1vec + P1(3)*P4(3)*x2vec + P1(3)*x14vec&
                + P1(3)*x15vec - P1(3)*x26vec + P1(3)*x32vec + P1(3)*x33vec +  &
               P1(:)*x11 + P1(:)*x16 + P1(:)*x19 - P1(:)*x25 - P1(:)*x26 - P1  &
               (:)*x27 - P2(0)**2*x1vec + P2(0)*x16vec - P2(0)*x18vec - P2(0)* &
               x28vec - P2(0)*x29vec + P2(0)*x5vec + P2(0)*x7vec + P2(1)**2*   &
               x1vec + P2(1)*x10vec - P2(1)*x19vec - P2(1)*x20vec - P2(1)*     &
               x21vec + P2(1)*x30vec + P2(1)*x34vec + P2(2)**2*x1vec - P2(2)*  &
               x22vec - P2(2)*x23vec - P2(2)*x24vec + P2(3)**2*x1vec + P2(3)*  &
               x14vec + P2(3)*x15vec - P2(3)*x25vec - P2(3)*x26vec + P2(:)*x11 &
                + P2(:)*x16 + P2(:)*x19 - P2(:)*x25 - P2(:)*x26 - P2(:)*x27 +  &
               P2(:)*x7 - P3(0)**2*x1vec + P3(0)*x16vec - P3(0)*x18vec - P3(0)*&
               x29vec + P3(0)*x7vec + P3(1)**2*x1vec + P3(1)*x10vec - P3(1)*   &
               x19vec - P3(1)*x20vec - P3(1)*x21vec + P3(1)*x30vec + P3(1)*    &
               x34vec + P3(2)**2*x1vec - P3(2)*x23vec - P3(2)*x24vec + P3(2)*  &
               x31vec + P3(2)*x35vec + P3(3)**2*x1vec + P3(3)*x14vec + P3(3)*  &
               x15vec - P3(3)*x25vec - P3(3)*x26vec + P3(:)*x11 + P3(:)*x19 +  &
               P3(:)*x7 - 2*P4(0)*x18vec + 2*P4(1)*x10vec - P4(1)*x21vec + P4(1&
               )*x30vec + P4(2)*x35vec + 2*P4(3)*x15vec + P4(3)*x32vec + P4(3)*&
               x33vec + 2*P4(:)*co(3)*x18 + P4(:)*x16 - P4(:)*x25 - P4(:)*x26  &
                - P4(:)*x27 + x0*x0vec - x0*x2vec - x0vec*x1 - x0vec*x2 - x0vec&
               *x3 + x1*x2vec + x10*x11vec + x10*x12vec - x10*x27vec - x10*    &
               x6vec + x10*x9vec + x11vec*x13 + x11vec*x14 + x11vec*x17 +      &
               x11vec*x18 - x11vec*x20 - x11vec*x22 - x11vec*x23 - x11vec*x5 + &
               x11vec*x8 + x12*x12vec - x12*x27vec - x12*x6vec - x12*x8vec +   &
               x12*x9vec + x12vec*x13 + x12vec*x14 + x12vec*x15 + x12vec*x17 + &
               x12vec*x18 - x12vec*x20 - x12vec*x22 - x12vec*x23 - x12vec*x5 + &
               x12vec*x8 + x12vec*x9 - x13*x27vec - x13*x4vec + x13*x9vec +    &
               x13vec*x14 + x13vec*x21 + x13vec*x8 - x14*x27vec - x14*x4vec +  &
               x14*x9vec - x15*x27vec - x15*x4vec - x15*x8vec + x15*x9vec - x17&
               *x17vec + x17*x9vec - x17vec*x18 + x17vec*x23 - x17vec*x30 - x18&
               *x8vec + x18*x9vec + x2*x2vec + x20*x6vec + x20*x8vec - x20*    &
               x9vec - x21*x27vec - x21*x6vec + x22*x4vec + x22*x8vec - x22*   &
               x9vec + x23*x8vec - x23*x9vec + x24*x2vec - x24*x3vec + x28*    &
               x2vec - x28*x3vec + x29*x2vec - x29*x3vec + x2vec*x3 - x2vec*x4 &
                - x30*x8vec + x3vec*x4 + x4vec*x5 - x4vec*x6 - x4vec*x8 - x4vec&
               *x9 + x5*x6vec + x5*x8vec - x5*x9vec - x6*x6vec + x6*x9vec -    &
               x6vec*x8 - x6vec*x9 + x8*x9vec - x8vec*x9 + x9*x9vec)
      case(SSSVV2)
!       P(4,5)*P(5,4)*c0
!       P(4,4)*P(5,5)*c1
!       c2*(P(4,4)*P(5,4) + P(4,5)*P(5,5))
!       c3*(Metric(4,5)*P(-1,4)**2 + Metric(4,5)*P(-1,5)**2)
!       Metric(4,5)*P(-1,4)*P(-1,5)*c4
        if (last) VB_last = .true.
        x0vec = co(3)*w4(:)
        x0 = P4(0)**2
        x1vec = co(4)*w4(:)
        x1 = P4(1)**2
        x2 = P4(2)**2
        x3 = P4(3)**2
        x2vec = 2*co(3)*w4(:)
        x3vec = P4(0)*co(4)*w4(:)
        x4 = P1(0)*w4(0)
        x4vec = P4(:)*co(0)
        x5vec = P1(:)*co(2)
        x5 = P1(1)*w4(1)
        x6vec = P2(:)*co(2)
        x7vec = P3(:)*co(2)
        x8vec = P4(:)*co(2)
        x9vec = P1(:)*co(2)*w4(2)
        x10vec = P2(:)*co(2)*w4(2)
        x11vec = P3(:)*co(2)*w4(2)
        x12vec = P1(2)*P4(:)*w4(2)
        x13vec = P1(:)*co(2)*w4(3)
        x14vec = P2(:)*co(2)*w4(3)
        x15vec = P3(:)*co(2)*w4(3)
        x16vec = P4(:)*co(2)*w4(3)
        x6 = P2(1)*w4(1)
        x7 = P3(1)*w4(1)
        x8 = P4(0)*co(1)*w4(0)
        x9 = P4(1)*w4(1)
        x10 = P4(2)*co(2)*w4(2)
        x17vec = P1(:)*P4(3)
        x11 = P2(0)*w4(0)
        x18vec = P3(:)*w4(2)
        x12 = P2(2)*co(2)
        x19vec = P4(:)*w4(2)
        x13 = P3(0)*w4(0)
        x20vec = P3(:)*P4(0)*w4(0)
        x14 = P4(0)*w4(0)
        x21vec = P4(1)*co(4)*w4(:)
        x22vec = P4(:)*co(0)*w4(1)
        x23vec = P4(2)*co(4)*w4(:)
        x24vec = P4(3)*co(4)*w4(:)
        x25vec = P4(:)*co(0)*w4(3)
        x15 = P4(1)*co(1)*w4(1)
        x16 = P4(2)*co(1)*w4(2)
        x26vec = P4(:)*co(0)*w4(2)
        x17 = P4(3)*co(1)*w4(3)
        x18 = P4(2)*co(1)
        x27vec = 2*P2(0)*co(3)*w4(:)
        x28vec = 2*P4(0)*co(3)*w4(:)
        x29vec = 2*P4(:)*co(2)
        x30vec = 2*P1(1)*co(3)*w4(:)
        x31vec = 2*P3(1)*co(3)*w4(:)
        x32vec = 2*P2(2)*co(3)*w4(:)
        x33vec = 2*P4(2)*co(3)*w4(:)
        x34vec = 2*P3(3)*co(3)*w4(:)
        x35vec = 2*P4(3)*co(3)*w4(:)
        wout = w1(0)*w2(0)*w3(0)*(-P1(0)**2*x0vec - P1(0)*P3(0)*x2vec - P1(0)* &
               x27vec - P1(0)*x28vec + P1(0)*x3vec + P1(1)**2*x0vec - P1(1)*   &
               x21vec - P1(1)*x22vec + P1(1)*x31vec + P1(2)**2*x0vec + P1(2)*P3&
               (2)*x2vec + P1(2)*x10vec + P1(2)*x11vec - P1(2)*x23vec + P1(2)* &
               x32vec + P1(2)*x33vec + P1(2)*x9vec + P1(3)**2*x0vec + P1(3)*P2(&
               3)*x2vec + P1(3)*x13vec + P1(3)*x14vec + P1(3)*x15vec + P1(3)*  &
               x16vec - P1(3)*x24vec - P1(3)*x25vec + P1(3)*x34vec + P1(3)*    &
               x35vec + P1(:)*x10 - P1(:)*x15 - P1(:)*x16 + P1(:)*x8 - P2(0)**2&
               *x0vec - P2(0)*x28vec + P2(0)*x3vec + P2(1)**2*x0vec + P2(1)*P4(&
               1)*x2vec - P2(1)*x21vec - P2(1)*x22vec + P2(1)*x30vec + P2(1)*  &
               x31vec + P2(2)**2*x0vec + P2(2)*x10vec - P2(2)*x23vec - P2(2)*  &
               x26vec + P2(2)*x33vec + P2(2)*x9vec + P2(3)**2*x0vec + P2(3)*   &
               x13vec + P2(3)*x14vec + P2(3)*x15vec + P2(3)*x16vec - P2(3)*    &
               x24vec - P2(3)*x25vec + P2(3)*x34vec + P2(3)*x35vec + P2(:)*x10 &
                - P2(:)*x15 - P2(:)*x16 - P2(:)*x17 + P2(:)*x8 - P3(0)**2*x0vec&
                - P3(0)*x27vec - P3(0)*x28vec + P3(0)*x3vec + P3(1)**2*x0vec - &
               P3(1)*x21vec - P3(1)*x22vec + P3(2)**2*x0vec + P3(2)*co(2)*     &
               x19vec + P3(2)*x10vec + P3(2)*x11vec - P3(2)*x23vec - P3(2)*    &
               x26vec + P3(2)*x32vec + P3(2)*x33vec + P3(2)*x9vec + P3(3)**2*  &
               x0vec + P3(3)*x13vec + P3(3)*x14vec + P3(3)*x15vec + P3(3)*     &
               x16vec - P3(3)*x24vec - P3(3)*x25vec + P3(:)*x10 - P3(:)*x15 -  &
               P3(:)*x17 - P4(1)*x22vec + P4(1)*x30vec + P4(1)*x31vec - P4(2)* &
               x26vec + P4(3)*x14vec + P4(3)*x15vec + 2*P4(3)*x16vec - P4(3)*  &
               x25vec + P4(3)*x34vec + 2*P4(:)*x10 - P4(:)*x15 - P4(:)*x17 + P4&
               (:)*x8 - co(0)*x12vec - co(1)*w4(3)*x17vec + co(1)*x20vec + co(2&
               )*w4(3)*x17vec + co(2)*x12vec - co(2)*x20vec + x0*x1vec - x0*   &
               x2vec - x1*x1vec + x1*x2vec + x11*x4vec - x11*x5vec - x11*x6vec &
                - x11*x7vec - x11*x8vec + x12*x18vec + x12*x19vec + x13*x4vec  &
                - x13*x5vec - x13*x6vec - x13*x7vec - x13*x8vec - x14*x29vec + &
               x14*x4vec - x14*x5vec - x14*x6vec - x18*x18vec - x18*x19vec -   &
               x1vec*x2 - x1vec*x3 + x2*x2vec + x29vec*x9 + x2vec*x3 + x4*x4vec&
                - x4*x5vec - x4*x6vec - x4*x7vec - x4*x8vec + x5*x5vec + x5*   &
               x6vec + x5*x7vec + x5*x8vec + x5vec*x6 + x5vec*x7 + x5vec*x9 +  &
               x6*x6vec + x6*x7vec + x6*x8vec + x6vec*x7 + x6vec*x9 + x7*x7vec &
                + x7*x8vec + x7vec*x9)
      case(SSSVV3)
!       P(4,5)*P(5,4)*c0
!       P(4,4)*P(5,5)*c1
!       c2*(2*P(4,2)*P(5,2) + P(4,2)*P(5,3) + P(4,3)*P(5,2) + 2*P(4,3)*P(5,3))
!       c3*(P(4,2)*P(5,4) + P(4,2)*P(5,5) + P(4,3)*P(5,4) + P(4,3)*P(5,5))
!       c4*(P(4,4)*P(5,2) + P(4,4)*P(5,3) + P(4,5)*P(5,2) + P(4,5)*P(5,3))
!       c5*(P(4,4)*P(5,4) + P(4,5)*P(5,5))
!       c6*(Metric(4,5)*P(-1,2)*P(-1,4) + Metric(4,5)*P(-1,2)*P(-1,5) + Metric(4,
!       5)*P(-1,3)*P(-1,4) + Metric(4,5)*P(-1,3)*P(-1,5))
!       Metric(4,5)*P(-1,2)*P(-1,3)*c7
!       Metric(4,5)*P(-1,4)*P(-1,5)*c8
!       c9*(Metric(4,5)*P(-1,2)**2 + Metric(4,5)*P(-1,3)**2)
!       c10*(Metric(4,5)*P(-1,4)**2 + Metric(4,5)*P(-1,5)**2)
        if (last) VB_last = .true.
        x0vec = co(10)*w4(:)
        x0 = P2(1)**2
        x1 = P2(2)**2
        x2 = P2(3)**2
        x3 = P3(1)**2
        x4 = P3(2)**2
        x5 = P3(3)**2
        x6 = P2(0)**2
        x1vec = co(6)*w4(:)
        x7 = P3(0)**2
        x8 = P4(0)**2
        x2vec = co(8)*w4(:)
        x3vec = co(9)*w4(:)
        x9 = P4(1)**2
        x10 = P4(2)**2
        x11 = P4(3)**2
        x4vec = 2*co(10)*w4(:)
        x5vec = P1(0)*co(6)*w4(:)
        x6vec = P2(:)*co(4)*w4(0)
        x7vec = P3(:)*w4(0)
        x8vec = P4(0)*co(8)*w4(:)
        x9vec = P4(:)*co(0)*w4(0)
        x12 = P1(1)*w4(1)
        x10vec = P1(:)*co(5)
        x11vec = P2(:)*co(5)
        x12vec = P3(:)*co(5)*w4(1)
        x13vec = P1(1)*P4(:)*w4(1)
        x13 = P1(2)*co(5)*w4(2)
        x14vec = P1(:)*co(5)*w4(3)
        x14 = P1(3)*w4(3)
        x15vec = P3(:)*co(5)
        x16vec = P4(:)*co(5)
        x17vec = P1(:)*co(3)*w4(0)
        x15 = P2(1)*w4(1)
        x16 = P2(2)*w4(2)
        x17 = P3(1)*co(5)
        x18vec = P1(:)*w4(1)
        x18 = P3(2)*co(5)*w4(2)
        x19 = P4(0)*co(1)
        x19vec = P1(:)*P4(1)*w4(1)
        x20 = P4(2)*w4(2)
        x20vec = P2(:)*co(3)*w4(0)
        x21 = P2(0)*co(4)*w4(0)
        x21vec = P2(0)*P3(:)*w4(0)
        x22vec = co(7)*w4(:)
        x22 = P2(1)*P3(1)
        x23vec = P2(1)*P3(:)*w4(1)
        x23 = P2(2)*P3(2)
        x24vec = P2(2)*P3(:)*w4(2)
        x24 = P2(3)*w4(3)
        x25 = P2(3)*P3(3)
        x25vec = P3(:)*co(2)
        x26vec = P2(:)*co(2)
        x26 = P3(1)*w4(1)
        x27 = P3(1)*co(5)*w4(1)
        x28 = P3(2)*w4(2)
        x29 = P3(3)*w4(3)
        x27vec = P2(:)*w4(0)
        x30 = P4(1)*w4(1)
        x31 = P4(3)*w4(3)
        x28vec = P3(0)*P3(:)*w4(0)
        x29vec = P3(:)*w4(1)
        x30vec = P3(:)*w4(2)
        x31vec = P3(:)*P4(3)*w4(3)
        x32vec = P4(:)*w4(0)
        x33vec = P1(:)*co(5)*w4(0)
        x32 = P1(0)*co(5)
        x34vec = P1(1)*co(6)*w4(:)
        x35vec = P2(:)*co(4)
        x36vec = P4(1)*co(8)*w4(:)
        x37vec = P1(2)*co(6)*w4(:)
        x38vec = P4(2)*co(8)*w4(:)
        x39vec = P4(:)*co(0)*w4(2)
        x40vec = P1(3)*co(6)*w4(:)
        x41vec = P3(:)*co(4)
        x42vec = P4(3)*co(8)*w4(:)
        x43vec = P4(:)*co(0)
        x44vec = P1(:)*co(3)
        x33 = P2(3)*co(3)*w4(3)
        x34 = P3(3)*co(3)*w4(3)
        x35 = P4(2)*co(1)*w4(2)
        x36 = P4(3)*co(1)*w4(3)
        x45vec = P2(0)*P2(:)*w4(0)
        x37 = P2(0)*P3(0)
        x46vec = P4(:)*co(5)*w4(0)
        x47vec = P2(:)*co(3)
        x48vec = P2(:)*P3(0)*w4(0)
        x38 = P4(0)*co(5)
        x49vec = P2(:)*co(1)
        x50vec = P3(1)*P3(:)*w4(1)
        x51vec = P3(2)*P3(:)*w4(2)
        x52vec = 2*P1(0)*co(10)*w4(:)
        x53vec = 2*P4(0)*co(10)*w4(:)
        x39 = 2*co(2)
        x54vec = 2*co(6)*w4(:)
        x55vec = 2*P1(1)*co(10)*w4(:)
        x56vec = 2*P1(2)*co(10)*w4(:)
        x57vec = 2*P4(2)*co(10)*w4(:)
        x58vec = 2*P1(3)*co(10)*w4(:)
        x59vec = 2*P2(:)*co(2)
        x60vec = 2*P4(1)*co(10)*w4(:)
        x61vec = 2*P4(3)*co(10)*w4(:)
        x62vec = 2*P4(:)*co(5)
        wout = w1(0)*w2(0)*w3(0)*(-P1(0)**2*x0vec + P1(0)*co(4)*x7vec - P1(0)* &
               x33vec - P1(0)*x53vec + P1(0)*x6vec + P1(0)*x8vec + P1(0)*x9vec &
                + P1(1)**2*x0vec - P1(1)*co(4)*x29vec + P1(1)*x12vec - P1(1)*  &
               x36vec + P1(2)**2*x0vec - P1(2)*co(4)*x30vec - P1(2)*w4(2)*     &
               x35vec - P1(2)*x38vec - P1(2)*x39vec + P1(2)*x57vec + P1(3)**2* &
               x0vec + P1(3)*x14vec - P1(3)*x42vec + P1(:)*w4(0)*x19 + P1(:)*  &
               x13 + P1(:)*x18 - P1(:)*x33 - P1(:)*x34 - P1(:)*x35 - P1(:)*x36 &
                + P2(0)*x17vec + P2(0)*x20vec - P2(0)*x33vec - P2(0)*x46vec -  &
               P2(0)*x52vec - P2(0)*x53vec + P2(0)*x5vec + P2(0)*x8vec + P2(0)*&
               x9vec - P2(1)*x34vec - P2(1)*x36vec + P2(1)*x55vec + P2(1)*     &
               x60vec - P2(2)*x37vec - P2(2)*x38vec - P2(2)*x39vec + P2(2)*    &
               x56vec + P2(2)*x57vec + P2(3)*x14vec - P2(3)*x40vec - P2(3)*    &
               x42vec + P2(3)*x58vec + P2(3)*x61vec + P2(:)*x13 + P2(:)*x18 +  &
               P2(:)*x21 + P2(:)*x27 - P2(:)*x33 - P2(:)*x34 - P2(:)*x35 + P3(0&
               )*x17vec + P3(0)*x20vec - P3(0)*x33vec - P3(0)*x46vec - P3(0)*  &
               x52vec - P3(0)*x53vec + P3(0)*x5vec + P3(0)*x6vec + P3(0)*x8vec &
                + P3(0)*x9vec - P3(1)*co(3)*x18vec - P3(1)*x34vec - P3(1)*     &
               x36vec + P3(1)*x55vec + P3(1)*x60vec - P3(2)*x37vec - P3(2)*    &
               x38vec - P3(2)*x39vec + P3(2)*x56vec + P3(2)*x57vec + 2*P3(3)*w4&
               (3)*x25vec + P3(3)*x14vec - P3(3)*x40vec - P3(3)*x42vec + P3(3)*&
               x58vec + P3(3)*x61vec + P3(:)*x13 + P3(:)*x18 + P3(:)*x21 - P3  &
               (:)*x33 - P3(:)*x34 - P3(:)*x35 - P4(0)*x33vec + P4(0)*x9vec -  &
               P4(1)*co(1)*x29vec + P4(1)*x12vec + P4(1)*x55vec + P4(2)*co(5)* &
               x30vec - P4(2)*x39vec + P4(3)*x14vec + P4(3)*x58vec - P4(:)*co(1&
               )*x30 - 2*P4(:)*w4(0)*x38 + P4(:)*x13 + P4(:)*x18 + P4(:)*x27 - &
               P4(:)*x35 - P4(:)*x36 - co(0)*x13vec - co(1)*x19vec - co(1)*    &
               x31vec - co(2)*x21vec + co(2)*x23vec + co(2)*x24vec - co(2)*    &
               x48vec + co(3)*x21vec - co(3)*x23vec - co(3)*x24vec + co(3)*    &
               x28vec - co(3)*x50vec - co(3)*x51vec - co(4)*x23vec - co(4)*    &
               x24vec + co(4)*x28vec - co(4)*x50vec - co(4)*x51vec + co(5)*    &
               x13vec + co(5)*x19vec - co(5)*x21vec + co(5)*x23vec + co(5)*    &
               x24vec - co(5)*x28vec + co(5)*x31vec - co(5)*x45vec - co(5)*    &
               x48vec + x0*x0vec - x0*x1vec + x0*x3vec + x0vec*x1 + x0vec*x2 + &
               x0vec*x3 + x0vec*x4 + x0vec*x5 - x0vec*x6 - x0vec*x7 - x1*x1vec &
                + x1*x3vec - x10*x2vec + x10*x4vec + x10vec*x12 + x10vec*x15 + &
               x10vec*x16 + x10vec*x20 - x11*x2vec + x11*x4vec + x11vec*x12 +  &
               x11vec*x14 + x11vec*x15 + x11vec*x16 + x11vec*x20 + x11vec*x24  &
                + x11vec*x29 + x11vec*x30 + x11vec*x31 - x12*x35vec + x14*     &
               x15vec + x14*x16vec - x14*x35vec - x14*x41vec - x14*x43vec + x15&
               *x16vec - x15*x35vec - x15*x43vec - x15*x44vec - x15*x47vec +   &
               x15*x59vec + x15vec*x24 + x15vec*x29 + x16*x16vec - x16*x35vec  &
                - x16*x44vec - x16*x47vec + x16*x59vec + x16vec*x24 + x16vec*  &
               x29 + x17*x18vec + x17*x29vec + x19*x27vec + x19*x32vec + x19*  &
               x7vec - x1vec*x2 - x1vec*x3 - x1vec*x4 - x1vec*x5 + x1vec*x6 +  &
               x1vec*x7 + x2*x3vec + x20*x62vec + x22*x22vec + x22*x4vec - x22*&
               x54vec + x22vec*x23 + x22vec*x25 - x22vec*x37 + x23*x4vec - x23*&
               x54vec + x24*x25vec - x24*x35vec - x24*x41vec - x24*x43vec + x24&
               *x59vec + x25*x4vec - x25*x54vec + x26*x26vec - x26*x35vec - x26&
               *x43vec - x26*x47vec + x26vec*x28 + x26vec*x29 - x27vec*x32 -   &
               x27vec*x38 - x28*x35vec - x28*x44vec - x28*x47vec - x28vec*x39  &
                - x29*x35vec - x29*x41vec - x29*x43vec + x2vec*x8 - x2vec*x9 + &
               x3*x3vec - x30*x43vec - x30*x49vec + x30*x62vec - x31*x43vec -  &
               x31*x49vec + x31*x62vec - x32*x32vec - x32*x7vec - x37*x4vec +  &
               x37*x54vec - x38*x7vec - x39*x45vec + x39*x50vec + x39*x51vec + &
               x3vec*x4 + x3vec*x5 - x3vec*x6 - x3vec*x7 - x4vec*x8 + x4vec*x9)
      end select 
    end subroutine treeSSSVV
end module tcSSSVV
