!******************************************************************************!
!                                                                              !
!    tcSSVVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSSVVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSSVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeSSVVS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SSVVS0)
!       P(3,4)*P(4,3)*c0
!       Metric(3,4)*P(-1,3)*P(-1,4)*c1
        x0 = co(1)*(-w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3))
        x1 = co(0)*(-P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3))
        wout(0) = w1(0)*w2(0)*(-P3(0)*P4(0)*x0 + P3(1)*P4(1)*x0 + P3(2)*P4(2)* &
                  x0 + P3(3)*P4(3)*x0 - P4(0)*w3(0)*x1 + P4(1)*w3(1)*x1 + P4(2 &
                  )*w3(2)*x1 + P4(3)*w3(3)*x1)
        wout(1:3) = cnul
      case(SSVVS1)
!       P(3,3)*P(4,4)*c0
!       P(3,4)*P(4,3)*c1
!       c2*(P(3,3)*P(4,3) + P(3,4)*P(4,4))
!       c3*(2*P(3,2)*P(4,2) + P(3,2)*P(4,3) + P(3,2)*P(4,4) + P(3,2)*P(4,5) + P(3
!       ,3)*P(4,2) + P(3,3)*P(4,5) + P(3,4)*P(4,2) + P(3,4)*P(4,5) + P(3,5)*P(4,2
!       ) + P(3,5)*P(4,3) + P(3,5)*P(4,4) + 2*P(3,5)*P(4,5))
!       c4*(Metric(3,4)*P(-1,2)**2 + Metric(3,4)*P(-1,2)*P(-1,3) + Metric(3,4)*P 
!       (-1,2)*P(-1,4) + Metric(3,4)*P(-1,2)*P(-1,5) + Metric(3,4)*P(-1,3)*P(-1,5
!       ) + Metric(3,4)*P(-1,4)*P(-1,5) + Metric(3,4)*P(-1,5)**2)
!       c5*(Metric(3,4)*P(-1,3)**2 + Metric(3,4)*P(-1,4)**2)
!       Metric(3,4)*P(-1,3)*P(-1,4)*c6
        x0 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x1 = co(4)*x0
        x2 = co(5)*x0
        x3 = P1(1)*co(4)*x0
        x4 = P3(1)*co(4)*x0
        x5 = P1(1)*w3(1)
        x6 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x7 = co(3)*x6
        x8 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x9 = co(3)*x8
        x10 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x11 = co(3)*x10
        x12 = P2(2)*co(4)*x0
        x13 = P1(2)*co(4)*x0
        x14 = P1(2)*w3(2)
        x15 = P2(3)*co(4)*x0
        x16 = P3(3)*co(4)*x0
        x17 = P1(3)*w3(3)
        x18 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x19 = co(3)*x18
        x20 = P2(1)*w3(1)
        x21 = co(3)*w3(2)*x18
        x22 = P2(2)*w3(2)
        x23 = co(3)*w3(3)*x18
        x24 = P2(3)*w3(3)
        x25 = co(6)*x0
        x26 = P3(1)*w3(1)
        x27 = co(0)*x10
        x28 = co(2)*x8
        x29 = P3(2)*w3(2)
        x30 = P3(3)*w3(3)
        x31 = co(1)*x8
        x32 = P4(1)*w3(1)
        x33 = co(2)*x10
        x34 = P4(2)*w3(2)
        x35 = P4(3)*w3(3)
        x36 = P2(0)*co(4)*x0
        x37 = P1(0)*co(4)*x0
        x38 = P1(0)*w3(0)
        x39 = co(3)*w3(0)*x18
        x40 = P2(0)*w3(0)
        x41 = P3(0)*w3(0)
        x42 = P4(0)*w3(0)
        x43 = 2*co(3)*x18
        x44 = 2*co(3)*x6
        wout(0) = w1(0)*w2(0)*(-P1(0)**2*x1 - P1(0)*x36 + P1(1)**2*x1 + P1(1)* &
                  x4 + P1(2)**2*x1 + P1(2)*x12 + 2*P1(2)*x21 + P1(3)**2*x1 + P1&
                  (3)*P4(3)*x1 + P1(3)*x15 + P1(3)*x16 - P2(0)**2*x1 - P2(0)*  &
                  x39 + P2(1)**2*x1 + P2(1)*P4(1)*x1 + P2(1)*x3 + P2(1)*x4 + P2&
                  (2)**2*x1 + P2(2)*x21 + P2(3)**2*x1 + P2(3)*x16 + P2(3)*x23  &
                   - P3(0)**2*x2 - P3(0)*P4(0)*x25 - P3(0)*x36 - P3(0)*x37 + P3&
                  (1)**2*x2 + P3(1)*P4(1)*x25 + P3(2)**2*x2 + P3(2)*P4(2)*x25  &
                   + P3(2)*x12 + P3(2)*x13 + P3(2)*x21 + P3(3)**2*x2 + P3(3)*P4&
                  (3)*x25 + P3(3)*x23 - P4(0)**2*x2 - P4(0)*x36 - P4(0)*x37 -  &
                  P4(0)*x39 + P4(1)**2*x2 + P4(1)*x3 + P4(2)**2*x2 + P4(2)*x12 &
                   + P4(2)*x13 + P4(2)*x21 + P4(3)**2*x2 + P4(3)*x15 + x11*x14 &
                   + x11*x17 + x11*x20 + x11*x22 + x11*x24 - x11*x38 - x11*x40 &
                   + x11*x5 + x14*x7 + x14*x9 + x17*x43 + x17*x7 + x17*x9 + x19&
                  *x20 + x19*x26 + x19*x32 + x19*x35 - x19*x41 + x20*x44 + x20*&
                  x9 + x22*x44 + x22*x9 + x24*x44 + x24*x9 + x26*x27 + x26*x28 &
                   + x26*x7 + x27*x29 + x27*x30 - x27*x41 + x28*x29 + x28*x30  &
                   - x28*x41 + x29*x7 + x30*x7 + x31*x32 + x31*x34 + x31*x35 - &
                  x31*x42 + x32*x33 + x32*x7 + x33*x34 + x33*x35 - x33*x42 +   &
                  x34*x7 + x35*x7 - x38*x43 - x38*x7 - x38*x9 - x40*x44 - x40* &
                  x9 - x41*x7 - x42*x7 + x43*x5 + x5*x7 + x5*x9)
        wout(1:3) = cnul
      case(SSVVS2)
!       c0*(P(3,3)*P(4,3) + P(3,4)*P(4,4))
!       P(3,4)*P(4,3)*c1
!       P(3,3)*P(4,4)*c2
!       c3*(Metric(3,4)*P(-1,3)**2 + Metric(3,4)*P(-1,4)**2)
!       Metric(3,4)*P(-1,3)*P(-1,4)*c4
        x0 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x1 = co(3)*x0
        x2 = co(4)*x0
        x3 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x4 = co(0)*x3
        x5 = P3(1)*w3(1)
        x6 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x7 = co(2)*x6
        x8 = P3(2)*w3(2)
        x9 = P3(3)*w3(3)
        x10 = co(0)*x6
        x11 = P4(1)*w3(1)
        x12 = co(1)*x3
        x13 = P4(2)*w3(2)
        x14 = P4(3)*w3(3)
        x15 = P3(0)*w3(0)
        x16 = P4(0)*w3(0)
        wout(0) = w1(0)*w2(0)*(-P3(0)**2*x1 - P3(0)*P4(0)*x2 + P3(1)**2*x1 + P3&
                  (1)*P4(1)*x2 + P3(2)**2*x1 + P3(2)*P4(2)*x2 + P3(3)**2*x1 +  &
                  P3(3)*P4(3)*x2 - P4(0)**2*x1 + P4(1)**2*x1 + P4(2)**2*x1 + P4&
                  (3)**2*x1 + x10*x11 + x10*x13 + x10*x14 - x10*x16 + x11*x12  &
                   + x12*x13 + x12*x14 - x12*x16 - x15*x4 - x15*x7 + x4*x5 + x4&
                  *x8 + x4*x9 + x5*x7 + x7*x8 + x7*x9)
        wout(1:3) = cnul
      case(SSVVS3)
!       c0*(P(3,3)*P(4,2) + P(3,3)*P(4,5) + P(3,4)*P(4,2) + P(3,4)*P(4,5))
!       c1*(P(3,2)*P(4,3) + P(3,2)*P(4,4) + P(3,5)*P(4,3) + P(3,5)*P(4,4))
!       P(3,3)*P(4,4)*c2
!       P(3,4)*P(4,3)*c3
!       c4*(2*P(3,2)*P(4,2) + P(3,2)*P(4,5) + P(3,5)*P(4,2) + 2*P(3,5)*P(4,5))
!       c5*(P(3,3)*P(4,3) + P(3,4)*P(4,4))
!       Metric(3,4)*P(-1,2)*P(-1,5)*c6
!       Metric(3,4)*P(-1,3)*P(-1,4)*c7
!       c8*(Metric(3,4)*P(-1,2)*P(-1,3) + Metric(3,4)*P(-1,2)*P(-1,4) + Metric(3,
!       4)*P(-1,3)*P(-1,5) + Metric(3,4)*P(-1,4)*P(-1,5))
!       c9*(Metric(3,4)*P(-1,3)**2 + Metric(3,4)*P(-1,4)**2)
!       c10*(Metric(3,4)*P(-1,2)**2 + Metric(3,4)*P(-1,5)**2)
        x0 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x1 = co(10)*x0
        x2 = P3(1)**2
        x3 = P3(2)**2
        x4 = P3(3)**2
        x5 = P4(1)**2
        x6 = P4(2)**2
        x7 = P4(3)**2
        x8 = P2(0)**2
        x9 = co(6)*x0
        x10 = P3(0)**2
        x11 = co(8)*x0
        x12 = P4(0)**2
        x13 = co(9)*x0
        x14 = P2(1)**2
        x15 = P2(2)**2
        x16 = P2(3)**2
        x17 = 2*co(10)*x0
        x18 = P2(0)*co(6)*x0
        x19 = P1(0)*co(8)*x0
        x20 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x21 = co(1)*x20
        x22 = P1(0)*w3(0)
        x23 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x24 = co(1)*x23
        x25 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x26 = co(4)*w3(1)*x25
        x27 = co(4)*x25
        x28 = P1(2)*w3(2)
        x29 = P1(3)*w3(3)
        x30 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x31 = P2(1)*co(4)*w3(1)
        x32 = P2(2)*co(4)*w3(2)
        x33 = P2(3)*co(4)*w3(3)
        x34 = co(0)*x30
        x35 = P3(0)*w3(0)
        x36 = co(0)*x20
        x37 = co(0)*w3(0)*x23
        x38 = co(7)*x0
        x39 = P3(1)*P4(1)
        x40 = P3(1)*w3(1)
        x41 = co(2)*x23
        x42 = co(5)*x20
        x43 = P3(2)*P4(2)
        x44 = P3(2)*w3(2)
        x45 = P3(3)*P4(3)
        x46 = P3(3)*w3(3)
        x47 = P3(3)*w3(3)*x20
        x48 = P4(0)*w3(0)
        x49 = P4(1)*w3(1)
        x50 = co(3)*x20
        x51 = co(5)*x23
        x52 = P4(2)*w3(2)
        x53 = P4(3)*w3(3)
        x54 = P2(1)*co(6)*x0
        x55 = P1(1)*co(8)*x0
        x56 = P1(1)*w3(1)
        x57 = P2(2)*co(6)*x0
        x58 = P1(2)*co(8)*x0
        x59 = P2(3)*co(6)*x0
        x60 = P1(3)*co(8)*x0
        x61 = P2(0)*co(4)*w3(0)
        x62 = P3(0)*P4(0)
        x63 = co(0)*x23
        x64 = 2*P2(0)*co(10)*x0
        x65 = 2*P1(0)*co(10)*x0
        x66 = 2*co(4)*x30
        x67 = 2*co(4)*x20
        x68 = -2*P4(0)*w4(0) + 2*P4(1)*w4(1) + 2*P4(2)*w4(2) + 2*P4(3)*w4(3)
        x69 = co(4)*x68
        x70 = 2*co(4)*x25
        x71 = 2*co(8)*x0
        x72 = 2*P2(1)*co(10)*x0
        x73 = 2*P1(1)*co(10)*x0
        x74 = P1(1)*co(4)*w3(1)
        x75 = -2*P1(0)*w4(0) + 2*P1(1)*w4(1) + 2*P1(2)*w4(2) + 2*P1(3)*w4(3)
        x76 = -2*P3(0)*w4(0) + 2*P3(1)*w4(1) + 2*P3(2)*w4(2) + 2*P3(3)*w4(3)
        x77 = 2*P1(2)*co(10)*x0
        x78 = 2*P1(3)*co(10)*x0
        x79 = -2*P2(0)*w4(0) + 2*P2(1)*w4(1) + 2*P2(2)*w4(2) + 2*P2(3)*w4(3)
        x80 = 2*P2(2)*co(10)*x0
        x81 = 2*P2(3)*co(10)*x0
        x82 = P3(1)*co(4)*w3(1)
        wout(0) = w1(0)*w2(0)*(-P1(0)**2*x1 + P1(0)*x18 - P1(0)*x64 + P1(1)**2*&
                  x1 + P1(1)*x26 - P1(1)*x54 + P1(1)*x72 + P1(2)**2*x1 - P1(2)*&
                  x57 + P1(3)**2*x1 - P1(3)*x59 - P2(0)*w3(0)*x70 + P2(2)*w3(2 &
                  )*x70 + P2(2)*x77 + P2(3)*x78 + P3(0)*x18 + P3(0)*x19 + P3(0 &
                  )*x37 - P3(0)*x64 - P3(0)*x65 + P3(1)*x26 - P3(1)*x54 - P3(1 &
                  )*x55 + P3(1)*x72 + P3(1)*x73 - P3(2)*x57 - P3(2)*x58 + P3(2 &
                  )*x77 + P3(2)*x80 - P3(3)*x59 - P3(3)*x60 + P3(3)*x78 + P3(3 &
                  )*x81 + P4(0)*x18 + P4(0)*x19 + P4(0)*x37 - P4(0)*x64 - P4(0 &
                  )*x65 - P4(1)*x54 - P4(1)*x55 + P4(1)*x72 + P4(1)*x73 - P4(2 &
                  )*x57 - P4(2)*x58 + P4(2)*x77 + P4(2)*x80 - P4(3)*x59 - P4(3 &
                  )*x60 + P4(3)*x78 + P4(3)*x81 - co(0)*x47 - co(1)*x47 + 2*co(&
                  4)*x47 + co(5)*x47 - x1*x10 - x1*x12 + x1*x2 + x1*x3 + x1*x4 &
                   + x1*x5 + x1*x6 + x1*x7 + x10*x11 - x10*x13 + x11*x12 - x11*&
                  x2 - x11*x3 - x11*x4 - x11*x5 - x11*x6 - x11*x7 - x12*x13 +  &
                  x13*x2 + x13*x3 + x13*x4 + x13*x5 + x13*x6 + x13*x7 + x14*x17&
                   - x14*x9 + x15*x17 - x15*x9 + x16*x17 - x16*x9 + x17*x39 +  &
                  x17*x43 + x17*x45 - x17*x62 - x17*x8 + x20*x31 + x20*x32 +   &
                  x20*x33 - x20*x61 + x21*x22 - x21*x28 - x21*x29 + x21*x35 -  &
                  x21*x40 - x21*x44 + x21*x48 - x21*x49 - x21*x52 - x21*x53 -  &
                  x21*x56 + x22*x24 - x22*x27 - x22*x66 - x22*x67 - x22*x69 +  &
                  x23*x31 + x23*x32 + x23*x33 - x23*x61 - x24*x28 - x24*x29 +  &
                  x24*x35 - x24*x40 - x24*x44 - x24*x46 + x24*x48 - x24*x49 -  &
                  x24*x52 - x24*x53 - x24*x56 + x27*x28 + x27*x29 - x27*x35 +  &
                  x27*x44 + x27*x46 - x27*x48 + x27*x49 + x27*x52 + x27*x53 +  &
                  x28*x66 + x28*x67 + x28*x69 + x29*x66 + x29*x67 + x29*x69 +  &
                  x30*x31 + x30*x32 + x30*x33 - x30*x61 + x31*x79 + x33*x79 +  &
                  x34*x35 - x34*x40 - x34*x44 - x34*x46 + x34*x48 - x34*x49 -  &
                  x34*x52 - x34*x53 + x35*x36 - x35*x41 - x35*x42 - x35*x66 -  &
                  x35*x67 - x35*x69 - x36*x40 - x36*x44 + x36*x48 - x36*x49 -  &
                  x36*x52 - x36*x53 + x38*x39 + x38*x43 + x38*x45 - x38*x62 -  &
                  x39*x71 + x40*x41 + x40*x42 - x40*x63 + x41*x44 + x41*x46 +  &
                  x42*x44 - x43*x71 - x44*x63 + x44*x66 + x44*x67 + x44*x69 -  &
                  x45*x71 - x46*x63 + x46*x66 + x46*x69 - x48*x50 - x48*x51 -  &
                  x48*x66 - x48*x67 - x48*x69 + x49*x50 + x49*x51 - x49*x63 +  &
                  x49*x66 + x49*x67 + x49*x69 + x50*x52 + x50*x53 + x51*x52 +  &
                  x51*x53 - x52*x63 + x52*x66 + x52*x67 + x52*x69 - x53*x63 +  &
                  x53*x66 + x53*x67 + x53*x69 + x62*x71 + x68*x74 + x68*x82 +  &
                  x74*x75 + x74*x76 + x75*x82 + x76*x82 + x8*x9)
        wout(1:3) = cnul
      end select 
    end subroutine treeSSVVS
end module tcSSVVS
