!******************************************************************************!
!                                                                              !
!    tcSVSSV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVSSV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVSSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeSVSSV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVSSV0)
!       P(2,5)*P(5,2)*c0
!       Metric(2,5)*P(-1,2)*P(-1,5)*c1
        if (last) VB_last = .true.
        x0vec = co(1)*w2(:)
        x1vec = P2(1)*co(1)*w2(:)
        x2vec = P2(:)*co(0)*w2(1)
        x3vec = P2(2)*co(1)*w2(:)
        x4vec = P2(:)*co(0)*w2(2)
        x5vec = P2(3)*co(1)*w2(:)
        x6vec = P2(:)*co(0)*w2(3)
        x7vec = P2(0)*co(1)*w2(:)
        x8vec = P2(:)*co(0)*w2(0)
        wout = -w1(0)*w3(0)*w4(0)*(-P1(0)*x7vec - P1(0)*x8vec + P1(1)*x1vec +  &
               P1(1)*x2vec + P1(2)*x3vec + P1(2)*x4vec + P1(3)*x5vec + P1(3)*  &
               x6vec - P2(0)**2*x0vec - P2(0)*x8vec + P2(1)**2*x0vec + P2(1)*  &
               x2vec + P2(2)**2*x0vec + P2(2)*x4vec + P2(3)**2*x0vec + P2(3)*  &
               x6vec - P3(0)*x7vec - P3(0)*x8vec + P3(1)*x1vec + P3(1)*x2vec + &
               P3(2)*x3vec + P3(2)*x4vec + P3(3)*x5vec + P3(3)*x6vec - P4(0)*  &
               x7vec - P4(0)*x8vec + P4(1)*x1vec + P4(1)*x2vec + P4(2)*x3vec + &
               P4(2)*x4vec + P4(3)*x5vec + P4(3)*x6vec)
      case(SVSSV1)
!       c0*(P(2,2)*P(5,3) + P(2,2)*P(5,4) + P(2,3)*P(5,2) + 2*P(2,3)*P(5,3) + P(2
!       ,3)*P(5,4) + P(2,3)*P(5,5) + P(2,4)*P(5,2) + P(2,4)*P(5,3) + 2*P(2,4)*P(5
!       ,4) + P(2,4)*P(5,5) + P(2,5)*P(5,3) + P(2,5)*P(5,4))
!       P(2,2)*P(5,5)*c1
!       c2*(P(2,2)*P(5,2) + P(2,5)*P(5,5))
!       P(2,5)*P(5,2)*c3
!       Metric(2,5)*P(-1,2)*P(-1,5)*c4
!       c5*(Metric(2,5)*P(-1,2)**2 + Metric(2,5)*P(-1,5)**2)
!       c6*(Metric(2,5)*P(-1,2)*P(-1,3) + Metric(2,5)*P(-1,2)*P(-1,4) + Metric(2,
!       5)*P(-1,3)**2 + Metric(2,5)*P(-1,3)*P(-1,4) + Metric(2,5)*P(-1,3)*P(-1,5 
!       ) + Metric(2,5)*P(-1,4)**2 + Metric(2,5)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P2(0)**2
        x0vec = co(4)*w2(:)
        x1vec = co(5)*w2(:)
        x1 = P2(1)**2
        x2 = P2(2)**2
        x3 = P2(3)**2
        x2vec = 2*co(5)*w2(:)
        x3vec = P2(0)*co(4)*w2(:)
        x4vec = P2(:)*co(3)
        x4 = P1(0)*w2(0)
        x5vec = P1(0)*co(6)*w2(:)
        x6vec = P3(:)*co(0)
        x7vec = P4(:)*co(0)
        x5 = P1(1)*w2(1)
        x8vec = P1(:)*co(2)
        x9vec = P2(:)*co(2)
        x10vec = P3(:)*co(2)
        x11vec = P4(:)*co(2)
        x6 = P1(2)*w2(2)
        x12vec = P1(:)*co(2)*w2(3)
        x7 = P1(3)*w2(3)
        x8 = P2(0)*co(1)*w2(0)
        x9 = P2(1)*w2(1)
        x10 = P2(2)*w2(2)
        x13vec = P1(:)*co(0)
        x11 = P3(0)*w2(0)
        x12 = P3(1)*w2(1)
        x13 = P3(2)*w2(2)
        x14 = P4(0)*w2(0)
        x15 = P4(1)*w2(1)
        x16 = P4(2)*w2(2)
        x17 = P2(0)*w2(0)
        x18 = P2(3)*w2(3)
        x19 = P3(3)*w2(3)
        x20 = P4(3)*w2(3)
        x14vec = co(6)*w2(:)
        x21 = P3(0)*P4(0)
        x15vec = P3(:)*P4(3)*w2(3)
        x22 = P1(0)*co(2)*w2(0)
        x16vec = P2(1)*co(4)*w2(:)
        x23 = P1(1)*P3(1)
        x17vec = P4(1)*co(6)*w2(:)
        x18vec = P2(2)*co(4)*w2(:)
        x19vec = P1(2)*co(6)*w2(:)
        x20vec = P2(3)*co(4)*w2(:)
        x24 = P1(3)*P3(3)
        x21vec = P4(3)*co(6)*w2(:)
        x25 = P2(1)*co(1)*w2(1)
        x26 = P2(2)*co(1)*w2(2)
        x27 = P2(3)*co(1)*w2(3)
        x22vec = P4(:)*co(2)*w2(0)
        x28 = P3(2)*P4(2)
        x23vec = 2*P1(0)*co(5)*w2(:)
        x24vec = 2*P4(0)*co(5)*w2(:)
        x25vec = 2*P2(:)*co(2)
        x26vec = 2*P1(1)*co(5)*w2(:)
        x27vec = 2*P2(2)*co(5)*w2(:)
        x28vec = 2*P1(2)*co(5)*w2(:)
        x29vec = 2*P1(3)*co(5)*w2(:)
        x30vec = 2*P4(1)*co(5)*w2(:)
        x31vec = 2*P3(3)*co(5)*w2(:)
        wout = w1(0)*w3(0)*w4(0)*(-P1(0)**2*x1vec - P1(0)*x24vec + P1(0)*x3vec &
                + P1(1)**2*x1vec - P1(1)*x16vec - P1(1)*x17vec + P1(2)**2*x1vec&
                - P1(2)*x18vec + P1(2)*x27vec + P1(3)**2*x1vec + P1(3)*x12vec  &
                - P1(3)*x20vec - P1(3)*x21vec - P1(:)*x22 - P1(:)*x25 - P1(:)* &
               x26 - P1(:)*x27 + P1(:)*x8 - P2(0)*P3(0)*x2vec - P2(0)*x22vec - &
               P2(0)*x23vec - P2(0)*x24vec + P2(1)*P3(1)*x2vec + P2(1)*x26vec  &
                + P2(1)*x30vec + P2(3)*P4(3)*x2vec + P2(3)*x12vec + P2(3)*     &
               x29vec + P2(3)*x31vec - P2(:)*x22 - P2(:)*x25 - P2(:)*x26 - P2  &
               (:)*x27 + P2(:)*x8 - P3(0)**2*x1vec - P3(0)*x22vec - P3(0)*     &
               x23vec + P3(0)*x3vec + P3(0)*x5vec + P3(1)**2*x1vec - P3(1)*    &
               x16vec - P3(1)*x17vec + P3(1)*x30vec + P3(2)**2*x1vec - P3(2)*  &
               x18vec - P3(2)*x19vec + P3(2)*x27vec + P3(2)*x28vec + P3(3)**2* &
               x1vec + P3(3)*x12vec - P3(3)*x20vec - P3(3)*x21vec - P3(:)*x22  &
                - P3(:)*x25 - P3(:)*x26 - P3(:)*x27 + P3(:)*x8 - P4(0)**2*x1vec&
                + P4(0)*x3vec + P4(0)*x5vec + P4(1)**2*x1vec - P4(1)*x16vec +  &
               P4(1)*x26vec + P4(2)**2*x1vec - P4(2)*x18vec - P4(2)*x19vec + P4&
               (2)*x27vec + P4(2)*x28vec + P4(3)**2*x1vec + P4(3)*x12vec - P4(3&
               )*x20vec + P4(3)*x29vec + P4(3)*x31vec - P4(:)*x25 - P4(:)*x26  &
                - P4(:)*x27 + P4(:)*x8 - co(0)*x15vec + co(2)*x15vec + x0*x0vec&
                - x0*x2vec - x0vec*x1 - x0vec*x2 - x0vec*x3 + x1*x2vec + x10*  &
               x10vec + x10*x11vec + x10*x25vec - x10*x4vec + x10*x8vec -      &
               x10vec*x11 + x10vec*x12 + x10vec*x13 - x10vec*x14 + x10vec*x15  &
                + x10vec*x16 - x10vec*x17 + x10vec*x18 + x10vec*x19 + x10vec*x5&
                + x10vec*x6 + x10vec*x7 + x10vec*x9 + x11*x13vec + x11*x4vec + &
               x11*x7vec - x11*x8vec - x11*x9vec + x11vec*x12 + x11vec*x13 -   &
               x11vec*x14 + x11vec*x15 + x11vec*x16 + x11vec*x18 + x11vec*x19  &
                + x11vec*x20 - x11vec*x4 + x11vec*x5 + x11vec*x6 + x11vec*x7 + &
               x11vec*x9 - x12*x13vec - x12*x4vec - x12*x7vec + x12*x8vec + x12&
               *x9vec - x13*x13vec - x13*x4vec - x13*x7vec + x13*x8vec + x13*  &
               x9vec + x13vec*x14 - x13vec*x15 - x13vec*x16 - x13vec*x19 -     &
               x13vec*x20 + x14*x4vec + x14*x6vec - x14*x8vec - x14*x9vec +    &
               x14vec*x21 - x14vec*x23 - x14vec*x24 - x14vec*x28 - x15*x4vec - &
               x15*x6vec + x15*x8vec + x15*x9vec - x16*x4vec - x16*x6vec + x16*&
               x8vec + x16*x9vec - x17*x25vec + x17*x4vec - x17*x8vec + x18*   &
               x25vec - x18*x4vec - x19*x4vec - x19*x7vec + x19*x9vec + x2*    &
               x2vec - x20*x4vec + x20*x9vec - x21*x2vec + x23*x2vec + x24*    &
               x2vec + x25vec*x9 + x28*x2vec + x2vec*x3 + x4*x4vec + x4*x6vec  &
                + x4*x7vec - x4vec*x5 - x4vec*x6 - x4vec*x7 - x4vec*x9 - x5*   &
               x6vec - x5*x7vec + x5*x8vec + x5*x9vec - x6*x6vec - x6*x7vec +  &
               x6*x8vec + x6*x9vec - x6vec*x7 - x7*x7vec + x7*x9vec + x8vec*x9)
      case(SVSSV2)
!       P(2,5)*P(5,2)*c0
!       P(2,2)*P(5,5)*c1
!       c2*(P(2,2)*P(5,2) + P(2,5)*P(5,5))
!       Metric(2,5)*P(-1,2)*P(-1,5)*c3
!       c4*(Metric(2,5)*P(-1,2)**2 + Metric(2,5)*P(-1,5)**2)
        if (last) VB_last = .true.
        x0 = P2(0)**2
        x0vec = co(3)*w2(:)
        x1vec = co(4)*w2(:)
        x1 = P2(1)**2
        x2 = P2(2)**2
        x3 = P2(3)**2
        x2vec = 2*co(4)*w2(:)
        x3vec = P2(0)*co(3)*w2(:)
        x4vec = P2(:)*co(0)*w2(0)
        x4 = P1(1)*w2(1)
        x5vec = P1(:)*co(2)
        x6vec = P2(:)*co(2)
        x7vec = P3(:)*co(2)
        x8vec = P4(:)*co(2)
        x5 = P1(2)*w2(2)
        x9vec = P3(:)*co(2)*w2(2)
        x10vec = P4(:)*co(2)*w2(2)
        x11vec = P1(:)*co(2)*w2(3)
        x6 = P1(3)*w2(3)
        x12vec = P3(:)*co(2)*w2(3)
        x7 = P2(0)*co(1)*w2(0)
        x8 = P2(1)*w2(1)
        x13vec = P1(:)*co(2)*w2(2)
        x9 = P3(1)*w2(1)
        x10 = P4(1)*w2(1)
        x11 = P2(3)*w2(3)
        x14vec = P2(:)*co(2)*w2(2)
        x12 = P3(3)*w2(3)
        x13 = P4(0)*w2(0)
        x15vec = P2(:)*co(0)
        x14 = P4(3)*w2(3)
        x15 = P1(0)*co(2)*w2(0)
        x16vec = P4(:)*co(2)*w2(0)
        x17vec = P2(1)*co(3)*w2(:)
        x18vec = P2(2)*co(3)*w2(:)
        x19vec = P2(3)*co(3)*w2(:)
        x16 = P2(0)*w2(0)
        x17 = P2(1)*co(1)*w2(1)
        x18 = P2(2)*co(1)*w2(2)
        x19 = P2(3)*co(1)*w2(3)
        x20 = P3(0)*w2(0)
        x20vec = P2(2)*P2(:)*w2(2)
        x21vec = P2(:)*co(0)*w2(2)
        x22vec = 2*P2(0)*co(4)*w2(:)
        x23vec = 2*P1(0)*co(4)*w2(:)
        x24vec = 2*P2(:)*co(2)
        x25vec = 2*P2(1)*co(4)*w2(:)
        x26vec = 2*P1(1)*co(4)*w2(:)
        x27vec = 2*P2(2)*co(4)*w2(:)
        x28vec = 2*P3(2)*co(4)*w2(:)
        x29vec = 2*P1(3)*co(4)*w2(:)
        x30vec = 2*P2(3)*co(4)*w2(:)
        wout = w1(0)*w3(0)*w4(0)*(-P1(0)**2*x1vec - P1(0)*x16vec - P1(0)*x22vec&
                + P1(0)*x3vec + P1(0)*x4vec + P1(1)**2*x1vec - P1(1)*x17vec +  &
               P1(1)*x25vec + P1(2)**2*x1vec + P1(2)*P4(2)*x2vec + P1(2)*x10vec&
                - P1(2)*x18vec + P1(2)*x27vec + P1(2)*x28vec + P1(2)*x9vec + P1&
               (3)**2*x1vec + P1(3)*x11vec + P1(3)*x12vec - P1(3)*x19vec - P1  &
               (:)*x15 - P1(:)*x17 - P1(:)*x18 - P1(:)*x19 + P1(:)*x7 - P2(0)* &
               x16vec + P2(0)*x4vec + P2(2)*x10vec + P2(2)*x13vec + P2(2)*x9vec&
                + P2(3)*x11vec + P2(3)*x12vec + P2(3)*x29vec - P2(:)*x15 - P2  &
               (:)*x17 - P2(:)*x19 + P2(:)*x7 - P3(0)**2*x1vec - P3(0)*P4(0)*  &
               x2vec - P3(0)*x16vec - P3(0)*x22vec - P3(0)*x23vec + P3(0)*x3vec&
                + P3(0)*x4vec + P3(1)**2*x1vec + P3(1)*P4(1)*x2vec - P3(1)*    &
               x17vec + P3(1)*x25vec + P3(1)*x26vec + P3(2)**2*x1vec + P3(2)*  &
               x10vec + P3(2)*x13vec + P3(2)*x14vec - P3(2)*x18vec - P3(2)*    &
               x21vec + P3(2)*x27vec + P3(2)*x9vec + P3(3)**2*x1vec + P3(3)*P4(&
               3)*x2vec + P3(3)*x11vec + P3(3)*x12vec - P3(3)*x19vec + P3(3)*  &
               x29vec + P3(3)*x30vec - P3(:)*x15 - P3(:)*x17 - P3(:)*x18 - P3  &
               (:)*x19 + P3(:)*x7 - P4(0)**2*x1vec - P4(0)*x22vec - P4(0)*     &
               x23vec + P4(0)*x3vec + P4(1)**2*x1vec - P4(1)*x17vec + P4(1)*   &
               x25vec + P4(1)*x26vec + P4(2)**2*x1vec + P4(2)*x10vec + P4(2)*  &
               x13vec + P4(2)*x14vec - P4(2)*x18vec - P4(2)*x21vec + P4(2)*    &
               x27vec + P4(2)*x28vec + P4(2)*x9vec + P4(3)**2*x1vec + P4(3)*   &
               x11vec + P4(3)*x12vec - P4(3)*x19vec + P4(3)*x29vec + P4(3)*    &
               x30vec - P4(:)*x17 - P4(:)*x18 - P4(:)*x19 + P4(:)*x7 - co(0)*  &
               x20vec - co(1)*x20vec + 2*co(2)*x20vec + x0*x0vec - x0*x2vec -  &
               x0vec*x1 - x0vec*x2 - x0vec*x3 + x1*x2vec - x10*x15vec + x10*   &
               x5vec + x10*x6vec + x10*x7vec + x10*x8vec - x11*x15vec + x11*   &
               x24vec + x11*x8vec - x12*x15vec + x12*x6vec + x12*x8vec + x13*  &
               x15vec - x13*x5vec - x13*x6vec - x13*x7vec - x13*x8vec - x14*   &
               x15vec + x14*x6vec + x14*x8vec - x15vec*x4 - x15vec*x5 - x15vec*&
               x6 - x15vec*x8 - x15vec*x9 - x16*x24vec - x16*x5vec - x16*x7vec &
                + x2*x2vec - x20*x5vec - x20*x6vec - x20*x7vec + x24vec*x8 +   &
               x2vec*x3 + x4*x5vec + x4*x6vec + x4*x7vec + x4*x8vec + x5*x5vec &
                + x5*x6vec + x5vec*x8 + x5vec*x9 + x6*x6vec + x6*x8vec + x6vec*&
               x9 + x7vec*x8 + x7vec*x9 + x8*x8vec + x8vec*x9)
      case(SVSSV3)
!       P(2,2)*P(5,5)*c0
!       c1*(P(2,2)*P(5,3) + P(2,2)*P(5,4) + P(2,5)*P(5,3) + P(2,5)*P(5,4))
!       c2*(P(2,2)*P(5,2) + P(2,5)*P(5,5))
!       c3*(2*P(2,3)*P(5,3) + P(2,3)*P(5,4) + P(2,4)*P(5,3) + 2*P(2,4)*P(5,4))
!       c4*(P(2,3)*P(5,2) + P(2,3)*P(5,5) + P(2,4)*P(5,2) + P(2,4)*P(5,5))
!       P(2,5)*P(5,2)*c5
!       c6*(Metric(2,5)*P(-1,2)*P(-1,3) + Metric(2,5)*P(-1,2)*P(-1,4) + Metric(2,
!       5)*P(-1,3)*P(-1,5) + Metric(2,5)*P(-1,4)*P(-1,5))
!       Metric(2,5)*P(-1,2)*P(-1,5)*c7
!       Metric(2,5)*P(-1,3)*P(-1,4)*c8
!       c9*(Metric(2,5)*P(-1,2)**2 + Metric(2,5)*P(-1,5)**2)
!       c10*(Metric(2,5)*P(-1,3)**2 + Metric(2,5)*P(-1,4)**2)
        if (last) VB_last = .true.
        x0 = P3(1)**2
        x0vec = co(10)*w2(:)
        x1 = P3(2)**2
        x2 = P3(3)**2
        x3 = P4(1)**2
        x1vec = w2(:)*x3
        x4 = P4(2)**2
        x5 = P4(3)**2
        x6 = P3(0)**2
        x2vec = co(6)*w2(:)
        x7 = P4(0)**2
        x8 = P2(0)**2
        x3vec = co(7)*w2(:)
        x4vec = co(9)*w2(:)
        x9 = P2(1)**2
        x10 = P2(2)**2
        x11 = P2(3)**2
        x5vec = 2*co(9)*w2(:)
        x6vec = P2(0)*co(7)*w2(:)
        x7vec = P2(:)*co(5)
        x12 = P1(0)*w2(0)
        x8vec = P1(0)*co(6)*w2(:)
        x9vec = P3(:)*co(1)
        x10vec = P1(0)*P4(:)*w2(0)
        x13 = P1(1)*w2(1)
        x11vec = P1(:)*co(2)
        x12vec = P2(:)*co(2)
        x13vec = P3(:)*co(2)
        x14vec = P4(:)*co(2)
        x14 = P1(2)*w2(2)
        x15 = P1(3)*w2(3)
        x15vec = P3(:)*co(2)*w2(3)
        x16 = P2(0)*co(0)*w2(0)
        x17 = P2(1)*w2(1)
        x18 = P2(2)*w2(2)
        x19 = P2(3)*w2(3)
        x20 = P3(0)*w2(0)
        x16vec = P1(:)*co(4)
        x21 = P3(1)*w2(1)
        x22 = P3(2)*co(2)*w2(2)
        x17vec = P1(:)*P3(3)*w2(3)
        x23 = P4(0)*w2(0)
        x24 = P4(1)*w2(1)
        x25 = P4(2)*w2(2)
        x26 = P4(3)*w2(3)
        x18vec = P2(:)*co(0)
        x27 = P2(0)*w2(0)
        x19vec = P3(:)*co(0)
        x20vec = P2(1)*P4(:)*w2(1)
        x28 = P3(3)*w2(3)
        x21vec = P3(:)*co(4)
        x22vec = P4(:)*co(1)
        x23vec = P4(:)*co(4)
        x24vec = co(8)*w2(:)
        x29 = P3(1)*P4(1)
        x25vec = P4(:)*co(3)
        x30 = P3(2)*P4(2)
        x31 = P3(2)*w2(2)
        x32 = P3(3)*P4(3)
        x26vec = P3(:)*P4(0)*w2(0)
        x27vec = P3(:)*co(3)
        x28vec = P2(1)*co(7)*w2(:)
        x29vec = P1(1)*co(6)*w2(:)
        x30vec = P2(2)*co(7)*w2(:)
        x31vec = P1(2)*co(6)*w2(:)
        x32vec = P2(3)*co(7)*w2(:)
        x33vec = P1(3)*co(6)*w2(:)
        x33 = P2(1)*co(0)*w2(1)
        x34 = P2(2)*co(0)*w2(2)
        x35 = P2(3)*co(0)*w2(3)
        x36 = P3(0)*P4(0)
        x34vec = 2*P1(0)*co(9)*w2(:)
        x35vec = 2*P2(:)*co(2)
        x36vec = 2*P2(0)*co(9)*w2(:)
        x37vec = 2*P3(:)*co(3)
        x38vec = 2*co(6)*w2(:)
        x39vec = 2*P4(:)*co(3)
        x40vec = 2*P1(1)*co(9)*w2(:)
        x41vec = 2*P3(1)*co(9)*w2(:)
        x42vec = 2*P3(2)*co(9)*w2(:)
        x43vec = 2*P4(2)*co(9)*w2(:)
        x44vec = 2*P3(3)*co(9)*w2(:)
        x45vec = 2*P4(3)*co(9)*w2(:)
        wout = w1(0)*w3(0)*w4(0)*(-P1(0)**2*x4vec + P1(0)*x6vec + P1(1)**2*    &
               x4vec - P1(1)*x28vec + P1(1)*x41vec + P1(2)**2*x4vec + P1(2)*P2(&
               2)*x5vec - P1(2)*x30vec + P1(2)*x42vec + P1(2)*x43vec + P1(3)**2&
               *x4vec + P1(3)*P2(3)*x5vec + P1(3)*x15vec - P1(3)*x32vec + P1(3 &
               )*x44vec + P1(3)*x45vec + P1(:)*x16 + P1(:)*x22 - P1(:)*x33 - P1&
               (:)*x34 - P1(:)*x35 - P2(0)*x34vec + P2(1)*P4(1)*x5vec + P2(1)* &
               x40vec + P2(1)*x41vec + P2(2)*x42vec + P2(2)*x43vec + P2(3)*    &
               x44vec + P2(3)*x45vec + P2(:)*x22 - P3(0)*x34vec - P3(0)*x36vec &
                + P3(0)*x6vec + P3(0)*x8vec - P3(1)*x28vec - P3(1)*x29vec - P3(&
               2)*x30vec - P3(2)*x31vec + P3(3)*x15vec - P3(3)*x32vec - P3(3)* &
               x33vec + P3(:)*x22 - P3(:)*x33 - P3(:)*x35 - P4(0)*x34vec - P4(0&
               )*x36vec + P4(0)*x6vec + P4(0)*x8vec - P4(1)*x28vec - P4(1)*    &
               x29vec + P4(1)*x40vec - P4(2)*x30vec - P4(2)*x31vec + P4(3)*    &
               x15vec - P4(3)*x32vec - P4(3)*x33vec + P4(:)*x16 + P4(:)*x22 -  &
               P4(:)*x34 - P4(:)*x35 - co(0)*x20vec + co(1)*x10vec + co(1)*    &
               x26vec + co(10)*x1vec - co(2)*x10vec + co(2)*x17vec + co(2)*    &
               x20vec - co(3)*x26vec - co(4)*x17vec + co(4)*x26vec + co(9)*    &
               x1vec + x0*x0vec - x0*x2vec + x0*x4vec + x0vec*x1 + x0vec*x2 +  &
               x0vec*x4 + x0vec*x5 - x0vec*x6 - x0vec*x7 - x1*x2vec + x1*x4vec &
                - x10*x3vec + x10*x5vec - x11*x3vec + x11*x5vec - x11vec*x12 + &
               x11vec*x13 + x11vec*x14 + x11vec*x15 + x11vec*x17 + x11vec*x18  &
                + x11vec*x19 - x11vec*x20 + x11vec*x21 - x11vec*x23 + x11vec*  &
               x24 + x11vec*x25 + x11vec*x26 - x11vec*x27 - x12*x12vec - x12*  &
               x13vec + x12*x7vec + x12*x9vec + x12vec*x13 + x12vec*x14 +      &
               x12vec*x15 - x12vec*x20 + x12vec*x21 - x12vec*x23 + x12vec*x24  &
                + x12vec*x25 + x12vec*x26 + x12vec*x28 + x13*x13vec + x13*     &
               x14vec - x13*x22vec - x13*x7vec - x13*x9vec + x13vec*x14 +      &
               x13vec*x17 + x13vec*x18 + x13vec*x19 - x13vec*x20 + x13vec*x21  &
                - x13vec*x23 + x13vec*x24 + x13vec*x25 - x13vec*x27 + x14*     &
               x14vec - x14*x22vec - x14*x7vec - x14*x9vec + x14vec*x15 +      &
               x14vec*x18 + x14vec*x19 - x14vec*x20 + x14vec*x21 - x14vec*x23  &
                + x14vec*x24 + x14vec*x25 + x14vec*x26 - x14vec*x27 + x14vec*  &
               x28 - x15*x22vec - x15*x7vec - x15*x9vec + x16vec*x20 - x16vec* &
               x21 + x16vec*x23 - x16vec*x24 - x16vec*x25 - x16vec*x26 - x16vec&
               *x31 - x17*x18vec + x17*x35vec - x17*x7vec - x18*x18vec - x18*  &
               x19vec + x18*x35vec - x18*x7vec - x18vec*x19 + x18vec*x27 + x19*&
               x35vec - x19*x7vec + x19vec*x27 - x2*x2vec + x2*x4vec + x20*    &
               x21vec + x20*x22vec + x20*x23vec - x20*x25vec - x20*x37vec + x20&
               *x7vec + x20*x9vec - x21*x21vec - x21*x22vec - x21*x23vec + x21*&
               x25vec + x21*x37vec - x21*x7vec - x21*x9vec - x21vec*x24 -      &
               x21vec*x25 - x21vec*x26 - x21vec*x28 - x21vec*x31 + x22vec*x23  &
                - x22vec*x24 - x22vec*x25 - x22vec*x26 - x22vec*x28 - x22vec*  &
               x31 + x23*x23vec - x23*x39vec + x23*x7vec - x23vec*x24 - x23vec*&
               x25 - x23vec*x26 - x23vec*x28 - x23vec*x31 + x24*x27vec + x24*  &
               x39vec - x24*x7vec - x24*x9vec + x24vec*x29 + x24vec*x30 +      &
               x24vec*x32 - x24vec*x36 + x25*x27vec + x25*x39vec - x25*x7vec - &
               x25*x9vec + x25vec*x28 + x25vec*x31 + x26*x27vec + x26*x39vec - &
               x26*x7vec - x26*x9vec - x27*x35vec + x27*x7vec + x28*x37vec -   &
               x28*x7vec - x28*x9vec - x29*x38vec + x29*x5vec - x2vec*x3 -     &
               x2vec*x4 - x2vec*x5 + x2vec*x6 + x2vec*x7 - x30*x38vec + x30*   &
               x5vec + x31*x37vec - x31*x7vec - x31*x9vec - x32*x38vec + x32*  &
               x5vec + x36*x38vec - x36*x5vec + x3vec*x8 - x3vec*x9 + x4*x4vec &
                + x4vec*x5 - x4vec*x6 - x4vec*x7 - x5vec*x8 + x5vec*x9)
      end select 
    end subroutine treeSVSSV
end module tcSVSSV
