!******************************************************************************!
!                                                                              !
!    tcSVSVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVSVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeSVSVS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVSVS0)
!       P(2,4)*P(4,2)*c0
!       Metric(2,4)*P(-1,2)*P(-1,4)*c1
        x0 = co(1)*(-w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3))
        x1 = co(0)*(-P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3))
        wout(0) = w1(0)*w3(0)*(-P2(0)*P4(0)*x0 + P2(1)*P4(1)*x0 + P2(2)*P4(2)* &
                  x0 + P2(3)*P4(3)*x0 - P4(0)*w2(0)*x1 + P4(1)*w2(1)*x1 + P4(2 &
                  )*w2(2)*x1 + P4(3)*w2(3)*x1)
        wout(1:3) = cnul
      case(SVSVS1)
!       c0*(P(2,2)*P(4,2) + P(2,4)*P(4,4))
!       P(2,4)*P(4,2)*c1
!       c2*(P(2,2)*P(4,3) + P(2,2)*P(4,5) + P(2,3)*P(4,2) + 2*P(2,3)*P(4,3) + P(2
!       ,3)*P(4,4) + P(2,3)*P(4,5) + P(2,4)*P(4,3) + P(2,4)*P(4,5) + P(2,5)*P(4,2
!       ) + P(2,5)*P(4,3) + P(2,5)*P(4,4) + 2*P(2,5)*P(4,5))
!       P(2,2)*P(4,4)*c3
!       Metric(2,4)*P(-1,2)*P(-1,4)*c4
!       c5*(Metric(2,4)*P(-1,2)*P(-1,3) + Metric(2,4)*P(-1,2)*P(-1,5) + Metric(2,
!       4)*P(-1,3)**2 + Metric(2,4)*P(-1,3)*P(-1,4) + Metric(2,4)*P(-1,3)*P(-1,5 
!       ) + Metric(2,4)*P(-1,4)*P(-1,5) + Metric(2,4)*P(-1,5)**2)
!       c6*(Metric(2,4)*P(-1,2)**2 + Metric(2,4)*P(-1,4)**2)
        x0 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x1 = co(5)*x0
        x2 = co(6)*x0
        x3 = P1(1)*co(5)*x0
        x4 = P3(1)*co(5)*x0
        x5 = P1(1)*w2(1)
        x6 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x7 = co(2)*x6
        x8 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x9 = co(2)*x8
        x10 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x11 = co(2)*x10
        x12 = P1(2)*co(5)*x0
        x13 = P3(2)*co(5)*x0
        x14 = co(2)*w2(2)*x6
        x15 = co(2)*w2(2)*x8
        x16 = co(2)*w2(2)*x10
        x17 = P1(3)*co(5)*x0
        x18 = w2(3)*x6
        x19 = P1(3)*w2(3)
        x20 = co(4)*x0
        x21 = P2(1)*w2(1)
        x22 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x23 = co(2)*w2(1)*x22
        x24 = co(3)*x10
        x25 = w2(2)*x6
        x26 = co(2)*w2(2)*x22
        x27 = w2(2)*x10
        x28 = P3(3)*co(5)*x0
        x29 = co(0)*w2(3)
        x30 = co(2)*w2(3)*x22
        x31 = P2(3)*w2(3)
        x32 = P3(1)*w2(1)
        x33 = P3(3)*co(2)
        x34 = P4(1)*w2(1)
        x35 = co(1)*x6
        x36 = co(2)*w2(3)*x8
        x37 = P1(0)*co(5)*x0
        x38 = P3(0)*co(5)*x0
        x39 = P1(0)*co(2)*w2(0)
        x40 = co(2)*w2(0)*x8
        x41 = co(0)*w2(0)
        x42 = co(2)*w2(0)*x22
        x43 = P3(0)*co(2)*w2(0)
        wout(0) = w1(0)*w3(0)*(-P1(0)**2*x1 - P1(0)*x38 - P1(0)*x40 - 2*P1(0)* &
                  x42 + P1(1)**2*x1 + 2*P1(1)*co(2)*w2(1)*x22 + P1(1)*x4 + P1(2&
                  )**2*x1 + P1(2)*x13 + P1(2)*x14 + P1(2)*x15 + P1(2)*x16 + 2* &
                  P1(2)*x26 + P1(3)**2*x1 + P1(3)*co(2)*x18 + 2*P1(3)*x30 - P2(&
                  0)**2*x2 - P2(0)*P4(0)*x20 - P2(0)*w2(0)*x24 - P2(0)*x37 - P2&
                  (0)*x38 - P2(0)*x40 - P2(0)*x41*x6 - P2(0)*x42 + P2(1)**2*x2 &
                   + P2(1)*P4(1)*x20 + P2(1)*x23 + P2(1)*x3 + P2(1)*x4 + P2(2  &
                  )**2*x2 + P2(2)*P4(2)*x20 + P2(2)*co(0)*x25 + P2(2)*co(3)*x27&
                   + P2(2)*x12 + P2(2)*x13 + P2(2)*x15 + P2(2)*x26 + P2(3)**2* &
                  x2 + P2(3)*P4(3)*x20 + P2(3)*x17 + P2(3)*x28 + P2(3)*x29*x6  &
                   + P2(3)*x30 - P3(0)**2*x1 - 2*P3(0)*x40 + P3(1)**2*x1 + P3(1&
                  )*x23 + P3(2)**2*x1 + P3(2)*x14 + 2*P3(2)*x15 + P3(2)*x16 +  &
                  P3(2)*x26 + P3(3)**2*x1 + P3(3)*x17 + P3(3)*x30 + 2*P3(3)*x36&
                   - P4(0)**2*x2 - P4(0)*w2(0)*x35 - P4(0)*x10*x41 - P4(0)*x37 &
                   - P4(0)*x38 - P4(0)*x40 - P4(0)*x42 + P4(1)**2*x2 + P4(1)*  &
                  x23 + P4(1)*x3 + P4(1)*x4 + P4(2)**2*x2 + P4(2)*co(0)*x27 +  &
                  P4(2)*co(1)*x25 + P4(2)*x12 + P4(2)*x13 + P4(2)*x15 + P4(2)* &
                  x26 + P4(3)**2*x2 + P4(3)*co(1)*x18 + P4(3)*x10*x29 + P4(3)* &
                  x17 + P4(3)*x28 + P4(3)*x30 + P4(3)*x36 + co(0)*x10*x34 + co(&
                  0)*x21*x6 + 2*co(2)*x32*x8 + w2(3)*x10*x33 - x10*x39 - x10*  &
                  x43 + x11*x19 + x11*x32 + x11*x5 + x18*x33 + x19*x9 + x21*x24&
                   + x21*x9 - x22*x43 + x24*x31 + x31*x9 + x32*x7 + x34*x35 +  &
                  x34*x9 - x39*x6 - x43*x6 + x5*x7 + x5*x9)
        wout(1:3) = cnul
      case(SVSVS2)
!       c0*(P(2,2)*P(4,2) + P(2,4)*P(4,4))
!       P(2,2)*P(4,4)*c1
!       P(2,4)*P(4,2)*c2
!       Metric(2,4)*P(-1,2)*P(-1,4)*c3
!       c4*(Metric(2,4)*P(-1,2)**2 + Metric(2,4)*P(-1,4)**2)
        x0 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x1 = co(4)*x0
        x2 = co(3)*x0
        x3 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x4 = co(0)*x3
        x5 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x6 = w2(1)*x5
        x7 = co(0)*w2(2)
        x8 = co(1)*x5
        x9 = P2(3)*w2(3)
        x10 = co(2)*x3
        x11 = co(0)*x5
        x12 = P4(3)*w2(3)
        x13 = P2(0)*w2(0)
        x14 = P4(0)*w2(0)
        wout(0) = w1(0)*w3(0)*(-P2(0)**2*x1 - P2(0)*P4(0)*x2 + P2(1)**2*x1 + P2&
                  (1)*P4(1)*x2 + P2(1)*co(1)*x6 + P2(1)*w2(1)*x4 + P2(2)**2*x1 &
                   + P2(2)*P4(2)*x2 + P2(2)*w2(2)*x8 + P2(2)*x3*x7 + P2(3)**2* &
                  x1 + P2(3)*P4(3)*x2 - P4(0)**2*x1 + P4(1)**2*x1 + P4(1)*co(0 &
                  )*x6 + P4(1)*w2(1)*x10 + P4(2)**2*x1 + P4(2)*w2(2)*x10 + P4(2&
                  )*x5*x7 + P4(3)**2*x1 + x10*x12 - x10*x14 + x11*x12 - x11*x14&
                   - x13*x4 - x13*x8 + x4*x9 + x8*x9)
        wout(1:3) = cnul
      case(SVSVS3)
!       c0*(P(2,2)*P(4,2) + P(2,4)*P(4,4))
!       P(2,4)*P(4,2)*c1
!       P(2,2)*P(4,4)*c2
!       c3*(2*P(2,3)*P(4,3) + P(2,3)*P(4,5) + P(2,5)*P(4,3) + 2*P(2,5)*P(4,5))
!       c4*(P(2,3)*P(4,2) + P(2,3)*P(4,4) + P(2,5)*P(4,2) + P(2,5)*P(4,4))
!       c5*(P(2,2)*P(4,3) + P(2,2)*P(4,5) + P(2,4)*P(4,3) + P(2,4)*P(4,5))
!       Metric(2,4)*P(-1,2)*P(-1,4)*c6
!       c7*(Metric(2,4)*P(-1,2)*P(-1,3) + Metric(2,4)*P(-1,2)*P(-1,5) + Metric(2,
!       4)*P(-1,3)*P(-1,4) + Metric(2,4)*P(-1,4)*P(-1,5))
!       c8*(Metric(2,4)*P(-1,3)**2 + Metric(2,4)*P(-1,5)**2)
!       Metric(2,4)*P(-1,3)*P(-1,5)*c9
!       c10*(Metric(2,4)*P(-1,2)**2 + Metric(2,4)*P(-1,4)**2)
        x0 = P2(1)**2
        x1 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x2 = co(10)*x1
        x3 = P2(2)**2*x1
        x4 = P2(3)**2
        x5 = P4(1)**2
        x6 = P4(2)**2
        x7 = P4(3)**2
        x8 = P2(0)**2
        x9 = co(7)*x1
        x10 = P4(0)**2
        x11 = co(8)*x1
        x12 = P3(0)**2
        x13 = co(9)*x1
        x14 = P3(1)**2
        x15 = P3(2)**2
        x16 = P3(3)**2
        x17 = 2*co(8)*x1
        x18 = P1(0)*co(7)*x1
        x19 = P3(0)*co(9)*x1
        x20 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x21 = P1(0)*w2(0)*x20
        x22 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x23 = co(4)*x22
        x24 = P1(0)*w2(0)
        x25 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x26 = co(3)*x25
        x27 = P1(1)*w2(1)
        x28 = co(3)*w2(2)*x25
        x29 = P1(3)*w2(3)
        x30 = P2(0)*w2(0)*x20
        x31 = P2(0)*w2(0)*x22
        x32 = P2(0)*w2(0)
        x33 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x34 = co(5)*x33
        x35 = co(6)*x1
        x36 = P2(1)*P4(1)
        x37 = P2(1)*w2(1)
        x38 = co(0)*x20
        x39 = co(2)*x22
        x40 = P2(2)*P4(2)
        x41 = P2(2)*w2(2)*x20
        x42 = P2(2)*w2(2)*x22
        x43 = P2(3)*P4(3)
        x44 = P2(3)*w2(3)
        x45 = P3(1)*co(3)*w2(1)
        x46 = P3(2)*co(3)
        x47 = w2(2)*x33
        x48 = w2(2)*x20
        x49 = w2(2)*x22
        x50 = P3(3)*co(3)*w2(3)
        x51 = P4(0)*w2(0)*x20
        x52 = P4(0)*w2(0)
        x53 = co(5)*x22
        x54 = co(0)*x22
        x55 = P4(1)*w2(1)
        x56 = P4(1)*w2(1)*x20
        x57 = P4(2)*w2(2)
        x58 = P4(2)*w2(2)*x20
        x59 = P4(3)*w2(3)
        x60 = P4(3)*w2(3)*x20
        x61 = P1(1)*co(7)*x1
        x62 = P3(1)*co(9)*x1
        x63 = co(4)*x20
        x64 = P1(2)*co(7)*x1
        x65 = P3(2)*co(9)*x1
        x66 = P1(2)*co(4)
        x67 = P1(3)*co(7)*x1
        x68 = P3(3)*co(9)*x1
        x69 = P2(0)*P4(0)
        x70 = P2(1)*w2(1)*x20
        x71 = co(5)*w2(1)*x22
        x72 = P2(2)*w2(2)
        x73 = P2(3)*w2(3)*x20
        x74 = P3(0)*co(3)*w2(0)
        x75 = 2*P1(0)*co(8)*x1
        x76 = 2*P3(0)*co(8)*x1
        x77 = 2*co(3)*x33
        x78 = 2*co(3)
        x79 = 2*co(3)*x22
        x80 = 2*co(7)*x1
        x81 = 2*co(3)*x25
        x82 = 2*P1(1)*co(8)*x1
        x83 = 2*co(3)*x20
        x84 = 2*P1(2)*co(8)*x1
        x85 = 2*P1(2)*co(3)
        x86 = 2*P1(3)*co(8)*x1
        x87 = 2*P3(3)*co(8)*x1
        x88 = 2*P3(1)*co(8)*x1
        x89 = 2*P3(2)*co(8)*x1
        wout(0) = w1(0)*w3(0)*(-P1(0)**2*x11 + P1(0)*x19 - P1(0)*x76 + P1(1)**2&
                  *x11 - P1(1)*x62 + P1(2)**2*x11 + P1(2)*x28 - P1(2)*x65 + P1(&
                  3)**2*x11 - P1(3)*x68 + P1(3)*x87 + P2(0)*x18 + P2(0)*x19 -  &
                  P2(0)*x75 - P2(0)*x76 - P2(1)*x61 - P2(1)*x62 - P2(1)*x71 +  &
                  P2(1)*x82 + P2(1)*x88 + P2(2)*w2(2)*x33*x78 + P2(2)*x28 - P2(&
                  2)*x64 - P2(2)*x65 + P2(2)*x84 + P2(2)*x89 - P2(3)*x67 - P2(3&
                  )*x68 + P2(3)*x86 + P2(3)*x87 - P3(0)*co(3)*w2(0)*x20 - P3(0 &
                  )*w2(0)*x81 + P3(1)*w2(1)*x81 + P3(1)*x82 + 2*P3(2)*x28 + P3(&
                  2)*x84 + P3(3)*w2(3)*x81 + P4(0)*x18 + P4(0)*x19 - P4(0)*x75 &
                   - P4(0)*x76 - P4(1)*x61 - P4(1)*x62 - P4(1)*x71 + P4(1)*x82 &
                   + P4(1)*x88 - P4(2)*x64 - P4(2)*x65 + P4(2)*x84 + P4(2)*x89 &
                   - P4(3)*x67 - P4(3)*x68 + P4(3)*x86 + P4(3)*x87 - co(0)*x30 &
                   + co(0)*x41 - co(1)*x51 + co(1)*x56 + co(1)*x58 + co(1)*x60 &
                   + co(10)*x3 - co(2)*x31 + co(2)*x42 + co(4)*x21 + co(4)*x30 &
                   + co(4)*x31 - co(4)*x41 + co(4)*x51 - co(4)*x56 - co(4)*x58 &
                   - co(4)*x60 - co(4)*x70 + co(5)*x30 + co(5)*x31 - co(5)*x41 &
                   + co(5)*x51 - co(5)*x56 - co(5)*x58 - co(5)*x60 - co(5)*x70 &
                   - co(5)*x73 - co(7)*x3 + co(8)*x3 + x0*x11 + x0*x2 - x0*x9  &
                   - x10*x11 - x10*x2 + x10*x9 + x11*x4 + x11*x5 + x11*x6 + x11&
                  *x7 - x11*x8 + x12*x13 - x12*x17 - x13*x14 - x13*x15 - x13*  &
                  x16 + x14*x17 + x15*x17 + x16*x17 + x17*x36 + x17*x40 + x17* &
                  x43 - x17*x69 + x2*x4 + x2*x5 + x2*x6 + x2*x7 - x2*x8 + x20* &
                  x45 + x20*x50 - x21*x78 + x22*x45 + x22*x50 - x22*x74 + x23* &
                  x24 - x23*x27 - x23*x29 - x23*x37 - x23*x44 + x23*x52 - x23* &
                  x55 - x23*x57 - x23*x59 - x23*x72 - x24*x26 - x24*x77 - x24* &
                  x79 + x26*x27 + x26*x29 - x26*x32 + x26*x37 + x26*x44 - x26* &
                  x52 + x26*x55 + x26*x57 + x26*x59 - x27*x63 + x27*x77 + x27* &
                  x79 + x27*x83 - x29*x63 + x29*x77 + x29*x79 + x29*x83 - x30* &
                  x78 - x31*x78 + x32*x34 - x32*x77 + x33*x45 + x33*x50 - x33* &
                  x74 - x34*x37 - x34*x44 + x34*x52 - x34*x55 - x34*x57 - x34* &
                  x59 - x34*x72 + x35*x36 + x35*x40 + x35*x43 - x35*x69 - x36* &
                  x80 + x37*x38 + x37*x39 + x37*x77 + x37*x79 + x38*x44 + x39* &
                  x44 - x4*x9 - x40*x80 + x41*x78 + x42*x78 - x43*x80 - x44*x53&
                   - x44*x63 + x44*x77 + x44*x79 + x46*x47 + x46*x48 + x46*x49 &
                   + x47*x85 - x48*x66 + x48*x85 - x49*x66 + x49*x85 - x5*x9 - &
                  x51*x78 + x52*x53 - x52*x54 - x52*x77 - x52*x79 - x53*x57 -  &
                  x53*x59 - x53*x72 + x54*x55 + x54*x57 + x54*x59 + x55*x77 +  &
                  x55*x79 + x56*x78 + x57*x77 + x57*x79 + x58*x78 + x59*x77 +  &
                  x59*x79 - x6*x9 + x60*x78 + x69*x80 - x7*x9 + x70*x78 + x73* &
                  x78 + x8*x9)
        wout(1:3) = cnul
      end select 
    end subroutine treeSVSVS
end module tcSVSVS
