!******************************************************************************!
!                                                                              !
!    tcSVVSS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVVSS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeSVVSS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVVSS0)
!       P(2,3)*P(3,2)*c0
!       Metric(2,3)*P(-1,2)*P(-1,3)*c1
        x0 = co(1)*(-w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3))
        x1 = co(0)*(-P2(0)*w3(0) + P2(1)*w3(1) + P2(2)*w3(2) + P2(3)*w3(3))
        wout(0) = w1(0)*w4(0)*(-P2(0)*P3(0)*x0 + P2(1)*P3(1)*x0 + P2(2)*P3(2)* &
                  x0 + P2(3)*P3(3)*x0 - P3(0)*w2(0)*x1 + P3(1)*w2(1)*x1 + P3(2 &
                  )*w2(2)*x1 + P3(3)*w2(3)*x1)
        wout(1:3) = cnul
      case(SVVSS1)
!       P(2,3)*P(3,2)*c0
!       c1*(P(2,4)*P(3,2) + P(2,4)*P(3,3) + P(2,5)*P(3,2) + P(2,5)*P(3,3))
!       c2*(P(2,2)*P(3,4) + P(2,2)*P(3,5) + P(2,3)*P(3,4) + P(2,3)*P(3,5))
!       P(2,2)*P(3,3)*c3
!       c4*(P(2,2)*P(3,2) + P(2,3)*P(3,3))
!       c5*(2*P(2,4)*P(3,4) + P(2,4)*P(3,5) + P(2,5)*P(3,4) + 2*P(2,5)*P(3,5))
!       c6*(Metric(2,3)*P(-1,2)*P(-1,4) + Metric(2,3)*P(-1,2)*P(-1,5) + Metric(2,
!       3)*P(-1,3)*P(-1,4) + Metric(2,3)*P(-1,3)*P(-1,5))
!       c7*(Metric(2,3)*P(-1,2)**2 + Metric(2,3)*P(-1,3)**2)
!       Metric(2,3)*P(-1,4)*P(-1,5)*c8
!       Metric(2,3)*P(-1,2)*P(-1,3)*c9
!       c10*(Metric(2,3)*P(-1,4)**2 + Metric(2,3)*P(-1,5)**2)
        x0 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x1 = co(10)*x0
        x2 = P2(1)**2
        x3 = x0*x2
        x4 = P2(2)**2
        x5 = P2(3)**2
        x6 = P3(1)**2
        x7 = P3(2)**2
        x8 = P3(3)**2
        x9 = P2(0)**2
        x10 = co(6)*x0
        x11 = P3(0)**2
        x12 = co(7)*x0
        x13 = P4(0)**2
        x14 = co(8)*x0
        x15 = P4(1)**2
        x16 = P4(2)**2
        x17 = P4(3)**2
        x18 = 2*co(10)*x0
        x19 = P1(0)*co(6)*x0
        x20 = P4(0)*co(8)*x0
        x21 = P1(0)*w2(0)
        x22 = -P2(0)*w3(0) + P2(1)*w3(1) + P2(2)*w3(2) + P2(3)*w3(3)
        x23 = co(1)*x22
        x24 = -P3(0)*w3(0) + P3(1)*w3(1) + P3(2)*w3(2) + P3(3)*w3(3)
        x25 = co(1)*x24
        x26 = -P4(0)*w3(0) + P4(1)*w3(1) + P4(2)*w3(2) + P4(3)*w3(3)
        x27 = co(5)*w2(1)*x26
        x28 = co(5)*w2(2)*x26
        x29 = co(5)*w2(3)*x26
        x30 = P2(0)*w2(0)*x22
        x31 = P2(0)*w2(0)
        x32 = -P1(0)*w3(0) + P1(1)*w3(1) + P1(2)*w3(2) + P1(3)*w3(3)
        x33 = co(2)*x32
        x34 = co(2)*x24
        x35 = co(9)*x0
        x36 = P2(1)*P3(1)
        x37 = P2(1)*w2(1)*x24
        x38 = P2(1)*w2(1)*x22
        x39 = P2(2)*P3(2)
        x40 = P2(2)*w2(2)*x24
        x41 = P2(2)*w2(2)*x22
        x42 = co(5)*x26
        x43 = P2(2)*w2(2)
        x44 = P2(3)*P3(3)
        x45 = co(3)*x24
        x46 = P2(3)*w2(3)
        x47 = P2(3)*w2(3)*x22
        x48 = P3(0)*w2(0)
        x49 = P3(0)*co(2)*w2(0)
        x50 = P3(1)*w2(1)*x22
        x51 = P3(1)*w2(1)*x24
        x52 = P3(2)*w2(2)
        x53 = co(0)*x22
        x54 = P3(2)*w2(2)*x24
        x55 = P3(3)*w2(3)*x22
        x56 = P3(3)*w2(3)*x24
        x57 = P4(1)*co(5)
        x58 = w2(1)*x32
        x59 = w2(1)*x22
        x60 = w2(1)*x24
        x61 = P4(2)*co(5)
        x62 = w2(2)*x32
        x63 = w2(2)*x22
        x64 = w2(2)*x24
        x65 = P4(3)*co(5)
        x66 = w2(3)*x32
        x67 = w2(3)*x22
        x68 = w2(3)*x24
        x69 = P1(1)*co(6)*x0
        x70 = P4(1)*co(8)*x0
        x71 = P1(1)*co(1)
        x72 = P1(2)*co(6)*x0
        x73 = P4(2)*co(8)*x0
        x74 = P1(2)*co(1)
        x75 = P1(3)*co(6)*x0
        x76 = P4(3)*co(8)*x0
        x77 = co(1)*w2(3)*x22
        x78 = co(1)*w2(3)*x24
        x79 = P2(0)*P3(0)
        x80 = P2(1)*co(2)
        x81 = P2(2)*co(2)
        x82 = P3(0)*w2(0)*x24
        x83 = P3(2)*w2(2)*x22
        x84 = P3(3)*co(2)
        x85 = P4(0)*co(5)*w2(0)
        x86 = 2*P1(0)*co(10)*x0
        x87 = 2*co(5)*x32
        x88 = 2*P1(0)*co(5)*w2(0)
        x89 = 2*P4(0)*co(10)*x0
        x90 = 2*co(5)
        x91 = 2*co(5)*x24
        x92 = 2*co(6)*x0
        x93 = 2*P3(1)*co(10)*x0
        x94 = 2*P4(1)*co(10)*x0
        x95 = 2*co(5)*w2(1)*x32
        x96 = 2*P1(1)*co(5)
        x97 = 2*P1(2)*co(10)*x0
        x98 = 2*P1(2)*co(5)
        x99 = 2*P1(3)*co(10)*x0
        x100 = 2*P1(3)*co(5)
        x101 = 2*P4(2)*co(10)*x0
        x102 = 2*P4(3)*co(10)*x0
        wout(0) = w1(0)*w4(0)*(-P1(0)**2*x1 + P1(0)*x20 + P1(1)**2*x1 + P1(1)* &
                  P2(1)*x18 + P1(1)*x27 - P1(1)*x70 + P1(1)*x93 + P1(1)*x94 +  &
                  P1(1)*x95 + P1(2)**2*x1 + P1(2)*x28 - P1(2)*x73 + P1(3)**2*x1&
                   + P1(3)*x29 - P1(3)*x76 - P1(3)*x77 - P1(3)*x78 + P2(0)*x19 &
                   + P2(0)*x20 - P2(0)*x86 - P2(0)*x89 + P2(1)*x27 - P2(1)*x69 &
                   - P2(1)*x70 + P2(1)*x94 + P2(1)*x95 + P2(2)*x101 - P2(2)*x72&
                   - P2(2)*x73 + P2(2)*x97 + P2(3)*x102 + P2(3)*x29 - P2(3)*x75&
                   - P2(3)*x76 + P2(3)*x99 - P3(0)*w2(0)*x22*x90 + P3(0)*x19 + &
                  P3(0)*x20 - P3(0)*x86 - P3(0)*x89 - P3(1)*w2(1)*x33 + P3(1)* &
                  x27 - P3(1)*x69 - P3(1)*x70 + P3(1)*x95 + P3(2)*x101 - P3(2)*&
                  x72 - P3(2)*x73 + P3(2)*x97 + P3(3)*w2(3)*x32*x90 + P3(3)*   &
                  x102 + P3(3)*x29 - P3(3)*x75 - P3(3)*x76 - P3(3)*x77 - P3(3)*&
                  x78 + P3(3)*x99 - 2*P4(0)*w2(0)*x42 - P4(0)*x86 + 2*P4(1)*x27&
                   + P4(1)*x93 + 2*P4(2)*x28 + P4(2)*x97 + 2*P4(3)*x29 + P4(3)*&
                  x99 + co(0)*x50 + co(0)*x55 + co(1)*x30 - co(1)*x37 - co(1)* &
                  x38 - co(1)*x40 - co(1)*x41 - co(1)*x47 - co(1)*x50 - co(1)* &
                  x51 - co(1)*x54 - co(1)*x83 + co(10)*x3 + co(2)*x30 - co(2)* &
                  x47 - co(2)*x50 - co(2)*x51 - co(2)*x54 - co(2)*x83 + co(3)* &
                  x37 + co(3)*x40 - co(4)*x30 + co(4)*x38 + co(4)*x41 + co(4)* &
                  x47 + co(4)*x51 + co(4)*x54 + co(4)*x56 - co(4)*x82 + co(7)* &
                  x3 - x1*x11 + x1*x4 + x1*x5 + x1*x6 + x1*x7 + x1*x8 - x1*x9  &
                   + x10*x11 - x10*x2 - x10*x4 - x10*x5 - x10*x6 - x10*x7 - x10&
                  *x8 + x10*x9 + x100*x66 + x100*x67 + x100*x68 - x11*x12 + x12&
                  *x4 + x12*x5 + x12*x6 + x12*x7 + x12*x8 - x12*x9 + x13*x14 - &
                  x13*x18 - x14*x15 - x14*x16 - x14*x17 + x15*x18 + x16*x18 +  &
                  x17*x18 + x18*x36 + x18*x39 + x18*x44 - x18*x79 + x21*x23 +  &
                  x21*x25 - x21*x42 - x21*x87 + x22*x49 - x22*x85 - x22*x88 +  &
                  x23*x48 + x24*x49 - x24*x85 - x24*x88 + x25*x31 - x25*x46 +  &
                  x25*x48 - x30*x90 + x31*x33 + x31*x34 - x31*x42 - x31*x45 -  &
                  x31*x87 - x31*x91 - x32*x85 - x33*x43 - x33*x46 + x33*x48 -  &
                  x33*x52 - x34*x46 + x35*x36 + x35*x39 + x35*x44 - x35*x79 -  &
                  x36*x92 + x37*x90 + x38*x90 - x39*x92 + x40*x90 + x41*x90 +  &
                  x42*x43 - x42*x48 + x42*x52 + x43*x87 - x44*x92 + x45*x46 +  &
                  x46*x87 + x46*x91 + x47*x90 - x48*x53 - x48*x87 + x50*x90 +  &
                  x51*x90 + x52*x53 + x52*x87 + x54*x90 + x55*x90 + x56*x90 +  &
                  x57*x58 + x57*x59 + x57*x60 - x58*x80 - x59*x71 - x59*x80 +  &
                  x59*x96 - x60*x71 - x60*x80 + x60*x96 + x61*x62 + x61*x63 +  &
                  x61*x64 + x62*x98 - x63*x74 - x63*x81 + x63*x98 - x64*x74 -  &
                  x64*x81 + x64*x98 + x65*x66 + x65*x67 + x65*x68 - x66*x84 -  &
                  x67*x84 - x68*x84 + x79*x92 - x82*x90 + x83*x90)
        wout(1:3) = cnul
      case(SVVSS2)
!       P(2,3)*P(3,2)*c0
!       c1*(P(2,2)*P(3,2) + P(2,3)*P(3,3))
!       P(2,2)*P(3,3)*c2
!       c3*(Metric(2,3)*P(-1,2)**2 + Metric(2,3)*P(-1,3)**2)
!       Metric(2,3)*P(-1,2)*P(-1,3)*c4
        x0 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x1 = co(3)*x0
        x2 = co(4)*x0
        x3 = -P2(0)*w3(0) + P2(1)*w3(1) + P2(2)*w3(2) + P2(3)*w3(3)
        x4 = co(1)*x3
        x5 = P2(1)*w2(1)
        x6 = -P3(0)*w3(0) + P3(1)*w3(1) + P3(2)*w3(2) + P3(3)*w3(3)
        x7 = co(2)*x6
        x8 = P2(2)*w2(2)
        x9 = P2(3)*w2(3)
        x10 = co(0)*x3
        x11 = P3(1)*w2(1)
        x12 = co(1)*x6
        x13 = P3(2)*w2(2)
        x14 = P3(3)*w2(3)
        x15 = P2(0)*w2(0)
        x16 = P3(0)*w2(0)
        wout(0) = w1(0)*w4(0)*(-P2(0)**2*x1 - P2(0)*P3(0)*x2 + P2(1)**2*x1 + P2&
                  (1)*P3(1)*x2 + P2(2)**2*x1 + P2(2)*P3(2)*x2 + P2(3)**2*x1 +  &
                  P2(3)*P3(3)*x2 - P3(0)**2*x1 + P3(1)**2*x1 + P3(2)**2*x1 + P3&
                  (3)**2*x1 + x10*x11 + x10*x13 + x10*x14 - x10*x16 + x11*x12  &
                   + x12*x13 + x12*x14 - x12*x16 - x15*x4 - x15*x7 + x4*x5 + x4&
                  *x8 + x4*x9 + x5*x7 + x7*x8 + x7*x9)
        wout(1:3) = cnul
      end select 
    end subroutine treeSVVSS
end module tcSVVSS
