!******************************************************************************!
!                                                                              !
!    tcSVVVV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcSVVVV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcSVVVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeSVVVV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(SVVVV0)
!       Metric(2,5)*Metric(3,4)*c0
!       Metric(2,4)*Metric(3,5)*c1
!       Metric(2,3)*Metric(4,5)*c2
        if (last) VB_last = .true.
        x0vec = co(1)*w3(:)
        x1vec = co(2)*w4(:)
        wout = w1(0)*(co(0)*w2(:)*(-w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) +  &
               w3(3)*w4(3)) - w2(0)*w3(0)*x1vec - w2(0)*w4(0)*x0vec + w2(1)*w3(&
               1)*x1vec + w2(1)*w4(1)*x0vec + w2(2)*w3(2)*x1vec + w2(2)*w4(2)* &
               x0vec + w2(3)*w3(3)*x1vec + w2(3)*w4(3)*x0vec)
      case(SVVVV1)
!       c0*(-Metric(2,3)*P(4,2)*P(5,4) + Metric(2,3)*P(4,3)*P(5,4) + Metric(2,3)*
!       P(4,5)*P(5,2) - Metric(2,3)*P(4,5)*P(5,3) - Metric(2,4)*P(3,2)*P(5,3) +  
!       Metric(2,4)*P(3,4)*P(5,3) + Metric(2,4)*P(3,5)*P(5,2) - Metric(2,4)*P(3,5
!       )*P(5,4) - Metric(3,5)*P(2,3)*P(4,2) + Metric(3,5)*P(2,4)*P(4,3) - Metric
!       (3,5)*P(2,4)*P(4,5) + Metric(3,5)*P(2,5)*P(4,2) + Metric(4,5)*P(2,3)*P(3,
!       4) - Metric(4,5)*P(2,3)*P(3,5) - Metric(4,5)*P(2,4)*P(3,2) + Metric(4,5)*
!       P(2,5)*P(3,2))
!       c1*(Metric(2,3)*P(4,2)*P(5,3) + Metric(2,4)*P(3,2)*P(5,4) - Metric(2,5)*P
!       (3,2)*P(4,5) - Metric(2,5)*P(3,5)*P(4,2) - Metric(3,4)*P(2,3)*P(5,4) -   
!       Metric(3,4)*P(2,4)*P(5,3) + Metric(3,5)*P(2,3)*P(4,5) + Metric(4,5)*P(2,4
!       )*P(3,5))
!       c2*(-Metric(2,3)*Metric(4,5)*P(-1,2)*P(-1,4) + Metric(2,3)*Metric(4,5)*P 
!       (-1,2)*P(-1,5) + Metric(2,3)*Metric(4,5)*P(-1,3)*P(-1,4) - Metric(2,3)*  
!       Metric(4,5)*P(-1,3)*P(-1,5) - Metric(2,4)*Metric(3,5)*P(-1,2)*P(-1,3) +  
!       Metric(2,4)*Metric(3,5)*P(-1,2)*P(-1,5) + Metric(2,4)*Metric(3,5)*P(-1,3 
!       )*P(-1,4) - Metric(2,4)*Metric(3,5)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P2(1)**2
        x1 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x0vec = co(2)*w3(:)*x1
        x2 = P2(2)**2
        x3 = P2(3)**2
        x4 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x1vec = co(2)*w4(:)*x4
        x5 = P2(0)**2
        x2vec = P3(0)*co(2)*w4(:)*x4
        x6 = P1(0)*w4(0)
        x3vec = P3(:)*co(0)*x4
        x4vec = P4(0)*co(2)*w3(:)*x1
        x7 = P1(0)*w3(0)
        x5vec = P4(:)*co(0)*x1
        x8 = P2(1)*w4(1)
        x9 = P2(2)*w4(2)
        x10 = P2(3)*w4(3)
        x11 = P2(0)*w4(0)
        x12 = x10 - x11 + x8 + x9
        x6vec = co(1)*w2(:)*x12
        x7vec = P1(1)*co(2)*w3(:)*x1
        x8vec = P1(1)*co(2)*w4(:)*x4
        x13 = P1(1)*w3(1)
        x9vec = P2(:)*co(0)*x1
        x14 = P1(1)*w4(1)
        x10vec = P2(:)*co(0)*x4
        x11vec = co(0)*w2(1)*w3(:)*x12
        x15 = P2(1)*w3(1)
        x16 = P2(2)*w3(2)
        x17 = P2(3)*w3(3)
        x18 = P2(0)*w3(0)
        x19 = x15 + x16 + x17 - x18
        x12vec = co(0)*w2(1)*w4(:)*x19
        x13vec = P1(2)*co(2)*w3(:)*x1
        x14vec = P1(2)*co(2)*w4(:)*x4
        x20 = P1(2)*w3(2)
        x21 = P1(2)*w4(2)
        x15vec = co(0)*w3(:)*x12
        x22 = P1(2)*w2(2)
        x16vec = co(0)*w4(:)*x19
        x17vec = P1(3)*co(2)*w3(:)*x1
        x18vec = P1(3)*co(2)*w4(:)*x4
        x23 = P1(3)*w3(3)
        x24 = P1(3)*w4(3)
        x19vec = co(0)*w2(3)*w3(:)*x12
        x20vec = co(0)*w2(3)*w4(:)*x19
        x25 = P2(0)*co(0)*w4(0)*x4
        x21vec = P3(:)*co(1)*x4
        x22vec = P4(:)*co(1)*x1
        x26 = x14 + x21 + x24 - x6
        x23vec = co(1)*w2(:)*x26
        x27 = P3(1)*w4(1)
        x28 = P3(2)*w4(2)
        x29 = P3(3)*w4(3)
        x30 = P3(0)*w4(0)
        x31 = x27 + x28 + x29 - x30
        x24vec = co(1)*w2(:)*x31
        x32 = P4(1)*w4(1)
        x33 = P4(2)*w4(2)
        x34 = P4(3)*w4(3)
        x35 = P4(0)*w4(0)
        x36 = x32 + x33 + x34 - x35
        x25vec = co(1)*w2(:)*x36
        x26vec = P3(:)*co(0)*x1
        x27vec = P4(:)*co(0)*x4
        x37 = P2(2)*w2(2)
        x38 = P3(1)*w3(1)
        x39 = P3(2)*w3(2)
        x40 = P3(3)*w3(3)
        x41 = P4(1)*w3(1)
        x42 = P4(2)*w3(2)
        x43 = P4(3)*w3(3)
        x44 = P3(0)*w3(0)
        x45 = x13 + x20 + x23 - x7
        x28vec = co(0)*w4(:)*x45
        x46 = P3(0)*w2(0)
        x47 = x38 + x39 + x40 - x44
        x29vec = co(0)*w4(:)*x47
        x48 = P3(1)*w2(1)
        x49 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x30vec = P4(:)*co(1)*x49
        x31vec = co(1)*w3(:)*x26
        x32vec = co(1)*w3(:)*x12
        x33vec = co(1)*w3(:)*x31
        x34vec = co(1)*w3(:)*x36
        x50 = P3(2)*w2(2)
        x35vec = P3(2)*co(1)*w2(2)*w3(:)
        x51 = P3(3)*w2(3)
        x52 = P4(0)*w3(0)
        x53 = P4(1)*co(1)*w2(1)
        x36vec = P3(:)*x49
        x54 = P4(2)*co(1)*w2(2)
        x55 = P4(3)*co(1)*w2(3)
        x37vec = co(0)*w3(:)*x26
        x56 = P4(0)*w2(0)
        x38vec = co(0)*w3(:)*x36
        x39vec = P4(1)*co(1)*w2(1)*w4(:)
        x57 = x41 + x42 + x43 - x52
        x40vec = w4(:)*x57
        x41vec = P4(2)*co(1)*w2(2)*w4(:)
        x42vec = P4(3)*co(1)*w2(3)*w4(:)
        x58 = P1(0)*P2(0)
        x43vec = co(0)*w2(0)*w3(:)*x12
        x44vec = co(0)*w2(0)*w4(:)*x19
        x59 = P4(0)*co(1)*w2(0)
        x45vec = P4(0)*co(1)*w2(0)*w4(:)
        x60 = P4(1)*w2(1)
        x61 = P4(2)*w2(2)
        x62 = P4(3)*w2(3)
        x63 = 2*P3(0)
        x46vec = 2*co(1)*w2(:)*x12
        x47vec = 2*P3(1)*co(2)*w3(:)*x1
        x48vec = 2*P4(1)*co(2)*w4(:)*x4
        x49vec = 2*co(0)*w4(:)*x57
        x50vec = 2*P3(2)*co(2)*w3(:)*x1
        x51vec = 2*P4(2)*co(2)*w4(:)*x4
        x52vec = 2*P3(3)*co(2)*w3(:)*x1
        x64 = 2*P3(3)
        x53vec = P4(3)*co(2)*w4(:)*x4
        x54vec = 2*co(0)*w4(:)*x19
        x55vec = 2*co(0)*w3(:)*x31
        x56vec = 2*co(0)*w3(:)*x12
        wout = w1(0)*(P1(0)*x2vec - P1(0)*x43vec - P1(0)*x44vec + P1(0)*x4vec  &
                + P1(1)*x11vec + P1(1)*x12vec + P1(3)*x19vec + P1(3)*x20vec - 2&
               *P2(0)*P4(0)*co(2)*w4(:)*x4 - P2(0)*co(2)*w3(:)*x1*x63 - P2(0)* &
               x43vec - P2(0)*x44vec + P2(1)*x11vec + P2(1)*x12vec + P2(1)*    &
               x47vec + P2(1)*x48vec + P2(1)*x7vec + P2(1)*x8vec + P2(2)*x13vec&
                + P2(2)*x14vec + P2(2)*x50vec + P2(2)*x51vec + P2(3)*x17vec +  &
               P2(3)*x18vec + P2(3)*x19vec + P2(3)*x20vec + P2(3)*x52vec + 2*P2&
               (3)*x53vec + P3(0)**2*x1vec - P3(1)**2*x1vec - P3(1)*x48vec - P3&
               (1)*x8vec - P3(2)**2*x1vec - P3(2)*x14vec - P3(2)*x51vec - P3(3 &
               )**2*x1vec - P3(3)*x18vec + P3(:)*x25 + P4(0)**2*x0vec + 2*P4(0 &
               )*x2vec - P4(1)**2*x0vec - P4(1)*x47vec - P4(1)*x7vec - P4(2)**2&
               *x0vec - P4(2)*x13vec - P4(2)*x50vec - P4(3)**2*x0vec - P4(3)*  &
               x17vec - P4(3)*x52vec - P4(:)*x25 + x0*x0vec + x0*x1vec + x0vec*&
               x2 + x0vec*x3 - x0vec*x5 - x0vec*x58 + x10*x10vec - x10*x21vec  &
                + x10*x27vec - x10*x3vec - x10vec*x11 + x10vec*x14 + x10vec*x21&
                + x10vec*x24 + x10vec*x27 + x10vec*x28 + x10vec*x29 - x10vec*  &
               x30 + x10vec*x32 + x10vec*x33 + x10vec*x34 - x10vec*x35 - x10vec&
               *x6 + x10vec*x8 + x10vec*x9 + x11*x21vec - x13*x5vec - x13*x6vec&
                + x13*x9vec - x14*x3vec - x15*x22vec - x15*x23vec - x15*x24vec &
                - x15*x25vec + x15*x26vec - x15*x46vec - x15*x5vec + x15*x9vec &
                + x15vec*x22 + x15vec*x37 - x16*x22vec - x16*x23vec - x16*     &
               x24vec - x16*x25vec + x16*x26vec - x16*x46vec - x16*x5vec + x16*&
               x9vec + x16vec*x22 + x16vec*x37 - x17*x22vec - x17*x23vec - x17*&
               x24vec - x17*x25vec + x17*x26vec - x17*x46vec - x17*x5vec + x17*&
               x9vec + x18*x22vec + x18*x23vec + x18*x24vec + x18*x25vec - x18*&
               x26vec + x18*x46vec + x18*x5vec - x18*x9vec + x19*x39vec + x19* &
               x41vec + x19*x42vec - x19*x45vec + x19vec*x64 + x1vec*x2 + x1vec&
               *x3 - x1vec*x5 - x1vec*x58 - x20*x5vec - x20*x6vec + x20*x9vec  &
                - x21*x3vec - x21vec*x8 - x21vec*x9 - x23*x5vec - x23*x6vec +  &
               x23*x9vec - x24*x3vec + x26*x35vec - x26vec*x41 - x26vec*x42 -  &
               x26vec*x43 + x26vec*x52 - x27*x27vec - x27*x3vec - x27vec*x28 - &
               x27vec*x29 + x27vec*x30 + x27vec*x8 + x27vec*x9 - x28*x3vec +   &
               x28vec*x46 - x28vec*x48 - x28vec*x50 - x28vec*x51 - x29*x3vec + &
               x29vec*x46 - x29vec*x48 - x29vec*x50 - x29vec*x51 + x30*x3vec - &
               x30vec*x46 + x30vec*x48 + x30vec*x50 + x30vec*x51 + x31*x35vec  &
                - x31vec*x46 + x31vec*x48 + x31vec*x51 - x32*x3vec - x32vec*x46&
                + x32vec*x48 + x32vec*x50 + x32vec*x51 - x33*x3vec - x33vec*x46&
                + x33vec*x48 + x33vec*x51 - x34*x3vec - x34vec*x46 + x34vec*x48&
                + x34vec*x50 + x34vec*x51 + x35*x3vec + x36vec*x53 + x36vec*x54&
                + x36vec*x55 - x36vec*x59 + x37vec*x56 - x37vec*x60 - x37vec*  &
               x61 - x37vec*x62 - x38*x5vec - x38*x6vec + x38*x9vec + x38vec*  &
               x56 - x38vec*x60 - x38vec*x61 - x38vec*x62 - x39*x5vec - x39*   &
               x6vec + x39*x9vec + x39vec*x45 + x39vec*x47 + x3vec*x6 - x3vec* &
               x8 - x3vec*x9 - x40*x5vec - x40*x6vec + x40*x9vec + x40vec*x53  &
                + x40vec*x54 + x40vec*x55 - x40vec*x59 - x41*x5vec - x41*x6vec &
                + x41*x9vec + x41vec*x45 + x41vec*x47 - x42*x5vec - x42*x6vec  &
                + x42*x9vec + x42vec*x45 + x42vec*x47 - x43*x5vec - x43*x6vec  &
                + x43*x9vec - x43vec*x63 + x44*x5vec + x44*x6vec - x44*x9vec - &
               x45*x45vec - x45vec*x47 + x46*x49vec - x48*x49vec + x48*x56vec  &
                - x49vec*x50 - x49vec*x51 + x4vec*x63 + x50*x56vec + x52*x5vec &
                + x52*x6vec - x52*x9vec - x53vec*x64 - x54vec*x56 + x54vec*x60 &
                + x54vec*x61 + x54vec*x62 + x55vec*x56 - x55vec*x60 - x55vec*  &
               x61 - x55vec*x62 + x5vec*x7 + x6vec*x7 - x7*x9vec)
      case(SVVVV2)
!       c0*(-Metric(2,3)*P(4,3)*P(5,2) + Metric(2,4)*P(3,2)*P(5,4) + Metric(2,4)*
!       P(3,4)*P(5,2) - Metric(2,5)*P(3,2)*P(4,5) - Metric(3,4)*P(2,3)*P(5,4) +  
!       Metric(3,5)*P(2,3)*P(4,5) + Metric(3,5)*P(2,5)*P(4,3) - Metric(4,5)*P(2,5
!       )*P(3,4))
!       c1*(-Metric(2,3)*P(4,2)*P(5,4) + Metric(2,3)*P(4,3)*P(5,4) + Metric(2,3)*
!       P(4,5)*P(5,2) - Metric(2,3)*P(4,5)*P(5,3) + Metric(2,5)*P(3,2)*P(4,3) -  
!       Metric(2,5)*P(3,4)*P(4,2) + Metric(2,5)*P(3,4)*P(4,5) - Metric(2,5)*P(3,5
!       )*P(4,3) + Metric(3,4)*P(2,3)*P(5,2) - Metric(3,4)*P(2,4)*P(5,2) - Metric
!       (3,4)*P(2,5)*P(5,3) + Metric(3,4)*P(2,5)*P(5,4) + Metric(4,5)*P(2,3)*P(3,
!       4) - Metric(4,5)*P(2,3)*P(3,5) - Metric(4,5)*P(2,4)*P(3,2) + Metric(4,5)*
!       P(2,5)*P(3,2))
!       c2*(Metric(2,3)*Metric(4,5)*P(-1,2)*P(-1,4) - Metric(2,3)*Metric(4,5)*P(-
!       1,2)*P(-1,5) - Metric(2,3)*Metric(4,5)*P(-1,3)*P(-1,4) + Metric(2,3)*    
!       Metric(4,5)*P(-1,3)*P(-1,5) - Metric(2,5)*Metric(3,4)*P(-1,2)*P(-1,3) +  
!       Metric(2,5)*Metric(3,4)*P(-1,2)*P(-1,4) + Metric(2,5)*Metric(3,4)*P(-1,3 
!       )*P(-1,5) - Metric(2,5)*Metric(3,4)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P3(0)**2
        x1 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x0vec = co(2)*w2(:)*x1
        x2 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x1vec = co(2)*w4(:)*x2
        x3 = P3(1)**2
        x4 = P3(2)**2
        x5 = P3(3)**2
        x6 = P1(0)*w4(0)
        x2vec = P2(:)*co(1)*x2
        x3vec = P1(0)*co(2)*w2(:)*x1
        x4vec = P1(0)*co(2)*w4(:)*x2
        x7 = P1(0)*w2(0)
        x5vec = P4(:)*co(1)*x1
        x8 = P3(1)*w4(1)
        x9 = P3(2)*w4(2)
        x10 = P3(3)*w4(3)
        x11 = P3(0)*w4(0)
        x12 = x10 - x11 + x8 + x9
        x6vec = co(0)*w3(:)*x12
        x13 = P2(1)*w3(1)
        x14 = P2(2)*w3(2)
        x15 = P2(3)*w3(3)
        x16 = P2(0)*w3(0)
        x17 = x13 + x14 + x15 - x16
        x7vec = co(1)*w2(0)*w4(:)*x17
        x8vec = P1(1)*co(2)*w4(:)*x2
        x9vec = P3(:)*co(1)*w2(1)*x1
        x18 = P1(1)*w4(1)
        x10vec = P3(:)*co(1)*x2
        x11vec = P1(1)*co(2)*w2(:)*x1
        x19 = P4(1)*w3(1)
        x20 = P4(2)*w3(2)
        x21 = P4(3)*w3(3)
        x22 = P4(0)*w3(0)
        x23 = x19 + x20 + x21 - x22
        x12vec = co(0)*w4(:)*x23
        x24 = P1(1)*w2(1)
        x25 = P1(1)*w3(1)
        x13vec = co(1)*w2(:)*x12
        x14vec = P1(2)*co(2)*w4(:)*x2
        x15vec = P3(:)*co(1)*x1
        x26 = P1(2)*w2(2)
        x27 = P1(2)*w4(2)
        x16vec = P1(2)*co(2)*w2(:)*x1
        x17vec = co(0)*w2(2)*w4(:)*x23
        x28 = P1(2)*w3(2)
        x18vec = P1(3)*co(2)*w4(:)*x2
        x29 = P1(3)*w2(3)
        x30 = P1(3)*w4(3)
        x19vec = P1(3)*co(2)*w2(:)*x1
        x31 = P1(3)*w3(3)
        x32 = P2(0)*w4(0)
        x33 = P2(0)*w2(0)
        x20vec = P4(:)*co(1)*x2
        x34 = P2(1)*w4(1)
        x35 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x21vec = P4(:)*co(0)*x35
        x36 = P2(1)*w2(1)
        x37 = x18 + x27 + x30 - x6
        x22vec = co(0)*w2(:)*x37
        x38 = P2(2)*w4(2)
        x39 = P2(3)*w4(3)
        x40 = -x32 + x34 + x38 + x39
        x23vec = co(0)*w2(:)*x40
        x24vec = co(0)*w2(:)*x12
        x41 = P4(1)*w4(1)
        x42 = P4(2)*w4(2)
        x43 = P4(3)*w4(3)
        x44 = P4(0)*w4(0)
        x45 = x41 + x42 + x43 - x44
        x25vec = co(0)*w2(:)*x45
        x46 = P2(2)*w2(2)
        x47 = P2(3)*w2(3)
        x26vec = P2(:)*co(0)*x2
        x48 = P3(1)*w2(1)
        x27vec = P2(:)*co(1)*x1
        x49 = P3(2)*w2(2)
        x50 = P3(3)*w2(3)
        x51 = P4(0)*w2(0)
        x28vec = P2(:)*co(0)*x35
        x52 = P3(0)*w2(0)
        x29vec = P4(:)*co(0)*x1
        x30vec = P3(0)*co(0)*w2(0)*w3(:)
        x53 = P1(0)*w3(0)
        x54 = x25 + x28 + x31 - x53
        x31vec = co(1)*w4(:)*x54
        x55 = P3(1)*w3(1)
        x56 = P3(2)*w3(2)
        x57 = P3(3)*w3(3)
        x58 = P3(0)*w3(0)
        x59 = x55 + x56 + x57 - x58
        x32vec = co(1)*w4(:)*x59
        x33vec = P3(2)*co(1)*w2(2)*w4(:)
        x60 = P4(2)*w2(2)
        x61 = P4(3)*w2(3)
        x34vec = P4(0)*co(1)*w2(:)*w3(0)
        x62 = P4(1)*w2(1)
        x35vec = co(1)*w4(:)*x17
        x36vec = P3(1)*co(0)*w2(1)*w3(:)
        x37vec = co(0)*w3(:)*x37
        x38vec = co(0)*w3(:)*x40
        x39vec = co(0)*w3(:)*x45
        x40vec = co(1)*w2(:)*x37
        x41vec = co(1)*w2(:)*x45
        x63 = 2*P2(0)*P4(0)
        x42vec = 2*co(1)*w2(:)*x12
        x43vec = 2*P2(1)*co(2)*w2(:)*x1
        x44vec = 2*co(2)*w2(:)*x1
        x45vec = 2*P2(3)*co(2)*w2(:)*x1
        x46vec = 2*co(1)*w4(:)*x23
        x47vec = 2*P4(1)*co(2)*w4(:)*x2
        x64 = -2*P3(0)*w4(0) + 2*P3(1)*w4(1) + 2*P3(2)*w4(2) + 2*P3(3)*w4(3)
        x48vec = 2*co(2)*w4(:)*x2
        x49vec = 2*co(0)*w3(:)*x12
        x50vec = 2*P4(3)*co(2)*w4(:)*x2
        x51vec = 2*co(1)*w4(:)*x17
        x65 = -2*P2(0)*w4(0) + 2*P2(1)*w4(1) + 2*P2(2)*w4(2) + 2*P2(3)*w4(3)
        x52vec = co(1)*w2(:)*x65
        x66 = P2(2)*P4(2)
        x67 = 2*P4(0)
        wout = -w1(0)*(P1(0)*x7vec + P1(1)*x9vec + P1(2)*x17vec - P2(0)**2*    &
               x1vec + P2(0)*P3(0)*x44vec - P2(0)*x4vec + P2(0)*x7vec + P2(1)**&
               2*x1vec + P2(1)*x47vec + P2(1)*x8vec + P2(1)*x9vec + P2(2)**2*  &
               x1vec - P2(2)*P3(2)*x44vec + P2(2)*x14vec + P2(2)*x17vec + P2(3 &
               )**2*x1vec + P2(3)*x18vec + P2(3)*x50vec + P3(0)*co(2)*w4(:)*x2*&
               x67 + P3(0)*x3vec + P3(0)*x4vec - P3(1)*x11vec - P3(1)*x43vec - &
               P3(1)*x47vec - P3(1)*x8vec - P3(2)*P4(2)*x48vec - P3(2)*x14vec  &
                - P3(2)*x16vec - P3(3)*x18vec - P3(3)*x19vec - P3(3)*x45vec -  &
               P3(3)*x50vec - P4(0)**2*x0vec - P4(0)*x3vec + P4(1)**2*x0vec +  &
               P4(1)*x11vec + P4(1)*x43vec + P4(1)*x9vec + P4(2)**2*x0vec + P4(&
               2)*x16vec + P4(2)*x17vec + P4(3)**2*x0vec + P4(3)*x19vec + P4(3 &
               )*x45vec + x0*x0vec + x0*x1vec - x0vec*x3 - x0vec*x4 - x0vec*x5 &
                - x0vec*x63 + x10*x10vec + x10*x20vec - x10*x26vec - x10*x2vec &
                - x10vec*x11 + x10vec*x18 + x10vec*x27 + x10vec*x30 - x10vec*  &
               x32 + x10vec*x34 + x10vec*x38 + x10vec*x39 + x10vec*x41 + x10vec&
               *x42 + x10vec*x43 - x10vec*x44 - x10vec*x6 + x10vec*x8 + x10vec*&
               x9 - x11*x20vec + x11*x26vec + x11*x2vec + x12vec*x24 + x12vec* &
               x29 - x12vec*x33 + x12vec*x36 + x12vec*x47 + x12vec*x48 + x12vec&
               *x49 + x12vec*x50 - x12vec*x51 - x12vec*x52 + x12vec*x61 +      &
               x12vec*x62 - x12vec*x7 + x13*x21vec + x13*x22vec + x13*x23vec + &
               x13*x24vec + x13*x25vec + x13*x42vec + x13vec*x25 + x13vec*x28  &
                + x13vec*x31 - x13vec*x53 + x13vec*x55 + x13vec*x56 + x13vec*  &
               x57 - x13vec*x58 + x14*x21vec + x14*x22vec + x14*x23vec + x14*  &
               x24vec + x14*x25vec + x14*x42vec + x15*x21vec + x15*x22vec + x15&
               *x23vec + x15*x24vec + x15*x25vec + x15*x42vec + x15vec*x26 +   &
               x15vec*x29 - x15vec*x33 + x15vec*x46 + x15vec*x47 + x15vec*x48  &
                + x15vec*x49 + x15vec*x50 - x15vec*x51 - x15vec*x52 + x15vec*  &
               x60 + x15vec*x61 - x15vec*x7 - x16*x21vec - x16*x22vec - x16*   &
               x23vec - x16*x24vec - x16*x25vec - x16*x42vec - x18*x2vec + x19*&
               x28vec - x19*x40vec - x19*x41vec - x19*x52vec - x1vec*x3 - x1vec&
               *x4 - x1vec*x5 - x1vec*x63 + x20*x28vec - x20*x40vec - x20*     &
               x41vec - x20*x52vec + x20vec*x32 - x20vec*x34 - x20vec*x38 -    &
               x20vec*x39 + x20vec*x8 + x20vec*x9 + x21*x28vec - x21*x40vec -  &
               x21*x41vec - x21*x52vec - x22*x28vec - x24*x35vec - x24*x5vec - &
               x24*x6vec - x26*x35vec - x26*x5vec - x26*x6vec - x26vec*x8 -    &
               x26vec*x9 - x27*x2vec + x27vec*x48 + x27vec*x49 + x27vec*x50 +  &
               x27vec*x51 - x27vec*x52 - x27vec*x60 - x27vec*x61 - x27vec*x62  &
                - x29*x35vec - x29*x5vec - x29*x6vec - x29vec*x48 - x29vec*x49 &
                - x29vec*x50 + x29vec*x52 - x2vec*x30 + x2vec*x32 - x2vec*x34  &
                - x2vec*x38 - x2vec*x39 - x2vec*x41 - x2vec*x42 - x2vec*x43 +  &
               x2vec*x44 + x2vec*x6 - x2vec*x8 - x2vec*x9 + x30vec*x37 + x30vec&
               *x40 + x30vec*x45 + x30vec*x64 + x31vec*x48 + x31vec*x50 -      &
               x31vec*x52 + x32vec*x48 + x32vec*x50 - x32vec*x52 + x33*x5vec + &
               x33*x6vec + x33vec*x54 + x33vec*x59 + x33vec*(-2*P4(0)*w3(0) + 2&
               *P4(1)*w3(1) + 2*P4(2)*w3(2) + 2*P4(3)*w3(3)) + x34vec*x37 +    &
               x34vec*x45 + x34vec*x65 - x35vec*x36 - x35vec*x46 - x35vec*x47  &
                - x36*x5vec - x36*x6vec - x36vec*x37 - x36vec*x40 - x36vec*x45 &
                - x36vec*x64 - x37vec*x49 - x37vec*x50 - x38vec*x49 - x38vec*  &
               x50 - x39vec*x49 - x39vec*x50 + x44vec*x66 - x46*x5vec - x46*   &
               x6vec + x46vec*x48 + x46vec*x50 - x46vec*x52 - x47*x5vec - x47* &
               x6vec - x48*x5vec + x48vec*x66 - x49*x49vec - x49*x5vec - x49vec&
               *x50 - x50*x5vec + x51*x5vec + x51*x6vec - x51vec*x60 - x51vec* &
               x61 - x51vec*x62 + x52*x5vec - x5vec*x60 - x5vec*x61 - x5vec*x62&
                + x5vec*x7 - x60*x6vec - x61*x6vec - x62*x6vec + x67*x7vec +   &
               x6vec*x7)
      case(SVVVV3)
!       c0*(Metric(2,4)*P(3,2)*P(5,3) - Metric(2,4)*P(3,4)*P(5,3) - Metric(2,4)*P
!       (3,5)*P(5,2) + Metric(2,4)*P(3,5)*P(5,4) + Metric(2,5)*P(3,2)*P(4,3) -   
!       Metric(2,5)*P(3,4)*P(4,2) + Metric(2,5)*P(3,4)*P(4,5) - Metric(2,5)*P(3,5
!       )*P(4,3) + Metric(3,4)*P(2,3)*P(5,2) - Metric(3,4)*P(2,4)*P(5,2) - Metric
!       (3,4)*P(2,5)*P(5,3) + Metric(3,4)*P(2,5)*P(5,4) + Metric(3,5)*P(2,3)*P(4,
!       2) - Metric(3,5)*P(2,4)*P(4,3) + Metric(3,5)*P(2,4)*P(4,5) - Metric(3,5)*
!       P(2,5)*P(4,2))
!       c1*(Metric(2,3)*P(4,2)*P(5,3) + Metric(2,3)*P(4,3)*P(5,2) - Metric(2,4)*P
!       (3,4)*P(5,2) - Metric(2,5)*P(3,5)*P(4,2) - Metric(3,4)*P(2,4)*P(5,3) -   
!       Metric(3,5)*P(2,5)*P(4,3) + Metric(4,5)*P(2,4)*P(3,5) + Metric(4,5)*P(2,5
!       )*P(3,4))
!       c2*(-Metric(2,4)*Metric(3,5)*P(-1,2)*P(-1,3) + Metric(2,4)*Metric(3,5)*P 
!       (-1,2)*P(-1,5) + Metric(2,4)*Metric(3,5)*P(-1,3)*P(-1,4) - Metric(2,4)*  
!       Metric(3,5)*P(-1,4)*P(-1,5) - Metric(2,5)*Metric(3,4)*P(-1,2)*P(-1,3) +  
!       Metric(2,5)*Metric(3,4)*P(-1,2)*P(-1,4) + Metric(2,5)*Metric(3,4)*P(-1,3 
!       )*P(-1,5) - Metric(2,5)*Metric(3,4)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x0vec = co(2)*w2(:)*x0
        x1 = P4(1)**2
        x2 = P4(2)**2
        x3 = P4(3)**2
        x4 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x1vec = co(2)*w3(:)*x4
        x5 = P4(0)**2
        x2vec = P1(0)*co(2)*w3(:)*x4
        x3vec = P1(0)*co(2)*w2(:)*x0
        x4vec = P4(:)*co(0)*x0
        x6 = P1(0)*w2(0)
        x7 = P1(0)*w3(0)
        x5vec = P4(:)*co(0)*x4
        x8 = P4(1)*w3(1)
        x9 = P4(2)*w3(2)
        x10 = P4(3)*w3(3)
        x11 = P4(0)*w3(0)
        x12 = x10 - x11 + x8 + x9
        x6vec = co(1)*w2(0)*w4(:)*x12
        x13 = P1(1)*w3(1)
        x7vec = P2(:)*co(0)*x4
        x8vec = P3(:)*co(0)*x0
        x14 = P1(1)*w2(1)
        x9vec = P1(1)*co(2)*w2(:)*x0
        x10vec = P1(1)*co(2)*w3(:)*x4
        x15 = P2(1)*w4(1)
        x16 = P2(2)*w4(2)
        x17 = P2(3)*w4(3)
        x18 = P2(0)*w4(0)
        x19 = x15 + x16 + x17 - x18
        x11vec = co(0)*w3(:)*x19
        x20 = P3(1)*w4(1)
        x21 = P3(2)*w4(2)
        x22 = P3(3)*w4(3)
        x23 = P3(0)*w4(0)
        x24 = x20 + x21 + x22 - x23
        x12vec = co(0)*w2(:)*x24
        x13vec = co(1)*w3(:)*x24
        x14vec = co(1)*w2(:)*x19
        x25 = P1(2)*w3(2)
        x26 = P1(2)*w2(2)
        x15vec = P1(2)*co(2)*w2(:)*x0
        x16vec = P1(2)*co(2)*w3(:)*x4
        x27 = P1(3)*w3(3)
        x28 = P1(3)*w2(3)
        x17vec = P1(3)*co(2)*w2(:)*x0
        x18vec = P1(3)*co(2)*w3(:)*x4
        x19vec = co(1)*w2(3)*w3(:)*x24
        x29 = P2(0)*w2(0)
        x30 = P2(0)*w3(0)
        x31 = P2(1)*w3(1)
        x32 = P2(1)*w2(1)
        x20vec = P3(:)*co(0)*x4
        x33 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x21vec = P3(:)*co(1)*x33
        x34 = P2(2)*w3(2)
        x35 = P2(2)*w2(2)
        x36 = P2(3)*w3(3)
        x37 = P2(3)*w2(3)
        x22vec = P2(:)*co(0)*x0
        x38 = P3(1)*w2(1)
        x39 = P3(1)*w3(1)
        x23vec = P2(:)*co(1)*x33
        x40 = P3(2)*w2(2)
        x41 = P3(2)*w3(2)
        x42 = P3(3)*w2(3)
        x43 = P3(3)*w3(3)
        x44 = P4(0)*w2(0)
        x24vec = P2(:)*co(1)*x4
        x25vec = P2(:)*P4(3)*w3(3)
        x45 = P3(0)*w2(0)
        x46 = P3(0)*w3(0)
        x47 = P4(0)*co(0)*w3(0)*x4
        x26vec = P3(:)*co(1)*x0
        x48 = P4(1)*w2(1)
        x49 = P4(2)*w2(2)
        x50 = P4(3)*w2(3)
        x27vec = P4(0)*w2(0)*w3(:)
        x51 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x52 = co(0)*x51
        x53 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x54 = co(0)*x53
        x28vec = co(0)*w2(:)*x51
        x29vec = co(0)*w2(:)*x53
        x55 = x13 + x25 + x27 - x7
        x30vec = P4(0)*co(1)*w2(0)*w4(:)
        x56 = -x30 + x31 + x34 + x36
        x57 = x39 + x41 + x43 - x46
        x58 = co(1)*x24
        x31vec = P4(1)*w2(1)*w3(:)
        x32vec = P4(1)*w2(:)*w3(1)*x19
        x33vec = co(1)*w4(:)*x12
        x59 = P4(1)*co(0)*w2(1)*x0
        x34vec = P4(1)*w2(:)*w3(1)
        x35vec = P4(1)*co(1)*w2(1)*w4(:)
        x36vec = P4(2)*w2(2)*w3(:)
        x37vec = P4(2)*co(1)*w2(2)*w4(:)
        x38vec = P4(3)*w2(3)*w3(:)
        x39vec = P4(3)*w2(:)*w3(3)
        x40vec = P4(3)*co(1)*w2(3)*w4(:)
        x41vec = P2(0)*co(2)*w2(:)*x0
        x60 = 2*P4(0)
        x42vec = 2*co(0)*w2(:)*x24
        x43vec = 2*P2(1)*co(2)*w2(:)*x0
        x44vec = 2*P3(1)*co(2)*w3(:)*x4
        x61 = P2(2)*P3(2)
        x45vec = 2*co(2)*w2(:)*x0
        x46vec = 2*co(2)*w3(:)*x4
        x62 = P2(3)*P3(3)
        x47vec = 2*P3(0)*co(2)*w3(:)*x4
        x48vec = 2*co(0)*w3(:)*x19
        x63 = 2*co(0)*x24
        x64 = 2*co(0)
        x49vec = 2*co(1)*w4(:)*x12
        x50vec = 2*co(0)*w2(:)*x19
        wout = -w1(0)*(P1(0)*x6vec + P1(3)*x19vec + P2(0)**2*x1vec + P2(0)*    &
               x2vec + P2(0)*x47vec + P2(0)*x6vec - P2(1)**2*x1vec - P2(1)*    &
               x10vec - P2(1)*x44vec - P2(2)**2*x1vec + P2(2)*P4(2)*x45vec - P2&
               (2)*x16vec - P2(3)**2*x1vec + P2(3)*P4(3)*x45vec - P2(3)*x18vec &
                + P2(3)*x19vec - P2(:)*x47 - P2(:)*x59 + P3(0)**2*x0vec + P3(0 &
               )*x3vec + 2*P3(0)*x41vec + P3(0)*x6vec - P3(1)**2*x0vec - P3(1)*&
               x43vec - P3(1)*x9vec - P3(2)**2*x0vec + P3(2)*P4(2)*x46vec - P3(&
               2)*x15vec - P3(3)**2*x0vec + P3(3)*P4(3)*x46vec - P3(3)*x17vec  &
                - P3(:)*P4(1)*co(1)*w2(1)*x0 + P3(:)*x47 - P4(0)*x2vec - P4(0)*&
               x3vec - P4(0)*x47vec + P4(1)*x10vec + P4(1)*x43vec + P4(1)*     &
               x44vec + P4(1)*x9vec + P4(2)*x15vec + P4(2)*x16vec - P4(3)*w2   &
               (:)*w3(3)*x19*x64 + P4(3)*x17vec + P4(3)*x18vec + P4(3)*x19vec  &
                + P4(:)*x47 - P4(:)*x59 + co(0)*x25vec*x4 - co(1)*x25vec*x4 +  &
               co(1)*x32vec + x0vec*x1 + x0vec*x2 + x0vec*x3 - x0vec*x5 + x1*  &
               x1vec + x10*x14vec - x10*x20vec - x10*x5vec - x11*x14vec + x11* &
               x24vec + x11*x28vec + x11*x29vec + x11*x50vec + x11vec*x14 +    &
               x11vec*x26 + x11vec*x28 - x11vec*x29 + x11vec*x32 + x11vec*x35  &
                + x11vec*x37 - x11vec*x6 + x12vec*x13 + x12vec*x25 + x12vec*x27&
                + x12vec*x39 + x12vec*x41 + x12vec*x43 - x12vec*x46 - x12vec*x7&
                + x13*x14vec - x13*x5vec + x13*x7vec + x13vec*x14 + x13vec*x26 &
                - x13vec*x29 + x13vec*x32 + x13vec*x35 + x13vec*x38 + x13vec*  &
               x40 + x13vec*x42 - x13vec*x45 + x13vec*x49 - x13vec*x6 - x14*   &
               x33vec - x14*x4vec + x14*x8vec + x14vec*x25 + x14vec*x27 -      &
               x14vec*x30 + x14vec*x31 + x14vec*x34 + x14vec*x36 + x14vec*x39  &
                + x14vec*x41 + x14vec*x43 - x14vec*x46 - x14vec*x7 + x14vec*x9 &
                + x15*x21vec + x16*x21vec + x17*x21vec - x18*x21vec + x1vec*x2 &
                + x1vec*x3 - x1vec*x5 + x20*x23vec - x20vec*x30 + x20vec*x31 + &
               x20vec*x34 + x20vec*x36 - x20vec*x8 - x20vec*x9 + x21*x23vec +  &
               x22*x23vec + x22vec*x38 + x22vec*x40 + x22vec*x42 + x22vec*x44  &
                - x22vec*x45 - x22vec*x49 - x22vec*x50 - x23*x23vec - x24vec*x8&
                - x24vec*x9 - x25*x5vec + x25*x7vec - x26*x33vec - x26*x4vec + &
               x26*x8vec + x26vec*x44 - x26vec*x49 - x26vec*x50 - x27*x5vec +  &
               x27*x7vec + x27vec*x52 + x27vec*x54 - x27vec*x58 + x27vec*x63 - &
               x28*x33vec - x28*x4vec + x28*x8vec - x28vec*x9 + x29*x4vec - x29&
               *x8vec - x29vec*x9 - x30*x42vec + x30*x5vec - x30*x7vec + x30vec&
               *x55 + x30vec*x56 + x30vec*x57 + x31*x42vec - x31*x5vec + x31*  &
               x7vec - x31vec*x52 - x31vec*x54 + x31vec*x58 - x31vec*x63 - x32*&
               x33vec - x32*x4vec + x32*x8vec - x32vec*x64 - x33vec*x35 -      &
               x33vec*x37 - x33vec*x38 - x33vec*x40 - x33vec*x42 + x34*x42vec  &
                - x34*x5vec + x34*x7vec - x34vec*x52 - x34vec*x54 - x35*x4vec  &
                + x35*x8vec - x35vec*x55 - x35vec*x56 - x35vec*x57 + x36*x42vec&
                - x36*x5vec + x36*x7vec - x36vec*x52 - x36vec*x54 - x36vec*x63 &
                - x37*x4vec + x37*x8vec - x37vec*x55 - x37vec*x56 - x37vec*x57 &
                + x38*x48vec - x38*x4vec + x38*x8vec - x38vec*x52 - x38vec*x54 &
                - x38vec*x63 - x39*x5vec + x39*x7vec - x39vec*x52 - x39vec*x54 &
                + x40*x48vec - x40*x4vec + x40*x8vec - x40vec*x55 - x40vec*x56 &
                - x40vec*x57 - x41*x5vec + x41*x7vec - x41vec*x60 + x42*x48vec &
                - x42*x4vec + x42*x8vec - x43*x5vec + x43*x7vec + x44*x4vec -  &
               x44*x8vec - x45*x48vec + x45*x4vec - x45*x8vec - x45vec*x61 -   &
               x45vec*x62 + x46*x5vec - x46*x7vec - x46vec*x61 - x46vec*x62 -  &
               x48*x49vec + x48*x8vec - x49*x49vec - x49*x4vec + x49*x8vec -   &
               x49vec*x50 - x4vec*x50 + x4vec*x6 + x50*x8vec - x50vec*x9 +     &
               x5vec*x7 - x5vec*x8 - x5vec*x9 - x6*x8vec + x60*x6vec - x7*x7vec&
                + x7vec*x8 + x7vec*x9)
      end select 
    end subroutine treeSVVVV
end module tcSVVVV
