!******************************************************************************!
!                                                                              !
!    tcVSSSV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVSSSV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVSSSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeVSSSV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VSSSV0)
!       P(1,5)*P(5,1)*c0
!       Metric(1,5)*P(-1,1)*P(-1,5)*c1
        if (last) VB_last = .true.
        x0vec = co(1)*w1(:)
        x1vec = P1(:)*co(0)*w1(1)
        x2vec = P1(1)*co(1)*w1(:)
        x3vec = P1(:)*co(0)*w1(2)
        x4vec = P1(2)*co(1)*w1(:)
        x5vec = P1(:)*co(0)*w1(3)
        x6vec = P1(3)*co(1)*w1(:)
        x7vec = P1(:)*co(0)*w1(0)
        x8vec = P1(0)*co(1)*w1(:)
        wout = -w2(0)*w3(0)*w4(0)*(-P1(0)**2*x0vec - P1(0)*x7vec + P1(1)**2*   &
               x0vec + P1(1)*x1vec + P1(2)**2*x0vec + P1(2)*x3vec + P1(3)**2*  &
               x0vec + P1(3)*x5vec - P2(0)*x7vec - P2(0)*x8vec + P2(1)*x1vec + &
               P2(1)*x2vec + P2(2)*x3vec + P2(2)*x4vec + P2(3)*x5vec + P2(3)*  &
               x6vec - P3(0)*x7vec - P3(0)*x8vec + P3(1)*x1vec + P3(1)*x2vec + &
               P3(2)*x3vec + P3(2)*x4vec + P3(3)*x5vec + P3(3)*x6vec - P4(0)*  &
               x7vec - P4(0)*x8vec + P4(1)*x1vec + P4(1)*x2vec + P4(2)*x3vec + &
               P4(2)*x4vec + P4(3)*x5vec + P4(3)*x6vec)
      case(VSSSV1)
!       P(1,5)*P(5,1)*c0
!       c1*(P(1,1)*P(5,3) + P(1,1)*P(5,4) + P(1,3)*P(5,1) + 2*P(1,3)*P(5,3) + P(1
!       ,3)*P(5,4) + P(1,3)*P(5,5) + P(1,4)*P(5,1) + P(1,4)*P(5,3) + 2*P(1,4)*P(5
!       ,4) + P(1,4)*P(5,5) + P(1,5)*P(5,3) + P(1,5)*P(5,4))
!       P(1,1)*P(5,5)*c2
!       c3*(P(1,1)*P(5,1) + P(1,5)*P(5,5))
!       c4*(Metric(1,5)*P(-1,1)**2 + Metric(1,5)*P(-1,5)**2)
!       c5*(Metric(1,5)*P(-1,1)*P(-1,3) + Metric(1,5)*P(-1,1)*P(-1,4) + Metric(1,
!       5)*P(-1,3)**2 + Metric(1,5)*P(-1,3)*P(-1,4) + Metric(1,5)*P(-1,3)*P(-1,5 
!       ) + Metric(1,5)*P(-1,4)**2 + Metric(1,5)*P(-1,4)*P(-1,5))
!       Metric(1,5)*P(-1,1)*P(-1,5)*c6
        if (last) VB_last = .true.
        x0vec = co(4)*w1(:)
        x0 = P1(0)**2
        x1vec = co(6)*w1(:)
        x1 = P1(1)**2
        x2 = P1(2)**2
        x3 = P1(3)**2
        x2vec = 2*co(4)*w1(:)
        x3vec = P1(0)*P1(:)*w1(0)
        x4vec = P1(0)*co(6)*w1(:)
        x4 = P1(0)*w1(0)
        x5vec = P2(:)*co(2)
        x6vec = P3(:)*co(2)
        x7vec = P4(:)*co(2)
        x8vec = P2(:)*co(3)
        x5 = P1(1)*w1(1)
        x9vec = P3(:)*co(3)
        x10vec = P4(:)*co(3)
        x6 = P1(2)*w1(2)
        x7 = P1(3)*w1(3)
        x11vec = P4(:)*co(3)*w1(3)
        x12vec = P1(:)*co(0)
        x8 = P2(0)*w1(0)
        x9 = P2(1)*w1(1)
        x13vec = P1(:)*co(3)
        x10 = P2(2)*w1(2)
        x11 = P2(3)*w1(3)
        x12 = P3(0)*w1(0)
        x13 = P3(1)*co(3)*w1(1)
        x14 = P3(2)*w1(2)
        x15 = P3(3)*w1(3)
        x16 = P4(0)*w1(0)
        x17 = P4(1)*w1(1)
        x18 = P4(2)*w1(2)
        x19 = P4(3)*w1(3)
        x14vec = P2(0)*co(5)*w1(:)
        x15vec = P3(:)*co(1)
        x16vec = P4(:)*co(1)
        x17vec = P2(:)*co(1)
        x20 = P3(1)*w1(1)
        x18vec = co(5)*w1(:)
        x21 = P3(0)*P4(0)
        x19vec = P3(:)*P4(2)*w1(2)
        x20vec = P1(:)*co(2)
        x21vec = P1(1)*co(6)*w1(:)
        x22vec = P1(2)*co(6)*w1(:)
        x23vec = P1(:)*co(0)*w1(3)
        x24vec = P1(3)*co(6)*w1(:)
        x25vec = P2(1)*co(5)*w1(:)
        x22 = P2(2)*P3(2)
        x26vec = P4(2)*co(5)*w1(:)
        x27vec = P2(3)*co(5)*w1(:)
        x23 = P3(1)*P4(1)
        x24 = P3(3)*P4(3)
        x28vec = 2*P1(:)*co(3)
        x29vec = 2*P2(0)*co(4)*w1(:)
        x30vec = 2*P4(0)*co(4)*w1(:)
        x31vec = 2*P2(1)*co(4)*w1(:)
        x32vec = 2*P1(1)*co(4)*w1(:)
        x33vec = 2*P1(2)*co(4)*w1(:)
        x34vec = 2*P1(3)*co(4)*w1(:)
        x35vec = 2*P4(2)*co(4)*w1(:)
        x36vec = 2*P2(3)*co(4)*w1(:)
        wout = w2(0)*w3(0)*w4(0)*(-P1(0)*P3(0)*x2vec - P1(0)*x29vec - P1(0)*   &
               x30vec + P1(1)*x31vec + P1(3)*x11vec - P1(3)*x23vec + P1(:)*x13 &
                - P2(0)**2*x0vec - P2(0)*x30vec + P2(0)*x4vec + P2(1)**2*x0vec &
                - P2(1)*x21vec + P2(2)**2*x0vec - P2(2)*x22vec - P2(2)*x26vec  &
                + P2(2)*x33vec + P2(2)*x35vec + P2(3)**2*x0vec + P2(3)*x11vec  &
                - P2(3)*x23vec - P2(3)*x24vec + P2(3)*x34vec - P3(0)**2*x0vec  &
                + P3(0)*x14vec - P3(0)*x29vec + P3(0)*x4vec + P3(1)**2*x0vec - &
               P3(1)*x21vec - P3(1)*x25vec + P3(1)*x31vec + P3(1)*x32vec + P3(2&
               )**2*x0vec - P3(2)*x22vec - P3(2)*x26vec + P3(2)*x33vec + P3(2)*&
               x35vec + P3(3)**2*x0vec + P3(3)*x11vec - P3(3)*x23vec - P3(3)*  &
               x24vec - P3(3)*x27vec + P3(3)*x34vec + P3(3)*x36vec + P3(:)*x13 &
                - P4(0)**2*x0vec + P4(0)*x14vec + P4(0)*x4vec + P4(1)**2*x0vec &
                - P4(1)*x21vec - P4(1)*x25vec + P4(1)*x31vec + P4(1)*x32vec +  &
               P4(2)**2*x0vec - P4(2)*x22vec + P4(2)*x33vec + P4(3)**2*x0vec + &
               P4(3)*x11vec - P4(3)*x23vec - P4(3)*x24vec - P4(3)*x27vec + P4(3&
               )*x34vec + P4(3)*x36vec + co(0)*x3vec - co(1)*x19vec + co(2)*   &
               x3vec + co(3)*x19vec + x0*x1vec - x0*x2vec - x1*x1vec + x1*x2vec&
                + x10*x10vec - x10*x12vec + x10*x13vec - x10*x15vec - x10*     &
               x16vec + x10*x8vec + x10*x9vec - x10vec*x12 + x10vec*x14 -      &
               x10vec*x16 + x10vec*x17 + x10vec*x18 + x10vec*x20 - x10vec*x4 + &
               x10vec*x5 + x10vec*x6 - x10vec*x8 + x10vec*x9 + x11*x13vec - x11&
               *x15vec - x11*x16vec + x11*x8vec + x11*x9vec + x12*x12vec - x12*&
               x13vec + x12*x16vec + x12*x17vec - x12*x8vec - x12*x9vec -      &
               x12vec*x14 + x12vec*x16 - x12vec*x17 - x12vec*x18 - x12vec*x20  &
                - x12vec*x5 - x12vec*x6 + x12vec*x8 - x12vec*x9 + x13vec*x14 + &
               x13vec*x15 - x13vec*x16 + x13vec*x17 + x13vec*x18 + x13vec*x19  &
                - x13vec*x8 + x13vec*x9 - x14*x16vec - x14*x17vec + x14*x8vec  &
                + x14*x9vec - x15*x16vec - x15*x17vec + x15*x8vec + x15*x9vec  &
                + x15vec*x16 - x15vec*x17 - x15vec*x19 + x15vec*x8 - x15vec*x9 &
                + x16*x17vec - x16*x8vec - x16*x9vec - x16vec*x20 + x16vec*x8  &
                - x16vec*x9 - x17*x17vec + x17*x8vec + x17*x9vec - x17vec*x18  &
                - x17vec*x19 - x17vec*x20 + x18*x8vec + x18vec*x21 - x18vec*x22&
                - x18vec*x23 - x18vec*x24 + x19*x8vec + x19*x9vec - x1vec*x2 - &
               x1vec*x3 + x2*x2vec + x20*x8vec - x20vec*x5 - x20vec*x6 - x20vec&
               *x7 - x21*x2vec + x22*x2vec + x23*x2vec + x24*x2vec - x28vec*x4 &
                + x28vec*x5 + x28vec*x6 + x28vec*x7 + x2vec*x3 + x4*x5vec + x4*&
               x6vec + x4*x7vec - x4*x8vec - x4*x9vec - x5*x5vec - x5*x6vec -  &
               x5*x7vec + x5*x8vec + x5*x9vec - x5vec*x6 - x5vec*x7 - x6*x6vec &
                - x6*x7vec + x6*x8vec + x6*x9vec - x6vec*x7 - x7*x7vec + x7*   &
               x8vec + x7*x9vec - x8*x8vec - x8*x9vec + x8vec*x9 + x9*x9vec)
      case(VSSSV2)
!       P(1,5)*P(5,1)*c0
!       P(1,1)*P(5,5)*c1
!       c2*(P(1,1)*P(5,1) + P(1,5)*P(5,5))
!       Metric(1,5)*P(-1,1)*P(-1,5)*c3
!       c4*(Metric(1,5)*P(-1,1)**2 + Metric(1,5)*P(-1,5)**2)
        if (last) VB_last = .true.
        x0 = P1(0)**2
        x0vec = co(3)*w1(:)
        x1vec = co(4)*w1(:)
        x1 = P1(1)**2
        x2 = P1(2)**2
        x3 = P1(3)**2
        x2vec = 2*co(4)*w1(:)
        x3vec = P1(:)*co(0)
        x4 = P1(0)*w1(0)
        x4vec = P1(:)*co(1)
        x5vec = P1(0)*co(3)*w1(:)
        x6vec = P2(:)*co(1)
        x7vec = P3(:)*co(1)
        x8vec = P4(:)*co(1)
        x9vec = P2(:)*co(2)
        x5 = P1(1)*w1(1)
        x10vec = P3(:)*co(2)*w1(1)
        x11vec = P4(:)*co(2)*w1(1)
        x6 = P1(2)*w1(2)
        x12vec = P3(:)*co(2)
        x13vec = P4(:)*co(2)
        x7 = P1(3)*w1(3)
        x8 = P2(0)*w1(0)
        x14vec = P1(:)*co(2)
        x9 = P2(1)*w1(1)
        x10 = P2(2)*w1(2)
        x11 = P2(3)*w1(3)
        x12 = P3(0)*w1(0)
        x13 = P3(1)*w1(1)
        x14 = P3(2)*w1(2)
        x15 = P3(3)*w1(3)
        x16 = P4(0)*w1(0)
        x17 = P4(1)*w1(1)
        x18 = P4(2)*w1(2)
        x19 = P4(3)*w1(3)
        x15vec = P1(:)*co(0)*w1(1)
        x16vec = P1(1)*co(3)*w1(:)
        x17vec = P1(2)*co(3)*w1(:)
        x18vec = P1(3)*co(3)*w1(:)
        x19vec = 2*P1(:)*co(2)
        x20vec = 2*P2(0)*co(4)*w1(:)
        x21vec = 2*P4(0)*co(4)*w1(:)
        x22vec = 2*P3(1)*co(4)*w1(:)
        x23vec = 2*P4(1)*co(4)*w1(:)
        x24vec = 2*P1(2)*co(4)*w1(:)
        x25vec = 2*P3(3)*co(4)*w1(:)
        x26vec = 2*P4(3)*co(4)*w1(:)
        x27vec = 2*P3(2)*co(4)*w1(:)
        wout = w2(0)*w3(0)*w4(0)*(-P1(0)*P3(0)*x2vec - P1(0)*x20vec - P1(0)*   &
               x21vec + P1(1)*P2(1)*x2vec + P1(1)*x10vec + P1(1)*x11vec - P1(1 &
               )*x15vec + P1(1)*x22vec + P1(1)*x23vec + P1(3)*P2(3)*x2vec + P1(&
               3)*x25vec + P1(3)*x26vec - P2(0)**2*x1vec - P2(0)*x21vec + P2(0 &
               )*x5vec + P2(1)**2*x1vec + P2(1)*x10vec + P2(1)*x11vec - P2(1)* &
               x15vec - P2(1)*x16vec + P2(1)*x22vec + P2(1)*x23vec + P2(2)**2* &
               x1vec + P2(2)*P4(2)*x2vec - P2(2)*x17vec + P2(2)*x24vec + P2(2)*&
               x27vec + P2(3)**2*x1vec - P2(3)*x18vec + P2(3)*x25vec + P2(3)*  &
               x26vec - P3(0)**2*x1vec - P3(0)*x20vec - P3(0)*x21vec + P3(0)*  &
               x5vec + P3(1)**2*x1vec - P3(1)*x16vec + P3(2)**2*x1vec - P3(2)* &
               x17vec + P3(2)*x24vec + P3(3)**2*x1vec - P3(3)*x18vec - P4(0)**2&
               *x1vec + P4(0)*x5vec + P4(1)**2*x1vec + P4(1)*x10vec + P4(1)*   &
               x11vec - P4(1)*x15vec - P4(1)*x16vec + P4(1)*x22vec + P4(2)**2* &
               x1vec - P4(2)*x17vec + P4(2)*x24vec + P4(2)*x27vec + P4(3)**2*  &
               x1vec - P4(3)*x18vec + P4(3)*x25vec + x0*x0vec - x0*x2vec -     &
               x0vec*x1 - x0vec*x2 - x0vec*x3 + x1*x2vec + x10*x12vec + x10*   &
               x13vec + x10*x14vec - x10*x3vec + x10*x9vec + x11*x12vec + x11* &
               x13vec + x11*x14vec - x11*x3vec + x11*x9vec - x12*x12vec - x12* &
               x13vec - x12*x14vec + x12*x3vec - x12*x9vec + x12vec*x13 +      &
               x12vec*x14 + x12vec*x15 - x12vec*x16 + x12vec*x18 + x12vec*x19  &
                - x12vec*x4 + x12vec*x6 + x12vec*x7 - x12vec*x8 + x13*x13vec + &
               x13*x14vec - x13*x3vec + x13*x9vec + x13vec*x14 + x13vec*x15 -  &
               x13vec*x16 + x13vec*x18 + x13vec*x19 - x13vec*x4 + x13vec*x6 +  &
               x13vec*x7 - x13vec*x8 + x14*x14vec - x14*x3vec + x14*x9vec +    &
               x14vec*x15 - x14vec*x16 + x14vec*x17 + x14vec*x18 + x14vec*x19  &
                - x14vec*x8 + x14vec*x9 - x15*x3vec + x15*x9vec + x16*x3vec -  &
               x16*x9vec + x17*x9vec - x18*x3vec + x18*x9vec - x19*x3vec + x19*&
               x9vec - x19vec*x4 + x19vec*x5 + x19vec*x6 + x19vec*x7 + x2*x2vec&
                + x2vec*x3 + x3vec*x4 - x3vec*x6 - x3vec*x7 + x3vec*x8 + x4*   &
               x4vec + x4*x6vec + x4*x7vec + x4*x8vec - x4*x9vec - x4vec*x5 -  &
               x4vec*x6 - x4vec*x7 - x5*x6vec - x5*x7vec - x5*x8vec + x5*x9vec &
                - x6*x6vec - x6*x7vec - x6*x8vec + x6*x9vec - x6vec*x7 - x7*   &
               x7vec - x7*x8vec + x7*x9vec - x8*x9vec + x9*x9vec)
      case(VSSSV3)
!       c0*(P(1,1)*P(5,3) + P(1,1)*P(5,4) + P(1,5)*P(5,3) + P(1,5)*P(5,4))
!       P(1,5)*P(5,1)*c1
!       c2*(2*P(1,3)*P(5,3) + P(1,3)*P(5,4) + P(1,4)*P(5,3) + 2*P(1,4)*P(5,4))
!       c3*(P(1,3)*P(5,1) + P(1,3)*P(5,5) + P(1,4)*P(5,1) + P(1,4)*P(5,5))
!       P(1,1)*P(5,5)*c4
!       c5*(P(1,1)*P(5,1) + P(1,5)*P(5,5))
!       Metric(1,5)*P(-1,3)*P(-1,4)*c6
!       c7*(Metric(1,5)*P(-1,1)**2 + Metric(1,5)*P(-1,5)**2)
!       c8*(Metric(1,5)*P(-1,1)*P(-1,3) + Metric(1,5)*P(-1,1)*P(-1,4) + Metric(1,
!       5)*P(-1,3)*P(-1,5) + Metric(1,5)*P(-1,4)*P(-1,5))
!       c9*(Metric(1,5)*P(-1,3)**2 + Metric(1,5)*P(-1,4)**2)
!       Metric(1,5)*P(-1,1)*P(-1,5)*c10
        if (last) VB_last = .true.
        x0 = P1(0)**2
        x0vec = co(10)*w1(:)
        x1vec = co(7)*w1(:)
        x1 = P3(1)**2
        x2 = P3(2)**2
        x3 = P3(3)**2
        x4 = P4(1)**2
        x5 = P4(2)**2
        x6 = P4(3)**2
        x7 = P3(0)**2
        x2vec = co(8)*w1(:)
        x8 = P4(0)**2
        x3vec = co(9)*w1(:)
        x9 = P1(1)**2
        x10 = P1(2)**2
        x11 = P1(3)**2
        x4vec = 2*co(7)*w1(:)
        x5vec = P1(:)*co(1)
        x12 = P1(0)*w1(0)
        x6vec = P1(:)*co(4)
        x7vec = P1(0)*co(10)*w1(:)
        x13 = P1(0)*co(4)*w1(0)
        x8vec = P4(:)*co(4)
        x9vec = P2(:)*co(5)
        x14 = P1(1)*w1(1)
        x10vec = P1(1)*P3(:)*w1(1)
        x11vec = P4(:)*co(5)
        x15 = P1(2)*co(5)*w1(2)
        x16 = P1(3)*w1(3)
        x12vec = P3(:)*co(5)
        x17 = P2(0)*w1(0)
        x13vec = P1(:)*co(5)*w1(1)
        x18 = P2(2)*w1(2)
        x14vec = P1(:)*co(5)
        x19 = P2(3)*w1(3)
        x20 = P3(0)*w1(0)
        x21 = P3(2)*w1(2)
        x22 = P3(3)*w1(3)
        x23 = P4(0)*w1(0)
        x24 = P4(2)*w1(2)
        x25 = P4(3)*w1(3)
        x15vec = P2(0)*co(8)*w1(:)
        x16vec = P3(:)*co(0)
        x17vec = P4(:)*co(0)
        x26 = P2(1)*w1(1)
        x18vec = P2(:)*co(3)
        x27 = P3(1)*w1(1)
        x28 = P4(1)*w1(1)
        x19vec = P3(:)*co(3)
        x20vec = P4(:)*co(3)
        x21vec = P3(1)*P3(:)*w1(1)
        x22vec = co(6)*w1(:)
        x29 = P3(1)*P4(1)
        x23vec = P4(:)*co(2)
        x30 = P3(2)*P4(2)
        x31 = P3(3)*P4(3)
        x24vec = P3(:)*P4(1)*w1(1)
        x25vec = P3(:)*co(2)
        x26vec = P1(1)*co(10)*w1(:)
        x27vec = P2(:)*co(4)
        x32 = P1(2)*w1(2)
        x28vec = P1(2)*co(10)*w1(:)
        x29vec = P3(:)*co(4)
        x30vec = P1(3)*co(10)*w1(:)
        x33 = P3(0)*co(5)*w1(0)
        x31vec = P2(1)*co(8)*w1(:)
        x32vec = P3(:)*co(0)*w1(1)
        x33vec = P2(2)*co(8)*w1(:)
        x34vec = P2(3)*co(8)*w1(:)
        x34 = P3(0)*P4(0)
        x35vec = 2*P1(:)*co(5)
        x36vec = 2*P1(0)*co(7)*w1(:)
        x37vec = 2*P2(0)*co(7)*w1(:)
        x38vec = 2*P3(:)*co(2)
        x39vec = 2*co(8)*w1(:)
        x40vec = 2*P4(:)*co(2)
        x41vec = 2*P1(1)*co(7)*w1(:)
        x42vec = 2*P4(1)*co(7)*w1(:)
        x43vec = 2*P2(2)*co(7)*w1(:)
        x44vec = 2*P1(2)*co(7)*w1(:)
        x45vec = 2*P2(3)*co(7)*w1(:)
        x46vec = 2*P1(3)*co(7)*w1(:)
        wout = w2(0)*w3(0)*w4(0)*(2*P1(1)*x13vec + P1(1)*x42vec + P1(2)*x43vec &
                + P1(3)*x45vec + 2*P1(:)*x15 - P1(:)*x33 - P2(0)**2*x1vec - P2(&
               0)*x36vec + P2(0)*x7vec + P2(1)**2*x1vec + P2(1)*P3(1)*x4vec +  &
               P2(1)*P3(:)*co(5)*w1(1) + P2(1)*x13vec - P2(1)*x26vec - P2(1)*  &
               x32vec + P2(1)*x41vec + P2(1)*x42vec + P2(2)**2*x1vec - P2(2)*  &
               x28vec + P2(3)**2*x1vec - P2(3)*x30vec + P2(:)*x13 + P2(:)*x15  &
                - P2(:)*x33 + P3(0)*x15vec - P3(0)*x36vec - P3(0)*x37vec + P3(0&
               )*x7vec + P3(1)*x13vec - P3(1)*x26vec - P3(1)*x31vec - P3(1)*   &
               x32vec + P3(1)*x41vec - P3(2)*x28vec - P3(2)*x33vec + P3(2)*    &
               x43vec + P3(2)*x44vec - P3(3)*x30vec - P3(3)*x34vec + P3(3)*    &
               x45vec + P3(3)*x46vec + P3(:)*x13 + P3(:)*x15 - P3(:)*x33 + P4(0&
               )*x15vec - P4(0)*x36vec - P4(0)*x37vec + P4(0)*x7vec + P4(1)*   &
               x13vec - P4(1)*x26vec - P4(1)*x31vec - P4(1)*x32vec - P4(2)*    &
               x28vec - P4(2)*x33vec + P4(2)*x43vec + P4(2)*x44vec - P4(3)*    &
               x30vec - P4(3)*x34vec + P4(3)*x45vec + P4(3)*x46vec + P4(:)*x15 &
                - P4(:)*x33 + 2*co(2)*x21vec + co(2)*x24vec - co(3)*x21vec - co&
               (3)*x24vec - co(4)*x10vec + co(5)*x10vec + co(5)*x21vec + co(5)*&
               x24vec + x0*x0vec - x0*x4vec - x0vec*x10 - x0vec*x11 - x0vec*x9 &
                + x1*x1vec - x1*x2vec + x1*x3vec + x10*x4vec + x11*x4vec -     &
               x11vec*x12 + x11vec*x14 + x11vec*x16 - x11vec*x17 + x11vec*x18  &
                + x11vec*x19 + x11vec*x21 + x11vec*x22 - x11vec*x23 + x11vec*  &
               x24 + x11vec*x25 + x11vec*x26 + x11vec*x27 + x11vec*x28 - x12*  &
               x12vec - x12*x35vec + x12*x5vec + x12*x6vec + x12*x8vec - x12*  &
               x9vec + x12vec*x16 - x12vec*x17 + x12vec*x18 + x12vec*x19 +     &
               x12vec*x21 + x12vec*x22 - x12vec*x23 + x12vec*x24 + x12vec*x25  &
                - x14*x27vec - x14*x5vec - x14*x6vec - x14*x8vec + x14*x9vec - &
               x14vec*x17 + x14vec*x18 + x14vec*x19 + x14vec*x21 + x14vec*x22  &
                - x14vec*x23 + x14vec*x24 + x14vec*x25 - x16*x27vec - x16*     &
               x29vec + x16*x35vec - x16*x5vec - x16*x6vec - x16*x8vec + x16*  &
               x9vec + x16vec*x17 - x16vec*x18 - x16vec*x19 + x16vec*x20 -     &
               x16vec*x21 - x16vec*x22 + x16vec*x23 - x16vec*x24 - x16vec*x25  &
                + x17*x17vec + x17*x5vec - x17*x9vec - x17vec*x18 - x17vec*x19 &
                + x17vec*x20 - x17vec*x21 - x17vec*x22 + x17vec*x23 - x17vec*  &
               x24 - x17vec*x25 - x17vec*x26 - x17vec*x27 - x17vec*x28 - x18*  &
               x5vec + x18*x9vec + x18vec*x20 - x18vec*x21 - x18vec*x22 +      &
               x18vec*x23 - x18vec*x24 - x18vec*x25 - x18vec*x27 - x18vec*x28  &
                - x19*x5vec + x19*x9vec + x19vec*x20 - x19vec*x21 - x19vec*x22 &
                + x19vec*x23 - x19vec*x24 - x19vec*x25 + x1vec*x2 + x1vec*x3 + &
               x1vec*x4 + x1vec*x5 + x1vec*x6 - x1vec*x7 - x1vec*x8 - x2*x2vec &
                + x2*x3vec + x20*x20vec - x20*x23vec - x20*x38vec + x20*x5vec  &
                - x20vec*x21 - x20vec*x22 + x20vec*x23 - x20vec*x24 - x20vec*  &
               x25 - x20vec*x27 - x20vec*x28 + x21*x23vec + x21*x38vec - x21*  &
               x5vec + x21*x9vec + x22*x23vec + x22*x38vec - x22*x5vec + x22*  &
               x9vec + x22vec*x29 + x22vec*x30 + x22vec*x31 - x22vec*x34 - x23*&
               x25vec - x23*x40vec + x23*x5vec - x23*x9vec + x23vec*x27 + x24* &
               x25vec + x24*x40vec - x24*x5vec + x24*x9vec + x25*x25vec + x25* &
               x40vec - x25*x5vec + x25*x9vec - x26*x5vec + x26*x9vec - x27*   &
               x5vec + x27*x9vec - x27vec*x32 + x28*x40vec - x28*x5vec + x28*  &
               x9vec - x29*x39vec + x29*x4vec - x29vec*x32 - x2vec*x3 - x2vec* &
               x4 - x2vec*x5 - x2vec*x6 + x2vec*x7 + x2vec*x8 + x3*x3vec - x30*&
               x39vec + x30*x4vec - x31*x39vec + x31*x4vec - x32*x5vec - x32*  &
               x6vec - x32*x8vec + x34*x39vec - x34*x4vec + x3vec*x4 + x3vec*x5&
                + x3vec*x6 - x3vec*x7 - x3vec*x8 + x4vec*x9)
      end select 
    end subroutine treeVSSSV
end module tcVSSSV
