!******************************************************************************!
!                                                                              !
!    tcVSSVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVSSVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVSSVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeVSSVS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VSSVS0)
!       P(1,4)*P(4,1)*c0
!       Metric(1,4)*P(-1,1)*P(-1,4)*c1
        x0 = co(1)*(-w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3))
        x1 = co(0)*(-P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3))
        wout(0) = w2(0)*w3(0)*(-P1(0)*P4(0)*x0 + P1(1)*P4(1)*x0 + P1(2)*P4(2)* &
                  x0 + P1(3)*P4(3)*x0 - P4(0)*w1(0)*x1 + P4(1)*w1(1)*x1 + P4(2 &
                  )*w1(2)*x1 + P4(3)*w1(3)*x1)
        wout(1:3) = cnul
      case(VSSVS1)
!       c0*(P(1,1)*P(4,1) + P(1,4)*P(4,4))
!       P(1,1)*P(4,4)*c1
!       c2*(P(1,1)*P(4,3) + P(1,1)*P(4,5) + P(1,3)*P(4,1) + 2*P(1,3)*P(4,3) + P(1
!       ,3)*P(4,4) + P(1,3)*P(4,5) + P(1,4)*P(4,3) + P(1,4)*P(4,5) + P(1,5)*P(4,1
!       ) + P(1,5)*P(4,3) + P(1,5)*P(4,4) + 2*P(1,5)*P(4,5))
!       P(1,4)*P(4,1)*c3
!       c4*(Metric(1,4)*P(-1,1)*P(-1,3) + Metric(1,4)*P(-1,1)*P(-1,5) + Metric(1,
!       4)*P(-1,3)**2 + Metric(1,4)*P(-1,3)*P(-1,4) + Metric(1,4)*P(-1,3)*P(-1,5 
!       ) + Metric(1,4)*P(-1,4)*P(-1,5) + Metric(1,4)*P(-1,5)**2)
!       Metric(1,4)*P(-1,1)*P(-1,4)*c5
!       c6*(Metric(1,4)*P(-1,1)**2 + Metric(1,4)*P(-1,4)**2)
        x0 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x1 = co(4)*x0
        x2 = co(6)*x0
        x3 = P3(1)*co(4)*x0
        x4 = co(5)*x0
        x5 = P1(1)*w1(1)
        x6 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x7 = co(0)*x6
        x8 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x9 = co(1)*x8
        x10 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x11 = co(2)*w1(1)*x10
        x12 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x13 = co(2)*x12
        x14 = P1(2)*co(4)*x0
        x15 = P1(2)*w1(2)
        x16 = co(2)*x10
        x17 = P2(3)*co(4)*x0
        x18 = P1(3)*w1(3)
        x19 = w1(3)*x8
        x20 = P4(1)*co(4)*x0
        x21 = co(2)*x6
        x22 = P2(1)*w1(1)
        x23 = co(2)*x8
        x24 = P4(2)*co(4)*x0
        x25 = co(2)*w1(2)*x6
        x26 = P2(2)*w1(2)
        x27 = P4(3)*co(4)*x0
        x28 = P2(3)*w1(3)
        x29 = co(2)*w1(3)*x8
        x30 = P3(1)*w1(1)
        x31 = P3(2)*w1(2)
        x32 = P3(3)*w1(3)
        x33 = P4(1)*w1(1)
        x34 = co(0)*x8
        x35 = co(3)*x6
        x36 = P4(2)*w1(2)
        x37 = P4(3)*w1(3)
        x38 = P2(0)*co(4)*x0
        x39 = P3(0)*co(4)*x0
        x40 = P1(0)*w1(0)
        x41 = co(2)*w1(0)*x6
        x42 = P2(0)*w1(0)
        x43 = P3(0)*w1(0)
        x44 = P4(0)*w1(0)
        x45 = 2*co(2)*x10
        x46 = 2*co(2)*x12
        wout(0) = w2(0)*w3(0)*(-P1(0)**2*x2 - P1(0)*P4(0)*x4 - P1(0)*x38 - P1(0&
                  )*x39 + P1(1)**2*x2 + P1(1)*P2(1)*x1 + P1(1)*P4(1)*x4 + P1(1 &
                  )*x11 + P1(1)*x3 + P1(2)**2*x2 + P1(2)*P4(2)*x4 + P1(2)*co(0 &
                  )*w1(2)*x6 + P1(3)**2*x2 + P1(3)*P3(3)*x1 + P1(3)*P4(3)*x4 + &
                  P1(3)*co(1)*x19 + P1(3)*x17 - P2(0)**2*x1 - P2(0)*x41 + P2(1 &
                  )**2*x1 + 2*P2(1)*x11 + P2(1)*x20 + P2(1)*x3 + P2(2)**2*x1 + &
                  P2(2)*P3(2)*x1 + P2(2)*x14 + P2(2)*x24 + P2(2)*x25 + P2(3)**2&
                  *x1 + P2(3)*x27 + P2(3)*x29 - P3(0)**2*x1 - P3(0)*x38 - P3(0 &
                  )*x41 + P3(1)**2*x1 + P3(1)*x11 + P3(1)*x20 + P3(2)**2*x1 +  &
                  P3(2)*x14 + P3(2)*x24 + P3(2)*x25 + P3(3)**2*x1 + P3(3)*x17  &
                   + P3(3)*x27 + P3(3)*x29 - P4(0)**2*x2 - P4(0)*x38 - P4(0)*  &
                  x39 + P4(1)**2*x2 + P4(1)*x11 + P4(2)**2*x2 + P4(3)**2*x2 +  &
                  P4(3)*co(0)*x19 + x13*x15 + x13*x18 + x13*x22 + x13*x26 + x13&
                  *x28 + x13*x33 + x13*x36 + x13*x37 - x13*x40 - x13*x42 - x13*&
                  x44 + x13*x5 + x15*x16 + x15*x9 + x16*x18 + x16*x31 + x16*x32&
                   + x16*x36 + x16*x37 - x16*x40 - x16*x43 - x16*x44 + x18*x7  &
                   + x21*x22 + x21*x28 + x21*x30 + x21*x32 + x22*x23 + x23*x26 &
                   + x23*x30 + x23*x31 - x23*x42 - x23*x43 + x26*x45 + x28*x45 &
                   + x30*x46 + x31*x46 + x32*x46 + x33*x34 + x33*x35 + x34*x36 &
                   - x34*x44 + x35*x36 + x35*x37 - x35*x44 - x40*x7 - x40*x9 - &
                  x42*x45 - x43*x46 + x5*x7 + x5*x9)
        wout(1:3) = cnul
      case(VSSVS2)
!       P(1,1)*P(4,4)*c0
!       c1*(P(1,1)*P(4,1) + P(1,4)*P(4,4))
!       P(1,4)*P(4,1)*c2
!       c3*(Metric(1,4)*P(-1,1)**2 + Metric(1,4)*P(-1,4)**2)
!       Metric(1,4)*P(-1,1)*P(-1,4)*c4
        x0 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x1 = co(3)*x0
        x2 = co(4)*x0
        x3 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x4 = co(0)*x3
        x5 = P1(1)*w1(1)
        x6 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x7 = co(1)*x6
        x8 = P1(2)*w1(2)
        x9 = P1(3)*w1(3)
        x10 = co(1)*x3
        x11 = P4(1)*w1(1)
        x12 = co(2)*x6
        x13 = P4(2)*w1(2)
        x14 = P4(3)*w1(3)
        x15 = P1(0)*w1(0)
        x16 = P4(0)*w1(0)
        wout(0) = w2(0)*w3(0)*(-P1(0)**2*x1 - P1(0)*P4(0)*x2 + P1(1)**2*x1 + P1&
                  (1)*P4(1)*x2 + P1(2)**2*x1 + P1(2)*P4(2)*x2 + P1(3)**2*x1 +  &
                  P1(3)*P4(3)*x2 - P4(0)**2*x1 + P4(1)**2*x1 + P4(2)**2*x1 + P4&
                  (3)**2*x1 + x10*x11 + x10*x13 + x10*x14 - x10*x16 + x11*x12  &
                   + x12*x13 + x12*x14 - x12*x16 - x15*x4 - x15*x7 + x4*x5 + x4&
                  *x8 + x4*x9 + x5*x7 + x7*x8 + x7*x9)
        wout(1:3) = cnul
      case(VSSVS3)
!       c0*(P(1,1)*P(4,1) + P(1,4)*P(4,4))
!       P(1,4)*P(4,1)*c1
!       c2*(2*P(1,3)*P(4,3) + P(1,3)*P(4,5) + P(1,5)*P(4,3) + 2*P(1,5)*P(4,5))
!       P(1,1)*P(4,4)*c3
!       c4*(P(1,3)*P(4,1) + P(1,3)*P(4,4) + P(1,5)*P(4,1) + P(1,5)*P(4,4))
!       c5*(P(1,1)*P(4,3) + P(1,1)*P(4,5) + P(1,4)*P(4,3) + P(1,4)*P(4,5))
!       Metric(1,4)*P(-1,1)*P(-1,4)*c6
!       c7*(Metric(1,4)*P(-1,1)*P(-1,3) + Metric(1,4)*P(-1,1)*P(-1,5) + Metric(1,
!       4)*P(-1,3)*P(-1,4) + Metric(1,4)*P(-1,4)*P(-1,5))
!       Metric(1,4)*P(-1,3)*P(-1,5)*c8
!       c9*(Metric(1,4)*P(-1,1)**2 + Metric(1,4)*P(-1,4)**2)
!       c10*(Metric(1,4)*P(-1,3)**2 + Metric(1,4)*P(-1,5)**2)
        x0 = P1(1)**2
        x1 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x2 = co(10)*x1
        x3 = P1(2)**2
        x4 = P1(3)**2
        x5 = P4(1)**2
        x6 = P4(2)**2
        x7 = P4(3)**2
        x8 = P1(0)**2
        x9 = co(7)*x1
        x10 = P4(0)**2
        x11 = P3(0)**2
        x12 = co(8)*x1
        x13 = co(9)*x1
        x14 = P3(1)**2
        x15 = P3(2)**2
        x16 = P3(3)**2
        x17 = 2*co(10)*x1
        x18 = P2(0)*co(7)*x1
        x19 = P3(0)*co(8)*x1
        x20 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x21 = P1(0)*w1(0)*x20
        x22 = P1(0)*w1(0)
        x23 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x24 = co(4)*x23
        x25 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x26 = co(5)*x25
        x27 = co(5)*x23
        x28 = co(6)*x1
        x29 = P1(1)*P4(1)
        x30 = P1(1)*w1(1)
        x31 = co(0)*x20
        x32 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x33 = co(2)*x32
        x34 = co(3)*x23
        x35 = P1(2)*P4(2)
        x36 = P1(2)*w1(2)*x20
        x37 = P1(2)*w1(2)
        x38 = P1(3)*P4(3)
        x39 = P1(3)*w1(3)
        x40 = co(4)*x20
        x41 = P2(0)*w1(0)
        x42 = P2(1)*w1(1)
        x43 = co(2)*w1(2)*x32
        x44 = P2(3)*w1(3)
        x45 = P3(1)*co(2)*w1(1)
        x46 = co(2)*x25
        x47 = P3(1)*w1(1)
        x48 = w1(2)*x20
        x49 = P3(2)*co(2)
        x50 = co(2)*w1(2)*x25
        x51 = w1(2)*x23
        x52 = P3(3)*co(2)*w1(3)
        x53 = P4(0)*w1(0)
        x54 = co(5)*x20
        x55 = P4(1)*w1(1)*x23
        x56 = P4(1)*w1(1)
        x57 = co(1)*x20
        x58 = P4(2)*w1(2)*x23
        x59 = P4(2)*w1(2)*x20
        x60 = P4(2)*w1(2)
        x61 = co(0)*x23
        x62 = P4(3)*w1(3)
        x63 = P1(0)*P4(0)
        x64 = P2(1)*co(7)*x1
        x65 = P3(1)*co(8)*x1
        x66 = P2(2)*co(7)*x1
        x67 = P3(2)*co(8)*x1
        x68 = P2(3)*co(7)*x1
        x69 = P3(3)*co(8)*x1
        x70 = co(5)*w1(3)*x23
        x71 = co(4)*w1(1)*x20
        x72 = co(4)*w1(1)
        x73 = P2(2)*co(4)
        x74 = P3(0)*co(2)*w1(0)
        x75 = P3(0)*w1(0)
        x76 = P4(3)*co(4)*w1(3)
        x77 = 2*P2(0)*co(10)*x1
        x78 = 2*P3(0)*co(10)*x1
        x79 = 2*co(2)
        x80 = 2*co(2)*x25
        x81 = 2*co(2)*x23
        x82 = 2*co(7)*x1
        x83 = 2*co(2)*x20
        x84 = 2*co(2)*x32
        x85 = 2*P1(1)*co(10)*x1
        x86 = 2*P1(2)*co(10)*x1
        x87 = 2*P2(3)*co(10)*x1
        x88 = 2*P3(3)*co(10)*x1
        x89 = 2*P4(1)*co(10)*x1
        x90 = 2*P4(2)*co(10)*x1
        x91 = 2*P2(2)*co(2)
        wout(0) = w2(0)*w3(0)*(P1(0)*x18 + P1(0)*x19 - P1(0)*x77 - P1(0)*x78 - &
                  P1(1)*x64 - P1(1)*x65 - P1(2)*x66 - P1(2)*x67 - P1(3)*x68 -  &
                  P1(3)*x69 - P1(3)*x70 + P1(3)*x87 + P1(3)*x88 - P2(0)**2*x2  &
                   + P2(0)*x19 - P2(0)*x78 + P2(1)**2*x2 + P2(1)*P3(1)*x17 - P2&
                  (1)*x23*x72 - P2(1)*x65 - P2(1)*x71 + P2(1)*x85 + P2(1)*x89  &
                   + P2(2)**2*x2 + P2(2)*P3(2)*x17 + P2(2)*x43 + 2*P2(2)*x50 - &
                  P2(2)*x67 + P2(2)*x86 + P2(2)*x90 + P2(3)**2*x2 - P2(3)*x69  &
                   + P2(3)*x88 + P3(1)*x85 + P3(1)*x89 + 2*P3(2)*x43 + P3(2)*  &
                  x50 + P3(2)*x86 + P3(2)*x90 + P3(3)*w1(3)*x46 + P4(0)*x18 +  &
                  P4(0)*x19 - P4(0)*x77 - P4(0)*x78 - P4(1)*x23*x72 - P4(1)*x64&
                   - P4(1)*x65 - P4(1)*x71 - P4(2)*x66 - P4(2)*x67 - P4(3)*x68 &
                   - P4(3)*x69 - P4(3)*x70 + P4(3)*x87 + P4(3)*x88 - co(0)*x21 &
                   + co(0)*x36 + co(0)*x55 + co(0)*x58 + co(1)*x59 + co(4)*x21 &
                   - co(4)*x36 - co(4)*x58 - co(4)*x59 + co(5)*x21 - co(5)*x36 &
                   - co(5)*x55 + x0*x13 + x0*x2 - x0*x9 - x10*x13 - x10*x2 +   &
                  x10*x9 + x11*x12 - x11*x17 - x12*x14 - x12*x15 - x12*x16 +   &
                  x13*x3 + x13*x4 + x13*x5 + x13*x6 + x13*x7 - x13*x8 + x14*x17&
                   + x15*x17 + x16*x17 + x17*x29 + x17*x35 + x17*x38 - x17*x63 &
                   + x2*x3 + x2*x4 + x2*x5 + x2*x6 + x2*x7 - x2*x8 + x20*x45 + &
                  x20*x52 - x20*x74 - x20*x76 - x21*x79 + x22*x24 + x22*x26 +  &
                  x22*x27 - x22*x33 - x22*x34 - x22*x80 - x22*x81 + x23*x45 +  &
                  x23*x52 - x23*x74 - x23*x76 - x24*x30 - x24*x37 - x24*x39 +  &
                  x24*x41 - x24*x44 + x24*x53 - x26*x30 - x26*x37 - x26*x39 +  &
                  x26*x53 - x26*x56 - x26*x60 - x26*x62 - x27*x30 - x27*x37 +  &
                  x27*x53 - x27*x60 + x28*x29 + x28*x35 + x28*x38 - x28*x63 -  &
                  x29*x82 - x3*x9 + x30*x31 + x30*x33 + x30*x34 - x30*x40 - x30&
                  *x54 + x30*x80 + x30*x81 + x30*x83 + x31*x39 + x33*x37 + x33*&
                  x39 - x33*x41 + x33*x42 + x33*x44 - x33*x53 + x33*x56 + x33* &
                  x60 + x33*x62 + x34*x37 + x34*x39 - x35*x82 + x36*x79 + x37* &
                  x80 + x37*x81 - x38*x82 - x39*x40 - x39*x54 + x39*x80 + x39* &
                  x81 + x39*x83 - x4*x9 + x40*x41 - x40*x44 + x40*x53 - x41*x80&
                   - x41*x81 - x41*x83 + x42*x80 + x42*x81 + x42*x83 + x44*x80 &
                   + x44*x81 + x44*x83 + x46*x47 - x46*x75 + x47*x84 + x48*x49 &
                   - x48*x73 + x48*x91 + x49*x51 - x5*x9 - x51*x73 + x51*x91 + &
                  x52*(-2*P3(0)*w4(0) + 2*P3(1)*w4(1) + 2*P3(2)*w4(2) + 2*P3(3 &
                  )*w4(3)) + x53*x54 - x53*x57 - x53*x61 - x53*x80 - x53*x81 - &
                  x53*x83 - x54*x56 - x54*x60 - x54*x62 + x55*x79 + x56*x57 +  &
                  x56*x80 + x56*x83 + x57*x62 + x58*x79 + x59*x79 - x6*x9 + x60&
                  *x80 + x61*x62 + x62*x80 + x62*x81 + x62*x83 + x63*x82 - x7* &
                  x9 - x75*x84 + x8*x9)
        wout(1:3) = cnul
      end select 
    end subroutine treeVSSVS
end module tcVSSVS
