!******************************************************************************!
!                                                                              !
!    tcVSVSS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVSVSS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVSVSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeVSVSS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VSVSS0)
!       P(1,3)*P(3,1)*c0
!       Metric(1,3)*P(-1,1)*P(-1,3)*c1
        x0 = co(1)*(-w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3))
        x1 = co(0)*(-P1(0)*w3(0) + P1(1)*w3(1) + P1(2)*w3(2) + P1(3)*w3(3))
        wout(0) = w2(0)*w4(0)*(-P1(0)*P3(0)*x0 + P1(1)*P3(1)*x0 + P1(2)*P3(2)* &
                  x0 + P1(3)*P3(3)*x0 - P3(0)*w1(0)*x1 + P3(1)*w1(1)*x1 + P3(2 &
                  )*w1(2)*x1 + P3(3)*w1(3)*x1)
        wout(1:3) = cnul
      case(VSVSS1)
!       c0*(P(1,1)*P(3,1) + P(1,3)*P(3,3))
!       P(1,1)*P(3,3)*c1
!       P(1,3)*P(3,1)*c2
!       c3*(P(1,1)*P(3,4) + P(1,1)*P(3,5) + P(1,3)*P(3,4) + P(1,3)*P(3,5) + P(1,4
!       )*P(3,1) + P(1,4)*P(3,3) + 2*P(1,4)*P(3,4) + P(1,4)*P(3,5) + P(1,5)*P(3,1
!       ) + P(1,5)*P(3,3) + P(1,5)*P(3,4) + 2*P(1,5)*P(3,5))
!       Metric(1,3)*P(-1,1)*P(-1,3)*c4
!       c5*(Metric(1,3)*P(-1,1)**2 + Metric(1,3)*P(-1,3)**2)
!       c6*(Metric(1,3)*P(-1,1)*P(-1,4) + Metric(1,3)*P(-1,1)*P(-1,5) + Metric(1,
!       3)*P(-1,3)*P(-1,4) + Metric(1,3)*P(-1,3)*P(-1,5) + Metric(1,3)*P(-1,4)**2
!        + Metric(1,3)*P(-1,4)*P(-1,5) + Metric(1,3)*P(-1,5)**2)
        x0 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x1 = co(5)*x0
        x2 = co(6)*x0
        x3 = P2(1)*co(6)*x0
        x4 = co(4)*x0
        x5 = P4(1)*co(6)*x0
        x6 = -P1(0)*w3(0) + P1(1)*w3(1) + P1(2)*w3(2) + P1(3)*w3(3)
        x7 = co(0)*w1(1)
        x8 = -P3(0)*w3(0) + P3(1)*w3(1) + P3(2)*w3(2) + P3(3)*w3(3)
        x9 = co(1)*x8
        x10 = P1(1)*w1(1)
        x11 = -P2(0)*w3(0) + P2(1)*w3(1) + P2(2)*w3(2) + P2(3)*w3(3)
        x12 = co(3)*x11
        x13 = -P4(0)*w3(0) + P4(1)*w3(1) + P4(2)*w3(2) + P4(3)*w3(3)
        x14 = co(3)*x13
        x15 = P1(2)*co(6)*x0
        x16 = co(0)*x6
        x17 = P1(2)*w1(2)
        x18 = co(3)*w1(2)*x11
        x19 = P4(3)*co(6)*x0
        x20 = P1(3)*w1(3)
        x21 = P2(1)*w1(1)
        x22 = co(3)*x6
        x23 = co(3)*x8
        x24 = P3(2)*co(6)*x0
        x25 = P2(2)*w1(2)
        x26 = P3(3)*co(6)*x0
        x27 = P2(3)*w1(3)
        x28 = co(2)*x6
        x29 = P3(1)*co(3)*w1(1)
        x30 = co(0)*x8
        x31 = P3(2)*w1(2)
        x32 = P3(3)*w1(3)
        x33 = P4(1)*w1(1)
        x34 = P4(2)*w1(2)
        x35 = P4(3)*w1(3)
        x36 = P2(0)*co(6)*x0
        x37 = P4(0)*co(6)*x0
        x38 = P1(0)*w1(0)
        x39 = w1(0)*x6
        x40 = P2(0)*co(3)
        x41 = P2(0)*w1(0)
        x42 = w1(0)*x11
        x43 = P3(0)*co(3)
        x44 = w1(0)*x13
        x45 = P4(0)*co(3)
        x46 = 2*co(3)*x11
        x47 = 2*co(3)*x13
        wout(0) = w2(0)*w4(0)*(-P1(0)**2*x1 - P1(0)*P3(0)*x4 - P1(0)*x36 - P1(0&
                  )*x37 + P1(1)**2*x1 + P1(1)*P3(1)*x4 + P1(1)*x3 + P1(1)*x5 + &
                  P1(1)*x6*x7 + P1(2)**2*x1 + P1(2)*P3(2)*x4 + P1(2)*x18 + P1(3&
                  )**2*x1 + P1(3)*P2(3)*x2 + P1(3)*P3(3)*x4 + P1(3)*x19 - P2(0 &
                  )**2*x2 - P2(0)*x37 + P2(1)**2*x2 + P2(2)**2*x2 + P2(2)*P4(2 &
                  )*x2 + P2(2)*x15 + P2(2)*x24 + P2(3)**2*x2 + P2(3)*x19 + P2(3&
                  )*x26 - P3(0)**2*x1 - P3(0)*co(2)*x39 - P3(0)*w1(0)*x30 - P3(&
                  0)*x36 - P3(0)*x37 + P3(1)**2*x1 + P3(1)*w1(1)*x28 + P3(1)*x3&
                   + P3(1)*x5 + P3(1)*x7*x8 + P3(2)**2*x1 + P3(3)**2*x1 - P4(0 &
                  )**2*x2 - 2*P4(0)*co(3)*x44 - P4(0)*w1(0)*x23 + P4(1)**2*x2  &
                   + P4(1)*x3 + P4(2)**2*x2 + P4(2)*x15 + P4(2)*x18 + P4(2)*x24&
                   + P4(3)**2*x2 + P4(3)*x26 - 2*w1(0)*x11*x40 + x10*x12 + x10*&
                  x14 + x10*x9 + x11*x29 + x12*x20 + x12*x31 + x12*x32 + x12*  &
                  x33 + x12*x35 - x12*x38 + x13*x29 + x14*x17 + x14*x20 + x14* &
                  x21 + x14*x25 + x14*x27 + x14*x31 + x14*x32 - x14*x38 - x14* &
                  x41 + x16*x17 + x16*x20 - x16*x38 + x17*x9 + x20*x9 + x21*x22&
                   + x21*x23 + x21*x46 + x22*x25 + x22*x27 + x22*x33 + x22*x34 &
                   + x22*x35 + x23*x25 + x23*x27 + x23*x33 + x23*x34 + x23*x35 &
                   - x23*x41 + x25*x46 + x27*x46 + x28*x31 + x28*x32 + x30*x31 &
                   + x30*x32 + x33*x47 + x34*x47 + x35*x47 - x38*x9 - x39*x40  &
                   - x39*x45 - x42*x43 - x42*x45 - x43*x44)
        wout(1:3) = cnul
      case(VSVSS2)
!       P(1,3)*P(3,1)*c0
!       P(1,1)*P(3,3)*c1
!       c2*(P(1,1)*P(3,1) + P(1,3)*P(3,3))
!       Metric(1,3)*P(-1,1)*P(-1,3)*c3
!       c4*(Metric(1,3)*P(-1,1)**2 + Metric(1,3)*P(-1,3)**2)
        x0 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x1 = co(4)*x0
        x2 = co(3)*x0
        x3 = -P3(0)*w3(0) + P3(1)*w3(1) + P3(2)*w3(2) + P3(3)*w3(3)
        x4 = co(1)*x3
        x5 = P1(1)*w1(1)
        x6 = -P1(0)*w3(0) + P1(1)*w3(1) + P1(2)*w3(2) + P1(3)*w3(3)
        x7 = co(2)*x6
        x8 = P1(2)*w1(2)
        x9 = P1(3)*w1(3)
        x10 = co(0)*x6
        x11 = P3(1)*w1(1)
        x12 = co(2)*x3
        x13 = P3(2)*w1(2)
        x14 = P3(3)*w1(3)
        x15 = P1(0)*w1(0)
        x16 = P3(0)*w1(0)
        wout(0) = w2(0)*w4(0)*(-P1(0)**2*x1 - P1(0)*P3(0)*x2 + P1(1)**2*x1 + P1&
                  (1)*P3(1)*x2 + P1(2)**2*x1 + P1(2)*P3(2)*x2 + P1(3)**2*x1 +  &
                  P1(3)*P3(3)*x2 - P3(0)**2*x1 + P3(1)**2*x1 + P3(2)**2*x1 + P3&
                  (3)**2*x1 + x10*x11 + x10*x13 + x10*x14 - x10*x16 + x11*x12  &
                   + x12*x13 + x12*x14 - x12*x16 - x15*x4 - x15*x7 + x4*x5 + x4&
                  *x8 + x4*x9 + x5*x7 + x7*x8 + x7*x9)
        wout(1:3) = cnul
      case(VSVSS3)
!       c0*(P(1,1)*P(3,1) + P(1,3)*P(3,3))
!       P(1,1)*P(3,3)*c1
!       c2*(P(1,1)*P(3,4) + P(1,1)*P(3,5) + P(1,3)*P(3,4) + P(1,3)*P(3,5))
!       P(1,3)*P(3,1)*c3
!       c4*(P(1,4)*P(3,1) + P(1,4)*P(3,3) + P(1,5)*P(3,1) + P(1,5)*P(3,3))
!       c5*(2*P(1,4)*P(3,4) + P(1,4)*P(3,5) + P(1,5)*P(3,4) + 2*P(1,5)*P(3,5))
!       c6*(Metric(1,3)*P(-1,1)*P(-1,4) + Metric(1,3)*P(-1,1)*P(-1,5) + Metric(1,
!       3)*P(-1,3)*P(-1,4) + Metric(1,3)*P(-1,3)*P(-1,5))
!       c7*(Metric(1,3)*P(-1,4)**2 + Metric(1,3)*P(-1,5)**2)
!       Metric(1,3)*P(-1,1)*P(-1,3)*c8
!       c9*(Metric(1,3)*P(-1,1)**2 + Metric(1,3)*P(-1,3)**2)
!       Metric(1,3)*P(-1,4)*P(-1,5)*c10
        x0 = P4(0)**2
        x1 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x2 = co(10)*x1
        x3 = P1(0)**2
        x4 = co(6)*x1
        x5 = P3(0)**2
        x6 = P1(1)**2
        x7 = co(7)*x1
        x8 = P1(2)**2
        x9 = P1(3)**2
        x10 = P3(1)**2
        x11 = P3(2)**2
        x12 = P3(3)**2
        x13 = co(9)*x1
        x14 = P4(1)**2
        x15 = P4(2)**2
        x16 = P4(3)**2
        x17 = 2*co(7)*x1
        x18 = P2(0)*co(6)*x1
        x19 = P4(0)*co(10)*x1
        x20 = -P1(0)*w3(0) + P1(1)*w3(1) + P1(2)*w3(2) + P1(3)*w3(3)
        x21 = co(2)*x20
        x22 = P1(0)*w1(0)
        x23 = -P2(0)*w3(0) + P2(1)*w3(1) + P2(2)*w3(2) + P2(3)*w3(3)
        x24 = co(2)*x23
        x25 = -P3(0)*w3(0) + P3(1)*w3(1) + P3(2)*w3(2) + P3(3)*w3(3)
        x26 = P1(0)*w1(0)*x25
        x27 = co(4)*w1(0)*x20
        x28 = co(8)*x1
        x29 = P1(1)*P3(1)
        x30 = co(0)*w1(1)
        x31 = P1(1)*x20
        x32 = P1(1)*w1(1)*x25
        x33 = -P4(0)*w3(0) + P4(1)*w3(1) + P4(2)*w3(2) + P4(3)*w3(3)
        x34 = co(5)*x33
        x35 = P1(1)*w1(1)
        x36 = P1(2)*P3(2)
        x37 = P1(2)*w1(2)
        x38 = co(0)*x20
        x39 = P1(2)*w1(2)*x25
        x40 = P1(3)*P3(3)
        x41 = P1(3)*w1(3)
        x42 = P1(3)*w1(3)*x25
        x43 = co(4)*x25
        x44 = P2(1)*w1(1)
        x45 = P2(2)*w1(2)
        x46 = P2(3)*w1(3)
        x47 = P3(0)*co(2)*w1(0)
        x48 = P3(0)*w1(0)*x25
        x49 = P3(1)*x25
        x50 = co(3)*x20
        x51 = P3(1)*w1(1)
        x52 = P3(2)*w1(2)*x25
        x53 = P3(2)*w1(2)
        x54 = P3(3)*w1(3)*x25
        x55 = P3(3)*w1(3)
        x56 = P4(1)*w1(1)
        x57 = co(5)*x20
        x58 = co(5)*x23
        x59 = co(5)*w1(1)*x25
        x60 = P4(2)*co(5)*w1(2)
        x61 = P4(3)*w1(3)
        x62 = P1(0)*P3(0)
        x63 = co(5)*w1(0)*x33
        x64 = P2(1)*co(6)*x1
        x65 = P4(1)*co(10)*x1
        x66 = co(2)*w1(1)
        x67 = co(4)*x20
        x68 = co(4)*w1(1)*x25
        x69 = P2(2)*co(6)*x1
        x70 = P4(2)*co(10)*x1
        x71 = P2(3)*co(6)*x1
        x72 = P4(3)*co(10)*x1
        x73 = P3(1)*w1(1)*x25
        x74 = P4(0)*co(5)*w1(0)
        x75 = 2*P2(0)*co(7)*x1
        x76 = 2*P4(0)*co(7)*x1
        x77 = 2*co(5)*w1(0)*x20
        x78 = 2*co(5)*w1(0)*x23
        x79 = 2*co(5)
        x80 = 2*co(6)*x1
        x81 = 2*P2(0)*co(5)*w1(0)
        x82 = 2*P1(1)*co(7)*x1
        x83 = 2*co(5)*x23
        x84 = 2*P1(2)*co(7)*x1
        x85 = 2*co(5)*x20
        x86 = 2*P2(3)*co(7)*x1
        x87 = 2*P4(3)*co(7)*x1
        x88 = 2*P2(1)*co(7)*x1
        x89 = 2*P3(2)*co(7)*x1
        x90 = 2*co(5)*x25
        x91 = 2*co(5)*x33
        wout(0) = w2(0)*w4(0)*(P1(0)*x18 + P1(0)*x19 + P1(0)*x27 - P1(0)*x63 - &
                  P1(0)*x75 - P1(0)*x76 - P1(0)*x77 - P1(0)*x78 + P1(1)*w1(1)* &
                  x20*x79 - P1(1)*x64 - P1(1)*x65 - P1(1)*x68 - P1(2)*x69 - P1(&
                  2)*x70 - P1(3)*x71 - P1(3)*x72 + P1(3)*x86 + P1(3)*x87 - P2(0&
                  )**2*x7 + P2(0)*w1(0)*x43 + P2(0)*x19 + P2(0)*x27 - P2(0)*x63&
                   - P2(0)*x77 + P2(1)**2*x7 + 2*P2(1)*x59 - P2(1)*x65 - P2(1)*&
                  x68 + P2(1)*x82 + P2(2)**2*x7 + P2(2)*P4(2)*x17 - P2(2)*x70  &
                   + P2(2)*x84 + P2(2)*x89 + P2(3)**2*x7 - P2(3)*x72 + P2(3)*  &
                  x87 - 2*P3(0)*co(5)*w1(0)*x25 - P3(0)*w1(0)*x50 + P3(0)*x18  &
                   + P3(0)*x19 + P3(0)*x27 - P3(0)*x63 - P3(0)*x75 - P3(0)*x76 &
                   - P3(0)*x77 - P3(0)*x78 + P3(1)*P4(1)*x17 - P3(1)*x64 - P3(1&
                  )*x65 + P3(1)*x88 - P3(2)*x69 - P3(2)*x70 - P3(3)*x71 - P3(3 &
                  )*x72 + P3(3)*x86 + P3(3)*x87 - P4(0)*x75 + P4(1)*x59 + P4(1 &
                  )*x82 + P4(1)*x88 + P4(2)*w1(2)*x91 + P4(2)*x84 + P4(2)*x89  &
                   - co(0)*x48 + co(0)*x52 + co(0)*x54 - co(1)*x26 + co(1)*x32 &
                   + co(1)*x39 + co(1)*x42 + co(2)*x26 - co(2)*x32 - co(2)*x39 &
                   - co(2)*x42 - co(2)*x52 - co(2)*x54 + co(4)*x26 - co(4)*x42 &
                   + co(4)*x48 - co(4)*x52 - co(4)*x54 - co(4)*x73 + co(5)*x25*&
                  x61 - x0*x17 + x0*x2 + x10*x13 - x10*x4 + x10*x7 + x11*x13 - &
                  x11*x4 + x11*x7 + x12*x13 - x12*x4 + x12*x7 - x13*x3 - x13*x5&
                   + x13*x6 + x13*x8 + x13*x9 + x14*x17 - x14*x2 + x15*x17 -   &
                  x15*x2 + x16*x17 - x16*x2 + x17*x29 + x17*x36 + x17*x40 - x17&
                  *x62 + x20*x47 + x20*x60 - x20*x74 + x21*x22 - x21*x37 - x21*&
                  x41 - x21*x51 - x21*x53 - x21*x55 + x22*x24 - x22*x38 + x23* &
                  x47 + x23*x60 - x23*x74 - x23*x81 - x24*x35 - x24*x37 - x24* &
                  x41 - x24*x51 - x24*x53 - x24*x55 + x25*x47 + x25*x60 - x25* &
                  x74 - x25*x81 - x26*x79 + x28*x29 + x28*x36 + x28*x40 - x28* &
                  x62 - x29*x80 + x3*x4 - x3*x7 + x30*x31 + x30*x49 - x31*x66  &
                   + x32*x79 + x34*x35 + x34*x37 + x34*x41 + x34*x44 + x34*x45 &
                   + x34*x46 + x34*x51 + x34*x53 + x34*x55 - x35*x67 + x35*x83 &
                   - x36*x80 + x37*x38 - x37*x43 - x37*x67 + x37*x83 + x37*x85 &
                   + x38*x41 + x39*x79 + x4*x5 - x4*x6 - x4*x8 - x4*x9 - x40*  &
                  x80 - x41*x67 + x41*x83 + x41*x85 + x42*x79 - x43*x45 - x43* &
                  x46 - x44*x67 + x44*x83 + x44*x85 - x45*x67 + x45*x83 + x45* &
                  x85 + x45*x90 - x46*x67 + x46*x83 + x46*x85 + x46*x90 - x49* &
                  x66 - x5*x7 + x50*x51 + x50*x53 + x50*x55 - x51*x67 + x51*x83&
                   + x51*x85 + x52*x79 - x53*x67 + x53*x83 + x53*x85 + x54*x79 &
                   - x55*x67 + x55*x83 + x55*x85 + x56*x57 + x56*x58 + x56*x91 &
                   + x57*x61 + x58*x61 + x6*x7 + x61*x91 + x62*x80 + x7*x8 + x7&
                  *x9 + x73*x79 - x74*(-2*P4(0)*w3(0) + 2*P4(1)*w3(1) + 2*P4(2 &
                  )*w3(2) + 2*P4(3)*w3(3)))
        wout(1:3) = cnul
      end select 
    end subroutine treeVSVSS
end module tcVSVSS
