!******************************************************************************!
!                                                                              !
!    tcVSVVV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVSVVV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVSVVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeVSVVV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VSVVV0)
!       c0*(-Metric(1,3)*P(4,3)*P(5,1) + Metric(1,4)*P(3,1)*P(5,4) + Metric(1,4)*
!       P(3,4)*P(5,1) - Metric(1,5)*P(3,1)*P(4,5) - Metric(3,4)*P(1,3)*P(5,4) +  
!       Metric(3,5)*P(1,3)*P(4,5) + Metric(3,5)*P(1,5)*P(4,3) - Metric(4,5)*P(1,5
!       )*P(3,4))
!       c1*(-Metric(1,3)*P(4,1)*P(5,4) + Metric(1,3)*P(4,3)*P(5,4) + Metric(1,3)*
!       P(4,5)*P(5,1) - Metric(1,3)*P(4,5)*P(5,3) + Metric(1,5)*P(3,1)*P(4,3) -  
!       Metric(1,5)*P(3,4)*P(4,1) + Metric(1,5)*P(3,4)*P(4,5) - Metric(1,5)*P(3,5
!       )*P(4,3) + Metric(3,4)*P(1,3)*P(5,1) - Metric(3,4)*P(1,4)*P(5,1) - Metric
!       (3,4)*P(1,5)*P(5,3) + Metric(3,4)*P(1,5)*P(5,4) + Metric(4,5)*P(1,3)*P(3,
!       4) - Metric(4,5)*P(1,3)*P(3,5) - Metric(4,5)*P(1,4)*P(3,1) + Metric(4,5)*
!       P(1,5)*P(3,1))
!       c2*(Metric(1,3)*Metric(4,5)*P(-1,1)*P(-1,4) - Metric(1,3)*Metric(4,5)*P(-
!       1,1)*P(-1,5) - Metric(1,3)*Metric(4,5)*P(-1,3)*P(-1,4) + Metric(1,3)*    
!       Metric(4,5)*P(-1,3)*P(-1,5) - Metric(1,5)*Metric(3,4)*P(-1,1)*P(-1,3) +  
!       Metric(1,5)*Metric(3,4)*P(-1,1)*P(-1,4) + Metric(1,5)*Metric(3,4)*P(-1,3 
!       )*P(-1,5) - Metric(1,5)*Metric(3,4)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P3(0)**2
        x1 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x0vec = co(2)*w1(:)*x1
        x2 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x1vec = co(2)*w4(:)*x2
        x3 = P3(1)**2
        x4 = P3(2)**2
        x5 = P3(3)**2
        x6 = P1(0)*w4(0)
        x2vec = P1(:)*co(1)*x2
        x7 = P1(0)*w1(0)
        x3vec = P4(:)*co(1)*x1
        x4vec = P4(:)*co(1)*x2
        x8 = P3(1)*w4(1)
        x9 = P3(2)*w4(2)
        x10 = P3(3)*w4(3)
        x11 = P3(0)*w4(0)
        x12 = x10 - x11 + x8 + x9
        x5vec = co(0)*w3(:)*x12
        x13 = P1(1)*w3(1)
        x14 = P1(2)*w3(2)
        x15 = P1(3)*w3(3)
        x16 = P1(0)*w3(0)
        x17 = x13 + x14 + x15 - x16
        x6vec = co(1)*w4(:)*x17
        x7vec = P1(1)*co(2)*w4(:)*x2
        x8vec = P3(:)*co(1)*x1
        x18 = P1(1)*w1(1)
        x19 = P1(1)*w4(1)
        x9vec = P3(:)*co(1)*x2
        x20 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x10vec = P4(:)*co(0)*x20
        x21 = P4(1)*w3(1)
        x22 = P4(2)*w3(2)
        x23 = P4(3)*w3(3)
        x24 = P4(0)*w3(0)
        x25 = x21 + x22 + x23 - x24
        x11vec = co(0)*w4(:)*x25
        x26 = P1(2)*w4(2)
        x27 = P1(3)*w4(3) + x19 + x26 - x6
        x12vec = P1(1)*co(0)*w1(:)*w3(1)
        x28 = P2(1)*w4(1)
        x29 = P2(2)*w4(2)
        x30 = P2(3)*w4(3)
        x31 = P2(0)*w4(0)
        x32 = x28 + x29 + x30 - x31
        x13vec = co(0)*w1(:)*x12
        x33 = P4(1)*w4(1)
        x34 = P4(2)*w4(2)
        x35 = P4(3)*w4(3)
        x36 = P4(0)*w4(0)
        x37 = x33 + x34 + x35 - x36
        x14vec = co(0)*w1(:)*x37
        x15vec = P2(2)*co(2)*w4(:)*x2
        x38 = P1(2)*w1(2)
        x16vec = co(0)*w1(:)*x27
        x17vec = co(0)*w1(:)*x32
        x18vec = P2(3)*co(2)*w4(:)*x2
        x39 = P1(3)*w1(3)
        x40 = P1(3)*w4(3)*x2
        x19vec = P1(:)*co(0)*x2
        x41 = P3(1)*co(1)*w1(1)*x1
        x42 = P3(2)*w1(2)
        x20vec = P1(:)*co(1)*x1
        x43 = P3(3)*w1(3)
        x44 = P4(0)*w1(0)
        x21vec = P1(:)*co(0)*x20
        x22vec = P2(0)*co(2)*w1(:)*x1
        x23vec = P2(0)*co(2)*w4(:)*x2
        x45 = P2(0)*w1(0)
        x46 = P2(1)*w1(1)
        x24vec = P4(1)*co(2)*w1(:)*x1
        x47 = P2(1)*w3(1)
        x25vec = co(1)*w1(:)*x12
        x48 = P2(2)*w1(2)
        x26vec = P2(2)*co(2)*w1(:)*x1
        x49 = P2(2)*w3(2)
        x50 = P2(3)*w1(3)
        x27vec = P2(3)*co(2)*w1(:)*x1
        x51 = P2(3)*w3(3)
        x28vec = P4(:)*co(0)*x1
        x52 = P3(0)*w1(0)
        x29vec = P3(0)*co(0)*w1(0)*w3(:)
        x53 = P3(1)*w1(1)
        x54 = P2(0)*w3(0)
        x55 = x47 + x49 + x51 - x54
        x56 = P3(1)*w3(1)
        x57 = P3(2)*w3(2)
        x58 = P3(3)*w3(3)
        x59 = P3(0)*w3(0)
        x60 = x56 + x57 + x58 - x59
        x30vec = P3(1)*co(1)*w1(1)*w4(:)
        x31vec = co(1)*w4(:)*x55
        x32vec = co(1)*w4(:)*x60
        x61 = P4(1)*w1(1)
        x62 = P4(2)*w1(2)
        x63 = P4(3)*w1(3)
        x33vec = co(1)*w1(:)*x32
        x34vec = co(1)*w1(:)*x37
        x35vec = P1(0)*co(0)*w1(:)*w3(0)
        x64 = P2(1)*P3(1)
        x36vec = P3(1)*co(0)*w1(1)*w3(:)
        x37vec = co(0)*w3(:)*x27
        x38vec = P3(2)*co(0)*w1(2)*w3(:)
        x39vec = P3(3)*co(0)*w1(3)*w3(:)
        x40vec = 2*P1(0)*co(2)*w1(:)*x1
        x41vec = 2*P4(0)*co(2)*w4(:)*x2
        x42vec = 2*co(1)*w1(:)*x12
        x43vec = 2*P1(2)*co(2)*w1(:)*x1
        x44vec = 2*P1(3)*co(2)*w1(:)*x1
        x45vec = co(1)*w4(:)*x25
        x65 = 2*P3(0)*w1(0)
        x46vec = 2*P4(2)*co(2)*w4(:)*x2
        x66 = 2*P3(2)*w1(2)
        x47vec = 2*P4(3)*co(2)*w4(:)*x2
        x67 = 2*P3(3)*w1(3)
        x48vec = 2*co(1)*w4(:)*x17
        x49vec = 2*co(1)*w1(:)*x27
        wout = -w2(0)*(-P1(0)**2*x1vec - P1(0)*x23vec - P1(0)*x41vec + P1(1)**2&
               *x1vec - 2*P1(1)*P3(1)*co(2)*w1(:)*x1 + 2*P1(1)*x24vec + P1(2)**&
               2*x1vec + P1(2)*x15vec + P1(2)*x46vec + P1(3)**2*x1vec + P1(3)* &
               x18vec + P1(3)*x47vec - P1(:)*co(1)*x40 + P1(:)*x41 + P2(1)*    &
               x24vec + P2(1)*x7vec + P3(0)*x22vec + P3(0)*x23vec + P3(0)*     &
               x40vec + P3(0)*x41vec - 2*P3(1)*P4(1)*co(2)*w4(:)*x2 + P3(1)*co(&
               1)*w1(1)*w4(:)*x55 - P3(2)*x15vec - P3(2)*x26vec - P3(2)*x43vec &
                - P3(2)*x46vec - P3(3)*x18vec - P3(3)*x27vec - P3(3)*x44vec -  &
               P3(3)*x47vec + P3(:)*co(1)*x40 + P3(:)*x41 - P4(0)**2*x0vec - P4&
               (0)*x22vec - P4(0)*x40vec + P4(1)**2*x0vec + 2*P4(1)*x7vec + P4(&
               2)**2*x0vec + P4(2)*x26vec + P4(2)*x43vec + P4(3)**2*x0vec + P4(&
               3)*x27vec + P4(3)*x44vec - P4(:)*co(1)*x40 - P4(:)*x41 + x0*    &
               x0vec + x0*x1vec - x0vec*x3 - x0vec*x4 - x0vec*x5 - x0vec*x64 - &
               x10*x19vec - x10*x2vec + x10*x4vec + x10*x9vec + x10vec*x13 +   &
               x10vec*x14 + x10vec*x15 - x10vec*x16 + x11*x19vec + x11*x2vec - &
               x11*x4vec - x11*x9vec + x11vec*x18 + x11vec*x38 + x11vec*x39 +  &
               x11vec*x42 + x11vec*x43 - x11vec*x44 - x11vec*x45 + x11vec*x46  &
                + x11vec*x48 + x11vec*x50 - x11vec*x52 + x11vec*x53 + x11vec*  &
               x61 + x11vec*x62 + x11vec*x63 - x11vec*x7 + x12vec*x27 + x12vec*&
               x32 + x13*x13vec + x13*x14vec + x13*x42vec + x13vec*x14 + x13vec&
               *x15 - x13vec*x16 + x14*x14vec + x14*x16vec + x14*x17vec + x14* &
               x42vec + x14vec*x15 + x15*x16vec + x15*x17vec + x15*x42vec - x16&
               *x42vec - x18*x3vec - x18*x5vec - x18*x6vec + x18*x8vec - x19*  &
               x2vec - x19*x4vec + x19*x9vec - x19vec*x8 - x19vec*x9 - x1vec*x3&
                - x1vec*x4 - x1vec*x5 - x1vec*x64 + x20vec*x42 + x20vec*x43 +  &
               x20vec*x44 - x20vec*x52 - x20vec*x61 - x20vec*x62 - x20vec*x63  &
                + x21*x21vec - x21*x33vec - x21*x34vec - x21*x49vec + x21vec*  &
               x22 + x21vec*x23 - x21vec*x24 - x22*x33vec - x22*x34vec - x22*  &
               x49vec - x23*x33vec - x23*x34vec - x23*x49vec + x24*x33vec + x24&
               *x34vec + x24*x49vec + x25vec*x47 + x25vec*x49 + x25vec*x51 -   &
               x25vec*x54 + x25vec*x56 + x25vec*x57 + x25vec*x58 - x25vec*x59  &
                - x26*x2vec - x26*x4vec + x26*x9vec + x27*x29vec - x27*x35vec  &
                - x27*x36vec - x28*x2vec + x28*x9vec - x28vec*x42 - x28vec*x43 &
                + x28vec*x52 - x28vec*x53 - x29*x2vec + x29*x9vec + x29vec*x32 &
                + x29vec*x37 - x2vec*x30 + x2vec*x31 - x2vec*x33 - x2vec*x34 - &
               x2vec*x35 + x2vec*x36 + x2vec*x6 - x2vec*x8 - x2vec*x9 + x30*   &
               x9vec + x30vec*x60 + x30vec*(-2*P4(0)*w3(0) + 2*P4(1)*w3(1) + 2*&
               P4(2)*w3(2) + 2*P4(3)*w3(3)) - x31*x9vec + x31vec*x42 + x31vec* &
               x43 - x31vec*x52 - x32*x35vec - x32*x36vec - x32*x38vec - x32*  &
               x39vec + x32vec*x42 + x32vec*x43 - x32vec*x52 + x33*x9vec + x34*&
               x9vec + x35*x9vec - x35vec*x37 - x36*x9vec - x36vec*x37 - x36vec&
               *(-2*P3(0)*w4(0) + 2*P3(1)*w4(1) + 2*P3(2)*w4(2) + 2*P3(3)*w4(3 &
               )) - x37*x38vec - x37*x39vec - x37vec*x42 - x37vec*x43 - x38*   &
               x3vec - x38*x5vec - x38*x6vec + x38*x8vec - x39*x3vec - x39*    &
               x5vec - x39*x6vec + x39*x8vec - x3vec*x42 - x3vec*x43 + x3vec*  &
               x44 + x3vec*x45 - x3vec*x46 - x3vec*x48 - x3vec*x50 + x3vec*x52 &
                - x3vec*x61 - x3vec*x62 - x3vec*x63 + x3vec*x7 + x42*x8vec +   &
               x43*x8vec + x44*x48vec + x44*x5vec - x44*x8vec + x45*x5vec + x45&
               *x6vec - x45*x8vec - x45vec*x65 + x45vec*x66 + x45vec*x67 - x46*&
               x5vec - x46*x6vec + x46*x8vec - x48*x5vec - x48*x6vec + x48*    &
               x8vec - x48vec*x61 - x48vec*x62 - x48vec*x63 + x4vec*x6 + x4vec*&
               x8 + x4vec*x9 - x50*x5vec - x50*x6vec + x50*x8vec - x52*x8vec - &
               x5vec*x61 - x5vec*x62 - x5vec*x63 + x5vec*x65 - x5vec*x66 -     &
               x5vec*x67 + x5vec*x7 - x6*x9vec + x61*x8vec + x62*x8vec + x63*  &
               x8vec + x6vec*x7 - x7*x8vec + x8*x9vec + x9*x9vec)
      case(VSVVV1)
!       c0*(Metric(1,4)*P(3,1)*P(5,3) - Metric(1,4)*P(3,4)*P(5,3) - Metric(1,4)*P
!       (3,5)*P(5,1) + Metric(1,4)*P(3,5)*P(5,4) + Metric(1,5)*P(3,1)*P(4,3) -   
!       Metric(1,5)*P(3,4)*P(4,1) + Metric(1,5)*P(3,4)*P(4,5) - Metric(1,5)*P(3,5
!       )*P(4,3) + Metric(3,4)*P(1,3)*P(5,1) - Metric(3,4)*P(1,4)*P(5,1) - Metric
!       (3,4)*P(1,5)*P(5,3) + Metric(3,4)*P(1,5)*P(5,4) + Metric(3,5)*P(1,3)*P(4,
!       1) - Metric(3,5)*P(1,4)*P(4,3) + Metric(3,5)*P(1,4)*P(4,5) - Metric(3,5)*
!       P(1,5)*P(4,1))
!       c1*(Metric(1,3)*P(4,1)*P(5,3) + Metric(1,3)*P(4,3)*P(5,1) - Metric(1,4)*P
!       (3,4)*P(5,1) - Metric(1,5)*P(3,5)*P(4,1) - Metric(3,4)*P(1,4)*P(5,3) -   
!       Metric(3,5)*P(1,5)*P(4,3) + Metric(4,5)*P(1,4)*P(3,5) + Metric(4,5)*P(1,5
!       )*P(3,4))
!       c2*(-Metric(1,4)*Metric(3,5)*P(-1,1)*P(-1,3) + Metric(1,4)*Metric(3,5)*P 
!       (-1,1)*P(-1,5) + Metric(1,4)*Metric(3,5)*P(-1,3)*P(-1,4) - Metric(1,4)*  
!       Metric(3,5)*P(-1,4)*P(-1,5) - Metric(1,5)*Metric(3,4)*P(-1,1)*P(-1,3) +  
!       Metric(1,5)*Metric(3,4)*P(-1,1)*P(-1,4) + Metric(1,5)*Metric(3,4)*P(-1,3 
!       )*P(-1,5) - Metric(1,5)*Metric(3,4)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x0vec = co(2)*w1(:)*x0
        x1 = P4(1)**2
        x2 = P4(2)**2
        x3 = P4(3)**2
        x4 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x1vec = co(2)*w3(:)*x4
        x5 = P4(0)**2
        x2vec = P1(0)*co(2)*w3(:)*x4
        x3vec = P4(:)*co(0)*x0
        x6 = P1(0)*w1(0)
        x7 = P1(0)*w3(0)
        x4vec = P4(:)*co(0)*x4
        x8 = P4(1)*w3(1)
        x9 = P4(2)*w3(2)
        x10 = P4(3)*w3(3)
        x11 = P4(0)*w3(0)
        x12 = x10 - x11 + x8 + x9
        x5vec = co(1)*w4(:)*x12
        x13 = P1(1)*w3(1)
        x6vec = P1(:)*co(0)*x4
        x14 = P1(1)*w1(1)
        x7vec = P3(:)*co(0)*x0
        x8vec = P3(:)*co(0)*x4
        x15 = P1(1)*w4(1)
        x16 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x9vec = P3(:)*co(1)*x16
        x17 = P1(2)*w4(2)
        x18 = P1(3)*w4(3)
        x19 = P1(0)*w4(0)
        x20 = x15 + x17 + x18 - x19
        x10vec = co(0)*w3(:)*x20
        x21 = P3(1)*w4(1)
        x22 = P3(2)*w4(2)
        x23 = P3(3)*w4(3)
        x24 = P3(0)*w4(0)
        x25 = x21 + x22 + x23 - x24
        x11vec = co(1)*w3(:)*x25
        x12vec = co(1)*w1(:)*x20
        x26 = P1(2)*w3(2)
        x27 = P1(2)*w1(2)
        x28 = P1(3)*co(0)*w3(3)*x4
        x29 = P1(3)*w1(3)
        x13vec = co(0)*w1(3)*w3(:)*x20
        x30 = P1(3)*w3(3)
        x31 = P2(1)*w3(1)
        x32 = P2(2)*w3(2)
        x33 = P2(3)*w3(3)
        x14vec = P1(:)*co(0)*x0
        x34 = P3(1)*w1(1)
        x35 = P3(1)*w3(1)
        x15vec = P1(:)*co(1)*x16
        x36 = P3(2)*w1(2)
        x37 = P3(2)*w3(2)
        x38 = P3(3)*w1(3)
        x39 = P3(3)*w3(3)
        x16vec = P1(:)*co(0)*w1(0)*x0
        x17vec = P1(:)*co(1)*x4
        x18vec = P3(0)*co(2)*w1(:)*x0
        x40 = P2(0)*w1(0)
        x41 = P2(0)*w3(0)
        x42 = P2(1)*w1(1)
        x19vec = P2(1)*co(2)*w1(:)*x0
        x20vec = P2(1)*co(2)*w3(:)*x4
        x21vec = co(0)*w1(:)*x25
        x43 = P2(2)*w1(2)
        x22vec = P2(2)*co(2)*w1(:)*x0
        x23vec = P2(2)*co(2)*w3(:)*x4
        x44 = P2(3)*w1(3)
        x24vec = P2(3)*co(2)*w1(:)*x0
        x25vec = P2(3)*co(2)*w3(:)*x4
        x45 = P3(0)*w1(0)
        x46 = P3(0)*w3(0)
        x47 = P4(0)*w1(0)
        x26vec = P3(:)*co(1)*x0
        x48 = P4(1)*w1(1)
        x49 = P4(2)*w1(2)
        x50 = P4(3)*w1(3)
        x51 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x27vec = P4(0)*co(0)*w1(0)*w3(:)
        x52 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x28vec = co(0)*w1(:)*x51
        x29vec = co(0)*w1(:)*x52
        x30vec = co(1)*w4(:)*(x13 + x26 + x30 - x7)
        x31vec = co(1)*w4(:)*(x31 + x32 + x33 - x41)
        x32vec = co(1)*w4(:)*(x35 + x37 + x39 - x46)
        x33vec = co(1)*w1(3)*w4(:)*x12
        x53 = P2(0)*P4(0)
        x34vec = P4(1)*co(0)*w1(1)*w3(:)
        x35vec = P4(2)*co(0)*w1(2)*w3(:)
        x36vec = P4(2)*co(0)*w1(:)*w3(2)
        x37vec = P4(3)*co(0)*w1(3)*w3(:)
        x38vec = 2*co(2)*w1(:)*x0
        x39vec = 2*co(0)*w1(:)*x25
        x40vec = 2*P1(1)*co(2)*w1(:)*x0
        x41vec = 2*P3(1)*co(2)*w3(:)*x4
        x42vec = P1(2)*co(2)*w1(:)*x0
        x43vec = 2*P3(2)*co(2)*w3(:)*x4
        x54 = 2*P1(3)*P3(3)
        x44vec = 2*co(0)*w3(:)*x20
        x55 = -2*P3(0)*w4(0) + 2*P3(1)*w4(1) + 2*P3(2)*w4(2) + 2*P3(3)*w4(3)
        x45vec = 2*co(0)*w1(:)*x20
        x46vec = 2*co(1)*w4(:)*x12
        x56 = 2*P3(3)
        wout = -w2(0)*(P1(0)**2*x1vec - P1(0)*P4(0)*x38vec + 2*P1(0)*x18vec -  &
               P1(1)**2*x1vec - P1(1)*x20vec - P1(1)*x41vec - P1(2)**2*x1vec - &
               P1(2)*x23vec - P1(2)*x43vec - P1(3)**2*x1vec + P1(3)*P4(3)*     &
               x38vec + P1(3)*x13vec - P1(3)*x25vec - P1(3)*x33vec + P1(:)*x28 &
                + P2(0)*x18vec + P2(0)*x2vec + P2(3)*x13vec - P2(3)*x33vec + P3&
               (0)**2*x0vec - 2*P3(0)*P4(0)*co(2)*w3(:)*x4 - P3(0)*x16vec + 2* &
               P3(0)*x2vec - P3(1)**2*x0vec - P3(1)*x19vec - P3(1)*x40vec - P3(&
               2)**2*x0vec - P3(2)*x22vec - 2*P3(2)*x42vec - P3(3)**2*x0vec -  &
               P3(3)*x24vec - P3(3)*x33vec + P3(:)*x28 + P4(0)*x16vec + P4(1)* &
               x19vec + P4(1)*x20vec + P4(1)*x40vec + P4(1)*x41vec + P4(2)*    &
               x22vec + P4(2)*x23vec + 2*P4(2)*x42vec + P4(2)*x43vec + P4(3)*co&
               (2)*w3(:)*x4*x56 + P4(3)*x24vec + P4(3)*x25vec - 2*P4(3)*x33vec &
                - P4(:)*x28 + x0vec*x1 + x0vec*x2 + x0vec*x3 - x0vec*x5 - x0vec&
               *x53 - x0vec*x54 + x1*x1vec + x10*x12vec - x10*x17vec - x10*    &
               x28vec - x10*x29vec - x10*x45vec - x10*x4vec + x10*x6vec - x10* &
               x8vec + x10vec*x14 + x10vec*x27 - x10vec*x40 + x10vec*x42 +     &
               x10vec*x43 - x10vec*x6 - x11*x12vec + x11*x17vec + x11*x28vec + &
               x11*x29vec + x11*x45vec + x11*x4vec - x11*x6vec + x11*x8vec +   &
               x11vec*x14 + x11vec*x27 + x11vec*x29 + x11vec*x34 + x11vec*x36  &
                + x11vec*x38 - x11vec*x40 + x11vec*x42 + x11vec*x43 + x11vec*  &
               x44 - x11vec*x45 - x11vec*x47 + x11vec*x48 + x11vec*x49 + x11vec&
               *x50 - x11vec*x6 + x12vec*x13 + x12vec*x26 + x12vec*x30 + x12vec&
               *x31 + x12vec*x32 + x12vec*x33 + x12vec*x35 + x12vec*x37 +      &
               x12vec*x39 - x12vec*x41 - x12vec*x46 - x12vec*x7 + x12vec*x8 +  &
               x12vec*x9 + x13*x39vec - x13*x4vec + x13*x6vec + x13*x8vec +    &
               x13vec*x56 - x14*x3vec - x14*x5vec + x14*x7vec + x14vec*x34 +   &
               x14vec*x36 + x14vec*x38 - x14vec*x48 - x14vec*x49 - x14vec*x50  &
                + x15*x9vec + x15vec*x21 + x15vec*x22 + x15vec*x23 - x15vec*x24&
                + x17*x9vec - x17vec*x8 - x17vec*x9 + x18*x9vec - x19*x9vec +  &
               x1vec*x2 + x1vec*x3 - x1vec*x5 - x1vec*x53 - x1vec*x54 + x21vec*&
               x31 + x21vec*x32 + x21vec*x33 + x21vec*x35 + x21vec*x37 + x21vec&
               *x39 - x21vec*x41 - x21vec*x46 + x26*x39vec - x26*x4vec + x26*  &
               x6vec + x26*x8vec + x26vec*x47 - x26vec*x48 - x26vec*x49 -      &
               x26vec*x50 - x27*x3vec - x27*x5vec + x27*x7vec + x27vec*x51 +   &
               x27vec*x52 + x27vec*x55 - x28vec*x8 - x29*x3vec + x29*x7vec -   &
               x29vec*x8 + x30*x39vec + x30vec*x47 - x30vec*x48 - x30vec*x49 - &
               x30vec*x50 - x31*x4vec + x31*x6vec + x31vec*x47 - x31vec*x48 -  &
               x31vec*x49 - x31vec*x50 - x32*x4vec + x32*x6vec + x32vec*x47 -  &
               x32vec*x48 - x32vec*x49 - x32vec*x50 - x33*x4vec + x33*x6vec -  &
               x34*x3vec + x34*x44vec - x34*x5vec + x34*x7vec - x34vec*x51 -   &
               x34vec*x52 - x34vec*x55 - x35*x4vec + x35*x6vec - x35vec*x51 -  &
               x35vec*x52 - x35vec*x55 - x36*x3vec + x36*x44vec - x36*x5vec +  &
               x36*x7vec - x36vec*x51 - x36vec*x52 - x36vec*(-2*P1(0)*w4(0) + 2&
               *P1(1)*w4(1) + 2*P1(2)*w4(2) + 2*P1(3)*w4(3)) - x37*x4vec + x37*&
               x6vec - x37vec*x51 - x37vec*x52 - x37vec*x55 - x38*x3vec + x38* &
               x7vec - x39*x4vec + x39*x6vec - x39vec*x7 + x3vec*x40 - x3vec*  &
               x42 - x3vec*x43 - x3vec*x44 + x3vec*x45 + x3vec*x47 - x3vec*x48 &
                - x3vec*x49 - x3vec*x50 + x3vec*x6 + x40*x5vec - x40*x7vec +   &
               x41*x4vec - x41*x6vec - x42*x5vec + x42*x7vec - x43*x5vec + x43*&
               x7vec + x44*x7vec - x44vec*x45 + x45*x5vec - x45*x7vec - x45vec*&
               x8 + x46*x4vec - x46*x6vec + x46vec*x47 - x46vec*x48 - x46vec*  &
               x49 - x47*x7vec + x48*x7vec + x49*x7vec + x4vec*x7 - x4vec*x8 - &
               x4vec*x9 + x50*x7vec + x5vec*x6 - x6*x7vec - x6vec*x7 + x6vec*x8&
                + x6vec*x9 - x7*x8vec - x8*x8vec - x8vec*x9)
      case(VSVVV2)
!       c0*(Metric(1,3)*P(4,1)*P(5,3) + Metric(1,4)*P(3,1)*P(5,4) - Metric(1,5)*P
!       (3,1)*P(4,5) - Metric(1,5)*P(3,5)*P(4,1) - Metric(3,4)*P(1,3)*P(5,4) -   
!       Metric(3,4)*P(1,4)*P(5,3) + Metric(3,5)*P(1,3)*P(4,5) + Metric(4,5)*P(1,4
!       )*P(3,5))
!       c1*(-Metric(1,3)*P(4,1)*P(5,4) + Metric(1,3)*P(4,3)*P(5,4) + Metric(1,3)*
!       P(4,5)*P(5,1) - Metric(1,3)*P(4,5)*P(5,3) - Metric(1,4)*P(3,1)*P(5,3) +  
!       Metric(1,4)*P(3,4)*P(5,3) + Metric(1,4)*P(3,5)*P(5,1) - Metric(1,4)*P(3,5
!       )*P(5,4) - Metric(3,5)*P(1,3)*P(4,1) + Metric(3,5)*P(1,4)*P(4,3) - Metric
!       (3,5)*P(1,4)*P(4,5) + Metric(3,5)*P(1,5)*P(4,1) + Metric(4,5)*P(1,3)*P(3,
!       4) - Metric(4,5)*P(1,3)*P(3,5) - Metric(4,5)*P(1,4)*P(3,1) + Metric(4,5)*
!       P(1,5)*P(3,1))
!       c2*(-Metric(1,3)*Metric(4,5)*P(-1,1)*P(-1,4) + Metric(1,3)*Metric(4,5)*P 
!       (-1,1)*P(-1,5) + Metric(1,3)*Metric(4,5)*P(-1,3)*P(-1,4) - Metric(1,3)*  
!       Metric(4,5)*P(-1,3)*P(-1,5) - Metric(1,4)*Metric(3,5)*P(-1,1)*P(-1,3) +  
!       Metric(1,4)*Metric(3,5)*P(-1,1)*P(-1,5) + Metric(1,4)*Metric(3,5)*P(-1,3 
!       )*P(-1,4) - Metric(1,4)*Metric(3,5)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P1(1)**2
        x1 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x0vec = co(2)*w3(:)*x1
        x2 = P1(2)**2
        x3 = P1(3)**2
        x4 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x1vec = co(2)*w4(:)*x4
        x5 = P1(0)**2
        x6 = P1(0)*w4(0)
        x2vec = P3(:)*co(0)*x4
        x3vec = P3(:)*co(1)*x4
        x7 = P1(0)*w3(0)
        x4vec = P4(:)*co(0)*x1
        x5vec = P4(:)*co(1)*x1
        x8 = P2(1)*w4(1)
        x9 = P2(2)*w4(2)
        x10 = P2(3)*w4(3)
        x11 = P2(0)*w4(0)
        x12 = x10 - x11 + x8 + x9
        x6vec = co(0)*w1(:)*x12
        x13 = P3(1)*w4(1)
        x14 = P3(2)*w4(2)
        x15 = P3(3)*w4(3)
        x16 = P3(0)*w4(0)
        x17 = x13 + x14 + x15 - x16
        x7vec = co(0)*w1(:)*x17
        x18 = P4(1)*w4(1)
        x19 = P4(2)*w4(2)
        x20 = P4(3)*w4(3)
        x21 = P4(0)*w4(0)
        x22 = x18 + x19 + x20 - x21
        x8vec = co(0)*w1(:)*x22
        x23 = P1(1)*w3(1)
        x9vec = P1(:)*co(1)*x1
        x24 = P1(1)*w4(1)
        x10vec = P1(:)*co(1)*x4
        x11vec = P2(1)*co(2)*w3(:)*x1
        x12vec = P2(1)*co(2)*w4(:)*x4
        x13vec = P3(:)*co(1)*x1
        x14vec = P4(:)*co(1)*x4
        x25 = P1(2)*w4(2)
        x26 = P1(3)*w4(3)
        x27 = x24 + x25 + x26 - x6
        x15vec = w3(:)*x27
        x28 = P1(1)*co(1)*w1(1)
        x29 = P1(2)*w3(2)
        x30 = P1(3)*w3(3)
        x31 = x23 + x29 + x30 - x7
        x16vec = w4(:)*x31
        x17vec = P2(2)*co(2)*w3(:)*x1
        x18vec = P2(2)*co(2)*w4(:)*x4
        x32 = P1(2)*w1(2)
        x33 = P1(3)*co(1)*w4(3)*x4
        x34 = P1(3)*P2(3)
        x19vec = co(1)*w1(3)*w3(:)*x27
        x20vec = co(1)*w1(3)*w4(:)*x31
        x35 = P2(1)*w3(1)
        x36 = P2(2)*w3(2)
        x37 = P2(3)*w3(3)
        x38 = P3(1)*w3(1)
        x39 = P3(2)*w3(2)
        x40 = P3(3)*w3(3)
        x41 = P4(1)*w3(1)
        x42 = P4(2)*w3(2)
        x43 = P4(3)*w3(3)
        x21vec = P3(0)*co(2)*w4(:)*x4
        x22vec = P4(0)*co(2)*w3(:)*x1
        x44 = P2(0)*w3(0)
        x23vec = co(0)*w1(:)*x27
        x24vec = co(1)*w1(1)*w3(:)*x27
        x25vec = co(1)*w1(1)*w4(:)*x31
        x45 = P2(2)*co(1)*w1(2)
        x46 = P3(0)*w3(0)
        x47 = P3(0)*w1(0)
        x48 = x35 + x36 + x37 - x44
        x26vec = co(1)*w4(:)*x48
        x49 = x38 + x39 + x40 - x46
        x27vec = co(1)*w4(:)*x49
        x50 = P3(1)*w1(1)
        x51 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x28vec = P4(:)*co(0)*x51
        x29vec = co(0)*w3(:)*x27
        x30vec = co(0)*w3(:)*x12
        x31vec = co(0)*w3(:)*x17
        x32vec = co(0)*w3(:)*x22
        x52 = P3(2)*w1(2)
        x33vec = P3(2)*co(0)*w1(2)*w3(:)
        x53 = P3(3)*w1(3)
        x54 = P4(0)*w3(0)
        x34vec = P3(:)*co(0)*x51
        x55 = P4(2)*w1(2)
        x56 = P4(3)*w1(3)
        x35vec = co(1)*w3(:)*x12
        x57 = P4(0)*w1(0)
        x36vec = co(1)*w3(:)*x22
        x37vec = P4(1)*co(0)*w1(1)*w4(:)
        x58 = x41 + x42 + x43 - x54
        x38vec = P4(2)*co(0)*w1(2)*w4(:)
        x39vec = P4(3)*co(0)*w1(3)*w4(:)
        x59 = P1(0)*P2(0)
        x40vec = co(1)*w1(0)*w3(:)*x27
        x41vec = co(1)*w1(0)*w4(:)*x31
        x42vec = P3(3)*co(2)*w4(:)*x4
        x43vec = P4(3)*co(2)*w3(:)*x1
        x44vec = P3(1)*co(1)*w1(1)*w4(:)
        x45vec = P4(0)*co(0)*w1(0)*w4(:)
        x46vec = P4(1)*co(1)*w1(1)*w3(:)
        x47vec = 2*co(2)*w3(:)*x1
        x60 = 2*P4(0)
        x48vec = 2*co(0)*w1(:)*x27
        x49vec = 2*co(1)*w3(:)*x27
        x61 = 2*P3(1)*P4(1)
        x50vec = 2*P3(2)*co(2)*w3(:)*x1
        x51vec = 2*P4(2)*co(2)*w4(:)*x4
        x52vec = 2*co(1)*w4(:)*x58
        x62 = 2*P3(3)
        x63 = 2*P4(3)
        x53vec = 2*co(1)*w4(:)*x31
        x54vec = 2*co(1)*w3(:)*x17
        x64 = 2*P4(1)
        wout = w2(0)*(-P1(0)*P3(0)*x47vec - P1(0)*co(2)*w4(:)*x4*x60 - P1(0)*  &
               x40vec - P1(0)*x41vec + P1(1)*P3(1)*x47vec + P1(1)*co(2)*w4(:)* &
               x4*x64 + P1(1)*x11vec + P1(1)*x12vec + P1(2)*x17vec + P1(2)*    &
               x18vec + P1(2)*x50vec + P1(2)*x51vec + P1(3)*co(2)*w3(:)*x1*x62 &
                + P1(3)*co(2)*w4(:)*x4*x63 + P1(3)*x19vec + P1(3)*x20vec + P1  &
               (:)*x33 + P2(0)*x21vec + P2(0)*x22vec - P2(0)*x40vec - P2(0)*   &
               x41vec + P2(1)*x24vec + P2(1)*x25vec + P2(3)*x19vec + P2(3)*    &
               x20vec - P2(3)*x42vec - P2(3)*x43vec + P3(0)**2*x1vec + 2*P3(0)*&
               x22vec - P3(1)**2*x1vec - P3(1)*x12vec + 2*P3(1)*x24vec - P3(2  &
               )**2*x1vec - P3(2)*x18vec - P3(2)*x51vec - P3(3)**2*x1vec - P3  &
               (:)*x33 + P4(0)**2*x0vec - P4(1)**2*x0vec + P4(1)*w1(1)*x34vec  &
                - P4(1)*x11vec - P4(2)**2*x0vec - P4(2)*x17vec - P4(2)*x50vec  &
                - P4(3)**2*x0vec + P4(:)*x33 + co(1)*w3(:)*x27*x32 + co(1)*w4  &
               (:)*x31*x32 + x0*x0vec + x0*x1vec + x0vec*x2 + x0vec*x3 + x0vec*&
               x34 - x0vec*x5 - x0vec*x59 - x0vec*x61 + x10*x10vec - x10*x3vec &
                - x10vec*x11 + x10vec*x13 + x10vec*x14 + x10vec*x15 - x10vec*  &
               x16 + x10vec*x18 + x10vec*x19 + x10vec*x20 - x10vec*x21 + x10vec&
               *x24 + x10vec*x25 - x10vec*x6 + x10vec*x8 + x10vec*x9 + x11*    &
               x3vec + x12*x33vec - x12*x46vec - x13*x14vec - x13*x3vec +      &
               x13vec*x23 + x13vec*x29 + x13vec*x30 - x13vec*x41 - x13vec*x42  &
                - x13vec*x43 + x13vec*x54 - x13vec*x7 - x14*x14vec - x14*x3vec &
                - x14vec*x15 + x14vec*x16 + x14vec*x24 + x14vec*x25 - x14vec*x6&
                - x15*x3vec + x15vec*x28 + x15vec*x45 + x16*x3vec + x16vec*x28 &
                + x16vec*x45 + x17*x33vec - x18*x3vec - x19*x3vec + x19vec*x62 &
                + x1vec*x2 + x1vec*x3 + x1vec*x34 - x1vec*x5 - x1vec*x59 -     &
               x1vec*x61 - x20*x3vec + x21*x3vec + x21vec*x60 + x22*x33vec -   &
               x22*x46vec - x23*x48vec - x23*x4vec - x23*x5vec - x23*x6vec -   &
               x23*x7vec - x23*x8vec + x23*x9vec - x23vec*x35 - x23vec*x36 -   &
               x23vec*x37 - x23vec*x38 - x23vec*x39 - x23vec*x40 - x23vec*x41  &
                - x23vec*x42 - x23vec*x43 + x23vec*x44 + x23vec*x46 + x23vec*  &
               x54 - x24*x2vec - x24*x3vec - x25*x2vec - x25*x3vec + x25vec*x64&
                - x26*x2vec + x26vec*x47 - x26vec*x52 - x26vec*x53 + x27vec*x47&
                - x27vec*x52 - x27vec*x53 - x28vec*x47 + x28vec*x50 + x28vec*  &
               x52 + x28vec*x53 - x29*x48vec - x29*x4vec - x29*x5vec - x29*    &
               x6vec - x29*x7vec - x29*x8vec + x29*x9vec - x29vec*x47 + x29vec*&
               x50 + x29vec*x52 + x29vec*x53 + x2vec*x6 - x30*x48vec - x30*    &
               x4vec - x30*x5vec - x30*x6vec - x30*x7vec - x30*x8vec + x30*    &
               x9vec - x30vec*x47 + x30vec*x50 + x30vec*x53 + x31*x37vec + x31*&
               x38vec + x31*x39vec - x31*x45vec - x31vec*x47 + x31vec*x50 +    &
               x31vec*x53 - x32vec*x47 + x32vec*x50 + x32vec*x53 + x34vec*x55  &
                + x34vec*x56 - x34vec*x57 - x35*x5vec + x35*x9vec - x35vec*x55 &
                - x35vec*x56 + x35vec*x57 - x36*x5vec + x36*x9vec - x36vec*x55 &
                - x36vec*x56 + x36vec*x57 - x37*x5vec + x37*x9vec + x37vec*x48 &
                + x37vec*x49 + x37vec*x58 - x38*x5vec + x38*x9vec + x38vec*x48 &
                + x38vec*x49 + x38vec*x58 - x39*x5vec + x39*x9vec + x39vec*x48 &
                + x39vec*x49 + x39vec*x58 + x3vec*x6 - x3vec*x8 - x3vec*x9 -   &
               x40*x5vec + x40*x9vec - x41*x5vec + x41*x9vec - x42*x5vec + x42*&
               x9vec - x42vec*x63 - x43*x5vec + x43*x9vec - x43vec*x62 + x44*  &
               x5vec - x44*x9vec - x44vec*x48 - x44vec*x49 - x44vec*(-2*P4(0)* &
               w3(0) + 2*P4(1)*w3(1) + 2*P4(2)*w3(2) + 2*P4(3)*w3(3)) - x45vec*&
               x48 - x45vec*x49 - x45vec*x58 + x46*x5vec - x46*x9vec - x46vec  &
               *(-2*P3(0)*w4(0) + 2*P3(1)*w4(1) + 2*P3(2)*w4(2) + 2*P3(3)*w4(3 &
               )) - x47*x49vec + x47*x52vec + x48vec*x7 + x49vec*x52 + x4vec*x7&
                - x52*x52vec - x52vec*x53 + x53vec*x55 + x53vec*x56 - x53vec*  &
               x57 + x54*x5vec - x54*x9vec - x54vec*x55 - x54vec*x56 + x54vec* &
               x57 + x5vec*x7 + x6vec*x7 + x7*x7vec + x7*x8vec - x7*x9vec)
      end select 
    end subroutine treeVSVVV
end module tcVSVVV
