!******************************************************************************!
!                                                                              !
!    tcVVSSS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVSSS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVSSS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeVVSSS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVSSS0)
!       P(1,2)*P(2,1)*c0
!       Metric(1,2)*P(-1,1)*P(-1,2)*c1
        x0 = co(1)*(-w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3))
        x1 = co(0)*(-P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3))
        wout(0) = w3(0)*w4(0)*(-P1(0)*P2(0)*x0 + P1(1)*P2(1)*x0 + P1(2)*P2(2)* &
                  x0 + P1(3)*P2(3)*x0 - P2(0)*w1(0)*x1 + P2(1)*w1(1)*x1 + P2(2 &
                  )*w1(2)*x1 + P2(3)*w1(3)*x1)
        wout(1:3) = cnul
      case(VVSSS1)
!       c0*(P(1,1)*P(2,1) + P(1,2)*P(2,2))
!       c1*(P(1,1)*P(2,4) + P(1,1)*P(2,5) + P(1,2)*P(2,4) + P(1,2)*P(2,5) + P(1,4
!       )*P(2,1) + P(1,4)*P(2,2) + 2*P(1,4)*P(2,4) + P(1,4)*P(2,5) + P(1,5)*P(2,1
!       ) + P(1,5)*P(2,2) + P(1,5)*P(2,4) + 2*P(1,5)*P(2,5))
!       P(1,2)*P(2,1)*c2
!       P(1,1)*P(2,2)*c3
!       c4*(Metric(1,2)*P(-1,1)**2 + Metric(1,2)*P(-1,2)**2)
!       c5*(Metric(1,2)*P(-1,1)*P(-1,4) + Metric(1,2)*P(-1,1)*P(-1,5) + Metric(1,
!       2)*P(-1,2)*P(-1,4) + Metric(1,2)*P(-1,2)*P(-1,5) + Metric(1,2)*P(-1,4)**2
!        + Metric(1,2)*P(-1,4)*P(-1,5) + Metric(1,2)*P(-1,5)**2)
!       Metric(1,2)*P(-1,1)*P(-1,2)*c6
        x0 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x1 = co(4)*x0
        x2 = co(5)*x0
        x3 = co(6)*x0
        x4 = P1(1)*co(5)*x0
        x5 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x6 = co(0)*x5
        x7 = P1(1)*w1(1)
        x8 = -P3(0)*w2(0) + P3(1)*w2(1) + P3(2)*w2(2) + P3(3)*w2(3)
        x9 = co(1)*w1(1)*x8
        x10 = -P4(0)*w2(0) + P4(1)*w2(1) + P4(2)*w2(2) + P4(3)*w2(3)
        x11 = co(1)*w1(1)*x10
        x12 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x13 = co(3)*x12
        x14 = P3(2)*co(5)*x0
        x15 = P4(2)*co(5)*x0
        x16 = P1(2)*w1(2)
        x17 = co(1)*x8
        x18 = co(1)*x10
        x19 = P1(3)*co(5)*x0
        x20 = P1(3)*w1(3)
        x21 = co(1)*w1(3)*x8
        x22 = P3(1)*co(5)*x0
        x23 = co(0)*x12
        x24 = P2(1)*w1(1)
        x25 = co(2)*x5
        x26 = P2(2)*w1(2)
        x27 = P2(3)*co(5)*x0
        x28 = P2(3)*w1(3)
        x29 = co(1)*x5
        x30 = P3(1)*w1(1)
        x31 = co(1)*x12
        x32 = P3(2)*w1(2)
        x33 = P3(3)*w1(3)
        x34 = P4(1)*w1(1)
        x35 = P4(2)*co(1)*w1(2)
        x36 = P4(3)*w1(3)
        x37 = P3(0)*co(5)*x0
        x38 = P4(0)*co(5)*x0
        x39 = P1(0)*w1(0)
        x40 = P2(0)*w1(0)
        x41 = P3(0)*w1(0)
        x42 = P4(0)*w1(0)
        x43 = 2*co(1)*x8
        x44 = 2*co(1)*x10
        wout(0) = w3(0)*w4(0)*(-P1(0)**2*x1 - P1(0)*P2(0)*x3 - P1(0)*x37 - P1(0&
                  )*x38 + P1(1)**2*x1 + P1(1)*P2(1)*x3 + P1(1)*x11 + P1(1)*x9  &
                   + P1(2)**2*x1 + P1(2)*P2(2)*x3 + P1(2)*x14 + P1(2)*x15 + P1(&
                  3)**2*x1 + P1(3)*P2(3)*x3 + P1(3)*x21 - P2(0)**2*x1 - P2(0)* &
                  x37 - P2(0)*x38 + P2(1)**2*x1 + P2(1)*P4(1)*x2 + P2(1)*x22 + &
                  P2(1)*x9 + P2(2)**2*x1 + P2(2)*x14 + P2(2)*x15 + P2(3)**2*x1 &
                   + P2(3)*x21 - P3(0)**2*x2 + P3(1)**2*x2 + P3(1)*x11 + P3(1)*&
                  x4 + 2*P3(1)*x9 + P3(2)**2*x2 + P3(3)**2*x2 + P3(3)*P4(3)*x2 &
                   + P3(3)*x19 + P3(3)*x27 - P4(0)**2*x2 - P4(0)*x37 + P4(1)**2&
                  *x2 + P4(1)*x22 + P4(1)*x4 + P4(1)*x9 + P4(2)**2*x2 + P4(2)* &
                  w1(2)*x17 + P4(2)*x14 + P4(3)**2*x2 + P4(3)*x19 + P4(3)*x21  &
                   + P4(3)*x27 + x12*x35 + x13*x16 + x13*x20 - x13*x39 + x13*x7&
                   + x16*x17 + x16*x18 + x16*x6 + x17*x26 - x17*x39 - x17*x40  &
                   - x17*x42 + x18*x20 + x18*x24 + x18*x26 + x18*x28 + x18*x32 &
                   + x18*x33 - x18*x39 - x18*x40 - x18*x41 + x20*x6 + x23*x24  &
                   + x23*x26 + x23*x28 - x23*x40 + x24*x25 + x25*x26 + x25*x28 &
                   - x25*x40 + x29*x30 + x29*x32 + x29*x33 + x29*x34 + x29*x36 &
                   - x29*x41 - x29*x42 + x30*x31 + x31*x32 + x31*x33 + x31*x34 &
                   + x31*x36 - x31*x41 - x31*x42 + x32*x43 + x33*x43 + x34*x44 &
                   + x35*x5 + x35*(-2*P4(0)*w2(0) + 2*P4(1)*w2(1) + 2*P4(2)*w2(&
                  2) + 2*P4(3)*w2(3)) + x36*x44 - x39*x6 - x41*x43 - x42*x44 + &
                  x6*x7)
        wout(1:3) = cnul
      case(VVSSS2)
!       c0*(P(1,1)*P(2,1) + P(1,2)*P(2,2))
!       P(1,2)*P(2,1)*c1
!       P(1,1)*P(2,2)*c2
!       Metric(1,2)*P(-1,1)*P(-1,2)*c3
!       c4*(Metric(1,2)*P(-1,1)**2 + Metric(1,2)*P(-1,2)**2)
        x0 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x1 = co(4)*x0
        x2 = co(3)*x0
        x3 = P1(1)*w1(1)
        x4 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x5 = co(0)*x4
        x6 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x7 = co(2)*x6
        x8 = co(0)*w1(2)
        x9 = w1(3)*x4
        x10 = co(0)*x6
        x11 = P2(1)*w1(1)
        x12 = co(1)*x4
        x13 = P1(0)*w1(0)
        x14 = P2(0)*w1(0)
        wout(0) = w3(0)*w4(0)*(-P1(0)**2*x1 - P1(0)*P2(0)*x2 + P1(1)**2*x1 + P1&
                  (1)*P2(1)*x2 + P1(2)**2*x1 + P1(2)*P2(2)*x2 + P1(2)*w1(2)*x7 &
                   + P1(2)*x4*x8 + P1(3)**2*x1 + P1(3)*P2(3)*x2 + P1(3)*co(0)* &
                  x9 + P1(3)*w1(3)*x7 - P2(0)**2*x1 + P2(1)**2*x1 + P2(2)**2*x1&
                   + P2(2)*w1(2)*x12 + P2(2)*x6*x8 + P2(3)**2*x1 + P2(3)*co(1)*&
                  x9 + P2(3)*w1(3)*x10 + x10*x11 - x10*x14 + x11*x12 - x12*x14 &
                   - x13*x5 - x13*x7 + x3*x5 + x3*x7)
        wout(1:3) = cnul
      case(VVSSS3)
!       c0*(P(1,1)*P(2,1) + P(1,2)*P(2,2))
!       c1*(P(1,1)*P(2,4) + P(1,1)*P(2,5) + P(1,2)*P(2,4) + P(1,2)*P(2,5))
!       P(1,2)*P(2,1)*c2
!       P(1,1)*P(2,2)*c3
!       c4*(P(1,4)*P(2,1) + P(1,4)*P(2,2) + P(1,5)*P(2,1) + P(1,5)*P(2,2))
!       c5*(2*P(1,4)*P(2,4) + P(1,4)*P(2,5) + P(1,5)*P(2,4) + 2*P(1,5)*P(2,5))
!       c6*(Metric(1,2)*P(-1,1)**2 + Metric(1,2)*P(-1,2)**2)
!       c7*(Metric(1,2)*P(-1,4)**2 + Metric(1,2)*P(-1,5)**2)
!       Metric(1,2)*P(-1,1)*P(-1,2)*c8
!       c9*(Metric(1,2)*P(-1,1)*P(-1,4) + Metric(1,2)*P(-1,1)*P(-1,5) + Metric(1,
!       2)*P(-1,2)*P(-1,4) + Metric(1,2)*P(-1,2)*P(-1,5))
!       Metric(1,2)*P(-1,4)*P(-1,5)*c10
        x0 = P4(0)**2
        x1 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x2 = co(10)*x1
        x3 = P1(1)**2
        x4 = co(6)*x1
        x5 = P1(2)**2
        x6 = P1(3)**2
        x7 = P2(1)**2
        x8 = P2(2)**2
        x9 = P2(3)**2
        x10 = co(7)*x1
        x11 = P1(0)**2
        x12 = co(9)*x1
        x13 = P2(0)**2
        x14 = P4(1)**2
        x15 = P4(2)**2
        x16 = P4(3)**2
        x17 = 2*co(7)*x1
        x18 = P3(0)*co(9)*x1
        x19 = P4(0)*co(10)*x1
        x20 = -P1(0)*w2(0) + P1(1)*w2(1) + P1(2)*w2(2) + P1(3)*w2(3)
        x21 = co(1)*w1(0)*x20
        x22 = -P2(0)*w2(0) + P2(1)*w2(1) + P2(2)*w2(2) + P2(3)*w2(3)
        x23 = co(1)*x22
        x24 = P1(0)*w1(0)
        x25 = -P3(0)*w2(0) + P3(1)*w2(1) + P3(2)*w2(2) + P3(3)*w2(3)
        x26 = co(1)*x25
        x27 = co(4)*x20
        x28 = co(4)*x22
        x29 = co(8)*x1
        x30 = P1(1)*P2(1)
        x31 = P1(1)*w1(1)
        x32 = co(0)*x20
        x33 = co(3)*x22
        x34 = -P4(0)*w2(0) + P4(1)*w2(1) + P4(2)*w2(2) + P4(3)*w2(3)
        x35 = co(5)*x34
        x36 = P1(2)*P2(2)
        x37 = P1(2)*w1(2)
        x38 = P1(3)*P2(3)
        x39 = P1(3)*w1(3)
        x40 = P2(0)*w1(0)
        x41 = co(4)*w1(0)*x20
        x42 = P2(0)*w1(0)*x22
        x43 = P2(1)*w1(1)
        x44 = co(0)*x22
        x45 = co(2)*x20
        x46 = P2(2)*w1(2)
        x47 = P2(3)*w1(3)
        x48 = P3(0)*w1(0)
        x49 = P3(1)*w1(1)
        x50 = P3(2)*w1(2)
        x51 = P3(3)*w1(3)
        x52 = P4(1)*co(5)*w1(1)
        x53 = P4(2)*co(5)*w1(2)
        x54 = co(5)*x22
        x55 = P4(3)*co(5)*w1(3)
        x56 = P1(0)*P2(0)
        x57 = co(0)*w1(0)
        x58 = co(5)*w1(0)*x34
        x59 = P3(1)*co(9)*x1
        x60 = P4(1)*co(10)*x1
        x61 = co(1)*x20
        x62 = P3(2)*co(9)*x1
        x63 = P4(2)*co(10)*x1
        x64 = P3(3)*co(9)*x1
        x65 = P4(3)*co(10)*x1
        x66 = P4(0)*co(5)*w1(0)
        x67 = 2*P3(0)*co(7)*x1
        x68 = 2*P4(0)*co(7)*x1
        x69 = 2*co(5)
        x70 = 2*co(5)*x22
        x71 = 2*co(5)*x25
        x72 = 2*co(9)*x1
        x73 = 2*co(5)*x20
        x74 = -2*P4(0)*w2(0) + 2*P4(1)*w2(1) + 2*P4(2)*w2(2) + 2*P4(3)*w2(3)
        x75 = 2*P3(1)*co(7)*x1
        x76 = 2*P4(1)*co(7)*x1
        x77 = 2*P3(2)*co(7)*x1
        x78 = 2*P4(2)*co(7)*x1
        x79 = 2*P1(3)*co(7)*x1
        x80 = 2*P2(3)*co(7)*x1
        wout(0) = w3(0)*w4(0)*(-P1(0)*w1(0)*x20*x69 + P1(0)*x18 + P1(0)*x19 -  &
                  P1(0)*x20*x57 + P1(0)*x21 - P1(0)*x58 - P1(0)*x67 - P1(0)*x68&
                   - P1(1)*x59 - P1(1)*x60 + P1(1)*x75 + P1(1)*x76 - P1(2)*x62 &
                   - P1(2)*x63 + P1(2)*x77 + P1(2)*x78 - P1(3)*x64 - P1(3)*x65 &
                   + P2(0)*x18 + P2(0)*x19 + P2(0)*x21 - P2(0)*x22*x57 + P2(0)*&
                  x41 - P2(0)*x58 - P2(0)*x67 - P2(0)*x68 - P2(1)*x59 - P2(1)* &
                  x60 + P2(1)*x75 + P2(1)*x76 - P2(2)*x62 - P2(2)*x63 + P2(2)* &
                  x77 + P2(2)*x78 - P2(3)*x64 - P2(3)*x65 - P3(0)**2*x10 + P3(0&
                  )*x19 + P3(0)*x41 - P3(0)*x58 - P3(0)*x68 + P3(1)**2*x10 - P3&
                  (1)*x60 + P3(2)**2*x10 - P3(2)*x63 + P3(3)**2*x10 + P3(3)*P4(&
                  3)*x17 - P3(3)*x65 + P3(3)*x79 + P3(3)*x80 + P4(1)*x75 + P4(2&
                  )*w1(2)*x54 + P4(2)*x77 + 2*P4(3)*w1(3)*x35 + P4(3)*w1(3)*x54&
                   + P4(3)*x79 + P4(3)*x80 + co(4)*x42 - x0*x17 + x0*x2 - x10* &
                  x11 - x10*x13 + x10*x3 + x10*x5 + x10*x6 + x10*x7 + x10*x8 + &
                  x10*x9 + x11*x12 - x11*x4 + x12*x13 - x12*x3 - x12*x5 - x12* &
                  x6 - x12*x7 - x12*x8 - x12*x9 - x13*x4 + x14*x17 - x14*x2 +  &
                  x15*x17 - x15*x2 + x16*x17 - x16*x2 + x17*x30 + x17*x36 + x17&
                  *x38 - x17*x56 + x20*x52 + x20*x53 + x20*x55 - x20*x66 + x22*&
                  x52 - x22*x66 + x23*x24 - x23*x31 - x23*x37 - x23*x39 + x23* &
                  x40 - x23*x43 - x23*x46 - x23*x47 + x24*x26 + x24*x27 + x24* &
                  x28 - x24*x33 - x24*x70 - x24*x71 + x25*x52 + x25*x53 + x25* &
                  x55 - x25*x66 - x26*x31 - x26*x37 - x26*x39 + x26*x40 - x26* &
                  x43 - x26*x46 - x26*x47 - x27*x31 - x27*x37 - x27*x39 - x27* &
                  x43 - x27*x46 - x27*x47 - x27*x49 - x27*x50 - x27*x51 - x28* &
                  x31 - x28*x37 - x28*x39 - x28*x43 - x28*x46 - x28*x47 + x28* &
                  x48 - x28*x49 - x28*x50 - x28*x51 + x29*x30 + x29*x36 + x29* &
                  x38 - x29*x56 + x3*x4 - x30*x72 + x31*x32 + x31*x33 + x31*x35&
                   - x31*x61 + x31*x70 + x31*x71 + x31*x73 + x32*x37 + x32*x39 &
                   + x33*x37 + x33*x39 + x35*x37 + x35*x39 + x35*x43 + x35*x46 &
                   + x35*x47 + x35*x49 + x35*x50 + x35*x51 - x36*x72 - x37*x61 &
                   + x37*x70 + x37*x71 + x37*x73 - x38*x72 - x39*x61 + x39*x70 &
                   + x39*x71 + x39*x73 + x4*x5 + x4*x6 + x4*x7 + x4*x8 + x4*x9 &
                   - x40*x45 - x40*x71 - x40*x73 - x42*x69 + x43*x44 + x43*x45 &
                   - x43*x61 + x43*x70 + x43*x71 + x43*x73 + x44*x46 + x44*x47 &
                   + x45*x46 + x45*x47 - x46*x61 + x46*x70 + x46*x71 + x46*x73 &
                   - x47*x61 + x47*x70 + x47*x71 + x47*x73 - x48*x70 - x48*x71 &
                   - x48*x73 + x49*x70 + x49*x71 + x49*x73 + x50*x70 + x50*x71 &
                   + x50*x73 + x51*x70 + x51*x71 + x51*x73 + x52*x74 + x53*x74 &
                   + x56*x72 - x66*x74)
        wout(1:3) = cnul
      end select 
    end subroutine treeVVSSS
end module tcVVSSS
