!******************************************************************************!
!                                                                              !
!    tcVVSVV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVSVV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVSVV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeVVSVV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVSVV0)
!       c0*(-Metric(1,2)*P(4,1)*P(5,4) + Metric(1,2)*P(4,2)*P(5,4) + Metric(1,2)*
!       P(4,5)*P(5,1) - Metric(1,2)*P(4,5)*P(5,2) + Metric(1,5)*P(2,1)*P(4,2) -  
!       Metric(1,5)*P(2,4)*P(4,1) + Metric(1,5)*P(2,4)*P(4,5) - Metric(1,5)*P(2,5
!       )*P(4,2) + Metric(2,4)*P(1,2)*P(5,1) - Metric(2,4)*P(1,4)*P(5,1) - Metric
!       (2,4)*P(1,5)*P(5,2) + Metric(2,4)*P(1,5)*P(5,4) + Metric(4,5)*P(1,2)*P(2,
!       4) - Metric(4,5)*P(1,2)*P(2,5) - Metric(4,5)*P(1,4)*P(2,1) + Metric(4,5)*
!       P(1,5)*P(2,1))
!       c1*(-Metric(1,2)*P(4,2)*P(5,1) + Metric(1,4)*P(2,1)*P(5,4) + Metric(1,4)*
!       P(2,4)*P(5,1) - Metric(1,5)*P(2,1)*P(4,5) - Metric(2,4)*P(1,2)*P(5,4) +  
!       Metric(2,5)*P(1,2)*P(4,5) + Metric(2,5)*P(1,5)*P(4,2) - Metric(4,5)*P(1,5
!       )*P(2,4))
!       c2*(Metric(1,2)*Metric(4,5)*P(-1,1)*P(-1,4) - Metric(1,2)*Metric(4,5)*P(-
!       1,1)*P(-1,5) - Metric(1,2)*Metric(4,5)*P(-1,2)*P(-1,4) + Metric(1,2)*    
!       Metric(4,5)*P(-1,2)*P(-1,5) - Metric(1,5)*Metric(2,4)*P(-1,1)*P(-1,2) +  
!       Metric(1,5)*Metric(2,4)*P(-1,1)*P(-1,4) + Metric(1,5)*Metric(2,4)*P(-1,2 
!       )*P(-1,5) - Metric(1,5)*Metric(2,4)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P2(0)**2
        x1 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x0vec = co(2)*w1(:)*x1
        x2 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x1vec = co(2)*w4(:)*x2
        x3 = P2(1)**2
        x4 = P2(2)**2
        x5 = P2(3)**2
        x6 = P1(0)*w4(0)
        x2vec = P1(:)*co(0)*x2
        x3vec = P4(:)*co(0)*w1(0)*x1
        x4vec = P4(:)*co(0)*x2
        x7 = P1(1)*w2(1)
        x8 = P1(2)*w2(2)
        x9 = P1(3)*w2(3)
        x10 = P1(0)*w2(0)
        x11 = -x10 + x7 + x8 + x9
        x5vec = co(0)*w4(:)*x11
        x12 = P1(0)*w1(0)
        x13 = P2(1)*w4(1)
        x14 = P2(2)*w4(2)
        x15 = P2(3)*w4(3)
        x16 = P2(0)*w4(0)
        x17 = x13 + x14 + x15 - x16
        x6vec = co(1)*w1(0)*w2(:)*x17
        x7vec = P2(:)*co(0)*x1
        x18 = P1(1)*w1(1)
        x19 = P1(1)*w4(1)
        x8vec = P2(:)*co(0)*x2
        x9vec = P3(1)*co(2)*w4(:)*x2
        x20 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x10vec = P4(:)*co(1)*x20
        x21 = P4(1)*w2(1)
        x22 = P4(2)*w2(2)
        x23 = P4(3)*w2(3)
        x24 = P4(0)*w2(0)
        x25 = x21 + x22 + x23 - x24
        x11vec = co(1)*w4(:)*x25
        x26 = P1(1)*co(1)*w2(1)
        x27 = P1(2)*w4(2)
        x28 = P1(3)*w4(3)
        x29 = x19 + x27 + x28 - x6
        x30 = P3(1)*w4(1)
        x31 = P3(2)*w4(2)
        x32 = P3(3)*w4(3)
        x33 = P3(0)*w4(0)
        x34 = x30 + x31 + x32 - x33
        x35 = P4(1)*w4(1)
        x36 = P4(2)*w4(2)
        x37 = P4(3)*w4(3)
        x38 = P4(0)*w4(0)
        x39 = x35 + x36 + x37 - x38
        x40 = P1(2)*w1(2)
        x12vec = P3(2)*co(2)*w4(:)*x2
        x13vec = co(1)*w1(:)*x29
        x14vec = co(1)*w1(:)*x17
        x15vec = co(1)*w1(:)*x34
        x16vec = co(1)*w1(:)*x39
        x41 = P1(3)*w1(3)
        x17vec = P3(3)*co(2)*w4(:)*x2
        x18vec = P1(:)*co(1)*x2
        x42 = P2(1)*co(0)*w1(1)
        x43 = P2(2)*w1(2)
        x19vec = P1(:)*co(0)*x1
        x44 = P2(3)*w1(3)
        x45 = P4(0)*w1(0)
        x20vec = P1(:)*co(1)*x20
        x21vec = P3(0)*co(2)*w1(:)*x1
        x22vec = P3(0)*co(2)*w4(:)*x2
        x46 = P2(0)*w1(0)
        x23vec = P4(:)*co(1)*x1
        x24vec = co(1)*w2(:)*x29
        x25vec = co(1)*w2(:)*x34
        x26vec = co(1)*w2(:)*x39
        x27vec = P2(:)*x1
        x47 = P2(1)*w2(1)
        x48 = P2(2)*w2(2)
        x49 = P2(3)*w2(3)
        x50 = P2(0)*w2(0)
        x51 = x47 + x48 + x49 - x50
        x52 = P3(1)*w2(1)
        x53 = P3(2)*w2(2)
        x54 = P3(3)*w2(3)
        x55 = P3(0)*w2(0)
        x56 = x52 + x53 + x54 - x55
        x28vec = co(0)*w1(:)*x17
        x57 = P2(1)*w1(1)
        x29vec = co(0)*w4(:)*x51
        x30vec = co(0)*w4(:)*x56
        x58 = P3(1)*w1(1)
        x59 = P3(2)*w1(2)
        x60 = P3(3)*w1(3)
        x61 = P4(1)*w1(1)
        x62 = P4(2)*w1(2)
        x63 = P4(3)*w1(3)
        x64 = P3(0)*co(0)*w1(0)
        x31vec = P3(1)*co(2)*w1(:)*x1
        x32vec = P3(2)*co(2)*w1(:)*x1
        x33vec = P3(3)*co(2)*w1(:)*x1
        x34vec = co(0)*w1(:)*x34
        x35vec = co(0)*w1(:)*x39
        x36vec = co(1)*w2(:)*x17
        x37vec = co(1)*w1(0)*w4(:)*x25
        x38vec = P4(:)*co(0)*x1
        x39vec = co(0)*w1(1)*w4(:)*x11
        x40vec = P4(:)*co(0)*w1(3)*x1
        x41vec = 2*co(2)*w1(:)*x1
        x65 = P1(0)*P4(0)
        x42vec = 2*co(2)*w4(:)*x2
        x43vec = 2*co(0)*w1(:)*x17
        x44vec = 2*P1(1)*co(2)*w1(:)*x1
        x45vec = 2*P1(2)*co(2)*w1(:)*x1
        x46vec = 2*P1(3)*co(2)*w1(:)*x1
        x47vec = 2*co(0)*w4(:)*x25
        x48vec = 2*P4(1)*co(2)*w4(:)*x2
        x49vec = 2*co(1)*w2(:)*x17
        x50vec = 2*P4(2)*co(2)*w4(:)*x2
        x51vec = 2*P4(3)*co(2)*w4(:)*x2
        x52vec = 2*co(0)*w1(:)*x29
        x53vec = 2*co(0)*w4(:)*x11
        wout = -w3(0)*(-P1(0)**2*x1vec + P1(0)*P2(0)*x41vec - P1(0)*x22vec - P1&
               (0)*x37vec + P1(0)*x3vec + P1(0)*x6vec + P1(1)**2*x1vec - P1(1)*&
               x39vec + P1(1)*x48vec + P1(1)*x9vec + P1(2)**2*x1vec + P1(2)*   &
               x12vec + P1(2)*x50vec + P1(3)**2*x1vec + P1(3)*x17vec - P1(3)*  &
               x40vec + P1(3)*x51vec + P1(:)*x1*x42 + P2(0)*P4(0)*x42vec + P2(0&
               )*x21vec + P2(0)*x22vec + P2(0)*x3vec + 2*P2(1)*co(0)*w1(1)*w4  &
               (:)*x25 - P2(1)*x31vec - P2(1)*x44vec - P2(1)*x48vec - P2(1)*   &
               x9vec - P2(2)*x12vec - P2(2)*x32vec - P2(2)*x45vec - P2(2)*     &
               x50vec - P2(3)*x17vec - P2(3)*x33vec - P2(3)*x40vec - P2(3)*    &
               x46vec - P2(3)*x51vec - P3(0)*x37vec + P3(0)*x3vec + P3(0)*x6vec&
                - P3(1)*x39vec - P3(3)*x40vec - P4(0)**2*x0vec - P4(0)*x21vec  &
                + P4(0)*x3vec + P4(1)**2*x0vec + P4(1)*x31vec - 2*P4(1)*x39vec &
                + P4(1)*x44vec + P4(2)**2*x0vec + P4(2)*x32vec + P4(2)*x45vec  &
                + P4(3)**2*x0vec + P4(3)*x33vec - P4(3)*x40vec + P4(3)*x46vec  &
                + w1(:)*x17*x26 + w1(:)*x26*x29 + w1(:)*x26*x34 + w1(:)*x26*x39&
                + w4(:)*x11*x64 + w4(:)*x42*x51 + w4(:)*x42*x56 + x0*x0vec + x0&
               *x1vec - x0vec*x3 - x0vec*x4 - x0vec*x5 - x10*x10vec - x10*     &
               x13vec - x10*x14vec - x10*x15vec - x10*x16vec - x10*x43vec +    &
               x10vec*x7 + x10vec*x8 + x10vec*x9 + x11vec*x18 + x11vec*x40 +   &
               x11vec*x41 + x11vec*x43 + x11vec*x44 - x11vec*x45 - x11vec*x46  &
                + x11vec*x57 + x11vec*x58 + x11vec*x59 + x11vec*x60 + x11vec*  &
               x61 + x11vec*x62 + x11vec*x63 + x12*x5vec - x12*x7vec - x13*    &
               x18vec - x13*x2vec + x13*x4vec + x13*x8vec + x13vec*x8 + x13vec*&
               x9 - x14*x18vec - x14*x2vec + x14*x4vec + x14*x8vec + x14vec*x8 &
                + x14vec*x9 - x15*x18vec - x15*x2vec + x15*x4vec + x15*x8vec + &
               x15vec*x8 + x15vec*x9 + x16*x18vec + x16*x2vec - x16*x4vec - x16&
               *x8vec + x16vec*x8 + x16vec*x9 - x18*x36vec - x18*x38vec + x18* &
               x7vec - x19*x2vec - x19*x4vec + x19*x8vec + x19vec*x43 + x19vec*&
               x44 + x19vec*x45 - x19vec*x46 - x19vec*x61 - x19vec*x62 - x19vec&
               *x63 - x1vec*x3 - x1vec*x4 - x1vec*x5 + x20vec*x21 + x20vec*x22 &
                + x20vec*x23 - x20vec*x24 - x21*x34vec - x21*x35vec - x21*     &
               x52vec - x22*x34vec - x22*x35vec - x22*x52vec - x23*x34vec - x23&
               *x35vec - x23*x52vec - x23vec*x43 - x23vec*x44 + x23vec*x46 -   &
               x23vec*x57 + x24*x34vec + x24*x35vec + x24*x52vec - x24vec*x43  &
                - x24vec*x44 + x24vec*x46 - x24vec*x57 - x25vec*x43 - x25vec*  &
               x44 + x25vec*x46 - x25vec*x57 - x26vec*x43 - x26vec*x44 + x26vec&
               *x46 - x26vec*x57 - x27*x2vec - x27*x4vec + x27*x8vec + x27vec* &
               x42 - x27vec*x64 - x28*x2vec - x28*x4vec + x28*x8vec + x28vec*  &
               x47 + x28vec*x48 + x28vec*x49 - x28vec*x50 + x28vec*x52 + x28vec&
               *x53 + x28vec*x54 - x28vec*x55 + x29vec*x43 + x29vec*x44 -      &
               x29vec*x46 - x2vec*x30 - x2vec*x31 - x2vec*x32 + x2vec*x33 -    &
               x2vec*x35 - x2vec*x36 - x2vec*x37 + x2vec*x38 + x2vec*x6 + x30* &
               x8vec + x30vec*x43 + x30vec*x44 - x30vec*x46 + x31*x8vec + x32* &
               x8vec - x33*x8vec + x35*x8vec + x36*x8vec - x36vec*x40 - x36vec*&
               x41 + x36vec*x45 - x36vec*x58 - x36vec*x59 - x36vec*x60 - x36vec&
               *x61 - x36vec*x62 - x36vec*x63 + x37*x8vec - x38*x8vec - x38vec*&
               x40 - x38vec*x43 - x38vec*x57 - x38vec*x58 - x38vec*x59 - x38vec&
               *x61 - x38vec*x62 - x40*x5vec + x40*x7vec - x41*x5vec + x41*    &
               x7vec - x41vec*x65 - x42vec*x65 + x43*x47vec - x43*x49vec + x43*&
               x7vec + x43vec*x7 + x43vec*x8 + x43vec*x9 + x44*x47vec - x44*   &
               x49vec + x44*x7vec + x45*x53vec - x45*x7vec - x46*x47vec + x46* &
               x49vec - x46*x7vec - x49vec*x57 + x4vec*x6 - x53vec*x62 - x53vec&
               *x63 + x58*x7vec - x59*x5vec + x59*x7vec - x5vec*x60 - x6*x8vec &
                + x60*x7vec + x61*x7vec + x62*x7vec + x63*x7vec)
      case(VVSVV1)
!       c0*(Metric(1,2)*P(4,1)*P(5,2) + Metric(1,2)*P(4,2)*P(5,1) - Metric(1,4)*P
!       (2,4)*P(5,1) - Metric(1,5)*P(2,5)*P(4,1) - Metric(2,4)*P(1,4)*P(5,2) -   
!       Metric(2,5)*P(1,5)*P(4,2) + Metric(4,5)*P(1,4)*P(2,5) + Metric(4,5)*P(1,5
!       )*P(2,4))
!       c1*(Metric(1,4)*P(2,1)*P(5,2) - Metric(1,4)*P(2,4)*P(5,2) - Metric(1,4)*P
!       (2,5)*P(5,1) + Metric(1,4)*P(2,5)*P(5,4) + Metric(1,5)*P(2,1)*P(4,2) -   
!       Metric(1,5)*P(2,4)*P(4,1) + Metric(1,5)*P(2,4)*P(4,5) - Metric(1,5)*P(2,5
!       )*P(4,2) + Metric(2,4)*P(1,2)*P(5,1) - Metric(2,4)*P(1,4)*P(5,1) - Metric
!       (2,4)*P(1,5)*P(5,2) + Metric(2,4)*P(1,5)*P(5,4) + Metric(2,5)*P(1,2)*P(4,
!       1) - Metric(2,5)*P(1,4)*P(4,2) + Metric(2,5)*P(1,4)*P(4,5) - Metric(2,5)*
!       P(1,5)*P(4,1))
!       c2*(-Metric(1,4)*Metric(2,5)*P(-1,1)*P(-1,2) + Metric(1,4)*Metric(2,5)*P 
!       (-1,1)*P(-1,5) + Metric(1,4)*Metric(2,5)*P(-1,2)*P(-1,4) - Metric(1,4)*  
!       Metric(2,5)*P(-1,4)*P(-1,5) - Metric(1,5)*Metric(2,4)*P(-1,1)*P(-1,2) +  
!       Metric(1,5)*Metric(2,4)*P(-1,1)*P(-1,4) + Metric(1,5)*Metric(2,4)*P(-1,2 
!       )*P(-1,5) - Metric(1,5)*Metric(2,4)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x0vec = co(2)*w1(:)*x0
        x1 = P4(1)**2
        x2 = P4(2)**2
        x3 = P4(3)**2
        x4 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x1vec = co(2)*w2(:)*x4
        x5 = P4(0)**2
        x2vec = P1(0)*co(2)*w2(:)*x4
        x6 = P1(0)*co(1)*w1(0)*x0
        x7 = P1(0)*w2(0)
        x3vec = P4(:)*co(1)*x4
        x8 = P4(1)*w2(1)
        x9 = P4(2)*w2(2)
        x10 = P4(3)*w2(3)
        x11 = P4(0)*w2(0)
        x12 = x10 - x11 + x8 + x9
        x4vec = co(0)*w1(0)*w4(:)*x12
        x13 = P1(1)*w2(1)
        x5vec = P1(:)*co(1)*x4
        x14 = P1(1)*w4(1)
        x15 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x6vec = P2(:)*co(0)*x15
        x7vec = P2(:)*co(1)*x0
        x16 = P1(1)*w1(1)
        x8vec = P2(:)*co(1)*x4
        x17 = P2(1)*w4(1)
        x18 = P2(2)*w4(2)
        x19 = P2(3)*w4(3)
        x20 = P2(0)*w4(0)
        x21 = x17 + x18 + x19 - x20
        x9vec = co(0)*w2(:)*x21
        x22 = P1(2)*w4(2)
        x23 = P1(3)*w4(3)
        x24 = P1(0)*w4(0)
        x25 = x14 + x22 + x23 - x24
        x10vec = co(0)*w1(:)*x25
        x11vec = co(1)*w1(1)*w2(:)*x25
        x26 = P1(2)*w2(2)
        x12vec = P2(:)*co(1)*w1(2)*x0
        x27 = P1(2)*w1(2)
        x13vec = co(1)*w2(:)*x25
        x28 = P1(3)*w2(3)
        x29 = P1(3)*w1(3)
        x14vec = P1(:)*co(0)*x15
        x30 = P2(1)*w1(1)
        x15vec = P1(:)*co(1)*x0
        x31 = P2(1)*w2(1)
        x32 = P2(2)*w1(2)
        x33 = P2(2)*w2(2)
        x34 = P2(3)*w1(3)
        x35 = P2(3)*w2(3)
        x36 = P3(1)*w2(1)
        x37 = P3(2)*w2(2)
        x38 = P3(3)*w2(3)
        x16vec = P1(:)*co(0)*x4
        x39 = P4(0)*co(1)*w1(0)*x0
        x17vec = P2(0)*co(2)*w1(:)*x0
        x40 = P2(0)*co(1)*w1(0)*x0
        x41 = P2(0)*w2(0)
        x18vec = co(1)*w1(:)*x21
        x19vec = co(0)*w1(2)*w2(:)*x21
        x42 = P3(1)*w1(1)
        x43 = P3(3)*w1(3)
        x44 = P4(0)*w1(0)
        x20vec = P2(:)*co(0)*x0
        x45 = P4(1)*w1(1)
        x46 = P4(2)*w1(2)
        x47 = P4(3)*w1(3)
        x48 = P3(0)*co(1)*w1(0)*x0
        x49 = P3(0)*w2(0)
        x50 = P3(1)*P4(1)
        x21vec = P3(2)*co(2)*w1(:)*x0
        x22vec = P3(2)*co(2)*w2(:)*x4
        x51 = P3(2)*w1(2)
        x23vec = P3(3)*co(2)*w1(:)*x0
        x24vec = P3(3)*co(2)*w2(:)*x4
        x52 = x13 + x26 + x28 - x7
        x25vec = P4(0)*co(0)*w1(0)*w4(:)
        x53 = x31 + x33 + x35 - x41
        x54 = x36 + x37 + x38 - x49
        x55 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x26vec = P4(0)*co(1)*w1(0)*w2(:)
        x56 = -P4(0)*w4(0) + P4(1)*w4(1) + P4(2)*w4(2) + P4(3)*w4(3)
        x27vec = co(1)*w1(:)*x55
        x28vec = co(1)*w1(:)*x56
        x29vec = co(0)*w1(0)*w2(:)*x21
        x30vec = co(1)*w1(0)*w2(:)*x25
        x31vec = P1(1)*co(2)*w2(:)*x4
        x32vec = P4(:)*co(1)*x0
        x33vec = co(0)*w4(:)*x12
        x34vec = P2(1)*co(2)*w1(:)*x0
        x57 = P3(0)*P4(0)
        x35vec = P4(1)*co(0)*w1(1)*w4(:)
        x36vec = P4(1)*w1(1)*w2(:)
        x37vec = P4(2)*co(0)*w1(2)*w4(:)
        x38vec = co(1)*w2(:)*x55
        x39vec = co(1)*w2(:)*x56
        x40vec = P4(3)*co(0)*w1(3)*w4(:)
        x41vec = 2*co(2)*w1(:)*x0
        x42vec = 2*co(1)*w1(:)*x21
        x58 = 2*P2(1)
        x59 = P1(2)*P2(2)
        x43vec = 2*co(2)*w2(:)*x4
        x44vec = 2*P1(3)*co(2)*w1(:)*x0
        x45vec = 2*P2(3)*co(2)*w2(:)*x4
        x60 = 2*P2(0)
        x46vec = 2*co(0)*w4(:)*x12
        x61 = -2*P2(0)*w4(0) + 2*P2(1)*w4(1) + 2*P2(2)*w4(2) + 2*P2(3)*w4(3)
        x47vec = 2*co(1)*w1(:)*x25
        x48vec = co(1)*w2(:)*x61
        x62 = -2*P4(0)*w2(0) + 2*P4(1)*w2(1) + 2*P4(2)*w2(2) + 2*P4(3)*w2(3)
        x49vec = 2*co(1)*w2(:)*x25
        wout = -w3(0)*(P1(0)**2*x1vec - P1(0)*P4(0)*x41vec + 2*P1(0)*x17vec -  &
               P1(0)*x29vec - P1(0)*x30vec + P1(0)*x4vec - P1(1)**2*x1vec + P1(&
               1)*P4(1)*x41vec + P1(1)*x11vec - 2*P1(1)*x34vec - P1(2)**2*x1vec&
                + P1(2)*P4(2)*x41vec + P1(2)*x12vec - P1(2)*x22vec - P1(3)**2* &
               x1vec - P1(3)*x24vec - P1(3)*x45vec + P1(:)*x39 - P1(:)*x40 + P2&
               (0)**2*x0vec - P2(0)*P4(0)*x43vec - P2(0)*x29vec + P2(0)*x4vec  &
                - P2(1)**2*x0vec - P2(2)**2*x0vec + P2(2)*P4(2)*x43vec + P2(2)*&
               x12vec + P2(2)*x19vec - P2(2)*x21vec - P2(3)**2*x0vec - P2(3)*  &
               x23vec - P2(3)*x44vec - P2(:)*x39 - P2(:)*x40 - P2(:)*x48 - P2  &
               (:)*x6 + P3(0)*x17vec - P3(0)*x29vec + P3(0)*x2vec - P3(0)*     &
               x30vec + P3(0)*x4vec + P3(1)*x11vec - P3(1)*x31vec - P3(1)*     &
               x34vec + P3(2)*x12vec + P3(2)*x19vec - P4(1)*co(1)*w1(1)*w2(:)* &
               x61 + P4(1)*co(2)*w2(:)*x4*x58 + P4(2)*x21vec + P4(2)*x22vec +  &
               P4(3)*x23vec + P4(3)*x24vec + P4(3)*x44vec + P4(3)*x45vec + P4  &
               (:)*x39 + P4(:)*x40 + P4(:)*x48 + P4(:)*x6 - co(1)*x36vec*x55 - &
               co(1)*x36vec*x56 + x0vec*x1 + x0vec*x2 + x0vec*x3 - x0vec*x5 +  &
               x0vec*x50 - x0vec*x57 + x1*x1vec + x10*x10vec - x10*x16vec - x10&
               *x27vec - x10*x28vec - x10*x3vec - x10*x47vec + x10*x5vec - x10*&
               x8vec - x10vec*x11 + x10vec*x13 + x10vec*x26 + x10vec*x28 +     &
               x10vec*x31 + x10vec*x33 + x10vec*x35 + x10vec*x36 + x10vec*x37  &
                + x10vec*x38 - x10vec*x41 - x10vec*x49 - x10vec*x7 + x10vec*x8 &
                + x10vec*x9 + x11*x16vec + x11*x27vec + x11*x28vec + x11*x3vec &
                + x11*x47vec - x11*x5vec + x11*x8vec + x11vec*x58 - x13*x3vec  &
                + x13*x42vec + x13*x5vec + x13*x8vec + x13vec*x27 + x13vec*x29 &
                + x13vec*x43 + x13vec*x51 + x14*x6vec + x14vec*x17 + x14vec*x18&
                + x14vec*x19 - x14vec*x20 + x15vec*x30 + x15vec*x32 + x15vec*  &
               x34 - x15vec*x45 - x15vec*x46 - x15vec*x47 - x16*x32vec - x16*  &
               x33vec + x16*x7vec + x16*x9vec - x16vec*x8 - x16vec*x9 + x18vec*&
               x31 + x18vec*x33 + x18vec*x35 + x18vec*x36 + x18vec*x37 + x18vec&
               *x38 - x18vec*x41 - x18vec*x49 + x1vec*x2 + x1vec*x3 - x1vec*x5 &
                + x1vec*x50 - x1vec*x57 + x20vec*x44 - x20vec*x45 - x20vec*x46 &
                - x20vec*x47 + x22*x6vec + x23*x6vec - x24*x6vec + x25vec*x52  &
                + x25vec*x53 + x25vec*x54 + x25vec*x62 - x26*x3vec + x26*x42vec&
                + x26*x5vec + x26*x8vec + x26vec*x55 + x26vec*x56 + x26vec*x61 &
                - x27*x32vec - x27*x33vec + x27*x9vec - x27vec*x8 - x27vec*x9  &
                - x28*x3vec + x28*x42vec + x28*x5vec + x28*x8vec - x28vec*x8 - &
               x28vec*x9 - x29*x32vec - x29*x33vec + x29*x7vec + x29*x9vec +   &
               x2vec*x60 - x30*x32vec - x30*x33vec + x30*x7vec + x30*x9vec -   &
               x30vec*x60 - x31*x3vec + x31*x5vec - x31vec*x58 - x32*x32vec -  &
               x32*x33vec + x32*x49vec - x32vec*x34 - x32vec*x42 - x32vec*x43  &
                - x32vec*x45 - x32vec*x46 - x32vec*x47 - x32vec*x51 - x33*x3vec&
                + x33*x5vec - x33vec*x34 - x33vec*x42 - x33vec*x43 - x33vec*x51&
                + x34*x49vec + x34*x7vec + x34*x9vec - x35*x3vec + x35*x5vec - &
               x35vec*x52 - x35vec*x53 - x35vec*x54 - x36*x3vec + x36*x5vec -  &
               x37*x3vec + x37*x5vec - x37vec*x52 - x37vec*x53 - x37vec*x54 -  &
               x38*x3vec + x38*x5vec - x38vec*x46 - x38vec*x47 - x39vec*x46 -  &
               x39vec*x47 + x3vec*x41 + x3vec*x49 + x3vec*x7 - x3vec*x8 - x3vec&
               *x9 - x40vec*x52 - x40vec*x53 - x40vec*x54 - x40vec*x62 - x41*  &
               x5vec - x41vec*x59 + x42*x7vec + x42*x9vec - x42vec*x7 + x43*   &
               x7vec + x43*x9vec - x43vec*x59 - x44*x9vec - x45*x46vec + x45*  &
               x7vec + x45*x9vec - x46*x46vec - x46*x48vec + x46*x7vec + x46*  &
               x9vec - x47*x48vec + x47*x7vec + x47*x9vec - x47vec*x8 - x47vec*&
               x9 - x49*x5vec - x5vec*x7 + x5vec*x8 + x5vec*x9 - x7*x8vec - x8*&
               x8vec - x8vec*x9)
      case(VVSVV2)
!       c0*(Metric(1,2)*P(4,1)*P(5,2) + Metric(1,4)*P(2,1)*P(5,4) - Metric(1,5)*P
!       (2,1)*P(4,5) - Metric(1,5)*P(2,5)*P(4,1) - Metric(2,4)*P(1,2)*P(5,4) -   
!       Metric(2,4)*P(1,4)*P(5,2) + Metric(2,5)*P(1,2)*P(4,5) + Metric(4,5)*P(1,4
!       )*P(2,5))
!       c1*(-Metric(1,2)*P(4,1)*P(5,4) + Metric(1,2)*P(4,2)*P(5,4) + Metric(1,2)*
!       P(4,5)*P(5,1) - Metric(1,2)*P(4,5)*P(5,2) - Metric(1,4)*P(2,1)*P(5,2) +  
!       Metric(1,4)*P(2,4)*P(5,2) + Metric(1,4)*P(2,5)*P(5,1) - Metric(1,4)*P(2,5
!       )*P(5,4) - Metric(2,5)*P(1,2)*P(4,1) + Metric(2,5)*P(1,4)*P(4,2) - Metric
!       (2,5)*P(1,4)*P(4,5) + Metric(2,5)*P(1,5)*P(4,1) + Metric(4,5)*P(1,2)*P(2,
!       4) - Metric(4,5)*P(1,2)*P(2,5) - Metric(4,5)*P(1,4)*P(2,1) + Metric(4,5)*
!       P(1,5)*P(2,1))
!       c2*(-Metric(1,2)*Metric(4,5)*P(-1,1)*P(-1,4) + Metric(1,2)*Metric(4,5)*P 
!       (-1,1)*P(-1,5) + Metric(1,2)*Metric(4,5)*P(-1,2)*P(-1,4) - Metric(1,2)*  
!       Metric(4,5)*P(-1,2)*P(-1,5) - Metric(1,4)*Metric(2,5)*P(-1,1)*P(-1,2) +  
!       Metric(1,4)*Metric(2,5)*P(-1,1)*P(-1,5) + Metric(1,4)*Metric(2,5)*P(-1,2 
!       )*P(-1,4) - Metric(1,4)*Metric(2,5)*P(-1,4)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P1(1)**2
        x1 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x0vec = co(2)*w2(:)*x1
        x2 = P1(2)**2
        x3 = P1(3)**2
        x4 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x1vec = co(2)*w4(:)*x4
        x5 = P1(0)**2
        x6 = P1(0)*w4(0)
        x2vec = P2(:)*co(0)*x4
        x3vec = P2(:)*co(1)*x4
        x7 = P1(0)*w2(0)
        x4vec = P4(:)*co(0)*x1
        x5vec = P4(:)*co(1)*x1
        x8 = P2(1)*w4(1)
        x9 = P2(2)*w4(2)
        x10 = P2(3)*w4(3)
        x11 = P2(0)*w4(0)
        x12 = x10 - x11 + x8 + x9
        x6vec = co(0)*w1(:)*x12
        x13 = P3(1)*w4(1)
        x14 = P3(2)*w4(2)
        x15 = P3(3)*w4(3)
        x16 = P3(0)*w4(0)
        x17 = x13 + x14 + x15 - x16
        x7vec = co(0)*w1(:)*x17
        x18 = P4(1)*w4(1)
        x19 = P4(2)*w4(2)
        x20 = P4(3)*w4(3)
        x21 = P4(0)*w4(0)
        x22 = x18 + x19 + x20 - x21
        x8vec = co(0)*w1(:)*x22
        x23 = P1(1)*w2(1)
        x9vec = P1(:)*co(1)*x1
        x24 = P1(1)*w4(1)
        x10vec = P1(:)*co(1)*x4
        x11vec = P2(:)*co(1)*x1
        x25 = P1(1)*P3(1)
        x12vec = P4(:)*co(1)*x4
        x26 = P1(2)*w4(2)
        x27 = P1(3)*w4(3)
        x28 = x24 + x26 + x27 - x6
        x13vec = co(1)*w1(1)*w2(:)*x28
        x29 = P1(2)*w2(2)
        x30 = P1(3)*w2(3)
        x31 = x23 + x29 + x30 - x7
        x14vec = co(1)*w1(1)*w4(:)*x31
        x32 = P1(2)*P3(2)
        x33 = P1(2)*co(1)*w4(2)*x4
        x15vec = co(1)*w2(:)*x28
        x34 = P1(2)*w1(2)
        x16vec = co(1)*w4(:)*x31
        x35 = P1(3)*P3(3)
        x17vec = co(1)*w1(3)*w2(:)*x28
        x18vec = co(1)*w1(3)*w4(:)*x31
        x36 = P2(1)*w2(1)
        x37 = P2(2)*w2(2)
        x38 = P2(3)*w2(3)
        x39 = P3(1)*w2(1)
        x40 = P3(2)*w2(2)
        x41 = P3(3)*w2(3)
        x42 = P4(1)*w2(1)
        x43 = P4(2)*w2(2)
        x44 = P4(3)*w2(3)
        x19vec = P3(0)*co(2)*w4(:)*x4
        x45 = P2(0)*w2(0)
        x20vec = co(0)*w1(:)*x28
        x46 = x36 + x37 + x38 - x45
        x21vec = w1(0)*w4(:)*x46
        x47 = P2(0)*co(1)
        x48 = P3(0)*w2(0)
        x49 = x39 + x40 + x41 - x48
        x22vec = w1(0)*w4(:)*x49
        x50 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x23vec = P4(:)*co(0)*x50
        x51 = P2(1)*w1(1)
        x24vec = co(0)*w2(:)*x28
        x25vec = co(0)*w2(:)*x12
        x26vec = co(0)*w2(:)*x17
        x27vec = co(0)*w2(:)*x22
        x52 = P2(2)*w1(2)
        x53 = P2(3)*w1(3)
        x28vec = P2(3)*co(0)*w1(3)*w2(:)
        x54 = P4(0)*w2(0)
        x55 = P4(1)*w1(1)
        x29vec = P2(:)*co(0)*x50
        x56 = P4(2)*w1(2)
        x30vec = P3(0)*co(2)*w2(:)*x1
        x57 = P3(2)*w1(2)
        x58 = P4(0)*w1(0)
        x31vec = co(1)*w2(:)*x17
        x32vec = co(1)*w2(:)*x22
        x33vec = P4(1)*co(0)*w1(1)*w4(:)
        x59 = x42 + x43 + x44 - x54
        x34vec = P4(2)*co(0)*w1(2)*w4(:)
        x35vec = P4(3)*co(0)*w1(3)*w4(:)
        x36vec = co(1)*w1(0)*w2(:)*x28
        x37vec = co(1)*w1(0)*w4(:)*x31
        x38vec = P1(2)*co(0)*w1(:)*w2(2)
        x60 = P2(0)*w1(0)
        x39vec = P2(0)*co(0)*w1(0)*w2(:)
        x40vec = P2(1)*co(2)*w4(:)*x4
        x41vec = P2(1)*co(1)*w1(1)*w4(:)
        x42vec = P2(2)*co(2)*w4(:)*x4
        x43vec = co(1)*w4(:)*x46
        x44vec = co(1)*w4(:)*x49
        x45vec = P2(3)*co(2)*w4(:)*x4
        x46vec = P4(1)*co(2)*w2(:)*x1
        x47vec = P4(2)*co(2)*w2(:)*x1
        x48vec = P4(3)*co(2)*w2(:)*x1
        x49vec = P4(0)*co(0)*w1(0)*w4(:)
        x61 = P4(0)*co(0)
        x50vec = P4(3)*co(1)*w1(3)*w2(:)
        x51vec = 2*co(2)*w2(:)*x1
        x52vec = 2*co(2)*w4(:)*x4
        x53vec = 2*co(0)*w1(:)*x28
        x54vec = 2*co(1)*w2(:)*x28
        x62 = 2*P2(1)
        x63 = -2*P4(0)*w2(0) + 2*P4(1)*w2(1) + 2*P4(2)*w2(2) + 2*P4(3)*w2(3)
        x55vec = co(1)*w4(:)*x63
        x64 = 2*P2(3)
        x65 = 2*P4(3)
        x56vec = 2*co(1)*w2(:)*x12
        x66 = P2(0)*P4(0)
        x57vec = 2*co(1)*w4(:)*x31
        wout = w3(0)*(-P1(0)*P2(0)*x51vec - P1(0)*P4(0)*x52vec - P1(0)*x19vec  &
                - P1(0)*x30vec - P1(0)*x36vec - P1(0)*x37vec + P1(1)*P4(1)*    &
               x52vec + P1(1)*co(2)*w2(:)*x1*x62 + P1(1)*x13vec + P1(1)*x14vec &
                + P1(2)*P2(2)*x51vec + P1(2)*P4(2)*x52vec - P1(2)*P4(:)*co(0)* &
               w2(2)*x1 + P1(3)*P4(3)*x52vec + P1(3)*co(2)*w2(:)*x1*x64 + P1(3 &
               )*x17vec + P1(3)*x18vec + P2(0)**2*x1vec + P2(0)*co(1)*w1(0)*w4 &
               (:)*x63 + P2(0)*x19vec - P2(1)**2*x1vec - P2(2)**2*x1vec - 2*P2(&
               2)*x47vec - P2(3)**2*x1vec + P2(3)*co(0)*w1(3)*w2(:)*x12 + 2*P2(&
               3)*co(1)*w1(3)*w2(:)*x28 - P2(:)*P4(0)*co(0)*w1(0)*x50 - P2(:)* &
               x33 - P3(0)*x36vec - P3(0)*x37vec + P3(1)*x13vec + P3(1)*x14vec &
                - P3(1)*x40vec - P3(1)*x46vec - P3(2)*x42vec - P3(2)*x47vec +  &
               P3(3)*x17vec + P3(3)*x18vec - P3(3)*x45vec - P3(3)*x48vec + P4(0&
               )**2*x0vec + P4(0)*x30vec - 2*P4(0)*x37vec - P4(1)**2*x0vec - 2*&
               P4(1)*x40vec - P4(2)**2*x0vec - 2*P4(2)*x42vec - P4(3)**2*x0vec &
                + P4(3)*w1(3)*x29vec + P4(:)*x33 + x0*x0vec + x0*x1vec + x0vec*&
               x2 + x0vec*x25 + x0vec*x3 + x0vec*x32 + x0vec*x35 - x0vec*x5 +  &
               x10*x10vec - x10*x12vec - x10*x3vec - x10vec*x11 + x10vec*x13 + &
               x10vec*x14 + x10vec*x15 - x10vec*x16 + x10vec*x18 + x10vec*x19  &
                + x10vec*x20 - x10vec*x21 + x10vec*x24 + x10vec*x26 + x10vec*  &
               x27 - x10vec*x6 + x10vec*x8 + x10vec*x9 + x11*x12vec + x11*x3vec&
                + x11vec*x23 + x11vec*x29 + x11vec*x30 - x11vec*x42 - x11vec*  &
               x43 - x11vec*x44 + x11vec*x54 - x11vec*x7 + x12vec*x24 + x12vec*&
               x27 - x12vec*x6 - x12vec*x8 - x12vec*x9 - x13*x3vec + x13vec*x62&
                - x14*x3vec - x15*x3vec + x15vec*x34 + x15vec*x57 + x16*x3vec  &
                + x16vec*x34 + x16vec*x57 + x17*x28vec - x17*x38vec - x17*     &
               x39vec - x17*x50vec - x18*x3vec + x18vec*x65 - x19*x3vec + x1vec&
               *x2 + x1vec*x25 + x1vec*x3 + x1vec*x32 + x1vec*x35 - x1vec*x5 - &
               x20*x3vec - x20vec*x36 - x20vec*x37 - x20vec*x38 - x20vec*x39 - &
               x20vec*x40 - x20vec*x41 - x20vec*x42 - x20vec*x43 - x20vec*x44  &
                + x20vec*x45 + x20vec*x48 + x20vec*x54 + x21*x3vec + x21vec*x47&
                - x21vec*x61 + x22*x28vec - x22*x38vec - x22*x39vec - x22*     &
               x50vec + x22vec*x47 - x22vec*x61 - x23*x4vec - x23*x53vec - x23*&
               x5vec - x23*x6vec - x23*x7vec - x23*x8vec + x23*x9vec + x23vec* &
               x51 + x23vec*x52 + x23vec*x53 - x23vec*x60 - x24*x2vec - x24*   &
               x3vec + x24vec*x51 + x24vec*x52 - x24vec*x60 + x25vec*x51 +     &
               x25vec*x52 - x25vec*x60 - x26*x2vec + x26vec*x51 + x26vec*x52 - &
               x27*x2vec - x27*x3vec + x27vec*x51 + x27vec*x52 + x28*x28vec -  &
               x29*x53vec - x29*x5vec - x29*x6vec + x29*x9vec + x29vec*x55 +   &
               x29vec*x56 + x2vec*x6 - x30*x4vec - x30*x53vec - x30*x5vec - x30&
               *x6vec - x30*x7vec - x30*x8vec + x30*x9vec + x31*x33vec + x31*  &
               x34vec + x31*x35vec - x31*x49vec - x31vec*x55 - x31vec*x56 +    &
               x31vec*x58 - x32vec*x55 - x32vec*x56 + x32vec*x58 + x33vec*x46  &
                + x33vec*x49 + x33vec*x59 + x34vec*x46 + x34vec*x49 + x34vec*  &
               x59 + x35vec*x46 + x35vec*x49 + x35vec*x59 - x36*x5vec + x36*   &
               x9vec - x37*x5vec + x37*x9vec - x38*x5vec + x38*x9vec - x39*    &
               x5vec + x39*x9vec + x3vec*x6 - x3vec*x8 - x3vec*x9 - x40*x5vec  &
                + x40*x9vec - x41*x5vec + x41*x9vec - x41vec*x46 - x41vec*x49  &
                - x41vec*x63 - x42*x5vec + x42*x9vec - x43*x5vec + x43*x9vec - &
               x43vec*x52 - x43vec*x53 - x44*x5vec + x44*x9vec - x44vec*x52 -  &
               x44vec*x53 + x45*x5vec - x45*x9vec - x45vec*x65 - x46vec*x62 +  &
               x48*x5vec - x48*x9vec - x48vec*x64 - x49vec*x59 + x4vec*x7 -    &
               x50vec*(-2*P2(0)*w4(0) + 2*P2(1)*w4(1) + 2*P2(2)*w4(2) + 2*P2(3 &
               )*w4(3)) + x51vec*x66 + x52*x54vec - x52*x55vec + x52vec*x66 -  &
               x53*x55vec + x53vec*x7 + x54*x5vec - x54*x9vec - x54vec*x60 -   &
               x55*x56vec + x55*x57vec - x56*x56vec + x56*x57vec + x56vec*x58  &
                + x5vec*x7 + x6vec*x7 + x7*x7vec + x7*x8vec - x7*x9vec)
      end select 
    end subroutine treeVVSVV
end module tcVVSVV
