!******************************************************************************!
!                                                                              !
!    tcVVVSV.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVVSV.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVVSV
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeVVVSV(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVVSV0)
!       Metric(1,5)*Metric(2,3)*c0
!       Metric(1,3)*Metric(2,5)*c1
!       Metric(1,2)*Metric(3,5)*c2
        if (last) VB_last = .true.
        x0vec = co(1)*w2(:)
        x1vec = co(2)*w3(:)
        wout = w4(0)*(co(0)*w1(:)*(-w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) +  &
               w2(3)*w3(3)) - w1(0)*w2(0)*x1vec - w1(0)*w3(0)*x0vec + w1(1)*w2(&
               1)*x1vec + w1(1)*w3(1)*x0vec + w1(2)*w2(2)*x1vec + w1(2)*w3(2)* &
               x0vec + w1(3)*w2(3)*x1vec + w1(3)*w3(3)*x0vec)
      case(VVVSV1)
!       c0*(Metric(1,2)*P(3,1)*P(5,2) + Metric(1,2)*P(3,2)*P(5,1) - Metric(1,3)*P
!       (2,3)*P(5,1) - Metric(1,5)*P(2,5)*P(3,1) - Metric(2,3)*P(1,3)*P(5,2) -   
!       Metric(2,5)*P(1,5)*P(3,2) + Metric(3,5)*P(1,3)*P(2,5) + Metric(3,5)*P(1,5
!       )*P(2,3))
!       c1*(Metric(1,3)*P(2,1)*P(5,2) - Metric(1,3)*P(2,3)*P(5,2) - Metric(1,3)*P
!       (2,5)*P(5,1) + Metric(1,3)*P(2,5)*P(5,3) + Metric(1,5)*P(2,1)*P(3,2) -   
!       Metric(1,5)*P(2,3)*P(3,1) + Metric(1,5)*P(2,3)*P(3,5) - Metric(1,5)*P(2,5
!       )*P(3,2) + Metric(2,3)*P(1,2)*P(5,1) - Metric(2,3)*P(1,3)*P(5,1) - Metric
!       (2,3)*P(1,5)*P(5,2) + Metric(2,3)*P(1,5)*P(5,3) + Metric(2,5)*P(1,2)*P(3,
!       1) - Metric(2,5)*P(1,3)*P(3,2) + Metric(2,5)*P(1,3)*P(3,5) - Metric(2,5)*
!       P(1,5)*P(3,1))
!       c2*(-Metric(1,3)*Metric(2,5)*P(-1,1)*P(-1,2) + Metric(1,3)*Metric(2,5)*P 
!       (-1,1)*P(-1,5) + Metric(1,3)*Metric(2,5)*P(-1,2)*P(-1,3) - Metric(1,3)*  
!       Metric(2,5)*P(-1,3)*P(-1,5) - Metric(1,5)*Metric(2,3)*P(-1,1)*P(-1,2) +  
!       Metric(1,5)*Metric(2,3)*P(-1,1)*P(-1,3) + Metric(1,5)*Metric(2,3)*P(-1,2 
!       )*P(-1,5) - Metric(1,5)*Metric(2,3)*P(-1,3)*P(-1,5))
        if (last) VB_last = .true.
        x0 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x0vec = co(2)*w1(:)*x0
        x1 = P3(1)**2
        x2 = P3(2)**2
        x3 = P3(3)**2
        x4 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x1vec = co(2)*w2(:)*x4
        x5 = P3(0)**2
        x6 = P1(0)*w1(0)
        x2vec = P3(:)*co(1)*x0
        x7 = P1(0)*w2(0)
        x3vec = P3(:)*co(1)*x4
        x4vec = P4(0)*co(2)*w2(:)*x4
        x8 = P3(1)*w2(1)
        x9 = P3(2)*w2(2)
        x10 = P3(3)*w2(3)
        x11 = P3(0)*w2(0)
        x12 = x10 - x11 + x8 + x9
        x5vec = co(0)*w3(:)*x12
        x13 = P1(1)*w2(1)
        x6vec = P1(:)*co(1)*x4
        x14 = P1(1)*w3(1)
        x15 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x7vec = P2(:)*co(0)*x15
        x8vec = P2(:)*co(1)*x0
        x16 = P1(1)*w1(1)
        x9vec = P2(:)*co(1)*x4
        x17 = P2(1)*w3(1)
        x18 = P2(2)*w3(2)
        x19 = P2(3)*w3(3)
        x20 = P2(0)*w3(0)
        x21 = x17 + x18 + x19 - x20
        x10vec = co(0)*w2(:)*x21
        x22 = P1(2)*w3(2)
        x23 = P1(3)*w3(3)
        x24 = P1(0)*w3(0)
        x25 = x14 + x22 + x23 - x24
        x11vec = co(0)*w1(:)*x25
        x12vec = co(1)*w2(:)*x25
        x26 = P1(2)*w2(2)
        x27 = P1(2)*w1(2)
        x28 = P1(3)*w2(3)
        x29 = P1(3)*w1(3)
        x13vec = P1(:)*co(0)*x15
        x14vec = P1(:)*co(1)*x0
        x30 = P2(1)*w1(1)
        x31 = P2(1)*w2(1)
        x32 = P2(2)*w1(2)
        x33 = P2(2)*w2(2)
        x34 = P2(3)*w1(3)
        x35 = P2(3)*w2(3)
        x15vec = P1(:)*co(0)*x4
        x36 = P3(0)*w1(0)
        x37 = P4(1)*w2(1)
        x38 = P4(2)*w2(2)
        x39 = P4(3)*w2(3)
        x40 = P2(0)*w1(0)
        x41 = P2(0)*w2(0)
        x16vec = P4(0)*co(2)*w1(:)*x0
        x17vec = co(1)*w1(:)*x21
        x18vec = P2(:)*co(0)*x0
        x42 = P3(0)*co(1)*w2(0)*x4
        x43 = P3(1)*w1(1)
        x44 = P3(2)*w1(2)
        x45 = P3(3)*w1(3)
        x46 = P4(1)*w1(1)
        x47 = P4(2)*w1(2)
        x48 = P4(3)*w1(3)
        x49 = x13 + x26 + x28 - x7
        x19vec = P3(0)*co(0)*w1(0)*w3(:)
        x50 = x31 + x33 + x35 - x41
        x51 = P4(0)*w2(0)
        x52 = x37 + x38 + x39 - x51
        x53 = -P3(0)*w3(0) + P3(1)*w3(1) + P3(2)*w3(2) + P3(3)*w3(3)
        x20vec = co(1)*w2(:)*x53
        x54 = -P4(0)*w3(0) + P4(1)*w3(1) + P4(2)*w3(2) + P4(3)*w3(3)
        x21vec = co(1)*w2(:)*x54
        x22vec = co(1)*w1(:)*x53
        x23vec = co(1)*w1(:)*x54
        x24vec = P4(1)*co(2)*w1(:)*x0
        x25vec = P4(1)*co(2)*w2(:)*x4
        x26vec = P4(2)*co(2)*w1(:)*x0
        x27vec = P4(2)*co(2)*w2(:)*x4
        x28vec = P4(3)*co(2)*w1(:)*x0
        x29vec = P4(3)*co(2)*w2(:)*x4
        x55 = P4(0)*w1(0)
        x30vec = P3(:)*co(1)*w1(2)*x0
        x31vec = P3(:)*co(1)*w1(3)*x0
        x32vec = P3(1)*co(0)*w1(1)*w3(:)
        x33vec = P3(2)*co(0)*w1(2)*w3(:)
        x34vec = P3(3)*co(0)*w1(3)*w3(:)
        x35vec = P1(0)*co(2)*w1(:)*x0
        x36vec = 2*co(1)*w1(:)*x21
        x56 = 2*P1(1)*P2(1)
        x57 = P1(2)*P2(2)
        x37vec = 2*co(2)*w1(:)*x0
        x38vec = 2*co(2)*w2(:)*x4
        x58 = P1(3)*P2(3)
        x39vec = 2*P2(0)*co(2)*w2(:)*x4
        x40vec = 2*co(1)*w2(:)*x25
        x41vec = 2*co(0)*w3(:)*x12
        x42vec = 2*co(1)*w2(:)*x21
        x43vec = 2*co(1)*w1(:)*x25
        wout = -w4(0)*(P1(0)**2*x1vec + P1(0)*x39vec + P1(0)*x4vec - P1(1)**2* &
               x1vec + P1(1)*P3(1)*x37vec - P1(1)*x25vec - P1(2)**2*x1vec + P1(&
               2)*P3(2)*x37vec - P1(2)*x27vec - P1(2)*x30vec - P1(3)**2*x1vec  &
                + P1(3)*P3(3)*x37vec - P1(3)*x29vec - P1(3)*x31vec - P1(:)*x42 &
                + P2(0)**2*x0vec + P2(0)*x16vec + 2*P2(0)*x35vec - P2(1)**2*   &
               x0vec + P2(1)*P3(1)*x38vec - P2(1)*x24vec - P2(2)**2*x0vec + P2(&
               2)*P3(2)*x38vec - P2(2)*x26vec - P2(2)*x30vec - P2(3)**2*x0vec  &
                + P2(3)*P3(3)*x38vec - P2(3)*x28vec - P2(3)*x31vec + P2(:)*x42 &
                - P3(0)*x16vec - 2*P3(0)*x35vec - P3(0)*x39vec - P3(0)*x4vec + &
               P3(1)*x24vec + P3(1)*x25vec + P3(2)*x26vec + P3(2)*x27vec - P3(2&
               )*x30vec + P3(3)*x28vec + P3(3)*x29vec - P3(3)*x31vec + P3(:)*  &
               x42 - P4(2)*x30vec - P4(3)*x31vec + x0vec*x1 + x0vec*x2 + x0vec*&
               x3 - x0vec*x5 - x0vec*x56 + x1*x1vec + x10*x11vec - x10*x15vec  &
                - x10*x22vec - x10*x23vec - x10*x3vec - x10*x43vec + x10*x6vec &
                - x10*x9vec + x10vec*x16 + x10vec*x27 + x10vec*x29 + x10vec*x30&
                + x10vec*x32 + x10vec*x34 - x10vec*x36 - x10vec*x40 + x10vec*  &
               x43 + x10vec*x44 + x10vec*x45 + x10vec*x46 + x10vec*x47 + x10vec&
               *x48 - x10vec*x55 - x10vec*x6 - x11*x11vec + x11*x15vec + x11*  &
               x22vec + x11*x23vec + x11*x43vec + x11vec*x13 + x11vec*x26 +    &
               x11vec*x28 + x11vec*x31 + x11vec*x33 + x11vec*x35 + x11vec*x37  &
                + x11vec*x38 + x11vec*x39 - x11vec*x41 - x11vec*x51 - x11vec*x7&
                + x11vec*x8 + x11vec*x9 + x12vec*x16 + x12vec*x27 + x12vec*x29 &
                + x12vec*x46 + x12vec*x47 + x12vec*x48 - x12vec*x55 - x12vec*x6&
                + x13*x36vec - x13*x3vec + x13*x6vec + x13*x9vec + x13vec*x17  &
                + x13vec*x18 + x13vec*x19 - x13vec*x20 + x14*x7vec + x14vec*x30&
                + x14vec*x32 + x14vec*x34 + x14vec*x36 - x14vec*x40 - x14vec*  &
               x43 - x14vec*x44 - x14vec*x45 - x15vec*x8 - x15vec*x9 - x16*    &
               x2vec - x16*x5vec + x16*x8vec + x17vec*x31 + x17vec*x33 + x17vec&
               *x35 + x17vec*x37 + x17vec*x38 + x17vec*x39 - x17vec*x41 -      &
               x17vec*x51 + x18vec*x36 - x18vec*x43 - x18vec*x44 - x18vec*x45  &
                + x19vec*x49 + x19vec*x50 + x19vec*x52 + x1vec*x2 + x1vec*x3 - &
               x1vec*x5 - x1vec*x56 + x20vec*x36 - x20vec*x43 - x20vec*x44 -   &
               x20vec*x45 + x21vec*x36 - x21vec*x43 - x21vec*x44 - x21vec*x45  &
                + x22*x7vec - x22vec*x8 - x22vec*x9 + x23*x7vec - x23vec*x8 -  &
               x23vec*x9 - x24*x7vec + x26*x36vec - x26*x3vec + x26*x6vec + x26&
               *x9vec - x27*x5vec + x27*x8vec + x28*x36vec - x28*x3vec + x28*  &
               x6vec + x28*x9vec - x29*x5vec + x29*x8vec - x2vec*x30 + x2vec*  &
               x36 + x2vec*x40 - x2vec*x43 - x2vec*x46 + x2vec*x55 + x2vec*x6  &
                + x30*x40vec - x30*x5vec + x30*x8vec - x31*x3vec + x31*x6vec + &
               x32*x40vec - x32*x5vec + x32*x8vec - x32vec*x49 - x32vec*x50 -  &
               x32vec*x52 - x33*x3vec + x33*x6vec - x33vec*x49 - x33vec*x50 -  &
               x33vec*x52 + x34*x40vec - x34*x5vec + x34*x8vec - x34vec*x49 -  &
               x34vec*x50 - x34vec*x52 - x35*x3vec + x35*x6vec + x36*x41vec +  &
               x36*x42vec - x36*x8vec - x36vec*x7 - x37*x3vec + x37*x6vec -    &
               x37vec*x57 - x37vec*x58 - x38*x3vec + x38*x6vec - x38vec*x57 -  &
               x38vec*x58 - x39*x3vec + x39*x6vec + x3vec*x41 + x3vec*x51 +    &
               x3vec*x7 - x3vec*x8 - x3vec*x9 - x40*x40vec + x40*x5vec - x40*  &
               x8vec - x41*x6vec - x41vec*x43 - x41vec*x44 - x41vec*x45 -      &
               x42vec*x43 - x42vec*x44 - x42vec*x45 + x43*x8vec - x43vec*x8 -  &
               x43vec*x9 + x44*x8vec + x45*x8vec - x46*x5vec + x46*x8vec - x47*&
               x5vec + x47*x8vec - x48*x5vec + x48*x8vec - x51*x6vec + x55*    &
               x5vec - x55*x8vec + x5vec*x6 - x6*x8vec - x6vec*x7 + x6vec*x8 + &
               x6vec*x9 - x7*x9vec - x8*x9vec - x9*x9vec)
      case(VVVSV2)
!       c0*(-Metric(1,2)*P(3,2)*P(5,1) + Metric(1,3)*P(2,1)*P(5,3) + Metric(1,3)*
!       P(2,3)*P(5,1) - Metric(1,5)*P(2,1)*P(3,5) - Metric(2,3)*P(1,2)*P(5,3) +  
!       Metric(2,5)*P(1,2)*P(3,5) + Metric(2,5)*P(1,5)*P(3,2) - Metric(3,5)*P(1,5
!       )*P(2,3))
!       c1*(-Metric(1,2)*P(3,1)*P(5,3) + Metric(1,2)*P(3,2)*P(5,3) + Metric(1,2)*
!       P(3,5)*P(5,1) - Metric(1,2)*P(3,5)*P(5,2) + Metric(1,5)*P(2,1)*P(3,2) -  
!       Metric(1,5)*P(2,3)*P(3,1) + Metric(1,5)*P(2,3)*P(3,5) - Metric(1,5)*P(2,5
!       )*P(3,2) + Metric(2,3)*P(1,2)*P(5,1) - Metric(2,3)*P(1,3)*P(5,1) - Metric
!       (2,3)*P(1,5)*P(5,2) + Metric(2,3)*P(1,5)*P(5,3) + Metric(3,5)*P(1,2)*P(2,
!       3) - Metric(3,5)*P(1,2)*P(2,5) - Metric(3,5)*P(1,3)*P(2,1) + Metric(3,5)*
!       P(1,5)*P(2,1))
!       c2*(Metric(1,2)*Metric(3,5)*P(-1,1)*P(-1,3) - Metric(1,2)*Metric(3,5)*P(-
!       1,1)*P(-1,5) - Metric(1,2)*Metric(3,5)*P(-1,2)*P(-1,3) + Metric(1,2)*    
!       Metric(3,5)*P(-1,2)*P(-1,5) - Metric(1,5)*Metric(2,3)*P(-1,1)*P(-1,2) +  
!       Metric(1,5)*Metric(2,3)*P(-1,1)*P(-1,3) + Metric(1,5)*Metric(2,3)*P(-1,2 
!       )*P(-1,5) - Metric(1,5)*Metric(2,3)*P(-1,3)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P2(0)**2
        x1 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x0vec = co(2)*w1(:)*x1
        x2 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x1vec = co(2)*w3(:)*x2
        x3 = P2(1)**2
        x4 = P2(2)**2
        x5 = P2(3)**2
        x6 = P1(0)*w3(0)
        x2vec = P1(:)*co(1)*x2
        x7 = P1(0)*w1(0)
        x3vec = P3(:)*co(1)*x1
        x4vec = P3(:)*co(1)*x2
        x8 = P2(1)*w3(1)
        x9 = P2(2)*w3(2)
        x10 = P2(3)*w3(3)
        x11 = P2(0)*w3(0)
        x12 = x10 - x11 + x8 + x9
        x5vec = co(0)*w2(:)*x12
        x13 = P1(1)*w2(1)
        x14 = P1(2)*w2(2)
        x15 = P1(3)*w2(3)
        x16 = P1(0)*w2(0)
        x17 = x13 + x14 + x15 - x16
        x6vec = co(1)*w3(:)*x17
        x7vec = P2(:)*co(1)*w1(1)*x1
        x18 = P1(1)*w3(1)
        x8vec = P2(:)*co(1)*x2
        x19 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x9vec = P3(:)*co(0)*x19
        x10vec = P4(1)*co(2)*w3(:)*x2
        x20 = P3(1)*w2(1)
        x21 = P3(2)*w2(2)
        x22 = P3(3)*w2(3)
        x23 = P3(0)*w2(0)
        x24 = x20 + x21 + x22 - x23
        x11vec = co(0)*w3(:)*x24
        x25 = P1(1)*w1(1)
        x26 = P1(2)*w3(2)
        x27 = P1(3)*w3(3)
        x28 = x18 + x26 + x27 - x6
        x12vec = co(0)*w1(:)*x28
        x13vec = co(0)*w1(:)*x12
        x29 = P3(1)*w3(1)
        x30 = P3(2)*w3(2)
        x31 = P3(3)*w3(3)
        x32 = P3(0)*w3(0)
        x33 = x29 + x30 + x31 - x32
        x14vec = co(0)*w1(:)*x33
        x34 = P4(1)*w3(1)
        x35 = P4(2)*w3(2)
        x36 = P4(3)*w3(3)
        x37 = P4(0)*w3(0)
        x38 = x34 + x35 + x36 - x37
        x15vec = co(0)*w1(:)*x38
        x16vec = P2(:)*co(1)*x1
        x39 = P1(2)*w1(2)
        x17vec = P4(2)*co(2)*w3(:)*x2
        x40 = P1(3)*w1(3)
        x18vec = P1(3)*co(2)*w3(:)*x2
        x19vec = P1(:)*co(0)*x2
        x20vec = P1(:)*co(1)*x1
        x41 = P2(1)*w1(1)
        x42 = P2(2)*w1(2)
        x43 = P2(3)*w1(3)
        x44 = P3(0)*w1(0)
        x21vec = P1(:)*co(0)*x19
        x45 = P2(0)*w1(0)
        x22vec = P3(:)*co(0)*x1
        x46 = P2(0)*P4(0)
        x23vec = co(0)*w2(:)*x28
        x24vec = co(0)*w2(:)*x33
        x25vec = co(0)*w2(:)*x38
        x47 = P2(1)*w2(1)
        x48 = P2(2)*w2(2)
        x49 = P2(3)*w2(3)
        x50 = P2(0)*w2(0)
        x26vec = co(1)*w3(:)*(x47 + x48 + x49 - x50)
        x51 = P4(1)*w2(1)
        x52 = P4(2)*w2(2)
        x53 = P4(3)*w2(3)
        x54 = P4(0)*w2(0)
        x27vec = co(1)*w3(:)*(x51 + x52 + x53 - x54)
        x28vec = co(1)*w1(:)*x12
        x55 = P3(2)*w1(2)
        x56 = P3(3)*w1(3)
        x57 = P4(2)*w1(2)
        x58 = P4(3)*w1(3)
        x29vec = co(1)*w1(:)*x33
        x30vec = co(1)*w1(:)*x38
        x31vec = P4(1)*co(2)*w1(:)*x1
        x59 = P3(1)*w1(1)
        x32vec = P4(2)*co(2)*w1(:)*x1
        x33vec = P3(3)*co(2)*w1(:)*x1
        x60 = P4(0)*w1(0)
        x61 = P4(1)*w1(1)
        x34vec = P1(0)*co(2)*w3(:)*x2
        x35vec = P3(:)*co(1)*w1(1)*x1
        x36vec = P3(:)*co(1)*w1(3)*x1
        x62 = P2(3)*P4(3)
        x37vec = P3(0)*co(2)*w1(:)*x1
        x38vec = 2*co(1)*w1(:)*x12
        x39vec = 2*P1(1)*co(2)*w1(:)*x1
        x40vec = 2*co(2)*w1(:)*x1
        x41vec = 2*co(1)*w3(:)*x24
        x42vec = 2*P3(1)*co(2)*w3(:)*x2
        x43vec = 2*co(0)*w2(:)*x12
        x44vec = 2*co(2)*w3(:)*x2
        x45vec = 2*co(1)*w3(:)*x17
        x46vec = 2*co(1)*w1(:)*x28
        x63 = P1(2)*P3(2)
        wout = -w4(0)*(-P1(0)**2*x1vec + P1(0)*P2(0)*x40vec - 2*P1(0)*x37vec + &
               P1(1)**2*x1vec + P1(1)*x10vec - P1(1)*x35vec + P1(1)*x42vec + P1&
               (1)*x7vec + P1(2)**2*x1vec - P1(2)*P2(2)*x40vec + P1(2)*x17vec  &
                + P1(3)**2*x1vec - P1(3)*P2(3)*x40vec + 2*P1(3)*x33vec - P1(3)*&
               x36vec + P2(0)*P3(0)*x44vec - P2(1)*x10vec - P2(1)*x31vec - P2(1&
               )*x35vec - P2(1)*x39vec - P2(1)*x42vec + P2(1)*x7vec - P2(2)*P3(&
               2)*x44vec - P2(2)*x17vec - P2(2)*x32vec - P2(3)*P3(3)*x44vec -  &
               P2(3)*x36vec - P3(0)**2*x0vec - 2*P3(0)*x34vec + P3(1)**2*x0vec &
                + P3(1)*x31vec - P3(1)*x35vec + P3(1)*x39vec + P3(1)*x7vec + P3&
               (2)**2*x0vec + P3(2)*x32vec + P3(3)**2*x0vec + 2*P3(3)*x18vec - &
               P3(3)*x36vec - P4(0)*x34vec - P4(0)*x37vec - P4(1)*x35vec + P4(1&
               )*x7vec + P4(3)*x18vec + P4(3)*x33vec - P4(3)*x36vec + x0*x0vec &
                + x0*x1vec - x0vec*x3 - x0vec*x4 + x0vec*x46 - x0vec*x5 - x0vec&
               *x62 - x10*x19vec - x10*x2vec + x10*x4vec + x10*x8vec + x11*    &
               x19vec + x11*x2vec - x11*x4vec - x11*x8vec + x11vec*x25 + x11vec&
               *x39 + x11vec*x40 + x11vec*x41 + x11vec*x42 + x11vec*x43 -      &
               x11vec*x44 - x11vec*x45 + x11vec*x55 + x11vec*x56 + x11vec*x57  &
                + x11vec*x58 + x11vec*x59 - x11vec*x60 + x11vec*x61 - x11vec*x7&
                + x12vec*x13 + x12vec*x14 + x12vec*x15 - x12vec*x16 + x13*     &
               x13vec + x13*x14vec + x13*x15vec + x13*x38vec + x13*x9vec +     &
               x13vec*x14 + x13vec*x15 - x13vec*x16 + x14*x14vec + x14*x15vec  &
                + x14*x38vec + x14*x9vec + x14vec*x15 - x14vec*x16 + x15*x15vec&
                + x15*x38vec + x15*x9vec - x15vec*x16 - x16*x38vec - x16*x9vec &
                + x16vec*x39 + x16vec*x40 + x16vec*x42 + x16vec*x43 - x16vec*  &
               x44 - x16vec*x45 + x16vec*x55 + x16vec*x56 + x16vec*x57 + x16vec&
               *x58 - x16vec*x60 - x16vec*x7 - x18*x2vec - x18*x4vec + x18*    &
               x8vec - x19vec*x8 - x19vec*x9 - x1vec*x3 - x1vec*x4 + x1vec*x46 &
                - x1vec*x5 - x1vec*x62 + x20*x21vec - x20*x29vec - x20*x30vec  &
                - x20*x46vec + x20vec*x41 + x20vec*x42 + x20vec*x43 + x20vec*  &
               x44 - x20vec*x45 - x20vec*x55 - x20vec*x56 - x20vec*x59 + x21*  &
               x21vec - x21*x29vec - x21*x30vec - x21*x46vec + x21vec*x22 -    &
               x21vec*x23 - x22*x29vec - x22*x30vec - x22*x46vec - x22vec*x41  &
                - x22vec*x42 - x22vec*x43 + x22vec*x45 + x23*x29vec + x23*     &
               x30vec + x23*x46vec - x23vec*x41 - x23vec*x42 - x23vec*x43 +    &
               x23vec*x45 - x24vec*x41 - x24vec*x42 - x24vec*x43 + x24vec*x45  &
                - x25*x5vec - x25*x6vec - x25vec*x41 - x25vec*x42 - x25vec*x43 &
                + x25vec*x45 - x26*x2vec - x26*x4vec + x26*x8vec + x26vec*x41  &
                + x26vec*x42 + x26vec*x43 - x26vec*x45 - x27*x2vec - x27*x4vec &
                + x27*x8vec + x27vec*x41 + x27vec*x42 + x27vec*x43 - x27vec*x45&
                + x28vec*x47 + x28vec*x48 + x28vec*x49 - x28vec*x50 + x28vec*  &
               x51 + x28vec*x52 + x28vec*x53 - x28vec*x54 - x29*x2vec + x29*   &
               x8vec - x2vec*x30 - x2vec*x31 + x2vec*x32 - x2vec*x34 - x2vec*  &
               x35 - x2vec*x36 + x2vec*x37 + x2vec*x6 - x2vec*x8 - x2vec*x9 +  &
               x30*x8vec + x31*x8vec - x32*x8vec + x34*x8vec + x35*x8vec + x36*&
               x8vec - x37*x8vec - x39*x3vec - x39*x5vec - x39*x6vec - x3vec*  &
               x42 + x3vec*x44 + x3vec*x45 - x3vec*x55 - x3vec*x57 + x3vec*x60 &
                + x3vec*x7 - x40*x5vec - x40*x6vec + x40vec*x63 + x41*x41vec - &
               x41*x43vec + x41vec*x42 + x41vec*x43 - x41vec*x45 - x42*x43vec  &
                - x43*x43vec + x43vec*x45 + x44*x45vec + x44*x5vec + x44vec*x63&
                - x45vec*x55 - x45vec*x56 - x45vec*x59 + x4vec*x6 + x4vec*x8 + &
               x4vec*x9 - x55*x5vec - x56*x5vec - x57*x5vec - x57*x6vec - x58* &
               x5vec - x58*x6vec - x59*x5vec + x5vec*x60 - x5vec*x61 + x5vec*x7&
                - x6*x8vec + x60*x6vec - x61*x6vec + x6vec*x7 + x8*x8vec +     &
               x8vec*x9)
      case(VVVSV3)
!       c0*(-Metric(1,2)*P(3,1)*P(5,3) + Metric(1,2)*P(3,2)*P(5,3) + Metric(1,2)*
!       P(3,5)*P(5,1) - Metric(1,2)*P(3,5)*P(5,2) - Metric(1,3)*P(2,1)*P(5,2) +  
!       Metric(1,3)*P(2,3)*P(5,2) + Metric(1,3)*P(2,5)*P(5,1) - Metric(1,3)*P(2,5
!       )*P(5,3) - Metric(2,5)*P(1,2)*P(3,1) + Metric(2,5)*P(1,3)*P(3,2) - Metric
!       (2,5)*P(1,3)*P(3,5) + Metric(2,5)*P(1,5)*P(3,1) + Metric(3,5)*P(1,2)*P(2,
!       3) - Metric(3,5)*P(1,2)*P(2,5) - Metric(3,5)*P(1,3)*P(2,1) + Metric(3,5)*
!       P(1,5)*P(2,1))
!       c1*(Metric(1,2)*P(3,1)*P(5,2) + Metric(1,3)*P(2,1)*P(5,3) - Metric(1,5)*P
!       (2,1)*P(3,5) - Metric(1,5)*P(2,5)*P(3,1) - Metric(2,3)*P(1,2)*P(5,3) -   
!       Metric(2,3)*P(1,3)*P(5,2) + Metric(2,5)*P(1,2)*P(3,5) + Metric(3,5)*P(1,3
!       )*P(2,5))
!       c2*(-Metric(1,2)*Metric(3,5)*P(-1,1)*P(-1,3) + Metric(1,2)*Metric(3,5)*P 
!       (-1,1)*P(-1,5) + Metric(1,2)*Metric(3,5)*P(-1,2)*P(-1,3) - Metric(1,2)*  
!       Metric(3,5)*P(-1,2)*P(-1,5) - Metric(1,3)*Metric(2,5)*P(-1,1)*P(-1,2) +  
!       Metric(1,3)*Metric(2,5)*P(-1,1)*P(-1,5) + Metric(1,3)*Metric(2,5)*P(-1,2 
!       )*P(-1,3) - Metric(1,3)*Metric(2,5)*P(-1,3)*P(-1,5))
        if (last) VB_last = .true.
        x0 = P1(1)**2
        x1 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x0vec = co(2)*w2(:)*x1
        x2 = P1(2)**2
        x3 = P1(3)**2
        x4 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x1vec = co(2)*w3(:)*x4
        x5 = P1(0)**2
        x6 = P1(0)*w3(0)*x4
        x7 = P1(0)*w2(0)
        x2vec = P3(:)*co(0)*x1
        x3vec = P3(:)*co(1)*x1
        x8 = P2(1)*w3(1)
        x9 = P2(2)*w3(2)
        x10 = P2(3)*w3(3)
        x11 = P2(0)*w3(0)
        x12 = x10 - x11 + x8 + x9
        x4vec = co(1)*w1(:)*x12
        x13 = P3(1)*w3(1)
        x14 = P3(2)*w3(2)
        x15 = P3(3)*w3(3)
        x16 = P3(0)*w3(0)
        x17 = x13 + x14 + x15 - x16
        x18 = co(1)*x17
        x5vec = P1(0)*w1(:)*w2(0)
        x19 = P4(1)*w3(1)
        x20 = P4(2)*w3(2)
        x21 = P4(3)*w3(3)
        x22 = P4(0)*w3(0)
        x23 = x19 + x20 + x21 - x22
        x24 = co(1)*x23
        x25 = P1(1)*w2(1)
        x6vec = P1(:)*co(0)*x1
        x26 = P1(1)*w3(1)
        x7vec = P1(:)*co(0)*x4
        x8vec = P2(:)*co(0)*x1
        x9vec = P3(:)*co(0)*x4
        x27 = P1(1)*P4(1)
        x28 = P1(1)*w1(1)
        x29 = P1(2)*w3(2)
        x30 = P1(3)*w3(3)
        x31 = P1(0)*w3(0)
        x32 = x26 + x29 + x30 - x31
        x10vec = co(0)*w2(:)*x32
        x33 = P1(2)*w2(2)
        x34 = P1(3)*w2(3)
        x35 = x25 + x33 + x34 - x7
        x11vec = co(0)*w3(:)*x35
        x36 = P1(2)*P4(2)
        x37 = P1(2)*w1(2)
        x12vec = P4(3)*co(2)*w2(:)*x1
        x13vec = P4(3)*co(2)*w3(:)*x4
        x14vec = co(0)*w1(3)*w2(:)*x32
        x15vec = co(0)*w1(3)*w3(:)*x35
        x38 = P2(1)*w2(1)
        x39 = P2(2)*w2(2)
        x40 = P2(3)*w2(3)
        x41 = P3(1)*w2(1)
        x42 = P3(2)*w2(2)
        x43 = P3(3)*w2(3)
        x44 = P4(1)*w2(1)
        x45 = P4(2)*w2(2)
        x46 = P4(3)*w2(3)
        x16vec = P2(:)*co(0)*x4
        x47 = P2(0)*w2(0)
        x17vec = P4(0)*co(2)*w3(:)*x4
        x48 = x38 + x39 + x40 - x47
        x49 = P4(0)*w2(0)
        x50 = x44 + x45 + x46 - x49
        x18vec = P2(0)*co(0)*w1(0)*w3(:)
        x19vec = co(1)*w1(:)*x32
        x51 = P2(1)*w1(1)
        x52 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x20vec = P3(:)*co(1)*x52
        x21vec = P2(1)*w1(1)*w2(:)
        x53 = co(1)*x12
        x54 = P2(2)*w1(2)
        x22vec = co(1)*w2(:)*x32
        x23vec = P2(2)*w1(2)*w2(:)
        x55 = P2(3)*w1(3)
        x24vec = P2(3)*w1(3)*w2(:)
        x25vec = co(1)*w2(:)*x17
        x56 = P3(0)*w2(0)
        x57 = P3(1)*w1(1)
        x26vec = P2(:)*co(1)*x52
        x58 = P3(2)*w1(2)
        x59 = P3(3)*w1(3)
        x27vec = P4(0)*co(2)*w2(:)*x1
        x28vec = co(0)*w2(:)*x17
        x60 = P3(0)*w1(0)
        x29vec = co(0)*w2(:)*x23
        x30vec = P3(1)*co(1)*w1(1)*w3(:)
        x31vec = co(1)*w3(:)*x48
        x61 = x41 + x42 + x43 - x56
        x32vec = P3(2)*co(1)*w1(2)*w3(:)
        x33vec = P3(3)*co(1)*w1(3)*w3(:)
        x62 = P4(1)*w1(1)
        x63 = P4(2)*w1(2)
        x34vec = co(0)*w1(0)*w2(:)*x32
        x35vec = co(0)*w1(0)*w3(:)*x35
        x36vec = P2(:)*co(1)*x4
        x37vec = P1(1)*w1(:)*w2(1)
        x38vec = P1(2)*w1(:)*w2(2)
        x39vec = P1(3)*w1(:)*w2(3)
        x64 = P2(0)*w1(0)
        x40vec = P2(0)*w1(0)*w2(:)
        x41vec = P2(1)*co(2)*w3(:)*x4
        x42vec = co(0)*w3(:)*x48
        x43vec = co(0)*w3(:)*x50
        x44vec = P2(2)*co(2)*w3(:)*x4
        x45vec = P3(0)*co(1)*w1(0)*w3(:)
        x46vec = P3(1)*co(2)*w2(:)*x1
        x47vec = P3(2)*co(2)*w2(:)*x1
        x48vec = 2*co(2)*w2(:)*x1
        x65 = 2*P3(0)
        x66 = 2*co(1)*x32
        x49vec = 2*co(1)*w1(:)*x32
        x50vec = 2*co(0)*w2(:)*x32
        x67 = 2*P3(1)
        x51vec = 2*co(0)*w3(:)*x61
        x68 = 2*P3(2)
        x52vec = 2*P2(3)*co(2)*w2(:)*x1
        x53vec = 2*P3(3)*co(2)*w3(:)*x4
        x54vec = 2*co(0)*w2(:)*x12
        x69 = 2*P2(0)*P3(0)
        x55vec = 2*co(0)*w3(:)*x35
        wout = w4(0)*(-P1(0)*P2(0)*x48vec - P1(0)*co(2)*w3(:)*x4*x65 - P1(0)*  &
               x17vec - P1(0)*x27vec - P1(0)*x34vec - P1(0)*x35vec + P1(1)*P2(1&
               )*x48vec + P1(1)*co(2)*w3(:)*x4*x67 + P1(2)*P2(2)*x48vec + P1(2 &
               )*co(2)*w3(:)*x4*x68 + P1(3)*x12vec + P1(3)*x13vec + P1(3)*     &
               x14vec + P1(3)*x15vec + P1(3)*x52vec + P1(3)*x53vec + P2(0)**2* &
               x1vec + P2(0)*co(0)*w1(0)*w3(:)*x48 + P2(0)*x17vec - P2(1)**2*  &
               x1vec + 2*P2(1)*co(0)*w1(1)*w2(:)*x32 - 2*P2(1)*x46vec - P2(2)**&
               2*x1vec - 2*P2(2)*x47vec - P2(3)**2*x1vec - P2(3)*x13vec - P2(3 &
               )*x53vec + P2(:)*co(0)*x6 + P2(:)*co(1)*x6 + P3(0)**2*x0vec + P3&
               (0)*x27vec - P3(1)**2*x0vec - P3(2)**2*x0vec - P3(3)**2*x0vec - &
               P3(3)*x12vec - P3(3)*x52vec - P3(:)*co(0)*x6 - P4(0)*x34vec - P4&
               (0)*x35vec - P4(1)*x41vec - P4(1)*x46vec - P4(2)*x44vec - P4(2)*&
               x47vec + P4(3)*x14vec + P4(3)*x15vec + co(1)*x21vec*x32 + x0*   &
               x0vec + x0*x1vec + x0vec*x2 + x0vec*x27 + x0vec*x3 + x0vec*x36  &
                - x0vec*x5 + x0vec*x69 - x10*x16vec + x10*x7vec - x10*x9vec +  &
               x10vec*x28 + x10vec*x37 + x10vec*x62 + x10vec*x63 + x11*x16vec  &
                - x11*x7vec + x11*x9vec + x11vec*x28 + x11vec*x37 + x11vec*x62 &
                + x11vec*x63 - x13*x16vec + x13*x7vec - x14*x16vec + x14*x7vec &
                - x15*x16vec + x15*x7vec + x16*x16vec - x16*x7vec - x16vec*x19 &
                - x16vec*x20 - x16vec*x21 + x16vec*x22 - x16vec*x26 - x16vec*  &
               x29 - x16vec*x30 - x16vec*x8 - x16vec*x9 + x18*x21vec + x18*    &
               x23vec - x18*x37vec - x18*x38vec - x18*x39vec + x18*x5vec +     &
               x18vec*x50 + x18vec*(-2*P3(0)*w2(0) + 2*P3(1)*w2(1) + 2*P3(2)*w2&
               (2) + 2*P3(3)*w2(3)) + x19*x7vec - x19vec*x38 - x19vec*x39 -    &
               x19vec*x40 - x19vec*x41 - x19vec*x42 - x19vec*x43 - x19vec*x44  &
                - x19vec*x45 - x19vec*x46 + x19vec*x47 + x19vec*x49 + x19vec*  &
               x56 + x1vec*x2 + x1vec*x27 + x1vec*x3 + x1vec*x36 - x1vec*x5 +  &
               x1vec*x69 + x20*x7vec + x20vec*x51 + x20vec*x54 + x20vec*x55 -  &
               x20vec*x64 + x21*x7vec + x21vec*x24 + x21vec*x53 - x22*x7vec +  &
               x22vec*x54 + x22vec*x55 - x22vec*x64 + x23vec*x24 + x23vec*x53  &
                + x24*x24vec - x24*x37vec - x24*x38vec - x24*x39vec - x24*     &
               x40vec + x24*x5vec + x24vec*x53 - x25*x2vec - x25*x3vec + x25*  &
               x6vec + x25*x8vec + x25vec*x55 - x25vec*x64 - x26*x36vec + x26* &
               x7vec + x26*x9vec + x26vec*x57 + x26vec*x58 + x26vec*x59 -      &
               x26vec*x60 - x28vec*x57 - x28vec*x58 - x28vec*x59 + x28vec*x60  &
                - x29*x36vec + x29*x7vec + x29*x9vec - x29vec*x57 - x29vec*x58 &
                - x29vec*x59 + x29vec*x60 - x2vec*x33 - x2vec*x34 - x2vec*x38  &
                - x2vec*x39 - x2vec*x40 - x2vec*x41 - x2vec*x42 - x2vec*x43 -  &
               x2vec*x44 - x2vec*x45 - x2vec*x46 + x2vec*x47 + x2vec*x49 +     &
               x2vec*x56 + x2vec*x7 - x30*x36vec + x30*x7vec + x30*x9vec +     &
               x30vec*x35 + x30vec*x50 + x30vec*x61 - x31*x7vec + x31vec*x57 + &
               x31vec*x58 + x31vec*x59 + x32vec*x35 + x32vec*x50 + x32vec*x61  &
                - x33*x3vec + x33*x6vec + x33*x8vec + x33vec*x35 + x33vec*x50  &
                + x33vec*x61 - x34*x3vec - x34*x49vec - x34*x4vec + x34*x6vec  &
                + x34*x8vec - x35*x45vec - x35vec*x65 - x37vec*x53 - x37vec*x66&
                + x38*x6vec - x38vec*x53 - x38vec*x66 + x39*x6vec + x3vec*x7 + &
               x40*x6vec - x40vec*x53 + x41*x6vec - x41*x8vec - x41vec*x67 +   &
               x42*x6vec - x42*x8vec - x42vec*x51 - x42vec*x54 - x42vec*x55 +  &
               x43*x6vec - x43*x8vec - x43vec*x51 - x43vec*x54 - x43vec*x55 +  &
               x44*x6vec - x44vec*x68 + x45*x6vec - x45vec*x48 - x45vec*x50 -  &
               x45vec*x61 + x46*x6vec - x47*x6vec - x49*x6vec + x49vec*x7 +    &
               x4vec*x7 + x50vec*x54 + x50vec*x55 - x50vec*x64 - x51*x51vec -  &
               x51vec*x54 - x51vec*x55 - x54vec*x57 - x54vec*x58 - x54vec*x59  &
                + x54vec*x60 + x55vec*x57 + x55vec*x58 + x55vec*x59 - x56*x6vec&
                + x56*x8vec - x6vec*x7 - x7*x8vec + x7vec*x8 + x7vec*x9 - x8*  &
               x9vec - x9*x9vec)
      end select 
    end subroutine treeVVVSV
end module tcVVVSV
