!******************************************************************************!
!                                                                              !
!    tcVVVVS.f90                                                               !
!    is part of RECOLA2 (REcursive Computation of One Loop Amplitudes)2        !
!                                                                              !
!    Copyright (C) 2016-2018 Ansgar Denner, Jean-Nicolas Lang and              !
!                            Sandro Uccirati                                   !
!                                                                              !
!    RECOLA2 is licenced under the GNU GPL version 3,                          !
!    see COPYING for details.                                                  !
!                                                                              !
!******************************************************************************!
!                                                           .---.              !
!                                                          /  .  \             !
!                                                         |\_/|   |            !
!                                                         |   |  /|            !
!          .----------------------------------------------------' |            !
!         /  .-.   tcVVVVS.f90                                    |            !
!        |  /   \  This code was generated with REPT1L.           |            !
!        | |\_.  | Change this file and you get what you deserve. |            !
!        |\|  | /| Author: J.N. Lang                              |            !
!        | `---' | UFO date: 03/2019                              |            !
!        |       | UFO version: 1.0                               |            !
!        |       | Generation date: 2019-03-21 23:40             /             !
!        |       |----------------------------------------------'              !
!        \       |                                                             !
!         \     /                                                              !
!          `---'                                                               !
!******************************************************************************!
module tcVVVVS
  use class_vertices
  use constants_mdl
  implicit none
  complex (dp) :: x0, x1, x2, x3, x4, x5, x6, x7, x8, x9, x10, x11, x12, x13,  &
                  x14, x15, x16, x17, x18, x19, x20, x21, x22, x23, x24, x25,  &
                  x26, x27, x28, x29, x30, x31, x32, x33, x34, x35, x36, x37,  &
                  x38, x39, x40, x41, x42, x43, x44, x45, x46, x47, x48, x49,  &
                  x50, x51, x52, x53, x54, x55, x56, x57, x58, x59, x60, x61,  &
                  x62, x63, x64, x65, x66, x67, x68, x69, x70, x71, x72, x73,  &
                  x74, x75, x76, x77, x78, x79, x80, x81, x82, x83, x84, x85,  &
                  x86, x87, x88, x89, x90, x91, x92, x93, x94, x95, x96, x97,  &
                  x98, x99, x100, x101, x102
  complex (dp), dimension(0:3) :: x0vec, x1vec, x2vec, x3vec, x4vec, x5vec,    &
                                  x6vec, x7vec, x8vec, x9vec, x10vec, x11vec,  &
                                  x12vec, x13vec, x14vec, x15vec, x16vec,      &
                                  x17vec, x18vec, x19vec, x20vec, x21vec,      &
                                  x22vec, x23vec, x24vec, x25vec, x26vec,      &
                                  x27vec, x28vec, x29vec, x30vec, x31vec,      &
                                  x32vec, x33vec, x34vec, x35vec, x36vec,      &
                                  x37vec, x38vec, x39vec, x40vec, x41vec,      &
                                  x42vec, x43vec, x44vec, x45vec, x46vec,      &
                                  x47vec, x48vec, x49vec, x50vec, x51vec,      &
                                  x52vec, x53vec, x54vec, x55vec, x56vec,      &
                                  x57vec, x58vec, x59vec, x60vec, x61vec,      &
                                  x62vec
  contains
    subroutine treeVVVVS(ty, co, w1, P1, PL1, w2, P2, PL2, w3, P3, PL3, w4, P4 &
    , PL4, den, m, wout, last, VB_last)
      integer, intent(in) :: ty
      logical, intent(inout) :: VB_last
      logical, intent(in) :: last
      complex(kind=dp), dimension(0:), intent(in) :: co
      complex(kind=dp), intent(in), dimension(0:3) :: P1, PL1
      complex(kind=dp), intent(in), dimension(0:3) :: w1
      complex(kind=dp), intent(in), dimension(0:3) :: P2, PL2
      complex(kind=dp), intent(in), dimension(0:3) :: w2
      complex(kind=dp), intent(in), dimension(0:3) :: P3, PL3
      complex(kind=dp), intent(in), dimension(0:3) :: w3
      complex(kind=dp), intent(in), dimension(0:3) :: P4, PL4
      complex(kind=dp), intent(in), dimension(0:3) :: w4
      complex(kind=dp), intent(in) :: m
      complex(kind=dp), intent(in) :: den
      complex(kind=dp), dimension(0:3), intent(out) :: wout
      character(len=3) :: ty_str
      complex(kind=dp), dimension(0:3) :: pl, p
      select case(ty)
      case(VVVVS0)
!       Metric(1,4)*Metric(2,3)*c0
!       Metric(1,3)*Metric(2,4)*c1
!       Metric(1,2)*Metric(3,4)*c2
        x0 = co(0)*(-w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3))
        x1 = co(1)*(-w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3))
        x2 = co(2)*(-w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3))
        wout(0) = -w1(0)*w2(0)*x2 - w1(0)*w3(0)*x1 - w1(0)*w4(0)*x0 + w1(1)*w2(&
                  1)*x2 + w1(1)*w3(1)*x1 + w1(1)*w4(1)*x0 + w1(2)*w2(2)*x2 + w1&
                  (2)*w3(2)*x1 + w1(2)*w4(2)*x0 + w1(3)*w2(3)*x2 + w1(3)*w3(3)*&
                  x1 + w1(3)*w4(3)*x0
        wout(1:3) = cnul
      case(VVVVS1)
!       c0*(-Metric(1,2)*P(3,2)*P(4,1) + Metric(1,3)*P(2,1)*P(4,3) + Metric(1,3)*
!       P(2,3)*P(4,1) - Metric(1,4)*P(2,1)*P(3,4) - Metric(2,3)*P(1,2)*P(4,3) +  
!       Metric(2,4)*P(1,2)*P(3,4) + Metric(2,4)*P(1,4)*P(3,2) - Metric(3,4)*P(1,4
!       )*P(2,3))
!       c1*(-Metric(1,2)*P(3,1)*P(4,3) + Metric(1,2)*P(3,2)*P(4,3) + Metric(1,2)*
!       P(3,4)*P(4,1) - Metric(1,2)*P(3,4)*P(4,2) + Metric(1,4)*P(2,1)*P(3,2) -  
!       Metric(1,4)*P(2,3)*P(3,1) + Metric(1,4)*P(2,3)*P(3,4) - Metric(1,4)*P(2,4
!       )*P(3,2) + Metric(2,3)*P(1,2)*P(4,1) - Metric(2,3)*P(1,3)*P(4,1) - Metric
!       (2,3)*P(1,4)*P(4,2) + Metric(2,3)*P(1,4)*P(4,3) + Metric(3,4)*P(1,2)*P(2,
!       3) - Metric(3,4)*P(1,2)*P(2,4) - Metric(3,4)*P(1,3)*P(2,1) + Metric(3,4)*
!       P(1,4)*P(2,1))
!       c2*(Metric(1,2)*Metric(3,4)*P(-1,1)*P(-1,3) - Metric(1,2)*Metric(3,4)*P(-
!       1,1)*P(-1,4) - Metric(1,2)*Metric(3,4)*P(-1,2)*P(-1,3) + Metric(1,2)*    
!       Metric(3,4)*P(-1,2)*P(-1,4) - Metric(1,4)*Metric(2,3)*P(-1,1)*P(-1,2) +  
!       Metric(1,4)*Metric(2,3)*P(-1,1)*P(-1,3) + Metric(1,4)*Metric(2,3)*P(-1,2 
!       )*P(-1,4) - Metric(1,4)*Metric(2,3)*P(-1,3)*P(-1,4))
        x0 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x1 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x2 = P1(0)*co(2)*x0*x1
        x3 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x4 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x5 = P1(0)*co(2)*x3*x4
        x6 = P1(0)*w2(0)
        x7 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x8 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x9 = co(0)*x7*x8
        x10 = P2(1)*w3(1)
        x11 = P2(2)*w3(2)
        x12 = P2(3)*w3(3)
        x13 = P2(0)*w3(0)
        x14 = x10 + x11 + x12 - x13
        x15 = co(1)*x14*x3
        x16 = P2(1)*co(2)*x3*x4
        x17 = co(2)*x0*x1
        x18 = P1(1)*w2(1)
        x19 = P4(1)*w3(1)
        x20 = P4(2)*w3(2)
        x21 = P4(3)*w3(3)
        x22 = P4(0)*w3(0)
        x23 = x19 + x20 + x21 - x22
        x24 = co(0)*x23*x3
        x25 = P1(1)*w3(1)
        x26 = co(1)*x0*x7
        x27 = P1(2)*co(2)*x3*x4
        x28 = P1(2)*co(2)*x0*x1
        x29 = P1(2)*w2(2)
        x30 = P1(2)*w3(2)
        x31 = P2(3)*co(2)*x3*x4
        x32 = P4(3)*co(2)*x0*x1
        x33 = P1(3)*w2(3)
        x34 = P1(3)*w3(3)
        x35 = P2(0)*co(2)*x0*x1
        x36 = P4(0)*co(2)*x3*x4
        x37 = P2(0)*w1(0)
        x38 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x39 = co(0)*x23*x38
        x40 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x41 = co(1)*x4*x40
        x42 = P3(1)*w2(1)
        x43 = P3(2)*w2(2)
        x44 = P3(3)*w2(3)
        x45 = P3(0)*w2(0)
        x46 = x42 + x43 + x44 - x45
        x47 = co(1)*x1*x46
        x48 = P2(1)*co(2)*x0*x1
        x49 = P2(1)*w1(1)
        x50 = co(0)*x4*x7
        x51 = co(0)*x0*x40
        x52 = P4(1)*w2(1)
        x53 = P4(2)*w2(2)
        x54 = P4(3)*w2(3)
        x55 = P4(0)*w2(0)
        x56 = co(1)*x1*(x52 + x53 + x54 - x55)
        x57 = P2(2)*w1(2)
        x58 = P2(3)*w1(3)
        x59 = co(0)*x40*x8
        x60 = P3(0)*co(1)*w2(0)
        x61 = co(2)*x3*x4
        x62 = x18 + x29 + x33 - x6
        x63 = co(1)*w1(1)*x1*x62
        x64 = P1(0)*w3(0)
        x65 = x25 + x30 + x34 - x64
        x66 = co(1)*x3*x65
        x67 = co(1)*x1*x62
        x68 = P3(2)*w1(2)
        x69 = P3(3)*w1(3)
        x70 = co(0)*x14*x38
        x71 = P4(0)*w1(0)
        x72 = co(1)*w1(0)*x1*x62
        x73 = co(1)*x4*x7
        x74 = co(1)*x0*x40
        x75 = P4(1)*w1(1)
        x76 = co(0)*x1*x46
        x77 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x78 = P4(1)*co(1)*w1(1)*x4
        x79 = co(1)*x0*x77
        x80 = P4(2)*w1(2)
        x81 = co(1)*x4*x77
        x82 = P4(3)*w1(3)
        x83 = P1(1)*P3(1)
        x84 = P1(3)*P3(3)
        x85 = P2(2)*P4(2)
        x86 = co(1)*x23*x3
        wout(0) = P1(1)*P4(1)*x17 + P1(1)*x16 + P1(3)*x31 + P1(3)*x32 + P2(0)* &
                  x36 - P2(0)*x5 + P2(2)*P3(2)*x17 + P2(2)*x27 + P2(3)*P3(3)*  &
                  x17 - P2(3)*x32 - P3(0)*w1(0)*x41 + P3(0)*x2 - P3(0)*x35 - P3&
                  (0)*x36 + P3(0)*x5 - P3(0)*x72 + P3(1)*P4(1)*x61 + P3(1)*w1(1&
                  )*x41 + P3(1)*x48 + P3(1)*x63 + P3(2)*P4(2)*x61 - P3(2)*x27  &
                   - P3(2)*x28 + P3(3)*P4(3)*x61 - P4(0)*x2 + P4(0)*x35 + P4(0 &
                  )*x72 - P4(1)*x16 - P4(1)*x48 - P4(1)*x63 + P4(2)*x28 - P4(3 &
                  )*x31 - x10*x26 + x10*x51 - x11*x26 + x11*x51 - x12*x26 + x12&
                  *x51 + x13*x26 - x13*x51 - x15*x18 - x15*x29 - x15*x33 + x15*&
                  x52 + x15*x53 + x15*x54 - x15*x55 + x15*x6 - x17*x83 - x17*  &
                  x84 - x17*x85 + x18*x24 - x18*x9 - x19*x74 + x19*x79 - x20*  &
                  x74 + x20*x79 - x21*x74 + x21*x79 + x22*x74 - x22*x79 + x23* &
                  x3*x60 + x24*x29 + x24*x33 - x24*x6 + x25*x26 + x26*x30 + x26&
                  *x34 - x26*x64 - x29*x9 - x3*x60*x65 - x33*x9 + x37*x39 + x37&
                  *x41 + x37*x47 - x37*x50 - x37*x56 - x39*x49 - x39*x57 - x39*&
                  x58 - x41*x49 - x41*x57 - x41*x58 + x41*x68 + x41*x69 - x42* &
                  x59 + x42*x66 - x42*x86 - x43*x59 + x43*x66 - x43*x86 - x44* &
                  x59 + x44*x66 - x44*x86 + x45*x59 - x47*x49 - x47*x57 - x47* &
                  x58 + x49*x50 + x49*x56 + x50*x57 + x50*x58 + x56*x57 + x56* &
                  x58 + x6*x9 - x61*x83 - x61*x84 - x61*x85 + x67*x68 + x67*x69&
                   - x67*x80 - x67*x82 - x7*x78 + x70*x71 - x70*x75 - x70*x80  &
                   - x70*x82 + x71*x73 - x71*x76 - x71*x81 - x73*x80 - x73*x82 &
                   + x75*x76 + x76*x80 + x76*x82 + x77*x78 + x80*x81 + x81*x82
        wout(1:3) = cnul
      case(VVVVS2)
!       c0*(Metric(1,2)*P(3,1)*P(4,2) + Metric(1,3)*P(2,1)*P(4,3) - Metric(1,4)*P
!       (2,1)*P(3,4) - Metric(1,4)*P(2,4)*P(3,1) - Metric(2,3)*P(1,2)*P(4,3) -   
!       Metric(2,3)*P(1,3)*P(4,2) + Metric(2,4)*P(1,2)*P(3,4) + Metric(3,4)*P(1,3
!       )*P(2,4))
!       c1*(-Metric(1,2)*P(3,1)*P(4,3) + Metric(1,2)*P(3,2)*P(4,3) + Metric(1,2)*
!       P(3,4)*P(4,1) - Metric(1,2)*P(3,4)*P(4,2) - Metric(1,3)*P(2,1)*P(4,2) +  
!       Metric(1,3)*P(2,3)*P(4,2) + Metric(1,3)*P(2,4)*P(4,1) - Metric(1,3)*P(2,4
!       )*P(4,3) - Metric(2,4)*P(1,2)*P(3,1) + Metric(2,4)*P(1,3)*P(3,2) - Metric
!       (2,4)*P(1,3)*P(3,4) + Metric(2,4)*P(1,4)*P(3,1) + Metric(3,4)*P(1,2)*P(2,
!       3) - Metric(3,4)*P(1,2)*P(2,4) - Metric(3,4)*P(1,3)*P(2,1) + Metric(3,4)*
!       P(1,4)*P(2,1))
!       c2*(-Metric(1,2)*Metric(3,4)*P(-1,1)*P(-1,3) + Metric(1,2)*Metric(3,4)*P 
!       (-1,1)*P(-1,4) + Metric(1,2)*Metric(3,4)*P(-1,2)*P(-1,3) - Metric(1,2)*  
!       Metric(3,4)*P(-1,2)*P(-1,4) - Metric(1,3)*Metric(2,4)*P(-1,1)*P(-1,2) +  
!       Metric(1,3)*Metric(2,4)*P(-1,1)*P(-1,4) + Metric(1,3)*Metric(2,4)*P(-1,2 
!       )*P(-1,3) - Metric(1,3)*Metric(2,4)*P(-1,3)*P(-1,4))
        x0 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x1 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x2 = P4(0)*co(2)*x0*x1
        x3 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x4 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x5 = P4(0)*co(2)*x3*x4
        x6 = P1(0)*w2(0)
        x7 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x8 = co(0)*x3*x7
        x9 = P1(0)*w3(0)
        x10 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x11 = co(0)*x0*x10
        x12 = P1(1)*co(2)*x3*x4
        x13 = P3(1)*co(2)*x0*x1
        x14 = P1(1)*w2(1)
        x15 = P4(1)*w3(1)
        x16 = P4(2)*w3(2)
        x17 = P4(3)*w3(3)
        x18 = P4(0)*w3(0)
        x19 = x15 + x16 + x17 - x18
        x20 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x21 = co(0)*x19*x20
        x22 = co(1)*x10*x3
        x23 = P1(1)*w3(1)
        x24 = co(1)*x0*x7
        x25 = P2(2)*co(2)*x3*x4
        x26 = P3(2)*co(2)*x0*x1
        x27 = P1(2)*w2(2)
        x28 = P1(2)*w3(2)
        x29 = P1(3)*co(2)*x3*x4
        x30 = P1(3)*co(2)*x0*x1
        x31 = P1(3)*w2(3)
        x32 = P1(3)*w3(3)
        x33 = co(2)*x0*x1
        x34 = P2(0)*P3(0)
        x35 = co(2)*x3*x4
        x36 = P2(0)*w1(0)
        x37 = co(0)*x19*x4
        x38 = P3(1)*w2(1)
        x39 = P3(2)*w2(2)
        x40 = P3(3)*w2(3)
        x41 = P3(0)*w2(0)
        x42 = x38 + x39 + x40 - x41
        x43 = co(1)*x1*x42
        x44 = P2(0)*w3(0)
        x45 = P4(1)*co(2)*x0*x1
        x46 = P2(1)*w1(1)
        x47 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x48 = co(0)*x47*x7
        x49 = x23 + x28 + x32 - x9
        x50 = co(1)*x4*x49
        x51 = P4(1)*w2(1)
        x52 = P4(2)*w2(2)
        x53 = P4(3)*w2(3)
        x54 = P4(0)*w2(0)
        x55 = x51 + x52 + x53 - x54
        x56 = co(1)*x1*x55
        x57 = P4(2)*co(2)*x0*x1
        x58 = P2(2)*w1(2)
        x59 = P2(3)*co(2)*x0*x1
        x60 = P2(3)*w1(3)
        x61 = x4*x49
        x62 = P2(3)*co(1)*w1(3)
        x63 = co(0)*x1*x55
        x64 = P3(0)*w1(0)
        x65 = P2(1)*w3(1)
        x66 = P2(2)*w3(2)
        x67 = P2(3)*w3(3)
        x68 = -x44 + x65 + x66 + x67
        x69 = co(1)*x4*x68
        x70 = P3(1)*co(2)*x3*x4
        x71 = co(0)*x10*x47
        x72 = P3(1)*w1(1)
        x73 = x14 + x27 + x31 - x6
        x74 = x1*x73
        x75 = P3(1)*co(1)*w1(1)*x4
        x76 = P4(2)*co(2)*x3*x4
        x77 = P3(2)*w1(2)
        x78 = co(1)*w1(2)*x1*x73
        x79 = P3(2)*co(1)*w1(2)*x4
        x80 = P3(3)*co(2)*x3*x4
        x81 = P3(3)*w1(3)
        x82 = co(1)*x1*x73
        x83 = co(1)*x19*x4
        x84 = co(1)*w1(0)*x1*x73
        x85 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x86 = P4(0)*co(1)*w2(0)*x3
        x87 = co(1)*x0*x85
        x88 = co(0)*x20*x49
        x89 = P4(1)*co(1)*w2(1)*x3
        x90 = co(1)*x0*x10
        x91 = P4(2)*co(1)*w2(2)*x3
        x92 = P4(3)*co(1)*w2(3)*x3
        x93 = P4(1)*co(1)*w1(1)
        x94 = P4(3)*w1(3)
        wout(0) = -P1(0)*P2(0)*x35 - P1(0)*P3(0)*x33 + P1(0)*x2 + P1(0)*x5 + P1&
                  (1)*x13 - P1(1)*x45 + P1(2)*x25 + P1(2)*x26 - P1(2)*x57 - P1(&
                  2)*x76 - P2(0)*x2 + P2(1)*x12 - P2(1)*x13 + P2(1)*x45 - P2(1 &
                  )*x70 - P2(2)*x26 + P2(2)*x57 + P2(3)*x29 - P2(3)*x80 - P3(0 &
                  )*x5 - P3(0)*x84 + P3(1)*co(1)*w1(1)*x74 - P3(2)*x25 + P3(2)*&
                  x76 + P3(2)*x78 + P3(3)*x30 - P3(3)*x59 + P4(0)*w1(0)*x50 +  &
                  P4(0)*x84 - P4(1)*x12 + P4(1)*x70 - P4(2)*w1(2)*x50 - P4(2)* &
                  x78 - P4(3)*x29 - P4(3)*x30 + P4(3)*x59 + P4(3)*x80 - x1*x42*&
                  x62 - x11*x23 - x11*x28 - x11*x32 + x11*x9 + x14*x21 + x14*  &
                  x22 - x14*x8 - x15*x87 + x15*x90 - x16*x87 + x16*x90 - x17*  &
                  x87 + x17*x90 + x18*x87 - x18*x90 + x19*x75 + x19*x79 + x21* &
                  x27 + x21*x31 - x21*x6 + x22*x27 + x22*x31 - x22*x38 - x22*  &
                  x39 - x22*x40 + x22*x41 - x22*x6 + x23*x24 + x24*x28 + x24*  &
                  x32 + x24*x44 - x24*x65 - x24*x66 - x24*x67 - x24*x9 - x27*x8&
                   - x31*x8 + x33*x34 + x34*x35 + x36*x37 + x36*x43 - x36*x48  &
                   - x36*x50 - x36*x56 - x37*x46 - x37*x58 - x37*x60 - x43*x46 &
                   - x43*x58 + x46*x48 + x46*x50 + x46*x56 + x48*x58 + x48*x60 &
                   + x50*x58 - x50*x94 + x51*x88 + x52*x88 + x53*x88 - x54*x88 &
                   + x56*x58 + x56*x60 + x6*x8 + x61*x62 - x61*x93 + x63*x64 - &
                  x63*x72 - x63*x77 - x63*x81 + x64*x69 - x64*x71 - x64*x83 -  &
                  x68*x75 - x68*x79 - x69*x81 - x7*x86 + x7*x89 + x7*x91 + x7* &
                  x92 + x71*x72 + x71*x77 + x71*x81 - x74*x93 + x81*x82 + x81* &
                  x83 - x82*x94 + x85*x86 - x85*x89 - x85*x91 - x85*x92
        wout(1:3) = cnul
      case(VVVVS3)
!       c0*(Metric(1,3)*P(2,1)*P(4,2) - Metric(1,3)*P(2,3)*P(4,2) - Metric(1,3)*P
!       (2,4)*P(4,1) + Metric(1,3)*P(2,4)*P(4,3) + Metric(1,4)*P(2,1)*P(3,2) -   
!       Metric(1,4)*P(2,3)*P(3,1) + Metric(1,4)*P(2,3)*P(3,4) - Metric(1,4)*P(2,4
!       )*P(3,2) + Metric(2,3)*P(1,2)*P(4,1) - Metric(2,3)*P(1,3)*P(4,1) - Metric
!       (2,3)*P(1,4)*P(4,2) + Metric(2,3)*P(1,4)*P(4,3) + Metric(2,4)*P(1,2)*P(3,
!       1) - Metric(2,4)*P(1,3)*P(3,2) + Metric(2,4)*P(1,3)*P(3,4) - Metric(2,4)*
!       P(1,4)*P(3,1))
!       c1*(Metric(1,2)*P(3,1)*P(4,2) + Metric(1,2)*P(3,2)*P(4,1) - Metric(1,3)*P
!       (2,3)*P(4,1) - Metric(1,4)*P(2,4)*P(3,1) - Metric(2,3)*P(1,3)*P(4,2) -   
!       Metric(2,4)*P(1,4)*P(3,2) + Metric(3,4)*P(1,3)*P(2,4) + Metric(3,4)*P(1,4
!       )*P(2,3))
!       c2*(-Metric(1,3)*Metric(2,4)*P(-1,1)*P(-1,2) + Metric(1,3)*Metric(2,4)*P 
!       (-1,1)*P(-1,4) + Metric(1,3)*Metric(2,4)*P(-1,2)*P(-1,3) - Metric(1,3)*  
!       Metric(2,4)*P(-1,3)*P(-1,4) - Metric(1,4)*Metric(2,3)*P(-1,1)*P(-1,2) +  
!       Metric(1,4)*Metric(2,3)*P(-1,1)*P(-1,3) + Metric(1,4)*Metric(2,3)*P(-1,2 
!       )*P(-1,4) - Metric(1,4)*Metric(2,3)*P(-1,3)*P(-1,4))
        x0 = -w1(0)*w4(0) + w1(1)*w4(1) + w1(2)*w4(2) + w1(3)*w4(3)
        x1 = -w2(0)*w3(0) + w2(1)*w3(1) + w2(2)*w3(2) + w2(3)*w3(3)
        x2 = P1(0)*co(2)*x0*x1
        x3 = -w1(0)*w3(0) + w1(1)*w3(1) + w1(2)*w3(2) + w1(3)*w3(3)
        x4 = -w2(0)*w4(0) + w2(1)*w4(1) + w2(2)*w4(2) + w2(3)*w4(3)
        x5 = P1(0)*co(2)*x3*x4
        x6 = P1(0)*w2(0)
        x7 = P2(1)*w3(1)
        x8 = P2(2)*w3(2)
        x9 = P2(3)*w3(3)
        x10 = P2(0)*w3(0)
        x11 = -x10 + x7 + x8 + x9
        x12 = co(0)*x0*x11
        x13 = -P2(0)*w4(0) + P2(1)*w4(1) + P2(2)*w4(2) + P2(3)*w4(3)
        x14 = co(0)*x13*x3
        x15 = P1(0)*w3(0)
        x16 = -w1(0)*w2(0) + w1(1)*w2(1) + w1(2)*w2(2) + w1(3)*w2(3)
        x17 = co(1)*x13*x16
        x18 = P1(1)*P2(1)
        x19 = co(2)*x3*x4
        x20 = co(2)*x0*x1
        x21 = P1(2)*P2(2)
        x22 = P2(3)*co(2)*x3*x4
        x23 = P1(3)*co(2)*x0*x1
        x24 = P3(0)*co(2)*x3*x4
        x25 = P4(0)*co(2)*x0*x1
        x26 = P1(1)*w3(1)
        x27 = P1(2)*w3(2)
        x28 = P1(3)*w3(3)
        x29 = -x15 + x26 + x27 + x28
        x30 = co(0)*x29*x4
        x31 = P2(0)*w1(0)
        x32 = -P1(0)*w4(0) + P1(1)*w4(1) + P1(2)*w4(2) + P1(3)*w4(3)
        x33 = co(0)*x1*x32
        x34 = co(1)*x16*x32
        x35 = -P4(0)*w3(0) + P4(1)*w3(1) + P4(2)*w3(2) + P4(3)*w3(3)
        x36 = P3(0)*co(0)*w1(0)*x4
        x37 = P3(0)*w2(0)
        x38 = co(0)*x0*x35
        x39 = P3(0)*w1(0)
        x40 = P4(1)*w2(1)
        x41 = P4(2)*w2(2)
        x42 = P4(3)*w2(3)
        x43 = P4(0)*w2(0)
        x44 = x40 + x41 + x42 - x43
        x45 = -w3(0)*w4(0) + w3(1)*w4(1) + w3(2)*w4(2) + w3(3)*w4(3)
        x46 = co(1)*x44*x45
        x47 = P3(1)*P4(1)
        x48 = P3(1)*w1(1)
        x49 = co(0)*x11*x4
        x50 = P3(1)*w2(1)
        x51 = co(0)*x0*x29
        x52 = co(1)*x1*x13
        x53 = co(1)*x3*x32
        x54 = P3(2)*co(2)*x3*x4
        x55 = P4(2)*co(2)*x0*x1
        x56 = P3(2)*w1(2)
        x57 = P3(2)*co(0)*w1(2)*x4
        x58 = P3(2)*w2(2)
        x59 = P4(3)*co(2)*x3*x4
        x60 = P4(3)*co(2)*x0*x1
        x61 = P3(3)*w1(3)
        x62 = P3(3)*w2(3)
        x63 = P4(0)*w1(0)
        x64 = -P3(0)*w4(0) + P3(1)*w4(1) + P3(2)*w4(2) + P3(3)*w4(3)
        x65 = co(0)*x1*x64
        x66 = co(0)*x3*x64
        x67 = -x37 + x50 + x58 + x62
        x68 = co(1)*x45*x67
        x69 = co(0)*w1(1)*x29*x4
        x70 = co(0)*x1*x13
        x71 = P4(1)*w1(1)
        x72 = co(0)*x3*x32
        x73 = co(1)*x11*x4
        x74 = co(1)*x0*x29
        x75 = P4(2)*w1(2)
        x76 = P4(3)*w1(3)
        x77 = P4(3)*co(1)*w1(3)
        x78 = P1(1)*w2(1)
        x79 = P1(2)*w2(2)
        x80 = P1(3)*w2(3)
        x81 = P2(2)*w1(2)
        x82 = P2(3)*w1(3)
        x83 = co(0)*x35*x4
        wout(0) = -P1(1)*P3(1)*x20 - P1(1)*P4(1)*x19 - P1(2)*P3(2)*x20 - P1(2)*&
                  P4(2)*x19 + P1(3)*x22 - P1(3)*x59 - P2(0)*x2 + P2(0)*x24 + P2&
                  (0)*x25 - P2(0)*x5 - P2(1)*P3(1)*x19 - P2(1)*P4(1)*x20 - P2(1&
                  )*w1(1)*x33 - P2(1)*x69 - P2(2)*x54 - P2(2)*x55 + P2(3)*x23  &
                   - P2(3)*x60 + P3(0)*x2 - P3(0)*x25 + P3(2)*x55 - P3(3)*co(1 &
                  )*w1(3)*x44*x45 - P3(3)*x22 - P3(3)*x23 + P3(3)*x59 + P3(3)* &
                  x60 - P4(0)*x24 + P4(0)*x5 + P4(1)*x69 + P4(2)*x54 + x10*x34 &
                   - x11*x36 + x11*x4*x77 + x11*x57 + x12*x40 + x12*x41 + x12* &
                  x42 - x12*x43 + x12*x6 - x12*x78 - x12*x79 - x12*x80 - x14*  &
                  x37 + x14*x50 + x14*x58 + x14*x6 + x14*x62 - x14*x78 - x14*  &
                  x79 - x14*x80 + x15*x17 - x17*x26 - x17*x27 - x17*x28 + x18* &
                  x19 + x18*x20 + x19*x21 + x19*x47 + x20*x21 + x20*x47 + x30* &
                  x31 - x30*x63 + x30*x75 + x30*x76 - x30*x81 - x30*x82 + x31* &
                  x33 - x33*x39 + x33*x48 + x33*x56 + x33*x61 - x33*x81 - x33* &
                  x82 - x34*x7 - x34*x8 - x34*x9 + x35*x36 - x35*x57 + x37*x38 &
                   - x37*x51 - x37*x53 - x38*x50 - x38*x58 - x38*x62 + x39*x46 &
                   - x39*x52 - x40*x66 + x40*x72 + x40*x74 - x41*x66 + x41*x72 &
                   + x41*x74 - x42*x66 + x42*x72 + x42*x74 + x43*x66 - x43*x72 &
                   - x43*x74 - x45*x67*x77 - x46*x48 - x46*x56 + x48*x49 + x48*&
                  x52 - x48*x83 + x49*x61 + x50*x51 + x50*x53 + x51*x58 + x51* &
                  x62 + x52*x56 + x52*x61 + x53*x58 + x53*x62 - x61*x83 + x63* &
                  x65 + x63*x68 - x63*x70 - x63*x73 - x65*x71 - x65*x75 - x65* &
                  x76 - x68*x71 - x68*x75 + x70*x71 + x70*x75 + x70*x76 + x71* &
                  x73 + x73*x75
        wout(1:3) = cnul
      end select 
    end subroutine treeVVVVS
end module tcVVVVS
